************************************************************************
* File (nc_si_1313_42.f) created on Fri Dec  5 12:54:58 MSK 2008.
************************************************************************
* This is the FORTRAN module (nc_si_1313_42) to calculate EW
* cross-section (width) by using the helicity amplitudes
* for the up + up -> h + z process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_si_1313_42 (s,t,u,sigma)
      implicit none!
      include 's2n_declare.h'

      integer iz,i,j,k,l,is,jj,izi
      real*8 sum,tw(2),sig(2)
      real*8 deltar,dr_bos,dr_fer
      real*8 kappa,cof,nsig,twcoeff,twl,coeff,slams
      complex*16 zoro
      complex*16 ffgp0,ffgp1,ffgp2,ffgm0,ffgm1,ffgm2
      complex*16 ff_gp0,ff_gp1,ff_gp2,ff_gm0,ff_gm1,ff_gm2	  

      complex*16 amp(2,2,3)
      real*8 sqrtlszh,isqrtlszh
      complex*16 propzs,propizs

      izi = 0
      if (ilin.eq.0) then
         twl = 0d0
      elseif (ilin.eq.1) then
         twl = 1d0
      endif

      cmz2 = mz2
      spr = s
      qs = -s
      ts = -t
      us = -u

      if (dabs(s-mz**2).le.1d-4) s = (mz**2-1d-4)

      cosf = (t-u)/(s+mz**2-mh**2)/betaf
      sinf = dsqrt(1d0-cosf**2)

      propizs = (cmz2-s)
      propzs = 1d0/propizs
      sqrtlszh = sqrt(s**2-2d0*s*(rzm2+rhm2)+(rzm2-rhm2)**2)
      isqrtlszh = 1d0/sqrtlszh
      nsig=1d0/4*1d0/2/s*(1d0/8/pi*sqrtlszh/s)*1d0/2*conhc*nc/fc

      if ((iborn.eq.1).or.(iew.eq.0)) then
         ff_gp0 = dcmplx(0d0,0d0)
         ff_gp1 = dcmplx(0d0,0d0)
         ff_gp2 = dcmplx(0d0,0d0)
         ff_gm0 = dcmplx(0d0,0d0)
         ff_gm1 = dcmplx(0d0,0d0)
         ff_gm2 = dcmplx(0d0,0d0)
      else
         coeff = alpha/4d0/pi/stw2
         call delr(deltar,dr_bos,dr_fer)
         call UniBosConsts_Bos ()
         call UniBosConsts_Fer ()
         call UniProConsts_Fer (-s)
         call nc_ff_1313_42 (-s,-t,-u)

         ff_gp0 = coeff*ffarray(1,1)
         ff_gp1 = coeff*ffarray(1,2)
         ff_gp2 = coeff*ffarray(1,3)
         ff_gm0 = coeff*ffarray(1,4)
         ff_gm1 = coeff*ffarray(1,5)
         ff_gm2 = coeff*ffarray(1,6)

         if ((gfscheme.eq.1).or.(gfscheme.eq.2)) then
            ff_gp0 = ff_gp0-coeff*deltar
            ff_gm0 = ff_gm0-coeff*deltar
         endif
      endif

      do iz = izi,1
         zoro = dcmplx(iz,0d0)
         ffgp0 = zoro + ff_gp0
         ffgp1 =        ff_gp1
         ffgp2 =        ff_gp2
         ffgm0 = zoro + ff_gm0
         ffgm1 =        ff_gm1
         ffgm2 =        ff_gm2
         if (iz.eq.1) then
            ffarray(2,1) = ffgp0
            ffarray(2,2) = ffgp1
            ffarray(2,3) = ffgp2
            ffarray(2,4) = ffgm0
            ffarray(2,5) = ffgm1
            ffarray(2,6) = ffgm2
         endif

      amp(1,1,1) =
     & 0d0

      amp(1,1,3) =
     & 0d0

      amp(1,1,2) =
     & 0d0

      amp(1,2,1) =
     & +propzs*cosf**2*sqrt(s)*sqrtlszh*ffgp1*i_*g**2/sr2*(+1d0/8/ctw**2
     & *mz)
     & +propzs*cosf**2*sqrt(s)*sqrtlszh*ffgp2*i_*g**2/sr2*(-1d0/8/ctw**2
     & *mz)
     & +propzs*cosf*sqrt(s)*ffgp0*i_*g**2/sr2*(+1d0/2/ctw**2*vpaup*mz)
     & +propzs*sqrt(s)*sqrtlszh*ffgp1*i_*g**2/sr2*(-1d0/8/ctw**2*mz)
     & +propzs*sqrt(s)*sqrtlszh*ffgp2*i_*g**2/sr2*(+1d0/8/ctw**2*mz)
     & +propzs*sqrt(s)*ffgp0*i_*g**2/sr2*(+1d0/2/ctw**2*vpaup*mz)

      amp(1,2,3) =
     & +propzs*sinf*cosf*sqrtlszh*ffgp1*i_*g**2*(-1d0/16/ctw**2*mz**2+1d
     & 0/16/ctw**2*mh**2-1d0/16/ctw**2*s)
     & +propzs*sinf*cosf*sqrtlszh*ffgp2*i_*g**2*(+1d0/16/ctw**2*mz**2-1d
     & 0/16/ctw**2*mh**2+1d0/16/ctw**2*s)
     & +propzs*sinf*ffgp1*i_*g**2*(+1d0/8/ctw**2*mz**2*mh**2+1d0/8/ctw**
     & 2*mz**2*s-1d0/16/ctw**2*mz**4+1d0/8/ctw**2*mh**2*s-1d0/16/ctw**2*
     & mh**4-1d0/16/ctw**2*s**2)
     & +propzs*sinf*ffgp2*i_*g**2*(+1d0/8/ctw**2*mz**2*mh**2+1d0/8/ctw**
     & 2*mz**2*s-1d0/16/ctw**2*mz**4+1d0/8/ctw**2*mh**2*s-1d0/16/ctw**2*
     & mh**4-1d0/16/ctw**2*s**2)
     & +propzs*sinf*ffgp0*i_*g**2*(-1d0/4/ctw**2*vpaup*mz**2+1d0/4/ctw**
     & 2*vpaup*mh**2-1d0/4/ctw**2*vpaup*s)

      amp(1,2,2) =
     & +propzs*cosf**2*sqrt(s)*sqrtlszh*ffgp1*i_*g**2/sr2*(-1d0/8/ctw**2
     & *mz)
     & +propzs*cosf**2*sqrt(s)*sqrtlszh*ffgp2*i_*g**2/sr2*(+1d0/8/ctw**2
     & *mz)
     & +propzs*cosf*sqrt(s)*ffgp0*i_*g**2/sr2*(-1d0/2/ctw**2*vpaup*mz)
     & +propzs*sqrt(s)*sqrtlszh*ffgp1*i_*g**2/sr2*(+1d0/8/ctw**2*mz)
     & +propzs*sqrt(s)*sqrtlszh*ffgp2*i_*g**2/sr2*(-1d0/8/ctw**2*mz)
     & +propzs*sqrt(s)*ffgp0*i_*g**2/sr2*(+1d0/2/ctw**2*vpaup*mz)

      amp(2,1,1) =
     & +propzs*cosf**2*sqrt(s)*sqrtlszh*ffgm1*i_*g**2/sr2*(-1d0/8/ctw**2
     & *mz)
     & +propzs*cosf**2*sqrt(s)*sqrtlszh*ffgm2*i_*g**2/sr2*(+1d0/8/ctw**2
     & *mz)
     & +propzs*cosf*sqrt(s)*ffgm0*i_*g**2/sr2*(-1d0/2/ctw**2*vmaup*mz)
     & +propzs*sqrt(s)*sqrtlszh*ffgm1*i_*g**2/sr2*(+1d0/8/ctw**2*mz)
     & +propzs*sqrt(s)*sqrtlszh*ffgm2*i_*g**2/sr2*(-1d0/8/ctw**2*mz)
     & +propzs*sqrt(s)*ffgm0*i_*g**2/sr2*(+1d0/2/ctw**2*vmaup*mz)

      amp(2,1,3) =
     & +propzs*sinf*cosf*sqrtlszh*ffgm1*i_*g**2*(+1d0/16/ctw**2*mz**2-1d
     & 0/16/ctw**2*mh**2+1d0/16/ctw**2*s)
     & +propzs*sinf*cosf*sqrtlszh*ffgm2*i_*g**2*(-1d0/16/ctw**2*mz**2+1d
     & 0/16/ctw**2*mh**2-1d0/16/ctw**2*s)
     & +propzs*sinf*ffgm1*i_*g**2*(-1d0/8/ctw**2*mz**2*mh**2-1d0/8/ctw**
     & 2*mz**2*s+1d0/16/ctw**2*mz**4-1d0/8/ctw**2*mh**2*s+1d0/16/ctw**2*
     & mh**4+1d0/16/ctw**2*s**2)
     & +propzs*sinf*ffgm2*i_*g**2*(-1d0/8/ctw**2*mz**2*mh**2-1d0/8/ctw**
     & 2*mz**2*s+1d0/16/ctw**2*mz**4-1d0/8/ctw**2*mh**2*s+1d0/16/ctw**2*
     & mh**4+1d0/16/ctw**2*s**2)
     & +propzs*sinf*ffgm0*i_*g**2*(+1d0/4/ctw**2*vmaup*mz**2-1d0/4/ctw**
     & 2*vmaup*mh**2+1d0/4/ctw**2*vmaup*s)

      amp(2,1,2) =
     & +propzs*cosf**2*sqrt(s)*sqrtlszh*ffgm1*i_*g**2/sr2*(+1d0/8/ctw**2
     & *mz)
     & +propzs*cosf**2*sqrt(s)*sqrtlszh*ffgm2*i_*g**2/sr2*(-1d0/8/ctw**2
     & *mz)
     & +propzs*cosf*sqrt(s)*ffgm0*i_*g**2/sr2*(+1d0/2/ctw**2*vmaup*mz)
     & +propzs*sqrt(s)*sqrtlszh*ffgm1*i_*g**2/sr2*(-1d0/8/ctw**2*mz)
     & +propzs*sqrt(s)*sqrtlszh*ffgm2*i_*g**2/sr2*(+1d0/8/ctw**2*mz)
     & +propzs*sqrt(s)*ffgm0*i_*g**2/sr2*(+1d0/2/ctw**2*vmaup*mz)

      amp(2,2,1) =
     & 0d0

      amp(2,2,3) =
     & 0d0

      amp(2,2,2) =
     & 0d0

         sum = 0d0
         do i=1,2
            do j=1,2
               do k=1,3
                  sum = sum+amp(i,j,k)*dconjg(amp(i,j,k))
               enddo
            enddo
         enddo
         sig(iz+1) = nsig*sum
      enddo

      sigma = sig(2)-twl*sig(1)

      return
      end
