************************************************************************
* File (nc_ff_1212_42.F) created on Wed Feb  6 18:13:16 CET 2008.
************************************************************************
* This is the FORTRAN module (nc_ff_1212_42) to calculate 1-loop EW
* form factors for the el + el -> h + z process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ff_1212_42 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ffgp0,ffgp1,ffgp2,ffgm0,ffgm1,ffgm2

      real*8 det3izhqs
      real*8 a0fw,a0fz,a0fh
      complex*16 b0pzww,b0pzzh,b0phww,b0phzz,b0phhh,b0pccz
      complex*16 b0fqsww,b0fqszh,b0fzww,b0fzzh,b0fzmomo,b0fzchch,b0fzst
     & st,b0fztata,b0fztptp,b0fzbtbt,b0fhww,b0fhzz,b0fhhh,b0fhmomo,b0fhc
     & hch,b0fhstst,b0fhtata,b0fhtptp,b0fhbtbt,b0fqsmomo,b0fqschch,b0fqs
     & stst,b0fqstata,b0fqstptp,b0fqsbtbt,b0ftswc,b0ftszc,b0fuswc,b0fusz
     & c,b0fqscc,b0fzcc
      complex*16 c0zhqswww,c0zhqszhh,c0zhqshzz,c0zhqsmomomo,c0zhqschchc
     & h,c0zhqsststst,c0zhqstatata,c0zhqstptptp,c0zhqsbtbtbt,c0chtscww,c
     & 0chtsczz,c0chuscww,c0chusczz,c0cztswcc,c0cztszcc,c0cztscww,c0czus
     & wcc,c0czuszcc,c0czuscww,c0ccqswcw,c0ccqscwc,c0ccqsczc
      complex*16 d0zchctsusccww,d0zchctsuscczz,d0cczhqstswcww,d0cchzqsu
     & swcww
      real*8 sdet3ichts,sdet3ichus,sdet4izhtsus,sdet3iczus,sdet3iczts
      complex*16 propzqs,propizqs

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      cmz2 = rzm2

      propizqs = (cmz2+qs)
      propzqs = 1d0/propizqs
      det3izhqs = 1d0/(-1d0/4d0*((-rzm2)**2+(-rhm2)**2+(qs)**2
     & -2d0*(-rzm2)*(-rhm2)-2d0*(-rzm2)*(qs)
     & -2d0*(-rhm2)*(qs)))
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      b0pzww = b0p(-rzm2,wm2,wm2)
      b0pzzh = b0p(-rzm2,zm2,hm2)
      b0phww = b0p(-rhm2,wm2,wm2)
      b0phzz = b0p(-rhm2,zm2,zm2)
      b0phhh = b0p(-rhm2,hm2,hm2)
      b0pccz = b0p(0d0,cm2,zm2)
      b0fqsww = b0f(qs,thmu2,wm2,wm2)
      b0fqszh = b0f(qs,thmu2,zm2,hm2)
      b0fzww = b0f(-rzm2,thmu2,wm2,wm2)
      b0fzzh = b0f(-rzm2,thmu2,zm2,hm2)
      b0fzmomo = b0f(-rzm2,thmu2,mom2,mom2)
      b0fzchch = b0f(-rzm2,thmu2,chm2,chm2)
      b0fzstst = b0f(-rzm2,thmu2,stm2,stm2)
      b0fztata = b0f(-rzm2,thmu2,tam2,tam2)
      b0fztptp = b0f(-rzm2,thmu2,tpm2,tpm2)
      b0fzbtbt = b0f(-rzm2,thmu2,btm2,btm2)
      b0fhww = b0f(-rhm2,thmu2,wm2,wm2)
      b0fhzz = b0f(-rhm2,thmu2,zm2,zm2)
      b0fhhh = b0f(-rhm2,thmu2,hm2,hm2)
      b0fhmomo = b0f(-rhm2,thmu2,mom2,mom2)
      b0fhchch = b0f(-rhm2,thmu2,chm2,chm2)
      b0fhstst = b0f(-rhm2,thmu2,stm2,stm2)
      b0fhtata = b0f(-rhm2,thmu2,tam2,tam2)
      b0fhtptp = b0f(-rhm2,thmu2,tpm2,tpm2)
      b0fhbtbt = b0f(-rhm2,thmu2,btm2,btm2)
      b0fqsmomo = b0f(qs,thmu2,mom2,mom2)
      b0fqschch = b0f(qs,thmu2,chm2,chm2)
      b0fqsstst = b0f(qs,thmu2,stm2,stm2)
      b0fqstata = b0f(qs,thmu2,tam2,tam2)
      b0fqstptp = b0f(qs,thmu2,tpm2,tpm2)
      b0fqsbtbt = b0f(qs,thmu2,btm2,btm2)
      b0ftswc = b0f(ts,thmu2,wm2,cm2)
      b0ftszc = b0f(ts,thmu2,zm2,cm2)
      b0fuswc = b0f(us,thmu2,wm2,cm2)
      b0fuszc = b0f(us,thmu2,zm2,cm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      b0fzcc = b0f(-rzm2,thmu2,cm2,cm2)
      c0zhqswww = -c0(rzm2,rhm2,-qs,rwm2,rwm2,rwm2)
      c0zhqszhh = -c0(rzm2,rhm2,-qs,rzm2,rhm2,rhm2)
      c0zhqshzz = -c0(rzm2,rhm2,-qs,rhm2,rzm2,rzm2)
      c0zhqsmomomo = -c0(rzm2,rhm2,-qs,rmom2,rmom2,rmom2)
      c0zhqschchch = -c0(rzm2,rhm2,-qs,rchm2,rchm2,rchm2)
      c0zhqsststst = -c0(rzm2,rhm2,-qs,rstm2,rstm2,rstm2)
      c0zhqstatata = -c0(rzm2,rhm2,-qs,rtam2,rtam2,rtam2)
      c0zhqstptptp = -c0(rzm2,rhm2,-qs,rtpm2,rtpm2,rtpm2)
      c0zhqsbtbtbt = -c0(rzm2,rhm2,-qs,rbtm2,rbtm2,rbtm2)
      c0chtscww = -c0(0d0,rhm2,-ts,0d0,rwm2,rwm2)
      c0chtsczz = -c0(0d0,rhm2,-ts,0d0,rzm2,rzm2)
      c0chuscww = -c0(0d0,rhm2,-us,0d0,rwm2,rwm2)
      c0chusczz = -c0(0d0,rhm2,-us,0d0,rzm2,rzm2)
      c0cztswcc = -c0(0d0,rzm2,-ts,rwm2,0d0,0d0)
      c0cztszcc = -c0(0d0,rzm2,-ts,rzm2,0d0,0d0)
      c0cztscww = -c0(0d0,rzm2,-ts,0d0,rwm2,rwm2)
      c0czuswcc = -c0(0d0,rzm2,-us,rwm2,0d0,0d0)
      c0czuszcc = -c0(0d0,rzm2,-us,rzm2,0d0,0d0)
      c0czuscww = -c0(0d0,rzm2,-us,0d0,rwm2,rwm2)
      c0ccqswcw = -c0(0d0,0d0,-qs,rwm2,0d0,rwm2)
      c0ccqscwc = -c0(0d0,0d0,-qs,0d0,rwm2,0d0)
      c0ccqsczc = -c0(0d0,0d0,-qs,0d0,rzm2,0d0)
      d0zchctsusccww =
     & d0(rzm2,0d0,rhm2,0d0,-ts,-us,0d0,0d0,rwm2,rwm2)
      d0zchctsuscczz =
     & d0(rzm2,0d0,rhm2,0d0,-ts,-us,0d0,0d0,rzm2,rzm2)
      d0cczhqstswcww =
     & d0(0d0,0d0,rzm2,rhm2,-qs,-ts,rwm2,0d0,rwm2,rwm2)
      d0cchzqsuswcww =
     & d0(0d0,0d0,rhm2,rzm2,-qs,-us,rwm2,0d0,rwm2,rwm2)
      sdet3ichts = 1d0/(ts+(mh)**2)
      sdet3ichus = 1d0/(us+(mh)**2)
      sdet4izhtsus = 1d0/(ts*us-rzm2*rhm2)
      sdet3iczus = 1d0/(us+(mz)**2)
      sdet3iczts = 1d0/(ts+(mz)**2)

      ffgp0=
     & +qel/vpael*(2*stw*ctw*zmsqrfer+2*stw**2*zz1fer-2*stw**2*caldzfer+
     & 2*stw**2*pizgfer)
     & +1d0/vpael*(-10d0/9-1d0/stw**2*deltarhobos-1d0/stw**2*deltarhofer
     & +1d0/stw*ctw*zmsqrfer-10d0/3*ctw**2-4*ctw**4+deltarhobos+deltarho
     & fer+zz1fer-caldzfer)
     & +vpael**2*(-1d0/4/ctw**2)
     & +vmael**2*(-1d0/8/ctw**2)
     & +cfl*(-1d0/2/ctw**2*vpamo**2/mz**2*mmo**2-1d0/2/ctw**2*vmamo**2/m
     & z**2*mmo**2-1d0/2/ctw**2*vpata**2/mz**2*mta**2-1d0/2/ctw**2*vmata
     & **2/mz**2*mta**2)
     & +cfq*(-1d0/2/ctw**2*vpach**2/mz**2*mch**2-1d0/2/ctw**2*vmach**2/m
     & z**2*mch**2-1d0/2/ctw**2*vpast**2/mz**2*mst**2-1d0/2/ctw**2*vmast
     & **2/mz**2*mst**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**2-1d0/2/ctw**2*
     & vmatp**2/mz**2*mtp**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**2-1d0/2/ct
     & w**2*vmabt**2/mz**2*mbt**2)
     & +propzqs*qel/vpael*(2*stw**2*mz**2*zmzzzbos+130d0/9*stw**2*mz**2-
     & 4*stw**2*mz**4/mh**2-64d0/3*stw**4*mz**2+4*stw**4*mz**4/mh**2+8*s
     & tw**6*mz**2+1d0/9/ctw**2*mz**2-2/ctw**2*mz**4/mh**2+1d0/3/ctw**2*
     & mh**2-1d0/9*mz**2+2*mz**4/mh**2-1d0/3*mh**2)
     & +propzqs/vpael*(1d0/18/ctw**2*mz**2-1d0/ctw**2*mz**4/mh**2+1d0/6/
     & ctw**2*mh**2+8d0/3*ctw**2*mz**2-2*ctw**2*mz**4/mh**2+4*ctw**4*mz*
     & *2+mz**2*zmzzzbos+5d0/9*mz**2)
     & +propzqs*a0fw*qel/vpael*(13*stw**2*mz**2-6*stw**2*mz**4/mh**2-64d
     & 0/3*stw**4*mz**2+6*stw**4*mz**4/mh**2+8*stw**6*mz**2)
     & +propzqs*a0fw/vpael*(8d0/3*ctw**2*mz**2-3*ctw**2*mz**4/mh**2+4*ct
     & w**4*mz**2-1d0/6*mz**2)
     & +propzqs*a0fz*qel/vpael*(-1d0/3/ctw**2*mz**2-3/ctw**2*mz**4/mh**2
     & +1d0/6/ctw**2*mh**2+1d0/3*mz**2+3*mz**4/mh**2-1d0/6*mh**2)
     & +propzqs*a0fz/vpael*(-1d0/6/ctw**2*mz**2-3d0/2/ctw**2*mz**4/mh**2
     & +1d0/12/ctw**2*mh**2)
     & +propzqs*a0fh*qel/vpael*(-1d0/6/ctw**2/mz**2*mh**4-1d0/ctw**2*mh*
     & *2+1d0/6/mz**2*mh**4+mh**2)
     & +propzqs*a0fh/vpael*(-1d0/12/ctw**2/mz**2*mh**4-1d0/2/ctw**2*mh**
     & 2)
     & +propzqs*b0fqsww*qel/vpael*(50d0/3*stw**2*mz**2-82d0/3*stw**4*mz*
     & *2+8*stw**6*mz**2-1d0/6/ctw**2*mz**2+1d0/6*mz**2)
     & +propzqs*b0fqsww/vpael*(-1d0/12/ctw**2*mz**2+17d0/3*ctw**2*mz**2+
     & 4*ctw**4*mz**2-4d0/3*mz**2)
     & +propzqs*b0fqszh*qel/vpael*(-1d0/6/ctw**2/mz**2*mh**4-2/ctw**2*mz
     & **2+2d0/3/ctw**2*mh**2+1d0/6/mz**2*mh**4+2*mz**2-2d0/3*mh**2)
     & +propzqs*b0fqszh/vpael*(-1d0/12/ctw**2/mz**2*mh**4-1d0/ctw**2*mz*
     & *2+1d0/3/ctw**2*mh**2)
     & +propizqs*qel/vpael*cfl/qs*(-2*stw**2*qmo*vpamo/mz**2*mmo**2-2*st
     & w**2*qmo*vmamo/mz**2*mmo**2-2*stw**2*qta*vpata/mz**2*mta**2-2*stw
     & **2*qta*vmata/mz**2*mta**2)
     & +propizqs*qel/vpael*cfq/qs*(-2*stw**2*qch*vpach/mz**2*mch**2-2*st
     & w**2*qch*vmach/mz**2*mch**2-2*stw**2*qst*vpast/mz**2*mst**2-2*stw
     & **2*qst*vmast/mz**2*mst**2-2*stw**2*qtp*vpatp/mz**2*mtp**2-2*stw*
     & *2*qtp*vmatp/mz**2*mtp**2-2*stw**2*qbt*vpabt/mz**2*mbt**2-2*stw**
     & 2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*qel/vpael/qs*(stw**2/mz**2*mh**2+10d0/3*stw**2-2*stw**4
     & /mz**2*mh**2-22d0/3*stw**4+4*stw**6)
     & +propizqs*det3izhqs*c0zhqswww*qel/vpael*(-5*stw**2*mz**2*mh**2-1d
     & 0/2*stw**2*mh**4+11*stw**4*mz**2*mh**2+stw**4*mh**4-6*stw**6*mz**
     & 2*mh**2)
     & +propizqs*det3izhqs*c0zhqswww*qs*(-1d0/8/ctw**2*mz**2-1d0/2*ctw**
     & 2*mz**2+1d0/2*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*(-1d0/4/ctw**2*mz**2*mh**2-1d0/8/ct
     & w**2*mz**4-1d0/8/ctw**2*mh**4-1d0/2*ctw**2*mz**4-1d0/2*ctw**2*mh*
     & *4-3*ctw**4*mz**2*mh**2+3d0/4*mz**2*mh**2+1d0/2*mz**4+1d0/2*mh**4
     & )
     & +propizqs*det3izhqs*c0zhqszhh*qs*(-3d0/4/ctw**2*mz**2-3d0/16/ctw*
     & *2*mh**2)
     & +propizqs*det3izhqs*c0zhqszhh*(-3d0/16/ctw**2/mz**2*mh**6-27d0/16
     & /ctw**2*mz**2*mh**2-3d0/4/ctw**2*mz**4-3d0/8/ctw**2*mh**4)
     & +propizqs*det3izhqs*c0zhqshzz*qs*(-1d0/8/ctw**2/mz**2*mh**4-11d0/
     & 8/ctw**2*mz**2-7d0/16/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqshzz*(-3d0/16/ctw**2/mz**2*mh**6-55d0/16
     & /ctw**2*mz**2*mh**2-11d0/8/ctw**2*mz**4-1d0/ctw**2*mh**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*qel/vpael*cfl*(stw**2*qmo*vpamo*
     & mh**2*mmo**2+stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*cfl*(1d0/4/ctw**2*vpamo**2*mh**2
     & *mmo**2+1d0/4/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqschchch*qel/vpael*cfq*(stw**2*qch*vpach*
     & mh**2*mch**2+stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*cfq*(1d0/4/ctw**2*vpach**2*mh**2
     & *mch**2+1d0/4/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs*c0zhqsststst*qel/vpael*cfq*(stw**2*qst*vpast*
     & mh**2*mst**2+stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*cfq*(1d0/4/ctw**2*vpast**2*mh**2
     & *mst**2+1d0/4/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs*c0zhqstatata*qel/vpael*cfl*(stw**2*qta*vpata*
     & mh**2*mta**2+stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*cfl*(1d0/4/ctw**2*vpata**2*mh**2
     & *mta**2+1d0/4/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qel/vpael*cfq*(stw**2*qtp*vpatp*
     & mh**2*mtp**2+stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*cfq*(1d0/4/ctw**2*vpatp**2*mh**2
     & *mtp**2+1d0/4/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qel/vpael*cfq*(stw**2*qbt*vpabt*
     & mh**2*mbt**2+stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*cfq*(1d0/4/ctw**2*vpabt**2*mh**2
     & *mbt**2+1d0/4/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs*b0fzww*qel/vpael/qs*(11d0/4*stw**2*mz**2*mh**
     & 2-11d0/4*stw**2*mz**4-6*stw**4*mz**2*mh**2+6*stw**4*mz**4+3*stw**
     & 6*mz**2*mh**2-3*stw**6*mz**4)
     & +propizqs*det3izhqs*b0fzww*qel/vpael*qs*(-1d0/4*stw**2+1d0/2*stw*
     & *4)
     & +propizqs*det3izhqs*b0fzww*qel/vpael*(-3*stw**2*mz**2-3d0/4*stw**
     & 2*mh**2+13d0/2*stw**4*mz**2+3d0/2*stw**4*mh**2-3*stw**6*mz**2)
     & +propizqs*det3izhqs*b0fzww*qs*(1d0/4-1d0/16/ctw**2-1d0/4*ctw**2)
     & +propizqs*det3izhqs*b0fzww*(-1d0/16/ctw**2*mz**2-3d0/16/ctw**2*mh
     & **2+1d0/4*ctw**2*mz**2-3d0/4*ctw**2*mh**2-3d0/2*ctw**4*mz**2+1d0/
     & 8*mz**2+3d0/4*mh**2)
     & +propizqs*det3izhqs*b0fzzh*qs*(1d0/16/ctw**2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fzzh*(1d0/16/ctw**2/mz**2*mh**4-1d0/8/ctw**
     & 2*mz**2+1d0/16/ctw**2*mh**2)
     & +propizqs*det3izhqs*b0fzmomo*qel/vpael*cfl/qs*(1d0/2*stw**2*qmo*v
     & pamo*mz**2*mmo**2-1d0/2*stw**2*qmo*vpamo*mh**2*mmo**2+1d0/2*stw**
     & 2*qmo*vmamo*mz**2*mmo**2-1d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*qel/vpael*cfl*(1d0/2*stw**2*qmo*vpam
     & o*mmo**2+1d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*cfl*(1d0/8/ctw**2*vpamo**2*mmo**2+1d
     & 0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*qel/vpael*cfq/qs*(1d0/2*stw**2*qch*v
     & pach*mz**2*mch**2-1d0/2*stw**2*qch*vpach*mh**2*mch**2+1d0/2*stw**
     & 2*qch*vmach*mz**2*mch**2-1d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs*b0fzchch*qel/vpael*cfq*(1d0/2*stw**2*qch*vpac
     & h*mch**2+1d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fzchch*cfq*(1d0/8/ctw**2*vpach**2*mch**2+1d
     & 0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs*b0fzstst*qel/vpael*cfq/qs*(1d0/2*stw**2*qst*v
     & past*mz**2*mst**2-1d0/2*stw**2*qst*vpast*mh**2*mst**2+1d0/2*stw**
     & 2*qst*vmast*mz**2*mst**2-1d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs*b0fzstst*qel/vpael*cfq*(1d0/2*stw**2*qst*vpas
     & t*mst**2+1d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fzstst*cfq*(1d0/8/ctw**2*vpast**2*mst**2+1d
     & 0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs*b0fztata*qel/vpael*cfl/qs*(1d0/2*stw**2*qta*v
     & pata*mz**2*mta**2-1d0/2*stw**2*qta*vpata*mh**2*mta**2+1d0/2*stw**
     & 2*qta*vmata*mz**2*mta**2-1d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs*b0fztata*qel/vpael*cfl*(1d0/2*stw**2*qta*vpat
     & a*mta**2+1d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fztata*cfl*(1d0/8/ctw**2*vpata**2*mta**2+1d
     & 0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs*b0fztptp*qel/vpael*cfq/qs*(1d0/2*stw**2*qtp*v
     & patp*mz**2*mtp**2-1d0/2*stw**2*qtp*vpatp*mh**2*mtp**2+1d0/2*stw**
     & 2*qtp*vmatp*mz**2*mtp**2-1d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*qel/vpael*cfq*(1d0/2*stw**2*qtp*vpat
     & p*mtp**2+1d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*cfq*(1d0/8/ctw**2*vpatp**2*mtp**2+1d
     & 0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*qel/vpael*cfq/qs*(1d0/2*stw**2*qbt*v
     & pabt*mz**2*mbt**2-1d0/2*stw**2*qbt*vpabt*mh**2*mbt**2+1d0/2*stw**
     & 2*qbt*vmabt*mz**2*mbt**2-1d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*qel/vpael*cfq*(1d0/2*stw**2*qbt*vpab
     & t*mbt**2+1d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*cfq*(1d0/8/ctw**2*vpabt**2*mbt**2+1d
     & 0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs*b0fhww*qel/vpael/qs*(-11d0/4*stw**2*mz**2*mh*
     & *2+11d0/4*stw**2*mz**4+6*stw**4*mz**2*mh**2-6*stw**4*mz**4-3*stw*
     & *6*mz**2*mh**2+3*stw**6*mz**4)
     & +propizqs*det3izhqs*b0fhww*qel/vpael*qs*(1d0/4*stw**2/mz**2*mh**2
     & +11d0/4*stw**2-1d0/2*stw**4/mz**2*mh**2-6*stw**4+3*stw**6)
     & +propizqs*det3izhqs*b0fhww*qel/vpael*(1d0/4*stw**2/mz**2*mh**4+11
     & d0/2*stw**2*mz**2+7d0/2*stw**2*mh**2-1d0/2*stw**4/mz**2*mh**4-12*
     & stw**4*mz**2-15d0/2*stw**4*mh**2+6*stw**6*mz**2+3*stw**6*mh**2)
     & +propizqs*det3izhqs*b0fhww*qs*(-3d0/8+1d0/16/ctw**2/mz**2*mh**2+1
     & d0/8/ctw**2+1d0/4*ctw**2/mz**2*mh**2+3d0/2*ctw**4-1d0/4/mz**2*mh*
     & *2)
     & +propizqs*det3izhqs*b0fhww*(1d0/16/ctw**2/mz**2*mh**4+1d0/8/ctw**
     & 2*mz**2+5d0/16/ctw**2*mh**2+1d0/4*ctw**2/mz**2*mh**4+3d0/4*ctw**2
     & *mh**2+3d0/2*ctw**4*mz**2+3d0/2*ctw**4*mh**2-1d0/4/mz**2*mh**4-3d
     & 0/8*mz**2-9d0/8*mh**2)
     & +propizqs*det3izhqs*b0fhzz*qs*(3d0/32/ctw**2/mz**2*mh**2+7d0/16/c
     & tw**2)
     & +propizqs*det3izhqs*b0fhzz*(5d0/32/ctw**2/mz**2*mh**4+7d0/16/ctw*
     & *2*mz**2+29d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs*b0fhhh*qs*(-3d0/32/ctw**2/mz**2*mh**2-3d0/8/c
     & tw**2)
     & +propizqs*det3izhqs*b0fhhh*(-9d0/32/ctw**2/mz**2*mh**4-3d0/8/ctw*
     & *2*mz**2-27d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs*b0fhmomo*qel/vpael*cfl/qs*(-1d0/2*stw**2*qmo*
     & vpamo*mz**2*mmo**2+1d0/2*stw**2*qmo*vpamo*mh**2*mmo**2-1d0/2*stw*
     & *2*qmo*vmamo*mz**2*mmo**2+1d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qel/vpael*cfl*qs*(-1d0/2*stw**2*qmo*
     & vpamo/mz**2*mmo**2-1d0/2*stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qel/vpael*cfl*(-1d0/2*stw**2*qmo*vpa
     & mo/mz**2*mh**2*mmo**2-stw**2*qmo*vpamo*mmo**2-1d0/2*stw**2*qmo*vm
     & amo/mz**2*mh**2*mmo**2-stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl*qs*(-1d0/8/ctw**2*vpamo**2/mz**2
     & *mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl*(-1d0/8/ctw**2*vpamo**2/mz**2*mh
     & **2*mmo**2-1d0/8/ctw**2*vpamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz*
     & *2*mh**2*mmo**2-1d0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*qel/vpael*cfq/qs*(-1d0/2*stw**2*qch*
     & vpach*mz**2*mch**2+1d0/2*stw**2*qch*vpach*mh**2*mch**2-1d0/2*stw*
     & *2*qch*vmach*mz**2*mch**2+1d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qel/vpael*cfq*qs*(-1d0/2*stw**2*qch*
     & vpach/mz**2*mch**2-1d0/2*stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qel/vpael*cfq*(-1d0/2*stw**2*qch*vpa
     & ch/mz**2*mh**2*mch**2-stw**2*qch*vpach*mch**2-1d0/2*stw**2*qch*vm
     & ach/mz**2*mh**2*mch**2-stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*cfq*qs*(-1d0/8/ctw**2*vpach**2/mz**2
     & *mch**2-1d0/8/ctw**2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*cfq*(-1d0/8/ctw**2*vpach**2/mz**2*mh
     & **2*mch**2-1d0/8/ctw**2*vpach**2*mch**2-1d0/8/ctw**2*vmach**2/mz*
     & *2*mh**2*mch**2-1d0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*qel/vpael*cfq/qs*(-1d0/2*stw**2*qst*
     & vpast*mz**2*mst**2+1d0/2*stw**2*qst*vpast*mh**2*mst**2-1d0/2*stw*
     & *2*qst*vmast*mz**2*mst**2+1d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qel/vpael*cfq*qs*(-1d0/2*stw**2*qst*
     & vpast/mz**2*mst**2-1d0/2*stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qel/vpael*cfq*(-1d0/2*stw**2*qst*vpa
     & st/mz**2*mh**2*mst**2-stw**2*qst*vpast*mst**2-1d0/2*stw**2*qst*vm
     & ast/mz**2*mh**2*mst**2-stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*cfq*qs*(-1d0/8/ctw**2*vpast**2/mz**2
     & *mst**2-1d0/8/ctw**2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*cfq*(-1d0/8/ctw**2*vpast**2/mz**2*mh
     & **2*mst**2-1d0/8/ctw**2*vpast**2*mst**2-1d0/8/ctw**2*vmast**2/mz*
     & *2*mh**2*mst**2-1d0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*qel/vpael*cfl/qs*(-1d0/2*stw**2*qta*
     & vpata*mz**2*mta**2+1d0/2*stw**2*qta*vpata*mh**2*mta**2-1d0/2*stw*
     & *2*qta*vmata*mz**2*mta**2+1d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qel/vpael*cfl*qs*(-1d0/2*stw**2*qta*
     & vpata/mz**2*mta**2-1d0/2*stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qel/vpael*cfl*(-1d0/2*stw**2*qta*vpa
     & ta/mz**2*mh**2*mta**2-stw**2*qta*vpata*mta**2-1d0/2*stw**2*qta*vm
     & ata/mz**2*mh**2*mta**2-stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*cfl*qs*(-1d0/8/ctw**2*vpata**2/mz**2
     & *mta**2-1d0/8/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*cfl*(-1d0/8/ctw**2*vpata**2/mz**2*mh
     & **2*mta**2-1d0/8/ctw**2*vpata**2*mta**2-1d0/8/ctw**2*vmata**2/mz*
     & *2*mh**2*mta**2-1d0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*qel/vpael*cfq/qs*(-1d0/2*stw**2*qtp*
     & vpatp*mz**2*mtp**2+1d0/2*stw**2*qtp*vpatp*mh**2*mtp**2-1d0/2*stw*
     & *2*qtp*vmatp*mz**2*mtp**2+1d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qel/vpael*cfq*qs*(-1d0/2*stw**2*qtp*
     & vpatp/mz**2*mtp**2-1d0/2*stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qel/vpael*cfq*(-1d0/2*stw**2*qtp*vpa
     & tp/mz**2*mh**2*mtp**2-stw**2*qtp*vpatp*mtp**2-1d0/2*stw**2*qtp*vm
     & atp/mz**2*mh**2*mtp**2-stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq*qs*(-1d0/8/ctw**2*vpatp**2/mz**2
     & *mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq*(-1d0/8/ctw**2*vpatp**2/mz**2*mh
     & **2*mtp**2-1d0/8/ctw**2*vpatp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz*
     & *2*mh**2*mtp**2-1d0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel/vpael*cfq/qs*(-1d0/2*stw**2*qbt*
     & vpabt*mz**2*mbt**2+1d0/2*stw**2*qbt*vpabt*mh**2*mbt**2-1d0/2*stw*
     & *2*qbt*vmabt*mz**2*mbt**2+1d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel/vpael*cfq*qs*(-1d0/2*stw**2*qbt*
     & vpabt/mz**2*mbt**2-1d0/2*stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel/vpael*cfq*(-1d0/2*stw**2*qbt*vpa
     & bt/mz**2*mh**2*mbt**2-stw**2*qbt*vpabt*mbt**2-1d0/2*stw**2*qbt*vm
     & abt/mz**2*mh**2*mbt**2-stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq*qs*(-1d0/8/ctw**2*vpabt**2/mz**2
     & *mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq*(-1d0/8/ctw**2*vpabt**2/mz**2*mh
     & **2*mbt**2-1d0/8/ctw**2*vpabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz*
     & *2*mh**2*mbt**2-1d0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*qel/vpael*qs*(-1d0/4*stw**2/mz**2*mh*
     & *2-5d0/2*stw**2+1d0/2*stw**4/mz**2*mh**2+11d0/2*stw**4-3*stw**6)
     & +propizqs*det3izhqs*b0fqsww*qel/vpael*(-1d0/4*stw**2/mz**2*mh**4-
     & 5d0/2*stw**2*mz**2-11d0/4*stw**2*mh**2+1d0/2*stw**4/mz**2*mh**4+1
     & 1d0/2*stw**4*mz**2+6*stw**4*mh**2-3*stw**6*mz**2-3*stw**6*mh**2)
     & +propizqs*det3izhqs*b0fqsww*qs*(1d0/8-1d0/16/ctw**2/mz**2*mh**2-1
     & d0/16/ctw**2-1d0/4*ctw**2/mz**2*mh**2+1d0/4*ctw**2-3d0/2*ctw**4+1
     & d0/4/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fqsww*(-1d0/16/ctw**2/mz**2*mh**4-1d0/16/ct
     & w**2*mz**2-1d0/8/ctw**2*mh**2-1d0/4*ctw**2/mz**2*mh**4-1d0/4*ctw*
     & *2*mz**2-3d0/2*ctw**4*mh**2+1d0/4/mz**2*mh**4+1d0/4*mz**2+3d0/8*m
     & h**2)
     & +propizqs*det3izhqs*b0fqszh*qs*(-1d0/16/ctw**2/mz**2*mh**2-1d0/16
     & /ctw**2)
     & +propizqs*det3izhqs*b0fqszh*(1d0/16/ctw**2/mz**2*mh**4+1d0/16/ctw
     & **2*mz**2-1d0/8/ctw**2*mh**2)
     & +propizqs*det3izhqs*b0fqsmomo*qel/vpael*cfl*qs*(1d0/2*stw**2*qmo*
     & vpamo/mz**2*mmo**2+1d0/2*stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*qel/vpael*cfl*(1d0/2*stw**2*qmo*vpa
     & mo/mz**2*mh**2*mmo**2+1d0/2*stw**2*qmo*vpamo*mmo**2+1d0/2*stw**2*
     & qmo*vmamo/mz**2*mh**2*mmo**2+1d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*cfl*qs*(1d0/8/ctw**2*vpamo**2/mz**2
     & *mmo**2+1d0/8/ctw**2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*cfl*(1d0/8/ctw**2*vpamo**2/mz**2*mh
     & **2*mmo**2+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*qel/vpael*cfq*qs*(1d0/2*stw**2*qch*
     & vpach/mz**2*mch**2+1d0/2*stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*qel/vpael*cfq*(1d0/2*stw**2*qch*vpa
     & ch/mz**2*mh**2*mch**2+1d0/2*stw**2*qch*vpach*mch**2+1d0/2*stw**2*
     & qch*vmach/mz**2*mh**2*mch**2+1d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fqschch*cfq*qs*(1d0/8/ctw**2*vpach**2/mz**2
     & *mch**2+1d0/8/ctw**2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*cfq*(1d0/8/ctw**2*vpach**2/mz**2*mh
     & **2*mch**2+1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*qel/vpael*cfq*qs*(1d0/2*stw**2*qst*
     & vpast/mz**2*mst**2+1d0/2*stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*qel/vpael*cfq*(1d0/2*stw**2*qst*vpa
     & st/mz**2*mh**2*mst**2+1d0/2*stw**2*qst*vpast*mst**2+1d0/2*stw**2*
     & qst*vmast/mz**2*mh**2*mst**2+1d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*cfq*qs*(1d0/8/ctw**2*vpast**2/mz**2
     & *mst**2+1d0/8/ctw**2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*cfq*(1d0/8/ctw**2*vpast**2/mz**2*mh
     & **2*mst**2+1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*qel/vpael*cfl*qs*(1d0/2*stw**2*qta*
     & vpata/mz**2*mta**2+1d0/2*stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*qel/vpael*cfl*(1d0/2*stw**2*qta*vpa
     & ta/mz**2*mh**2*mta**2+1d0/2*stw**2*qta*vpata*mta**2+1d0/2*stw**2*
     & qta*vmata/mz**2*mh**2*mta**2+1d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fqstata*cfl*qs*(1d0/8/ctw**2*vpata**2/mz**2
     & *mta**2+1d0/8/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*cfl*(1d0/8/ctw**2*vpata**2/mz**2*mh
     & **2*mta**2+1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*qel/vpael*cfq*qs*(1d0/2*stw**2*qtp*
     & vpatp/mz**2*mtp**2+1d0/2*stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*qel/vpael*cfq*(1d0/2*stw**2*qtp*vpa
     & tp/mz**2*mh**2*mtp**2+1d0/2*stw**2*qtp*vpatp*mtp**2+1d0/2*stw**2*
     & qtp*vmatp/mz**2*mh**2*mtp**2+1d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*cfq*qs*(1d0/8/ctw**2*vpatp**2/mz**2
     & *mtp**2+1d0/8/ctw**2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*cfq*(1d0/8/ctw**2*vpatp**2/mz**2*mh
     & **2*mtp**2+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qel/vpael*cfq*qs*(1d0/2*stw**2*qbt*
     & vpabt/mz**2*mbt**2+1d0/2*stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qel/vpael*cfq*(1d0/2*stw**2*qbt*vpa
     & bt/mz**2*mh**2*mbt**2+1d0/2*stw**2*qbt*vpabt*mbt**2+1d0/2*stw**2*
     & qbt*vmabt/mz**2*mh**2*mbt**2+1d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*cfq*qs*(1d0/8/ctw**2*vpabt**2/mz**2
     & *mbt**2+1d0/8/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*cfq*(1d0/8/ctw**2*vpabt**2/mz**2*mh
     & **2*mbt**2+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2)
     & +propizqs*sdet3ichts*c0chtscww*(-ctw**4*mz**2)
     & +propizqs*sdet3ichts*c0chtsczz*vpael**2*(-1d0/2/ctw**2*mz**2)
     & +propizqs*sdet3ichts*b0fhww*(-ctw**2)
     & +propizqs*sdet3ichts*b0fhzz*vpael**2*(-1d0/2/ctw**2)
     & +propizqs*sdet3ichts*b0ftswc*(ctw**2)
     & +propizqs*sdet3ichts*b0ftszc*vpael**2*(1d0/2/ctw**2)
     & +propizqs*sdet3ichus*c0chuscww*(-ctw**4*mz**2)
     & +propizqs*sdet3ichus*c0chusczz*vpael**2*(-1d0/2/ctw**2*mz**2)
     & +propizqs*sdet3ichus*b0fhww*(-ctw**2)
     & +propizqs*sdet3ichus*b0fhzz*vpael**2*(-1d0/2/ctw**2)
     & +propizqs*sdet3ichus*b0fuswc*(ctw**2)
     & +propizqs*sdet3ichus*b0fuszc*vpael**2*(1d0/2/ctw**2)
     & +propizqs*d0zchctsusccww/vpael/qs*(ctw**2*us*mz**2+ctw**2*us*mh**
     & 2+ctw**2*us**2+ctw**2*mz**2*mh**2+3d0/2*ctw**4*mz**2*mh**2-3d0/2*
     & ctw**4*mz**4+1d0/2*sdet4izhtsus*ctw**6*ts*mz**4*mh**2+1d0/2*sdet4
     & izhtsus*ctw**6*ts*mz**6+1d0/2*sdet4izhtsus*ctw**6*us*mz**4*mh**2+
     & 1d0/2*sdet4izhtsus*ctw**6*us*mz**6+2*sdet4izhtsus*ctw**6*mz**6*mh
     & **2)
     & +propizqs*d0zchctsusccww/vpael*(ctw**2*us+ctw**2*mz**2+3d0/2*ctw*
     & *4*mz**2+1d0/2*sdet4izhtsus*ctw**6*ts*mz**4+1d0/2*sdet4izhtsus*ct
     & w**6*us*mz**4)
     & +propizqs*d0zchctsuscczz*vpael**2/qs*(1d0/2/ctw**2*us*mz**2+1d0/2
     & /ctw**2*us*mh**2+1d0/2/ctw**2*us**2+5d0/4/ctw**2*mz**2*mh**2-3d0/
     & 4/ctw**2*mz**4+1d0/4*sdet4izhtsus/ctw**2*ts*mz**4*mh**2+1d0/4*sde
     & t4izhtsus/ctw**2*ts*mz**6+1d0/4*sdet4izhtsus/ctw**2*us*mz**4*mh**
     & 2+1d0/4*sdet4izhtsus/ctw**2*us*mz**6+sdet4izhtsus/ctw**2*mz**6*mh
     & **2)
     & +propizqs*d0zchctsuscczz*vpael**2*(1d0/2/ctw**2*us+5d0/4/ctw**2*m
     & z**2+1d0/4*sdet4izhtsus/ctw**2*ts*mz**4+1d0/4*sdet4izhtsus/ctw**2
     & *us*mz**4)
     & +propizqs*d0cczhqstswcww/vpael/qs*(-1d0/2*ctw**4*mz**2*mh**2+1d0/
     & 2*ctw**4*mz**4+2*ctw**6*mz**2*mh**2-2*ctw**6*mz**4-sdet4izhtsus*c
     & tw**8*mz**4*mh**4+2*sdet4izhtsus*ctw**8*mz**6*mh**2-sdet4izhtsus*
     & ctw**8*mz**8)
     & +propizqs*d0cczhqstswcww/vpael*(1d0/2*ctw**2*ts+ctw**4*ts+1d0/2*c
     & tw**4*mz**2+4*ctw**6*mz**2+sdet4izhtsus*ctw**4*ts*mz**2*mh**2+sde
     & t4izhtsus*ctw**4*ts**2*mz**2+sdet4izhtsus*ctw**4*ts**2*mh**2+sdet
     & 4izhtsus*ctw**4*ts**3-2*sdet4izhtsus*ctw**6*ts**2*mz**2+2*sdet4iz
     & htsus*ctw**6*mz**4*mh**2+sdet4izhtsus*ctw**8*ts*mz**4+sdet4izhtsu
     & s*ctw**8*us*mz**4-sdet4izhtsus*ctw**8*mz**4*mh**2-sdet4izhtsus*ct
     & w**8*mz**6)
     & +propizqs*d0cchzqsuswcww/vpael/qs*(-1d0/2*ctw**4*mz**2*mh**2+1d0/
     & 2*ctw**4*mz**4+2*ctw**6*mz**2*mh**2-2*ctw**6*mz**4-sdet4izhtsus*c
     & tw**8*mz**4*mh**4+2*sdet4izhtsus*ctw**8*mz**6*mh**2-sdet4izhtsus*
     & ctw**8*mz**8)
     & +propizqs*d0cchzqsuswcww/vpael*(1d0/2*ctw**2*us+ctw**4*us+1d0/2*c
     & tw**4*mz**2+4*ctw**6*mz**2+sdet4izhtsus*ctw**4*us*mz**2*mh**2+sde
     & t4izhtsus*ctw**4*us**2*mz**2+sdet4izhtsus*ctw**4*us**2*mh**2+sdet
     & 4izhtsus*ctw**4*us**3-2*sdet4izhtsus*ctw**6*us**2*mz**2+2*sdet4iz
     & htsus*ctw**6*mz**4*mh**2+sdet4izhtsus*ctw**8*ts*mz**4+sdet4izhtsu
     & s*ctw**8*us*mz**4-sdet4izhtsus*ctw**8*mz**4*mh**2-sdet4izhtsus*ct
     & w**8*mz**6)
     & +propizqs*c0zhqswww*qel/vpael/qs*(-32*stw**2*mz**2+10*stw**2*mh**
     & 2+92*stw**4*mz**2-22*stw**4*mh**2-84*stw**6*mz**2+12*stw**6*mh**2
     & +24*stw**8*mz**2)
     & +propizqs*c0zhqswww*qel/vpael*(12*stw**2-22*stw**4+10*stw**6)
     & +propizqs*c0zhqswww/vpael/qs*(ctw**2*mz**2-ctw**2*mh**2-4*ctw**4*
     & mz**2+4*ctw**4*mh**2-2*sdet4izhtsus*ctw**6*mz**2*mh**4+4*sdet4izh
     & tsus*ctw**6*mz**4*mh**2-2*sdet4izhtsus*ctw**6*mz**6)
     & +propizqs*c0zhqswww/vpael*(-ctw**4-sdet4izhtsus*ctw**4*ts**2-sdet
     & 4izhtsus*ctw**4*us**2+2*sdet4izhtsus*ctw**4*mz**2*mh**2+2*sdet4iz
     & htsus*ctw**6*ts*mz**2+2*sdet4izhtsus*ctw**6*us*mz**2-2*sdet4izhts
     & us*ctw**6*mz**2*mh**2-2*sdet4izhtsus*ctw**6*mz**4)
     & +propizqs*c0zhqswww*(-ctw**2+5*ctw**4)
     & +propizqs*c0zhqsmomomo*qel/vpael*cfl/qs*(-stw**2*qmo*vpamo/mz**2*
     & mh**2*mmo**2+4*stw**2*qmo*vpamo/mz**2*mmo**4+stw**2*qmo*vpamo*mmo
     & **2-stw**2*qmo*vmamo/mz**2*mh**2*mmo**2+4*stw**2*qmo*vmamo/mz**2*
     & mmo**4+stw**2*qmo*vmamo*mmo**2)
     & +propizqs*c0zhqsmomomo*qel/vpael*cfl*(-stw**2*qmo*vpamo/mz**2*mmo
     & **2-stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*c0zhqsmomomo*cfl*(-1d0/4/ctw**2*vpamo**2/mz**2*mmo**2-1
     & d0/4/ctw**2*vmamo**2/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*qel/vpael*cfq/qs*(-stw**2*qch*vpach/mz**2*
     & mh**2*mch**2+4*stw**2*qch*vpach/mz**2*mch**4+stw**2*qch*vpach*mch
     & **2-stw**2*qch*vmach/mz**2*mh**2*mch**2+4*stw**2*qch*vmach/mz**2*
     & mch**4+stw**2*qch*vmach*mch**2)
     & +propizqs*c0zhqschchch*qel/vpael*cfq*(-stw**2*qch*vpach/mz**2*mch
     & **2-stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*c0zhqschchch*cfq*(-1d0/4/ctw**2*vpach**2/mz**2*mch**2-1
     & d0/4/ctw**2*vmach**2/mz**2*mch**2)
     & +propizqs*c0zhqsststst*qel/vpael*cfq/qs*(-stw**2*qst*vpast/mz**2*
     & mh**2*mst**2+4*stw**2*qst*vpast/mz**2*mst**4+stw**2*qst*vpast*mst
     & **2-stw**2*qst*vmast/mz**2*mh**2*mst**2+4*stw**2*qst*vmast/mz**2*
     & mst**4+stw**2*qst*vmast*mst**2)
     & +propizqs*c0zhqsststst*qel/vpael*cfq*(-stw**2*qst*vpast/mz**2*mst
     & **2-stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*c0zhqsststst*cfq*(-1d0/4/ctw**2*vpast**2/mz**2*mst**2-1
     & d0/4/ctw**2*vmast**2/mz**2*mst**2)
     & +propizqs*c0zhqstatata*qel/vpael*cfl/qs*(-stw**2*qta*vpata/mz**2*
     & mh**2*mta**2+4*stw**2*qta*vpata/mz**2*mta**4+stw**2*qta*vpata*mta
     & **2-stw**2*qta*vmata/mz**2*mh**2*mta**2+4*stw**2*qta*vmata/mz**2*
     & mta**4+stw**2*qta*vmata*mta**2)
     & +propizqs*c0zhqstatata*qel/vpael*cfl*(-stw**2*qta*vpata/mz**2*mta
     & **2-stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*c0zhqstatata*cfl*(-1d0/4/ctw**2*vpata**2/mz**2*mta**2-1
     & d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*qel/vpael*cfq/qs*(-stw**2*qtp*vpatp/mz**2*
     & mh**2*mtp**2+4*stw**2*qtp*vpatp/mz**2*mtp**4+stw**2*qtp*vpatp*mtp
     & **2-stw**2*qtp*vmatp/mz**2*mh**2*mtp**2+4*stw**2*qtp*vmatp/mz**2*
     & mtp**4+stw**2*qtp*vmatp*mtp**2)
     & +propizqs*c0zhqstptptp*qel/vpael*cfq*(-stw**2*qtp*vpatp/mz**2*mtp
     & **2-stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*c0zhqstptptp*cfq*(-1d0/4/ctw**2*vpatp**2/mz**2*mtp**2-1
     & d0/4/ctw**2*vmatp**2/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*qel/vpael*cfq/qs*(-stw**2*qbt*vpabt/mz**2*
     & mh**2*mbt**2+4*stw**2*qbt*vpabt/mz**2*mbt**4+stw**2*qbt*vpabt*mbt
     & **2-stw**2*qbt*vmabt/mz**2*mh**2*mbt**2+4*stw**2*qbt*vmabt/mz**2*
     & mbt**4+stw**2*qbt*vmabt*mbt**2)
     & +propizqs*c0zhqsbtbtbt*qel/vpael*cfq*(-stw**2*qbt*vpabt/mz**2*mbt
     & **2-stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*c0zhqsbtbtbt*cfq*(-1d0/4/ctw**2*vpabt**2/mz**2*mbt**2-1
     & d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*c0cztswcc/vpael/qs*(-ctw**2*us-ctw**2*mh**2-1d0/2*sdet4
     & izhtsus*ctw**4*ts*mz**2*mh**2-1d0/2*sdet4izhtsus*ctw**4*us*mz**4-
     & sdet4izhtsus*ctw**4*mz**4*mh**2)
     & +propizqs*c0cztswcc/vpael*(-ctw**2-1d0/2*sdet4izhtsus*ctw**4*ts*m
     & z**2)
     & +propizqs*c0cztszcc*vpael**2/qs*(-1d0/2/ctw**2*us-1d0/2/ctw**2*mh
     & **2-1d0/4*sdet4izhtsus/ctw**2*ts*mz**2*mh**2-1d0/4*sdet4izhtsus/c
     & tw**2*us*mz**4-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2)
     & +propizqs*c0cztszcc*vpael**2*(-1d0/2/ctw**2-1d0/4*sdet4izhtsus/ct
     & w**2*ts*mz**2)
     & +propizqs*c0cztscww/vpael/qs*(-1d0/2*ctw**2*ts-1d0/2*ctw**2*mz**2
     & +2*ctw**4*ts+2*ctw**4*mz**2-sdet4izhtsus*ctw**6*ts*mz**2*mh**2+sd
     & et4izhtsus*ctw**6*ts*mz**4-sdet4izhtsus*ctw**6*mz**4*mh**2+sdet4i
     & zhtsus*ctw**6*mz**6)
     & +propizqs*c0cztscww/vpael*(sdet4izhtsus*ctw**4*ts*mz**2+sdet4izht
     & sus*ctw**4*ts**2-sdet4izhtsus*ctw**6*ts*mz**2+sdet4izhtsus*ctw**6
     & *mz**4)
     & +propizqs*c0czuswcc/vpael/qs*(ctw**2*us+ctw**2*mz**2-1d0/2*sdet4i
     & zhtsus*ctw**4*ts*mz**4-1d0/2*sdet4izhtsus*ctw**4*us*mz**2*mh**2-s
     & det4izhtsus*ctw**4*mz**4*mh**2)
     & +propizqs*c0czuswcc/vpael*(-1d0/2*sdet4izhtsus*ctw**4*us*mz**2)
     & +propizqs*c0czuszcc*vpael**2/qs*(1d0/2/ctw**2*us+1d0/2/ctw**2*mz*
     & *2-1d0/4*sdet4izhtsus/ctw**2*ts*mz**4-1d0/4*sdet4izhtsus/ctw**2*u
     & s*mz**2*mh**2-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2)
     & +propizqs*c0czuszcc*vpael**2*(-1d0/4*sdet4izhtsus/ctw**2*us*mz**2
     & )
     & +propizqs*c0czuscww/vpael/qs*(-1d0/2*ctw**2*us-1d0/2*ctw**2*mz**2
     & +2*ctw**4*us+2*ctw**4*mz**2-sdet4izhtsus*ctw**6*us*mz**2*mh**2+sd
     & et4izhtsus*ctw**6*us*mz**4-sdet4izhtsus*ctw**6*mz**4*mh**2+sdet4i
     & zhtsus*ctw**6*mz**6)
     & +propizqs*c0czuscww/vpael*(sdet4izhtsus*ctw**4*us*mz**2+sdet4izht
     & sus*ctw**4*us**2-sdet4izhtsus*ctw**6*us*mz**2+sdet4izhtsus*ctw**6
     & *mz**4)
     & +propizqs*c0chtscww/vpael/qs*(1d0/2*ctw**2*ts-ctw**2*us-ctw**2*mz
     & **2+1d0/2*ctw**2*mh**2-2*ctw**4*ts-2*ctw**4*mh**2+1d0/2*sdet4izht
     & sus*ctw**4*ts*mz**4+1d0/2*sdet4izhtsus*ctw**4*us*mz**2*mh**2+sdet
     & 4izhtsus*ctw**4*mz**4*mh**2+sdet4izhtsus*ctw**6*ts*mz**2*mh**2-sd
     & et4izhtsus*ctw**6*ts*mz**4+sdet4izhtsus*ctw**6*mz**2*mh**4-sdet4i
     & zhtsus*ctw**6*mz**4*mh**2)
     & +propizqs*c0chtscww/vpael*(-2*ctw**4+1d0/2*sdet4izhtsus*ctw**4*ts
     & *mz**2+sdet4izhtsus*ctw**4*ts*mh**2+sdet4izhtsus*ctw**4*ts**2-sde
     & t4izhtsus*ctw**6*ts*mz**2+sdet4izhtsus*ctw**6*mz**2*mh**2)
     & +propizqs*c0chtsczz*vpael**2/qs*(-1d0/2/ctw**2*us-1d0/2/ctw**2*mz
     & **2+1d0/4*sdet4izhtsus/ctw**2*ts*mz**4+1d0/4*sdet4izhtsus/ctw**2*
     & us*mz**2*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2)
     & +propizqs*c0chtsczz*vpael**2*(1d0/4*sdet4izhtsus/ctw**2*ts*mz**2)
     & +propizqs*c0chuscww/vpael/qs*(3d0/2*ctw**2*us+3d0/2*ctw**2*mh**2-
     & 2*ctw**4*us-2*ctw**4*mh**2+1d0/2*sdet4izhtsus*ctw**4*ts*mz**2*mh*
     & *2+1d0/2*sdet4izhtsus*ctw**4*us*mz**4+sdet4izhtsus*ctw**4*mz**4*m
     & h**2+sdet4izhtsus*ctw**6*us*mz**2*mh**2-sdet4izhtsus*ctw**6*us*mz
     & **4+sdet4izhtsus*ctw**6*mz**2*mh**4-sdet4izhtsus*ctw**6*mz**4*mh*
     & *2)
     & +propizqs*c0chuscww/vpael*(ctw**2-2*ctw**4+1d0/2*sdet4izhtsus*ctw
     & **4*us*mz**2+sdet4izhtsus*ctw**4*us*mh**2+sdet4izhtsus*ctw**4*us*
     & *2-sdet4izhtsus*ctw**6*us*mz**2+sdet4izhtsus*ctw**6*mz**2*mh**2)
     & +propizqs*c0chusczz*vpael**2/qs*(1d0/2/ctw**2*us+1d0/2/ctw**2*mh*
     & *2+1d0/4*sdet4izhtsus/ctw**2*ts*mz**2*mh**2+1d0/4*sdet4izhtsus/ct
     & w**2*us*mz**4+1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2)
     & +propizqs*c0chusczz*vpael**2*(1d0/2/ctw**2+1d0/4*sdet4izhtsus/ctw
     & **2*us*mz**2)
     & +propizqs*c0ccqswcw/vpael/qs*(-2*ctw**6*mz**2)
     & +propizqs*c0ccqswcw/vpael*(-ctw**2-2*ctw**4-sdet4izhtsus*ctw**4*t
     & s*mz**2-sdet4izhtsus*ctw**4*ts*mh**2-sdet4izhtsus*ctw**4*ts**2-sd
     & et4izhtsus*ctw**4*us*mz**2-sdet4izhtsus*ctw**4*us*mh**2-sdet4izht
     & sus*ctw**4*us**2-2*sdet4izhtsus*ctw**4*mz**2*mh**2)
     & +propizqs*c0ccqscwc/vpael/qs*(-ctw**4*mz**2)
     & +propizqs*c0ccqscwc/vpael*(-1)
     & +propizqs*c0ccqsczc*vpael**2/qs*(-1d0/2/ctw**2*mz**2)
     & +propizqs*c0ccqsczc*vpael**2*(-1d0/2/ctw**2)
     & +propizqs*a0fw*qel/vpael/qs*(-20d0/3*stw**2+44d0/3*stw**4-8*stw**
     & 6)
     & +propizqs*a0fw/vpael/qs*(ctw**2-2*ctw**4)
     & +propizqs*a0fz*qel/vpael/qs*(-1d0/6-1d0/6/ctw**2/mz**2*mh**2+1d0/
     & 6/ctw**2+1d0/6/mz**2*mh**2)
     & +propizqs*a0fz/vpael/qs*(-1d0/12/ctw**2/mz**2*mh**2+1d0/12/ctw**2
     & )
     & +propizqs*a0fz*vpael**2/qs*(1d0/2/ctw**2)
     & +propizqs*a0fh*qel/vpael/qs*(1d0/6/ctw**2/mz**4*mh**4-1d0/6/ctw**
     & 2/mz**2*mh**2-1d0/6/mz**4*mh**4+1d0/6/mz**2*mh**2)
     & +propizqs*a0fh/vpael/qs*(1d0/12/ctw**2/mz**4*mh**4-1d0/12/ctw**2/
     & mz**2*mh**2)
     & +propizqs*b0fzww*qel/vpael/qs*(-stw**2+2*stw**4)
     & +propizqs*b0fhww*qel/vpael/qs*(stw**2-2*stw**4)
     & +propizqs*b0fqsww*qel/vpael/qs*(-20d0/3*stw**2+44d0/3*stw**4-8*st
     & w**6)
     & +propizqs*b0fqsww/vpael/qs*(-2*ctw**4)
     & +propizqs*b0fqszh*qel/vpael/qs*(-1d0/6+1d0/6/ctw**2/mz**4*mh**4-1
     & d0/3/ctw**2/mz**2*mh**2+1d0/6/ctw**2-1d0/6/mz**4*mh**4+1d0/3/mz**
     & 2*mh**2)
     & +propizqs*b0fqszh/vpael/qs*(1d0/12/ctw**2/mz**4*mh**4-1d0/6/ctw**
     & 2/mz**2*mh**2+1d0/12/ctw**2)
     & +propizqs*b0fqscc/vpael/qs*(ctw**2)
     & +propizqs*b0fqscc*vpael**2/qs*(1d0/2/ctw**2)
     & +det3izhqs*c0zhqswww*(1d0/2/ctw**2*mz**4*mh**2+ctw**2*mz**4*mh**2
     & +3*ctw**4*mz**4*mh**2-7d0/4*mz**4*mh**2)
     & +det3izhqs*c0zhqszhh*(3/ctw**2*mz**4*mh**2)
     & +det3izhqs*c0zhqshzz*(6/ctw**2*mz**4*mh**2)
     & +det3izhqs*c0zhqsmomomo*cfl*(-1d0/4/ctw**2*vpamo**2*mz**2*mh**2*m
     & mo**2-1d0/4/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs*c0zhqschchch*cfq*(-1d0/4/ctw**2*vpach**2*mz**2*mh**2*m
     & ch**2-1d0/4/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs*c0zhqsststst*cfq*(-1d0/4/ctw**2*vpast**2*mz**2*mh**2*m
     & st**2-1d0/4/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs*c0zhqstatata*cfl*(-1d0/4/ctw**2*vpata**2*mz**2*mh**2*m
     & ta**2-1d0/4/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs*c0zhqstptptp*cfq*(-1d0/4/ctw**2*vpatp**2*mz**2*mh**2*m
     & tp**2-1d0/4/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs*c0zhqsbtbtbt*cfq*(-1d0/4/ctw**2*vpabt**2*mz**2*mh**2*m
     & bt**2-1d0/4/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*b0fzww*(1d0/4/ctw**2*mz**2*mh**2+1d0/2*ctw**2*mz**2*mh
     & **2+3d0/2*ctw**4*mz**2*mh**2-7d0/8*mz**2*mh**2)
     & +det3izhqs*b0fzmomo*cfl*(-1d0/8/ctw**2*vpamo**2*mh**2*mmo**2-1d0/
     & 8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fzchch*cfq*(-1d0/8/ctw**2*vpach**2*mh**2*mch**2-1d0/
     & 8/ctw**2*vmach**2*mh**2*mch**2)
     & +det3izhqs*b0fzstst*cfq*(-1d0/8/ctw**2*vpast**2*mh**2*mst**2-1d0/
     & 8/ctw**2*vmast**2*mh**2*mst**2)
     & +det3izhqs*b0fztata*cfl*(-1d0/8/ctw**2*vpata**2*mh**2*mta**2-1d0/
     & 8/ctw**2*vmata**2*mh**2*mta**2)
     & +det3izhqs*b0fztptp*cfq*(-1d0/8/ctw**2*vpatp**2*mh**2*mtp**2-1d0/
     & 8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fzbtbt*cfq*(-1d0/8/ctw**2*vpabt**2*mh**2*mbt**2-1d0/
     & 8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +det3izhqs*b0fhww*(-1d0/2/ctw**2*mz**2*mh**2-ctw**2*mz**2*mh**2-3
     & *ctw**4*mz**2*mh**2+7d0/4*mz**2*mh**2)
     & +det3izhqs*b0fhzz*(-3d0/2/ctw**2*mz**2*mh**2)
     & +det3izhqs*b0fhhh*(3d0/2/ctw**2*mz**2*mh**2)
     & +det3izhqs*b0fhmomo*cfl*(1d0/4/ctw**2*vpamo**2*mh**2*mmo**2+1d0/4
     & /ctw**2*vmamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fhchch*cfq*(1d0/4/ctw**2*vpach**2*mh**2*mch**2+1d0/4
     & /ctw**2*vmach**2*mh**2*mch**2)
     & +det3izhqs*b0fhstst*cfq*(1d0/4/ctw**2*vpast**2*mh**2*mst**2+1d0/4
     & /ctw**2*vmast**2*mh**2*mst**2)
     & +det3izhqs*b0fhtata*cfl*(1d0/4/ctw**2*vpata**2*mh**2*mta**2+1d0/4
     & /ctw**2*vmata**2*mh**2*mta**2)
     & +det3izhqs*b0fhtptp*cfq*(1d0/4/ctw**2*vpatp**2*mh**2*mtp**2+1d0/4
     & /ctw**2*vmatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fhbtbt*cfq*(1d0/4/ctw**2*vpabt**2*mh**2*mbt**2+1d0/4
     & /ctw**2*vmabt**2*mh**2*mbt**2)
     & +det3izhqs*b0fqsww*(1d0/4/ctw**2*mz**2*mh**2+1d0/2*ctw**2*mz**2*m
     & h**2+3d0/2*ctw**4*mz**2*mh**2-7d0/8*mz**2*mh**2)
     & +det3izhqs*b0fqsmomo*cfl*(-1d0/8/ctw**2*vpamo**2*mh**2*mmo**2-1d0
     & /8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fqschch*cfq*(-1d0/8/ctw**2*vpach**2*mh**2*mch**2-1d0
     & /8/ctw**2*vmach**2*mh**2*mch**2)
     & +det3izhqs*b0fqsstst*cfq*(-1d0/8/ctw**2*vpast**2*mh**2*mst**2-1d0
     & /8/ctw**2*vmast**2*mh**2*mst**2)
     & +det3izhqs*b0fqstata*cfl*(-1d0/8/ctw**2*vpata**2*mh**2*mta**2-1d0
     & /8/ctw**2*vmata**2*mh**2*mta**2)
     & +det3izhqs*b0fqstptp*cfq*(-1d0/8/ctw**2*vpatp**2*mh**2*mtp**2-1d0
     & /8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*cfq*(-1d0/8/ctw**2*vpabt**2*mh**2*mbt**2-1d0
     & /8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +c0zhqswww*(-1d0/2/ctw**2*mz**2+ctw**2*mz**2-2*ctw**2*mh**2-12*ct
     & w**4*mz**2+6*ctw**4*mh**2-12*ctw**6*mz**2+2*mz**2+1d0/2*mh**2)
     & +c0zhqszhh*(-3d0/4/ctw**2/mz**2*mh**4-3/ctw**2*mz**2+3d0/4/ctw**2
     & *mh**2)
     & +c0zhqshzz*(-1d0/2/ctw**2/mz**2*mh**4-5/ctw**2*mz**2-2/ctw**2*mh*
     & *2)
     & +c0zhqsmomomo*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mh**2*mmo**2+2
     & /ctw**2*vpamo*vmamo/mz**2*mmo**4+1d0/2/ctw**2*vpamo**2*mmo**2+1d0
     & /2/ctw**2*vmamo**2*mmo**2)
     & +c0zhqschchch*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mh**2*mch**2+2
     & /ctw**2*vpach*vmach/mz**2*mch**4+1d0/2/ctw**2*vpach**2*mch**2+1d0
     & /2/ctw**2*vmach**2*mch**2)
     & +c0zhqsststst*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mh**2*mst**2+2
     & /ctw**2*vpast*vmast/mz**2*mst**4+1d0/2/ctw**2*vpast**2*mst**2+1d0
     & /2/ctw**2*vmast**2*mst**2)
     & +c0zhqstatata*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mh**2*mta**2+2
     & /ctw**2*vpata*vmata/mz**2*mta**4+1d0/2/ctw**2*vpata**2*mta**2+1d0
     & /2/ctw**2*vmata**2*mta**2)
     & +c0zhqstptptp*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mh**2*mtp**2+2
     & /ctw**2*vpatp*vmatp/mz**2*mtp**4+1d0/2/ctw**2*vpatp**2*mtp**2+1d0
     & /2/ctw**2*vmatp**2*mtp**2)
     & +c0zhqsbtbtbt*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mh**2*mbt**2+2
     & /ctw**2*vpabt*vmabt/mz**2*mbt**4+1d0/2/ctw**2*vpabt**2*mbt**2+1d0
     & /2/ctw**2*vmabt**2*mbt**2)
     & +c0ccqswcw/vpael*(4*ctw**4*mz**2+2*ctw**6*mz**2)
     & +c0ccqscwc/vpael*(2*ctw**2*mz**2+ctw**4*mz**2+mz**2)
     & +c0ccqsczc*vpael**2*(2/ctw**2*mz**2)
     & +a0fw/vpael*(-2-1d0/3*ctw**2-2*ctw**4)
     & +a0fw*(1d0/4-3d0/2*ctw**2*mz**2/mh**2+8d0/3*ctw**2-4*ctw**4)
     & +a0fz*vpael**2*(-5d0/4/ctw**2)
     & +a0fz*(-1d0/8/ctw**2/mz**2*mh**2-3d0/4/ctw**2*mz**2/mh**2)
     & +a0fh*(1d0/8/ctw**2/mz**4*mh**4-1d0/2/ctw**2/mz**2*mh**2)
     & +b0fzww*qel/vpael*(1d0/6-31d0/3*stw**2+56d0/3*stw**4-8*stw**6-1d0
     & /6/ctw**2)
     & +b0fzww/vpael*(1d0/6-1d0/12/ctw**2-4d0/3*ctw**2-4*ctw**4)
     & +b0fzww*(1d0/3-3d0/8/ctw**2+7d0/6*ctw**2-4*ctw**4)
     & +b0fzzh*qel/vpael*(1d0/6/ctw**2/mz**4*mh**4-1d0/3/ctw**2/mz**2*mh
     & **2-1d0/6/mz**4*mh**4+1d0/3/mz**2*mh**2)
     & +b0fzzh/vpael*(1d0/12/ctw**2/mz**4*mh**4-1d0/6/ctw**2/mz**2*mh**2
     & )
     & +b0fzzh*(1d0/8/ctw**2/mz**4*mh**4-1d0/2/ctw**2)
     & +b0fzmomo*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mmo**2+1d0/4/ctw**
     & 2*vpamo**2/mz**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mmo**2)
     & +b0fzchch*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mch**2+1d0/4/ctw**
     & 2*vpach**2/mz**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mch**2)
     & +b0fzstst*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mst**2+1d0/4/ctw**
     & 2*vpast**2/mz**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*mst**2)
     & +b0fztata*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mta**2+1d0/4/ctw**
     & 2*vpata**2/mz**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +b0fztptp*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mtp**2+1d0/4/ctw**
     & 2*vpatp**2/mz**2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mtp**2)
     & +b0fzbtbt*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mbt**2+1d0/4/ctw**
     & 2*vpabt**2/mz**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +b0fhww*(-1+1d0/2/ctw**2+2*ctw**2)
     & +b0fhzz*(1d0/4/ctw**2/mz**2*mh**2+2/ctw**2)
     & +b0fhhh*(-3d0/4/ctw**2/mz**2*mh**2-3d0/2/ctw**2)
     & +b0fqsww*qel/vpael*(-1d0/6+31d0/3*stw**2-56d0/3*stw**4+8*stw**6+1
     & d0/6/ctw**2)
     & +b0fqsww/vpael*(-1d0/3+1d0/12/ctw**2-2*ctw**2+2*ctw**4)
     & +b0fqsww*(-1d0/4/ctw**2+ctw**2)
     & +b0fqszh*qel/vpael*(-1d0/6/ctw**2/mz**4*mh**4+1d0/3/ctw**2/mz**2*
     & mh**2+1d0/6/mz**4*mh**4-1d0/3/mz**2*mh**2)
     & +b0fqszh/vpael*(-1d0/12/ctw**2/mz**4*mh**4+1d0/6/ctw**2/mz**2*mh*
     & *2)
     & +b0fqszh*(1d0/4/ctw**2/mz**2*mh**2-1d0/2/ctw**2)
     & +b0fqsmomo*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mmo**2+1d0/4/ctw*
     & *2*vpamo**2/mz**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mmo**2)
     & +b0fqschch*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mch**2+1d0/4/ctw*
     & *2*vpach**2/mz**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mch**2)
     & +b0fqsstst*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mst**2+1d0/4/ctw*
     & *2*vpast**2/mz**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*mst**2)
     & +b0fqstata*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mta**2+1d0/4/ctw*
     & *2*vpata**2/mz**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +b0fqstptp*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mtp**2+1d0/4/ctw*
     & *2*vpatp**2/mz**2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mtp**2)
     & +b0fqsbtbt*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mbt**2+1d0/4/ctw*
     & *2*vpabt**2/mz**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +b0fqscc/vpael*(-3d0/2-ctw**2)
     & +b0fqscc*vpael**2*(-5d0/4/ctw**2)
     & +dreal(b0pzww)*qel/vpael*(-50d0/3*stw**2*mz**2+82d0/3*stw**4*mz**
     & 2-8*stw**6*mz**2+1d0/6/ctw**2*mz**2-1d0/6*mz**2)
     & +dreal(b0pzww)/vpael*(1d0/12/ctw**2*mz**2-17d0/3*ctw**2*mz**2-4*c
     & tw**4*mz**2+4d0/3*mz**2)
     & +dreal(b0pzww)*(1d0/8/ctw**2*mz**2-17d0/2*ctw**2*mz**2-6*ctw**4*m
     & z**2+2*mz**2)
     & +dreal(b0pzzh)*qel/vpael*(1d0/6/ctw**2/mz**2*mh**4+2/ctw**2*mz**2
     & -2d0/3/ctw**2*mh**2-1d0/6/mz**2*mh**4-2*mz**2+2d0/3*mh**2)
     & +dreal(b0pzzh)/vpael*(1d0/12/ctw**2/mz**2*mh**4+1d0/ctw**2*mz**2-
     & 1d0/3/ctw**2*mh**2)
     & +dreal(b0pzzh)*(1d0/8/ctw**2/mz**2*mh**4+3d0/2/ctw**2*mz**2-1d0/2
     & /ctw**2*mh**2)
     & +dreal(b0phww)*(1d0/8/ctw**2/mz**2*mh**4+3d0/2*ctw**2*mz**2-1d0/2
     & *mh**2)
     & +dreal(b0phzz)*(1d0/16/ctw**2/mz**2*mh**4+3d0/4/ctw**2*mz**2-1d0/
     & 4/ctw**2*mh**2)
     & +dreal(b0phhh)*(9d0/16/ctw**2/mz**2*mh**4)
     & +dreal(b0pccz)*vpael**2*(-1d0/4/ctw**2*mz**2)
     & +dreal(b0pccz)*vmael**2*(-1d0/4/ctw**2*mz**2)
     & +53d0/36+1d0/stw*ctw*zmsqrfer+3d0/4/ctw**2/mz**2*mh**2-1d0/2/ctw*
     & *2*mz**2/mh**2+1d0/12/ctw**2+ctw**2/mz**2*mh**2-ctw**2*mz**2/mh**
     & 2+2d0/3*ctw**2+2*ctw**4-1d0/mz**2*mh**2-za1bos+zmzzzbos-1d0/2*zmw
     & zwbos-1d0/2*deltarhobos-za1fer+zmzzzfer-1d0/2*zmwzwfer-1d0/2*delt
     & arhofer+3d0/2*zz1fer+1d0/2*zh1fer

      ffgp1=
     & +vpael*(3d0/2/ctw**2/mz**2+2*ctw**2/mz**2-2/mz**2)
     & +propizqs*qel/qs*(2*stw**2/mz**2-4*stw**4/mz**2)
     & +propizqs*det3izhqs*qel*cfl/qs*(stw**2*qmo*vpamo/mz**2*mh**2*mmo*
     & *2-stw**2*qmo*vpamo*mmo**2+stw**2*qmo*vmamo/mz**2*mh**2*mmo**2-st
     & w**2*qmo*vmamo*mmo**2+stw**2*qta*vpata/mz**2*mh**2*mta**2-stw**2*
     & qta*vpata*mta**2+stw**2*qta*vmata/mz**2*mh**2*mta**2-stw**2*qta*v
     & mata*mta**2)
     & +propizqs*det3izhqs*qel*cfl*(stw**2*qmo*vpamo/mz**2*mmo**2+stw**2
     & *qmo*vmamo/mz**2*mmo**2+stw**2*qta*vpata/mz**2*mta**2+stw**2*qta*
     & vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*qel*cfq/qs*(stw**2*qch*vpach/mz**2*mh**2*mch*
     & *2-stw**2*qch*vpach*mch**2+stw**2*qch*vmach/mz**2*mh**2*mch**2-st
     & w**2*qch*vmach*mch**2+stw**2*qst*vpast/mz**2*mh**2*mst**2-stw**2*
     & qst*vpast*mst**2+stw**2*qst*vmast/mz**2*mh**2*mst**2-stw**2*qst*v
     & mast*mst**2+stw**2*qtp*vpatp/mz**2*mh**2*mtp**2-stw**2*qtp*vpatp*
     & mtp**2+stw**2*qtp*vmatp/mz**2*mh**2*mtp**2-stw**2*qtp*vmatp*mtp**
     & 2+stw**2*qbt*vpabt/mz**2*mh**2*mbt**2-stw**2*qbt*vpabt*mbt**2+stw
     & **2*qbt*vmabt/mz**2*mh**2*mbt**2-stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*qel*cfq*(stw**2*qch*vpach/mz**2*mch**2+stw**2
     & *qch*vmach/mz**2*mch**2+stw**2*qst*vpast/mz**2*mst**2+stw**2*qst*
     & vmast/mz**2*mst**2+stw**2*qtp*vpatp/mz**2*mtp**2+stw**2*qtp*vmatp
     & /mz**2*mtp**2+stw**2*qbt*vpabt/mz**2*mbt**2+stw**2*qbt*vmabt/mz**
     & 2*mbt**2)
     & +propizqs*det3izhqs*qel/qs*(11d0/2*stw**2*mz**2-11d0/2*stw**2*mh*
     & *2-12*stw**4*mz**2+12*stw**4*mh**2+6*stw**6*mz**2-6*stw**6*mh**2)
     & 
     & +propizqs*det3izhqs*qel*qs*(1d0/2*stw**2/mz**2-stw**4/mz**2)
     & +propizqs*det3izhqs*qel*(1d0/2*stw**2/mz**2*mh**2-4*stw**2-stw**4
     & /mz**2*mh**2+9*stw**4-6*stw**6)
     & +propizqs*det3izhqs*vpael*cfl*(1d0/4/ctw**2*vpamo**2/mz**2*mmo**2
     & +1d0/4/ctw**2*vmamo**2/mz**2*mmo**2+1d0/4/ctw**2*vpata**2/mz**2*m
     & ta**2+1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*vpael*cfq*(1d0/4/ctw**2*vpach**2/mz**2*mch**2
     & +1d0/4/ctw**2*vmach**2/mz**2*mch**2+1d0/4/ctw**2*vpast**2/mz**2*m
     & st**2+1d0/4/ctw**2*vmast**2/mz**2*mst**2+1d0/4/ctw**2*vpatp**2/mz
     & **2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mtp**2+1d0/4/ctw**2*vpabt*
     & *2/mz**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*vpael*qs*(3d0/8/ctw**2/mz**2+1d0/2*ctw**2/mz*
     & *2-1d0/2/mz**2)
     & +propizqs*det3izhqs*vpael*(-3d0/4+3d0/8/ctw**2/mz**2*mh**2+1d0/4/
     & ctw**2+1d0/2*ctw**2/mz**2*mh**2+3d0/2*ctw**2-3*ctw**4-1d0/2/mz**2
     & *mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qel*qs*(15d0/2*stw**2*mz**2*mh**
     & 2+3d0/4*stw**2*mh**4-33d0/2*stw**4*mz**2*mh**2-3d0/2*stw**4*mh**4
     & +9*stw**6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qel*(27d0/4*stw**2*mz**2*mh**4-1
     & 5d0/2*stw**2*mz**4*mh**2+3d0/4*stw**2*mh**6-15*stw**4*mz**2*mh**4
     & +33d0/2*stw**4*mz**4*mh**2-3d0/2*stw**4*mh**6+9*stw**6*mz**2*mh**
     & 4-9*stw**6*mz**4*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*vpael*qs*(3d0/16/ctw**2*mz**2*mh
     & **2+3d0/8/ctw**2*mz**4+3d0/16/ctw**2*mh**4-3d0/4*ctw**2*mz**2*mh*
     & *2+3d0/4*ctw**2*mh**4+9d0/2*ctw**4*mz**2*mh**2+9d0/2*ctw**4*mz**4
     & -3d0/8*mz**2*mh**2-9d0/8*mz**4-3d0/4*mh**4)
     & +propizqs*det3izhqs**2*c0zhqswww*vpael*(15d0/16/ctw**2*mz**4*mh**
     & 2+3d0/8/ctw**2*mz**6+3d0/16/ctw**2*mh**6-3d0/2*ctw**2*mz**2*mh**4
     & +15d0/4*ctw**2*mz**4*mh**2+3d0/4*ctw**2*mh**6+9d0/2*ctw**4*mz**2*
     & mh**4+9d0/2*ctw**4*mz**6+3d0/8*mz**2*mh**4-15d0/4*mz**4*mh**2-9d0
     & /8*mz**6-3d0/4*mh**6)
     & +propizqs*det3izhqs**2*c0zhqszhh*vpael*qs*(9d0/32/ctw**2/mz**2*mh
     & **6+9d0/16/ctw**2*mz**2*mh**2+9d0/4/ctw**2*mz**4+9d0/32/ctw**2*mh
     & **4)
     & +propizqs*det3izhqs**2*c0zhqszhh*vpael*(9d0/32/ctw**2/mz**2*mh**8
     & +45d0/32/ctw**2*mz**2*mh**4+81d0/16/ctw**2*mz**4*mh**2+9d0/4/ctw*
     & *2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqshzz*vpael*qs*(3d0/32/ctw**2/mz**2*mh
     & **6+9d0/8/ctw**2*mz**2*mh**2+39d0/8/ctw**2*mz**4+9d0/32/ctw**2*mh
     & **4)
     & +propizqs*det3izhqs**2*c0zhqshzz*vpael*(3d0/32/ctw**2/mz**2*mh**8
     & +87d0/32/ctw**2*mz**2*mh**4+75d0/8/ctw**2*mz**4*mh**2+39d0/8/ctw*
     & *2*mz**6+15d0/16/ctw**2*mh**6)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qel*cfl*qs*(-3d0/2*stw**2*qmo
     & *vpamo*mh**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qel*cfl*(3d0/2*stw**2*qmo*vpa
     & mo*mz**2*mh**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**4*mmo**2+3d0/2*s
     & tw**2*qmo*vmamo*mz**2*mh**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**4*m
     & mo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vpael*cfl*qs*(-3d0/8/ctw**2*v
     & pamo**2*mz**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2-3d0/8/ctw
     & **2*vmamo**2*mz**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vpael*cfl*(-3d0/8/ctw**2*vpam
     & o**2*mz**4*mmo**2-3d0/8/ctw**2*vpamo**2*mh**4*mmo**2-3d0/8/ctw**2
     & *vmamo**2*mz**4*mmo**2-3d0/8/ctw**2*vmamo**2*mh**4*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qel*cfq*qs*(-3d0/2*stw**2*qch
     & *vpach*mh**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qel*cfq*(3d0/2*stw**2*qch*vpa
     & ch*mz**2*mh**2*mch**2-3d0/2*stw**2*qch*vpach*mh**4*mch**2+3d0/2*s
     & tw**2*qch*vmach*mz**2*mh**2*mch**2-3d0/2*stw**2*qch*vmach*mh**4*m
     & ch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vpael*cfq*qs*(-3d0/8/ctw**2*v
     & pach**2*mz**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2-3d0/8/ctw
     & **2*vmach**2*mz**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vpael*cfq*(-3d0/8/ctw**2*vpac
     & h**2*mz**4*mch**2-3d0/8/ctw**2*vpach**2*mh**4*mch**2-3d0/8/ctw**2
     & *vmach**2*mz**4*mch**2-3d0/8/ctw**2*vmach**2*mh**4*mch**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qel*cfq*qs*(-3d0/2*stw**2*qst
     & *vpast*mh**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qel*cfq*(3d0/2*stw**2*qst*vpa
     & st*mz**2*mh**2*mst**2-3d0/2*stw**2*qst*vpast*mh**4*mst**2+3d0/2*s
     & tw**2*qst*vmast*mz**2*mh**2*mst**2-3d0/2*stw**2*qst*vmast*mh**4*m
     & st**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vpael*cfq*qs*(-3d0/8/ctw**2*v
     & past**2*mz**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2-3d0/8/ctw
     & **2*vmast**2*mz**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vpael*cfq*(-3d0/8/ctw**2*vpas
     & t**2*mz**4*mst**2-3d0/8/ctw**2*vpast**2*mh**4*mst**2-3d0/8/ctw**2
     & *vmast**2*mz**4*mst**2-3d0/8/ctw**2*vmast**2*mh**4*mst**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qel*cfl*qs*(-3d0/2*stw**2*qta
     & *vpata*mh**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qel*cfl*(3d0/2*stw**2*qta*vpa
     & ta*mz**2*mh**2*mta**2-3d0/2*stw**2*qta*vpata*mh**4*mta**2+3d0/2*s
     & tw**2*qta*vmata*mz**2*mh**2*mta**2-3d0/2*stw**2*qta*vmata*mh**4*m
     & ta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vpael*cfl*qs*(-3d0/8/ctw**2*v
     & pata**2*mz**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2-3d0/8/ctw
     & **2*vmata**2*mz**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vpael*cfl*(-3d0/8/ctw**2*vpat
     & a**2*mz**4*mta**2-3d0/8/ctw**2*vpata**2*mh**4*mta**2-3d0/8/ctw**2
     & *vmata**2*mz**4*mta**2-3d0/8/ctw**2*vmata**2*mh**4*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qel*cfq*qs*(-3d0/2*stw**2*qtp
     & *vpatp*mh**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qel*cfq*(3d0/2*stw**2*qtp*vpa
     & tp*mz**2*mh**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**4*mtp**2+3d0/2*s
     & tw**2*qtp*vmatp*mz**2*mh**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**4*m
     & tp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vpael*cfq*qs*(-3d0/8/ctw**2*v
     & patp**2*mz**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2-3d0/8/ctw
     & **2*vmatp**2*mz**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vpael*cfq*(-3d0/8/ctw**2*vpat
     & p**2*mz**4*mtp**2-3d0/8/ctw**2*vpatp**2*mh**4*mtp**2-3d0/8/ctw**2
     & *vmatp**2*mz**4*mtp**2-3d0/8/ctw**2*vmatp**2*mh**4*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qel*cfq*qs*(-3d0/2*stw**2*qbt
     & *vpabt*mh**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qel*cfq*(3d0/2*stw**2*qbt*vpa
     & bt*mz**2*mh**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**4*mbt**2+3d0/2*s
     & tw**2*qbt*vmabt*mz**2*mh**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**4*m
     & bt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vpael*cfq*qs*(-3d0/8/ctw**2*v
     & pabt**2*mz**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2-3d0/8/ctw
     & **2*vmabt**2*mz**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vpael*cfq*(-3d0/8/ctw**2*vpab
     & t**2*mz**4*mbt**2-3d0/8/ctw**2*vpabt**2*mh**4*mbt**2-3d0/8/ctw**2
     & *vmabt**2*mz**4*mbt**2-3d0/8/ctw**2*vmabt**2*mh**4*mbt**2)
     & +propizqs*det3izhqs**2*b0fzww*qel*qs*(15d0/2*stw**2*mz**2+3d0/4*s
     & tw**2*mh**2-33d0/2*stw**4*mz**2-3d0/2*stw**4*mh**2+9*stw**6*mz**2
     & )
     & +propizqs*det3izhqs**2*b0fzww*qel*(33d0/4*stw**2*mz**2*mh**2+15d0
     & /2*stw**2*mz**4+3d0/4*stw**2*mh**4-18*stw**4*mz**2*mh**2-33d0/2*s
     & tw**4*mz**4-3d0/2*stw**4*mh**4+9*stw**6*mz**2*mh**2+9*stw**6*mz**
     & 4)
     & +propizqs*det3izhqs**2*b0fzww*vpael*qs*(3d0/16/ctw**2*mz**2+3d0/1
     & 6/ctw**2*mh**2-3d0/4*ctw**2*mz**2+3d0/4*ctw**2*mh**2+9d0/2*ctw**4
     & *mz**2-3d0/8*mz**2-3d0/4*mh**2)
     & +propizqs*det3izhqs**2*b0fzww*vpael*(3d0/8/ctw**2*mz**2*mh**2+3d0
     & /16/ctw**2*mz**4+3d0/16/ctw**2*mh**4+3d0/4*ctw**2*mz**4+3d0/4*ctw
     & **2*mh**4+9d0/2*ctw**4*mz**2*mh**2-9d0/8*mz**2*mh**2-3d0/4*mz**4-
     & 3d0/4*mh**4)
     & +propizqs*det3izhqs**2*b0fzzh*vpael*qs*(3d0/16/ctw**2*mz**2+3d0/1
     & 6/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fzzh*vpael*(3d0/8/ctw**2*mz**2*mh**2-3d0
     & /16/ctw**2*mz**4-3d0/16/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fzmomo*qel*cfl*qs*(-3d0/2*stw**2*qmo*vpa
     & mo*mmo**2-3d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qel*cfl*(-3d0/2*stw**2*qmo*vpamo*
     & mz**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**2*mmo**2-3d0/2*stw**2*qmo
     & *vmamo*mz**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vpael*cfl*qs*(-3d0/8/ctw**2*vpamo
     & **2*mmo**2-3d0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vpael*cfl*(-3d0/8/ctw**2*vpamo**2
     & *mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzchch*qel*cfq*qs*(-3d0/2*stw**2*qch*vpa
     & ch*mch**2-3d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qel*cfq*(-3d0/2*stw**2*qch*vpach*
     & mz**2*mch**2-3d0/2*stw**2*qch*vpach*mh**2*mch**2-3d0/2*stw**2*qch
     & *vmach*mz**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vpael*cfq*qs*(-3d0/8/ctw**2*vpach
     & **2*mch**2-3d0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vpael*cfq*(-3d0/8/ctw**2*vpach**2
     & *mh**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzstst*qel*cfq*qs*(-3d0/2*stw**2*qst*vpa
     & st*mst**2-3d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qel*cfq*(-3d0/2*stw**2*qst*vpast*
     & mz**2*mst**2-3d0/2*stw**2*qst*vpast*mh**2*mst**2-3d0/2*stw**2*qst
     & *vmast*mz**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vpael*cfq*qs*(-3d0/8/ctw**2*vpast
     & **2*mst**2-3d0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vpael*cfq*(-3d0/8/ctw**2*vpast**2
     & *mh**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fztata*qel*cfl*qs*(-3d0/2*stw**2*qta*vpa
     & ta*mta**2-3d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qel*cfl*(-3d0/2*stw**2*qta*vpata*
     & mz**2*mta**2-3d0/2*stw**2*qta*vpata*mh**2*mta**2-3d0/2*stw**2*qta
     & *vmata*mz**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vpael*cfl*qs*(-3d0/8/ctw**2*vpata
     & **2*mta**2-3d0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vpael*cfl*(-3d0/8/ctw**2*vpata**2
     & *mh**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztptp*qel*cfq*qs*(-3d0/2*stw**2*qtp*vpa
     & tp*mtp**2-3d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qel*cfq*(-3d0/2*stw**2*qtp*vpatp*
     & mz**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**2*mtp**2-3d0/2*stw**2*qtp
     & *vmatp*mz**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vpael*cfq*qs*(-3d0/8/ctw**2*vpatp
     & **2*mtp**2-3d0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vpael*cfq*(-3d0/8/ctw**2*vpatp**2
     & *mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qel*cfq*qs*(-3d0/2*stw**2*qbt*vpa
     & bt*mbt**2-3d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qel*cfq*(-3d0/2*stw**2*qbt*vpabt*
     & mz**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**2*mbt**2-3d0/2*stw**2*qbt
     & *vmabt*mz**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vpael*cfq*qs*(-3d0/8/ctw**2*vpabt
     & **2*mbt**2-3d0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vpael*cfq*(-3d0/8/ctw**2*vpabt**2
     & *mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhww*qel*(-15*stw**2*mz**2*mh**2-3d0/2*s
     & tw**2*mh**4+33*stw**4*mz**2*mh**2+3*stw**4*mh**4-18*stw**6*mz**2*
     & mh**2)
     & +propizqs*det3izhqs**2*b0fhww*vpael*qs*(-3d0/8/ctw**2*mz**2-3d0/2
     & *ctw**2*mz**2+3d0/2*mz**2)
     & +propizqs*det3izhqs**2*b0fhww*vpael*(-3d0/4/ctw**2*mz**2*mh**2-3d
     & 0/8/ctw**2*mz**4-3d0/8/ctw**2*mh**4-3d0/2*ctw**2*mz**4-3d0/2*ctw*
     & *2*mh**4-9*ctw**4*mz**2*mh**2+9d0/4*mz**2*mh**2+3d0/2*mz**4+3d0/2
     & *mh**4)
     & +propizqs*det3izhqs**2*b0fhzz*vpael*qs*(-3d0/32/ctw**2/mz**2*mh**
     & 4-15d0/16/ctw**2*mz**2-9d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhzz*vpael*(-3d0/32/ctw**2/mz**2*mh**6-8
     & 7d0/32/ctw**2*mz**2*mh**2-15d0/16/ctw**2*mz**4-3d0/4/ctw**2*mh**4
     & )
     & +propizqs*det3izhqs**2*b0fhhh*vpael*qs*(9d0/32/ctw**2/mz**2*mh**4
     & +9d0/8/ctw**2*mz**2+9d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhhh*vpael*(9d0/32/ctw**2/mz**2*mh**6+81
     & d0/32/ctw**2*mz**2*mh**2+9d0/8/ctw**2*mz**4+9d0/16/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fhmomo*qel*cfl*(3*stw**2*qmo*vpamo*mh**2
     & *mmo**2+3*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhmomo*vpael*cfl*(3d0/4/ctw**2*vpamo**2*
     & mh**2*mmo**2+3d0/4/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhchch*qel*cfq*(3*stw**2*qch*vpach*mh**2
     & *mch**2+3*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhchch*vpael*cfq*(3d0/4/ctw**2*vpach**2*
     & mh**2*mch**2+3d0/4/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhstst*qel*cfq*(3*stw**2*qst*vpast*mh**2
     & *mst**2+3*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhstst*vpael*cfq*(3d0/4/ctw**2*vpast**2*
     & mh**2*mst**2+3d0/4/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhtata*qel*cfl*(3*stw**2*qta*vpata*mh**2
     & *mta**2+3*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtata*vpael*cfl*(3d0/4/ctw**2*vpata**2*
     & mh**2*mta**2+3d0/4/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtptp*qel*cfq*(3*stw**2*qtp*vpatp*mh**2
     & *mtp**2+3*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhtptp*vpael*cfq*(3d0/4/ctw**2*vpatp**2*
     & mh**2*mtp**2+3d0/4/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*qel*cfq*(3*stw**2*qbt*vpabt*mh**2
     & *mbt**2+3*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*vpael*cfq*(3d0/4/ctw**2*vpabt**2*
     & mh**2*mbt**2+3d0/4/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsww*qel*qs*(-15d0/2*stw**2*mz**2-3d0/4
     & *stw**2*mh**2+33d0/2*stw**4*mz**2+3d0/2*stw**4*mh**2-9*stw**6*mz*
     & *2)
     & +propizqs*det3izhqs**2*b0fqsww*qel*(27d0/4*stw**2*mz**2*mh**2-15d
     & 0/2*stw**2*mz**4+3d0/4*stw**2*mh**4-15*stw**4*mz**2*mh**2+33d0/2*
     & stw**4*mz**4-3d0/2*stw**4*mh**4+9*stw**6*mz**2*mh**2-9*stw**6*mz*
     & *4)
     & +propizqs*det3izhqs**2*b0fqsww*vpael*qs*(3d0/16/ctw**2*mz**2-3d0/
     & 16/ctw**2*mh**2+9d0/4*ctw**2*mz**2-3d0/4*ctw**2*mh**2-9d0/2*ctw**
     & 4*mz**2-9d0/8*mz**2+3d0/4*mh**2)
     & +propizqs*det3izhqs**2*b0fqsww*vpael*(3d0/8/ctw**2*mz**2*mh**2+3d
     & 0/16/ctw**2*mz**4+3d0/16/ctw**2*mh**4+3d0/4*ctw**2*mz**4+3d0/4*ct
     & w**2*mh**4+9d0/2*ctw**4*mz**2*mh**2-9d0/8*mz**2*mh**2-3d0/4*mz**4
     & -3d0/4*mh**4)
     & +propizqs*det3izhqs**2*b0fqszh*vpael*qs*(-3d0/16/ctw**2/mz**2*mh*
     & *4-3d0/8/ctw**2*mz**2-3d0/16/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqszh*vpael*(-3d0/16/ctw**2/mz**2*mh**6-
     & 3d0/16/ctw**2*mz**2*mh**2+3d0/8/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fqsmomo*qel*cfl*qs*(3d0/2*stw**2*qmo*vpa
     & mo*mmo**2+3d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qel*cfl*(3d0/2*stw**2*qmo*vpamo*
     & mz**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**2*mmo**2+3d0/2*stw**2*qmo
     & *vmamo*mz**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vpael*cfl*qs*(3d0/8/ctw**2*vpamo
     & **2*mmo**2+3d0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vpael*cfl*(-3d0/8/ctw**2*vpamo**
     & 2*mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqschch*qel*cfq*qs*(3d0/2*stw**2*qch*vpa
     & ch*mch**2+3d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qel*cfq*(3d0/2*stw**2*qch*vpach*
     & mz**2*mch**2-3d0/2*stw**2*qch*vpach*mh**2*mch**2+3d0/2*stw**2*qch
     & *vmach*mz**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vpael*cfq*qs*(3d0/8/ctw**2*vpach
     & **2*mch**2+3d0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vpael*cfq*(-3d0/8/ctw**2*vpach**
     & 2*mh**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qel*cfq*qs*(3d0/2*stw**2*qst*vpa
     & st*mst**2+3d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qel*cfq*(3d0/2*stw**2*qst*vpast*
     & mz**2*mst**2-3d0/2*stw**2*qst*vpast*mh**2*mst**2+3d0/2*stw**2*qst
     & *vmast*mz**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vpael*cfq*qs*(3d0/8/ctw**2*vpast
     & **2*mst**2+3d0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vpael*cfq*(-3d0/8/ctw**2*vpast**
     & 2*mh**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqstata*qel*cfl*qs*(3d0/2*stw**2*qta*vpa
     & ta*mta**2+3d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qel*cfl*(3d0/2*stw**2*qta*vpata*
     & mz**2*mta**2-3d0/2*stw**2*qta*vpata*mh**2*mta**2+3d0/2*stw**2*qta
     & *vmata*mz**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vpael*cfl*qs*(3d0/8/ctw**2*vpata
     & **2*mta**2+3d0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vpael*cfl*(-3d0/8/ctw**2*vpata**
     & 2*mh**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qel*cfq*qs*(3d0/2*stw**2*qtp*vpa
     & tp*mtp**2+3d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qel*cfq*(3d0/2*stw**2*qtp*vpatp*
     & mz**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**2*mtp**2+3d0/2*stw**2*qtp
     & *vmatp*mz**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vpael*cfq*qs*(3d0/8/ctw**2*vpatp
     & **2*mtp**2+3d0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vpael*cfq*(-3d0/8/ctw**2*vpatp**
     & 2*mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qel*cfq*qs*(3d0/2*stw**2*qbt*vpa
     & bt*mbt**2+3d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qel*cfq*(3d0/2*stw**2*qbt*vpabt*
     & mz**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**2*mbt**2+3d0/2*stw**2*qbt
     & *vmabt*mz**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vpael*cfq*qs*(3d0/8/ctw**2*vpabt
     & **2*mbt**2+3d0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vpael*cfq*(-3d0/8/ctw**2*vpabt**
     & 2*mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqswww*qel/qs*(11*stw**2*mz**2*mh**2-11*st
     & w**2*mz**4-35*stw**4*mz**2*mh**2+35*stw**4*mz**4+36*stw**6*mz**2*
     & mh**2-36*stw**6*mz**4-12*stw**8*mz**2*mh**2+12*stw**8*mz**4)
     & +propizqs*det3izhqs*c0zhqswww*qel*qs*(-stw**2+3*stw**4-2*stw**6)
     & +propizqs*det3izhqs*c0zhqswww*qel*(18*stw**2*mz**2-48*stw**4*mz**
     & 2+stw**4*mh**2+42*stw**6*mz**2-2*stw**6*mh**2-12*stw**8*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*vpael*qs*(-3d0/4+ctw**2-ctw**4)
     & +propizqs*det3izhqs*c0zhqswww*vpael*(1d0/4/ctw**2*mh**2-1d0/2*ctw
     & **2*mz**2+2*ctw**2*mh**2+3*ctw**4*mz**2-ctw**4*mh**2+6*ctw**6*mz*
     & *2-1d0/4*mz**2-7d0/4*mh**2)
     & +propizqs*det3izhqs*c0zhqszhh*vpael*qs*(-3d0/4/ctw**2/mz**2*mh**2
     & -21d0/8/ctw**2)
     & +propizqs*det3izhqs*c0zhqszhh*vpael*(-3d0/4/ctw**2/mz**2*mh**4-21
     & d0/8/ctw**2*mz**2-6/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqshzz*vpael*qs*(-3d0/8/ctw**2/mz**2*mh**2
     & -7d0/2/ctw**2)
     & +propizqs*det3izhqs*c0zhqshzz*vpael*(-7d0/8/ctw**2/mz**2*mh**4-11
     & d0/4/ctw**2*mz**2-7/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*qel*cfl/qs*(-2*stw**2*qmo*vpamo/
     & mz**2*mh**2*mmo**4+2*stw**2*qmo*vpamo*mmo**4-2*stw**2*qmo*vmamo/m
     & z**2*mh**2*mmo**4+2*stw**2*qmo*vmamo*mmo**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*qel*cfl*(-2*stw**2*qmo*vpamo/mz*
     & *2*mmo**4-2*stw**2*qmo*vpamo*mmo**2-2*stw**2*qmo*vmamo/mz**2*mmo*
     & *4-2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vpael*cfl*qs*(-1d0/4/ctw**2*vpam
     & o*vmamo/mz**2*mmo**2+1d0/8/ctw**2*vpamo**2/mz**2*mmo**2+1d0/8/ctw
     & **2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vpael*cfl*(-1d0/4/ctw**2*vpamo*v
     & mamo/mz**2*mh**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo*mmo**2+1d0/8/ctw
     & **2*vpamo**2/mz**2*mh**2*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mmo**
     & 4-3d0/8/ctw**2*vpamo**2*mmo**2+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*
     & mmo**2-1d0/2/ctw**2*vmamo**2/mz**2*mmo**4-3d0/8/ctw**2*vmamo**2*m
     & mo**2)
     & +propizqs*det3izhqs*c0zhqschchch*qel*cfq/qs*(-2*stw**2*qch*vpach/
     & mz**2*mh**2*mch**4+2*stw**2*qch*vpach*mch**4-2*stw**2*qch*vmach/m
     & z**2*mh**2*mch**4+2*stw**2*qch*vmach*mch**4)
     & +propizqs*det3izhqs*c0zhqschchch*qel*cfq*(-2*stw**2*qch*vpach/mz*
     & *2*mch**4-2*stw**2*qch*vpach*mch**2-2*stw**2*qch*vmach/mz**2*mch*
     & *4-2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vpael*cfq*qs*(-1d0/4/ctw**2*vpac
     & h*vmach/mz**2*mch**2+1d0/8/ctw**2*vpach**2/mz**2*mch**2+1d0/8/ctw
     & **2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vpael*cfq*(-1d0/4/ctw**2*vpach*v
     & mach/mz**2*mh**2*mch**2-1d0/4/ctw**2*vpach*vmach*mch**2+1d0/8/ctw
     & **2*vpach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mch**
     & 4-3d0/8/ctw**2*vpach**2*mch**2+1d0/8/ctw**2*vmach**2/mz**2*mh**2*
     & mch**2-1d0/2/ctw**2*vmach**2/mz**2*mch**4-3d0/8/ctw**2*vmach**2*m
     & ch**2)
     & +propizqs*det3izhqs*c0zhqsststst*qel*cfq/qs*(-2*stw**2*qst*vpast/
     & mz**2*mh**2*mst**4+2*stw**2*qst*vpast*mst**4-2*stw**2*qst*vmast/m
     & z**2*mh**2*mst**4+2*stw**2*qst*vmast*mst**4)
     & +propizqs*det3izhqs*c0zhqsststst*qel*cfq*(-2*stw**2*qst*vpast/mz*
     & *2*mst**4-2*stw**2*qst*vpast*mst**2-2*stw**2*qst*vmast/mz**2*mst*
     & *4-2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*vpael*cfq*qs*(-1d0/4/ctw**2*vpas
     & t*vmast/mz**2*mst**2+1d0/8/ctw**2*vpast**2/mz**2*mst**2+1d0/8/ctw
     & **2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*vpael*cfq*(-1d0/4/ctw**2*vpast*v
     & mast/mz**2*mh**2*mst**2-1d0/4/ctw**2*vpast*vmast*mst**2+1d0/8/ctw
     & **2*vpast**2/mz**2*mh**2*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mst**
     & 4-3d0/8/ctw**2*vpast**2*mst**2+1d0/8/ctw**2*vmast**2/mz**2*mh**2*
     & mst**2-1d0/2/ctw**2*vmast**2/mz**2*mst**4-3d0/8/ctw**2*vmast**2*m
     & st**2)
     & +propizqs*det3izhqs*c0zhqstatata*qel*cfl/qs*(-2*stw**2*qta*vpata/
     & mz**2*mh**2*mta**4+2*stw**2*qta*vpata*mta**4-2*stw**2*qta*vmata/m
     & z**2*mh**2*mta**4+2*stw**2*qta*vmata*mta**4)
     & +propizqs*det3izhqs*c0zhqstatata*qel*cfl*(-2*stw**2*qta*vpata/mz*
     & *2*mta**4-2*stw**2*qta*vpata*mta**2-2*stw**2*qta*vmata/mz**2*mta*
     & *4-2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vpael*cfl*qs*(-1d0/4/ctw**2*vpat
     & a*vmata/mz**2*mta**2+1d0/8/ctw**2*vpata**2/mz**2*mta**2+1d0/8/ctw
     & **2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vpael*cfl*(-1d0/4/ctw**2*vpata*v
     & mata/mz**2*mh**2*mta**2-1d0/4/ctw**2*vpata*vmata*mta**2+1d0/8/ctw
     & **2*vpata**2/mz**2*mh**2*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mta**
     & 4-3d0/8/ctw**2*vpata**2*mta**2+1d0/8/ctw**2*vmata**2/mz**2*mh**2*
     & mta**2-1d0/2/ctw**2*vmata**2/mz**2*mta**4-3d0/8/ctw**2*vmata**2*m
     & ta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qel*cfq/qs*(-2*stw**2*qtp*vpatp/
     & mz**2*mh**2*mtp**4+2*stw**2*qtp*vpatp*mtp**4-2*stw**2*qtp*vmatp/m
     & z**2*mh**2*mtp**4+2*stw**2*qtp*vmatp*mtp**4)
     & +propizqs*det3izhqs*c0zhqstptptp*qel*cfq*(-2*stw**2*qtp*vpatp/mz*
     & *2*mtp**4-2*stw**2*qtp*vpatp*mtp**2-2*stw**2*qtp*vmatp/mz**2*mtp*
     & *4-2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vpael*cfq*qs*(-1d0/4/ctw**2*vpat
     & p*vmatp/mz**2*mtp**2+1d0/8/ctw**2*vpatp**2/mz**2*mtp**2+1d0/8/ctw
     & **2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vpael*cfq*(-1d0/4/ctw**2*vpatp*v
     & matp/mz**2*mh**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp*mtp**2+1d0/8/ctw
     & **2*vpatp**2/mz**2*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**
     & 4-3d0/8/ctw**2*vpatp**2*mtp**2+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*
     & mtp**2-1d0/2/ctw**2*vmatp**2/mz**2*mtp**4-3d0/8/ctw**2*vmatp**2*m
     & tp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qel*cfq/qs*(-2*stw**2*qbt*vpabt/
     & mz**2*mh**2*mbt**4+2*stw**2*qbt*vpabt*mbt**4-2*stw**2*qbt*vmabt/m
     & z**2*mh**2*mbt**4+2*stw**2*qbt*vmabt*mbt**4)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qel*cfq*(-2*stw**2*qbt*vpabt/mz*
     & *2*mbt**4-2*stw**2*qbt*vpabt*mbt**2-2*stw**2*qbt*vmabt/mz**2*mbt*
     & *4-2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vpael*cfq*qs*(-1d0/4/ctw**2*vpab
     & t*vmabt/mz**2*mbt**2+1d0/8/ctw**2*vpabt**2/mz**2*mbt**2+1d0/8/ctw
     & **2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vpael*cfq*(-1d0/4/ctw**2*vpabt*v
     & mabt/mz**2*mh**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt*mbt**2+1d0/8/ctw
     & **2*vpabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**
     & 4-3d0/8/ctw**2*vpabt**2*mbt**2+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*
     & mbt**2-1d0/2/ctw**2*vmabt**2/mz**2*mbt**4-3d0/8/ctw**2*vmabt**2*m
     & bt**2)
     & +propizqs*det3izhqs*a0fh*vpael*qs*(-1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*a0fh*vpael*(-1d0/2/ctw**2/mz**2*mh**2-1d0/4/c
     & tw**2)
     & +propizqs*det3izhqs*b0fzww*qel/qs*(5*stw**2*mz**2+1d0/2*stw**2*mh
     & **2-11*stw**4*mz**2-stw**4*mh**2+6*stw**6*mz**2)
     & +propizqs*det3izhqs*b0fzww*vpael*(1d0/2)
     & +propizqs*det3izhqs*b0fzzh*vpael*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fzzh*vpael*(1d0/4/ctw**2/mz**2*mh**2+3d0/8/
     & ctw**2)
     & +propizqs*det3izhqs*b0fzmomo*qel*cfl/qs*(-stw**2*qmo*vpamo*mmo**2
     & -stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*vpael*cfl*(1d0/4/ctw**2*vpamo*vmamo/
     & mz**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mmo**2-1d0/8/ctw**2*vmam
     & o**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*qel*cfq/qs*(-stw**2*qch*vpach*mch**2
     & -stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fzchch*vpael*cfq*(1d0/4/ctw**2*vpach*vmach/
     & mz**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mch**2-1d0/8/ctw**2*vmac
     & h**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzstst*qel*cfq/qs*(-stw**2*qst*vpast*mst**2
     & -stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fzstst*vpael*cfq*(1d0/4/ctw**2*vpast*vmast/
     & mz**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mst**2-1d0/8/ctw**2*vmas
     & t**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fztata*qel*cfl/qs*(-stw**2*qta*vpata*mta**2
     & -stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fztata*vpael*cfl*(1d0/4/ctw**2*vpata*vmata/
     & mz**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mta**2-1d0/8/ctw**2*vmat
     & a**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztptp*qel*cfq/qs*(-stw**2*qtp*vpatp*mtp**2
     & -stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*vpael*cfq*(1d0/4/ctw**2*vpatp*vmatp/
     & mz**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mtp**2-1d0/8/ctw**2*vmat
     & p**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*qel*cfq/qs*(-stw**2*qbt*vpabt*mbt**2
     & -stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*vpael*cfq*(1d0/4/ctw**2*vpabt*vmabt/
     & mz**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mbt**2-1d0/8/ctw**2*vmab
     & t**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhww*qel/qs*(-5*stw**2*mz**2-1d0/2*stw**2*m
     & h**2+11*stw**4*mz**2+stw**4*mh**2-6*stw**6*mz**2)
     & +propizqs*det3izhqs*b0fhww*qel*(1d0/2*stw**2/mz**2*mh**2+5*stw**2
     & -stw**4/mz**2*mh**2-11*stw**4+6*stw**6)
     & +propizqs*det3izhqs*b0fhww*vpael*(1d0/4+1d0/8/ctw**2/mz**2*mh**2+
     & 1d0/2*ctw**2/mz**2*mh**2-ctw**2+3*ctw**4-1d0/2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fhzz*vpael*qs*(1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhzz*vpael*(9d0/16/ctw**2/mz**2*mh**2+3d0/8
     & /ctw**2)
     & +propizqs*det3izhqs*b0fhhh*vpael*qs*(-3d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhhh*vpael*(-21d0/16/ctw**2/mz**2*mh**2-3d0
     & /4/ctw**2)
     & +propizqs*det3izhqs*b0fhmomo*qel*cfl/qs*(stw**2*qmo*vpamo*mmo**2+
     & stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qel*cfl*(-stw**2*qmo*vpamo/mz**2*mmo
     & **2-stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*vpael*cfl*(-1d0/4/ctw**2*vpamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*qel*cfq/qs*(stw**2*qch*vpach*mch**2+
     & stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qel*cfq*(-stw**2*qch*vpach/mz**2*mch
     & **2-stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*vpael*cfq*(-1d0/4/ctw**2*vpach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*qel*cfq/qs*(stw**2*qst*vpast*mst**2+
     & stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qel*cfq*(-stw**2*qst*vpast/mz**2*mst
     & **2-stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*vpael*cfq*(-1d0/4/ctw**2*vpast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*qel*cfl/qs*(stw**2*qta*vpata*mta**2+
     & stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qel*cfl*(-stw**2*qta*vpata/mz**2*mta
     & **2-stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*vpael*cfl*(-1d0/4/ctw**2*vpata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*qel*cfq/qs*(stw**2*qtp*vpatp*mtp**2+
     & stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qel*cfq*(-stw**2*qtp*vpatp/mz**2*mtp
     & **2-stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*vpael*cfq*(-1d0/4/ctw**2*vpatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel*cfq/qs*(stw**2*qbt*vpabt*mbt**2+
     & stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel*cfq*(-stw**2*qbt*vpabt/mz**2*mbt
     & **2-stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*vpael*cfq*(-1d0/4/ctw**2*vpabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*qel*(-1d0/2*stw**2/mz**2*mh**2-5*stw*
     & *2+stw**4/mz**2*mh**2+11*stw**4-6*stw**6)
     & +propizqs*det3izhqs*b0fqsww*vpael*(-3d0/4-1d0/8/ctw**2/mz**2*mh**
     & 2-1d0/2*ctw**2/mz**2*mh**2+ctw**2-3*ctw**4+1d0/2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fqszh*vpael*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fqszh*vpael*(-1d0/4/ctw**2)
     & +propizqs*det3izhqs*b0fqsmomo*qel*cfl*(stw**2*qmo*vpamo/mz**2*mmo
     & **2+stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*vpael*cfl*(-1d0/4/ctw**2*vpamo*vmam
     & o/mz**2*mmo**2+3d0/8/ctw**2*vpamo**2/mz**2*mmo**2+3d0/8/ctw**2*vm
     & amo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*qel*cfq*(stw**2*qch*vpach/mz**2*mch
     & **2+stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*vpael*cfq*(-1d0/4/ctw**2*vpach*vmac
     & h/mz**2*mch**2+3d0/8/ctw**2*vpach**2/mz**2*mch**2+3d0/8/ctw**2*vm
     & ach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*qel*cfq*(stw**2*qst*vpast/mz**2*mst
     & **2+stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*vpael*cfq*(-1d0/4/ctw**2*vpast*vmas
     & t/mz**2*mst**2+3d0/8/ctw**2*vpast**2/mz**2*mst**2+3d0/8/ctw**2*vm
     & ast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*qel*cfl*(stw**2*qta*vpata/mz**2*mta
     & **2+stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*vpael*cfl*(-1d0/4/ctw**2*vpata*vmat
     & a/mz**2*mta**2+3d0/8/ctw**2*vpata**2/mz**2*mta**2+3d0/8/ctw**2*vm
     & ata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*qel*cfq*(stw**2*qtp*vpatp/mz**2*mtp
     & **2+stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*vpael*cfq*(-1d0/4/ctw**2*vpatp*vmat
     & p/mz**2*mtp**2+3d0/8/ctw**2*vpatp**2/mz**2*mtp**2+3d0/8/ctw**2*vm
     & atp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qel*cfq*(stw**2*qbt*vpabt/mz**2*mbt
     & **2+stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*vpael*cfq*(-1d0/4/ctw**2*vpabt*vmab
     & t/mz**2*mbt**2+3d0/8/ctw**2*vpabt**2/mz**2*mbt**2+3d0/8/ctw**2*vm
     & abt**2/mz**2*mbt**2)
     & +propizqs*sdet3iczus*c0czuswcc/qs*(-2*ctw**4*mz**2)
     & +propizqs*sdet3iczus*c0czuszcc*vpael**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3iczus*c0czuscww*(-4*sdet4izhtsus*ctw**6*mz**4)
     & +propizqs*sdet3iczus*b0fzww*(-4*sdet4izhtsus*ctw**4*mz**2)
     & +propizqs*sdet3iczus*b0fzcc*vpael**3/qs*(1d0/ctw**2)
     & +propizqs*sdet3iczus*b0fzcc/qs*(2*ctw**2)
     & +propizqs*sdet3iczus*b0fuswc/qs*(-2*ctw**2)
     & +propizqs*sdet3iczus*b0fuswc*(4*sdet4izhtsus*ctw**4*mz**2)
     & +propizqs*sdet3iczus*b0fuszc*vpael**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichts*c0chtscww/qs*(-2*ctw**4*mz**2)
     & +propizqs*sdet3ichts*c0chtscww*(4*sdet4izhtsus*ctw**6*mz**2*mh**2
     & )
     & +propizqs*sdet3ichts*c0chtsczz*vpael**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3ichts*b0fhww/qs*(-2*ctw**2)
     & +propizqs*sdet3ichts*b0fhww*(4*sdet4izhtsus*ctw**4*mh**2)
     & +propizqs*sdet3ichts*b0fhzz*vpael**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichts*b0ftswc/qs*(2*ctw**2)
     & +propizqs*sdet3ichts*b0ftswc*(-4*sdet4izhtsus*ctw**4*mh**2)
     & +propizqs*sdet3ichts*b0ftszc*vpael**3/qs*(1d0/ctw**2)
     & +propizqs*d0zchctsusccww/qs*(-ctw**2*us-ctw**2*mh**2-ctw**4*mz**2
     & -2*sdet4izhtsus*ctw**4*ts*mz**2*mh**2+2*sdet4izhtsus*ctw**4*ts*mz
     & **4-2*sdet4izhtsus*ctw**4*mz**4*mh**2+2*sdet4izhtsus*ctw**4*mz**6
     & +sdet4izhtsus*ctw**6*mz**4*mh**2-sdet4izhtsus*ctw**6*mz**6+sdet4i
     & zhtsus**2*ctw**6*ts*mz**4*mh**4-2*sdet4izhtsus**2*ctw**6*ts*mz**6
     & *mh**2-sdet4izhtsus**2*ctw**6*us*mz**8+sdet4izhtsus**2*ctw**6*mz*
     & *6*mh**4-3*sdet4izhtsus**2*ctw**6*mz**8*mh**2)
     & +propizqs*d0zchctsusccww*(-ctw**2-2*sdet4izhtsus*ctw**4*ts*mz**2+
     & sdet4izhtsus**2*ctw**6*ts*mz**4*mh**2-sdet4izhtsus**2*ctw**6*ts**
     & 2*mz**4-sdet4izhtsus**2*ctw**6*us*mz**6)
     & +propizqs*d0zchctsuscczz*vpael**3/qs*(-1d0/2/ctw**2*us-1d0/2/ctw*
     & *2*mz**2-1d0/2/ctw**2*mh**2-sdet4izhtsus/ctw**2*ts*mz**2*mh**2+sd
     & et4izhtsus/ctw**2*ts*mz**4-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2+
     & 1d0/2*sdet4izhtsus/ctw**2*mz**6+1d0/2*sdet4izhtsus**2/ctw**2*ts*m
     & z**4*mh**4-sdet4izhtsus**2/ctw**2*ts*mz**6*mh**2-1d0/2*sdet4izhts
     & us**2/ctw**2*us*mz**8+1d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**4-3d
     & 0/2*sdet4izhtsus**2/ctw**2*mz**8*mh**2)
     & +propizqs*d0zchctsuscczz*vpael**3*(-1d0/2/ctw**2-sdet4izhtsus/ctw
     & **2*ts*mz**2+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2-1d0/2*sd
     & et4izhtsus**2/ctw**2*ts**2*mz**4-1d0/2*sdet4izhtsus**2/ctw**2*us*
     & mz**6)
     & +propizqs*d0cczhqstswcww/qs*(-2*sdet4izhtsus*ctw**6*ts*mz**2*mh**
     & 2+2*sdet4izhtsus*ctw**6*ts*mz**4-2*sdet4izhtsus*ctw**6*mz**4*mh**
     & 2+2*sdet4izhtsus*ctw**6*mz**6+2*sdet4izhtsus*ctw**8*mz**4*mh**2-2
     & *sdet4izhtsus*ctw**8*mz**6+2*sdet4izhtsus**2*ctw**8*ts*mz**4*mh**
     & 4-4*sdet4izhtsus**2*ctw**8*ts*mz**6*mh**2+2*sdet4izhtsus**2*ctw**
     & 8*ts*mz**8+2*sdet4izhtsus**2*ctw**8*mz**6*mh**4-4*sdet4izhtsus**2
     & *ctw**8*mz**8*mh**2+2*sdet4izhtsus**2*ctw**8*mz**10)
     & +propizqs*d0cczhqstswcww*(-4*sdet4izhtsus*ctw**6*ts*mz**2-2*sdet4
     & izhtsus*ctw**6*mz**4-2*sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2-4*sd
     & et4izhtsus**2*ctw**4*ts**2*mz**2*mh**2-2*sdet4izhtsus**2*ctw**4*t
     & s**2*mz**4-4*sdet4izhtsus**2*ctw**4*ts**3*mz**2-2*sdet4izhtsus**2
     & *ctw**4*ts**3*mh**2-2*sdet4izhtsus**2*ctw**4*ts**4-4*sdet4izhtsus
     & **2*ctw**6*ts*mz**4*mh**2+4*sdet4izhtsus**2*ctw**6*ts**2*mz**4+4*
     & sdet4izhtsus**2*ctw**6*ts**3*mz**2-4*sdet4izhtsus**2*ctw**6*mz**6
     & *mh**2+2*sdet4izhtsus**2*ctw**8*ts*mz**4*mh**2-2*sdet4izhtsus**2*
     & ctw**8*ts**2*mz**4-2*sdet4izhtsus**2*ctw**8*us*mz**6+2*sdet4izhts
     & us**2*ctw**8*mz**8)
     & +propizqs*d0cchzqsuswcww/qs*(-sdet4izhtsus*ctw**4*us*mz**2*mh**2+
     & sdet4izhtsus*ctw**4*us*mz**4-sdet4izhtsus*ctw**4*mz**2*mh**4+sdet
     & 4izhtsus*ctw**4*mz**4*mh**2+2*sdet4izhtsus*ctw**6*us*mz**2*mh**2-
     & 2*sdet4izhtsus*ctw**6*us*mz**4+2*sdet4izhtsus*ctw**6*mz**2*mh**4-
     & 2*sdet4izhtsus*ctw**6*mz**4*mh**2+2*sdet4izhtsus*ctw**8*mz**4*mh*
     & *2-2*sdet4izhtsus*ctw**8*mz**6-2*sdet4izhtsus**2*ctw**8*us*mz**4*
     & mh**4+4*sdet4izhtsus**2*ctw**8*us*mz**6*mh**2-2*sdet4izhtsus**2*c
     & tw**8*us*mz**8-2*sdet4izhtsus**2*ctw**8*mz**4*mh**6+4*sdet4izhtsu
     & s**2*ctw**8*mz**6*mh**4-2*sdet4izhtsus**2*ctw**8*mz**8*mh**2)
     & +propizqs*d0cchzqsuswcww*(-2*ctw**4-sdet4izhtsus*ctw**2*us*mh**2-
     & sdet4izhtsus*ctw**2*us**2-3*sdet4izhtsus*ctw**4*us*mz**2-5*sdet4i
     & zhtsus*ctw**4*mz**2*mh**2-4*sdet4izhtsus*ctw**6*ts*mz**2+2*sdet4i
     & zhtsus*ctw**6*mz**2*mh**2-4*sdet4izhtsus*ctw**6*mz**4-2*sdet4izht
     & sus**2*ctw**4*us*mz**2*mh**4-4*sdet4izhtsus**2*ctw**4*us*mz**4*mh
     & **2-4*sdet4izhtsus**2*ctw**4*us**2*mz**2*mh**2-2*sdet4izhtsus**2*
     & ctw**4*us**2*mz**4-2*sdet4izhtsus**2*ctw**4*us**3*mz**2-2*sdet4iz
     & htsus**2*ctw**4*mz**4*mh**4-4*sdet4izhtsus**2*ctw**6*ts*mz**4*mh*
     & *2+4*sdet4izhtsus**2*ctw**6*us*mz**4*mh**2+4*sdet4izhtsus**2*ctw*
     & *6*us**2*mz**4-4*sdet4izhtsus**2*ctw**6*mz**6*mh**2+2*sdet4izhtsu
     & s**2*ctw**8*ts*mz**4*mh**2-2*sdet4izhtsus**2*ctw**8*ts**2*mz**4-2
     & *sdet4izhtsus**2*ctw**8*us*mz**6-2*sdet4izhtsus**2*ctw**8*mz**4*m
     & h**4+4*sdet4izhtsus**2*ctw**8*mz**6*mh**2)
     & +propizqs*c0zhqswww*qel/qs*(20*stw**2-44*stw**4+24*stw**6)
     & +propizqs*c0zhqswww/qs*(sdet4izhtsus*ctw**2*us*mz**2-sdet4izhtsus
     & *ctw**2*us*mh**2+sdet4izhtsus*ctw**2*mz**2*mh**2-sdet4izhtsus*ctw
     & **2*mh**4+2*sdet4izhtsus*ctw**4*ts*mz**2-2*sdet4izhtsus*ctw**4*ts
     & *mh**2-2*sdet4izhtsus*ctw**4*us*mz**2+2*sdet4izhtsus*ctw**4*us*mh
     & **2-4*sdet4izhtsus*ctw**4*mz**2*mh**2+2*sdet4izhtsus*ctw**4*mz**4
     & +2*sdet4izhtsus*ctw**4*mh**4+4*sdet4izhtsus*ctw**6*mz**2*mh**2-4*
     & sdet4izhtsus*ctw**6*mz**4+2*sdet4izhtsus**2*ctw**6*ts*mz**2*mh**4
     & -4*sdet4izhtsus**2*ctw**6*ts*mz**4*mh**2+2*sdet4izhtsus**2*ctw**6
     & *ts*mz**6-2*sdet4izhtsus**2*ctw**6*us*mz**2*mh**4+4*sdet4izhtsus*
     & *2*ctw**6*us*mz**4*mh**2-2*sdet4izhtsus**2*ctw**6*us*mz**6-2*sdet
     & 4izhtsus**2*ctw**6*mz**2*mh**6+6*sdet4izhtsus**2*ctw**6*mz**4*mh*
     & *4-6*sdet4izhtsus**2*ctw**6*mz**6*mh**2+2*sdet4izhtsus**2*ctw**6*
     & mz**8)
     & +propizqs*c0zhqswww*(sdet4izhtsus*ctw**2*us-sdet4izhtsus*ctw**2*m
     & h**2-2*sdet4izhtsus*ctw**4*ts+2*sdet4izhtsus*ctw**4*mz**2+2*sdet4
     & izhtsus*ctw**4*mh**2-4*sdet4izhtsus**2*ctw**4*ts*mz**2*mh**2+2*sd
     & et4izhtsus**2*ctw**4*ts**2*mz**2+2*sdet4izhtsus**2*ctw**4*ts**3+2
     & *sdet4izhtsus**2*ctw**4*us*mz**2*mh**2+2*sdet4izhtsus**2*ctw**4*u
     & s**2*mz**2-4*sdet4izhtsus**2*ctw**4*mz**4*mh**2+4*sdet4izhtsus**2
     & *ctw**6*ts*mz**2*mh**2-4*sdet4izhtsus**2*ctw**6*ts**2*mz**2-4*sde
     & t4izhtsus**2*ctw**6*us*mz**4-2*sdet4izhtsus**2*ctw**6*mz**2*mh**4
     & +4*sdet4izhtsus**2*ctw**6*mz**4*mh**2+2*sdet4izhtsus**2*ctw**6*mz
     & **6)
     & +propizqs*c0zhqsmomomo*qel*cfl/qs*(-2*stw**2*qmo*vpamo/mz**2*mmo*
     & *2-2*stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*qel*cfq/qs*(-2*stw**2*qch*vpach/mz**2*mch*
     & *2-2*stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*qel*cfq/qs*(-2*stw**2*qst*vpast/mz**2*mst*
     & *2-2*stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*qel*cfl/qs*(-2*stw**2*qta*vpata/mz**2*mta*
     & *2-2*stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*qel*cfq/qs*(-2*stw**2*qtp*vpatp/mz**2*mtp*
     & *2-2*stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*qel*cfq/qs*(-2*stw**2*qbt*vpabt/mz**2*mbt*
     & *2-2*stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*c0cztswcc/qs*(ctw**2-sdet4izhtsus*ctw**2*ts*mz**2+sdet4
     & izhtsus*ctw**2*ts*mh**2+sdet4izhtsus*ctw**2*mz**2*mh**2-sdet4izht
     & sus*ctw**2*mz**4+sdet4izhtsus*ctw**4*ts*mz**2-sdet4izhtsus*ctw**4
     & *mz**2*mh**2+2*sdet4izhtsus*ctw**4*mz**4-sdet4izhtsus**2*ctw**4*t
     & s*mz**2*mh**4+2*sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2+sdet4izhtsu
     & s**2*ctw**4*us*mz**6-sdet4izhtsus**2*ctw**4*mz**4*mh**4+3*sdet4iz
     & htsus**2*ctw**4*mz**6*mh**2)
     & +propizqs*c0cztswcc*(sdet4izhtsus*ctw**2*ts-sdet4izhtsus**2*ctw**
     & 4*ts*mz**2*mh**2+sdet4izhtsus**2*ctw**4*ts*mz**4+sdet4izhtsus**2*
     & ctw**4*ts**2*mz**2)
     & +propizqs*c0cztszcc*vpael**3/qs*(1d0/2/ctw**2+1d0/2*sdet4izhtsus/
     & ctw**2*ts*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsu
     & s**2/ctw**2*ts*mz**2*mh**4+sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2+
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6-1d0/2*sdet4izhtsus**2/ctw**
     & 2*mz**4*mh**4+3d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2)
     & +propizqs*c0cztszcc*vpael**3*(1d0/2*sdet4izhtsus/ctw**2*ts-1d0/2*
     & sdet4izhtsus**2/ctw**2*ts*mz**2*mh**2+1d0/2*sdet4izhtsus**2/ctw**
     & 2*ts*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*ts**2*mz**2)
     & +propizqs*c0cztscww/qs*(2*ctw**4-2*sdet4izhtsus*ctw**4*ts*mz**2+2
     & *sdet4izhtsus*ctw**4*ts*mh**2+2*sdet4izhtsus*ctw**4*mz**2*mh**2-2
     & *sdet4izhtsus*ctw**4*mz**4+2*sdet4izhtsus*ctw**6*ts*mz**2-2*sdet4
     & izhtsus*ctw**6*mz**2*mh**2+4*sdet4izhtsus*ctw**6*mz**4-2*sdet4izh
     & tsus**2*ctw**6*ts*mz**2*mh**4+4*sdet4izhtsus**2*ctw**6*ts*mz**4*m
     & h**2-2*sdet4izhtsus**2*ctw**6*ts*mz**6-2*sdet4izhtsus**2*ctw**6*m
     & z**4*mh**4+4*sdet4izhtsus**2*ctw**6*mz**6*mh**2-2*sdet4izhtsus**2
     & *ctw**6*mz**8)
     & +propizqs*c0cztscww*(2*sdet4izhtsus*ctw**4*ts-2*sdet4izhtsus**2*c
     & tw**4*ts*mz**4-4*sdet4izhtsus**2*ctw**4*ts**2*mz**2-2*sdet4izhtsu
     & s**2*ctw**4*ts**3-2*sdet4izhtsus**2*ctw**6*ts*mz**2*mh**2+2*sdet4
     & izhtsus**2*ctw**6*ts*mz**4+2*sdet4izhtsus**2*ctw**6*ts**2*mz**2-2
     & *sdet4izhtsus**2*ctw**6*mz**6)
     & +propizqs*c0czuswcc/qs*(-ctw**2+sdet4izhtsus*ctw**2*ts*mz**2+sdet
     & 4izhtsus*ctw**2*us*mz**2+sdet4izhtsus*ctw**2*mz**2*mh**2+sdet4izh
     & tsus*ctw**2*mz**4+sdet4izhtsus*ctw**4*ts*mz**2+sdet4izhtsus*ctw**
     & 4*mz**4)
     & +propizqs*c0czuswcc*(-sdet4izhtsus**2*ctw**4*ts*mz**4+sdet4izhtsu
     & s**2*ctw**4*us*mz**4)
     & +propizqs*c0czuszcc*vpael**3/qs*(-1d0/2/ctw**2+sdet4izhtsus/ctw**
     & 2*ts*mz**2+1d0/2*sdet4izhtsus/ctw**2*us*mz**2+1d0/2*sdet4izhtsus/
     & ctw**2*mz**2*mh**2+sdet4izhtsus/ctw**2*mz**4)
     & +propizqs*c0czuszcc*vpael**3*(-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz
     & **4+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4)
     & +propizqs*c0czuscww/qs*(ctw**2-2*ctw**4+2*sdet4izhtsus*ctw**6*us*
     & mz**2+2*sdet4izhtsus*ctw**6*mz**2*mh**2)
     & +propizqs*c0czuscww*(-sdet4izhtsus*ctw**2*us-2*sdet4izhtsus*ctw**
     & 4*mz**2+2*sdet4izhtsus*ctw**6*mz**2-2*sdet4izhtsus**2*ctw**4*us*m
     & z**2*mh**2-2*sdet4izhtsus**2*ctw**4*us*mz**4-2*sdet4izhtsus**2*ct
     & w**4*us**2*mz**2-2*sdet4izhtsus**2*ctw**4*mz**4*mh**2-2*sdet4izht
     & sus**2*ctw**6*ts*mz**4+2*sdet4izhtsus**2*ctw**6*us*mz**4)
     & +propizqs*c0chtscww/qs*(ctw**2-2*ctw**4-sdet4izhtsus*ctw**4*ts*mz
     & **2-sdet4izhtsus*ctw**4*mz**4-2*sdet4izhtsus*ctw**6*ts*mz**2-2*sd
     & et4izhtsus*ctw**6*mz**4-sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2-sde
     & t4izhtsus**2*ctw**4*us*mz**4*mh**2-sdet4izhtsus**2*ctw**4*mz**4*m
     & h**4-sdet4izhtsus**2*ctw**4*mz**6*mh**2)
     & +propizqs*c0chtscww*(-sdet4izhtsus*ctw**2*ts+2*sdet4izhtsus*ctw**
     & 4*ts-4*sdet4izhtsus*ctw**6*mz**2-2*sdet4izhtsus**2*ctw**4*ts*mz**
     & 2*mh**2-3*sdet4izhtsus**2*ctw**4*ts**2*mz**2-2*sdet4izhtsus**2*ct
     & w**4*ts**2*mh**2-2*sdet4izhtsus**2*ctw**4*ts**3+2*sdet4izhtsus**2
     & *ctw**6*ts**2*mz**2-2*sdet4izhtsus**2*ctw**6*mz**4*mh**2)
     & +propizqs*c0chtsczz*vpael**3/qs*(1d0/2/ctw**2-1d0/2*sdet4izhtsus/
     & ctw**2*ts*mz**2-1d0/2*sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsu
     & s**2/ctw**2*ts*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*
     & mh**2-1d0/2*sdet4izhtsus**2/ctw**2*mz**4*mh**4-1d0/2*sdet4izhtsus
     & **2/ctw**2*mz**6*mh**2)
     & +propizqs*c0chtsczz*vpael**3*(-1d0/2*sdet4izhtsus/ctw**2*ts-1d0/2
     & *sdet4izhtsus**2/ctw**2*ts**2*mz**2)
     & +propizqs*c0chuscww/qs*(-2*ctw**2+2*ctw**4-sdet4izhtsus*ctw**2*ts
     & *mh**2-2*sdet4izhtsus*ctw**2*us*mz**2+sdet4izhtsus*ctw**2*us*mh**
     & 2-3*sdet4izhtsus*ctw**2*mz**2*mh**2+sdet4izhtsus*ctw**2*mh**4-sde
     & t4izhtsus*ctw**4*ts*mz**2+2*sdet4izhtsus*ctw**4*us*mz**2-2*sdet4i
     & zhtsus*ctw**4*us*mh**2+3*sdet4izhtsus*ctw**4*mz**2*mh**2-2*sdet4i
     & zhtsus*ctw**4*mz**4-2*sdet4izhtsus*ctw**4*mh**4-2*sdet4izhtsus*ct
     & w**6*us*mz**2-4*sdet4izhtsus*ctw**6*mz**2*mh**2+2*sdet4izhtsus*ct
     & w**6*mz**4+sdet4izhtsus**2*ctw**4*ts*mz**2*mh**4-sdet4izhtsus**2*
     & ctw**4*ts*mz**4*mh**2+sdet4izhtsus**2*ctw**4*us*mz**4*mh**2-sdet4
     & izhtsus**2*ctw**4*us*mz**6+2*sdet4izhtsus**2*ctw**4*mz**4*mh**4-2
     & *sdet4izhtsus**2*ctw**4*mz**6*mh**2+2*sdet4izhtsus**2*ctw**6*us*m
     & z**2*mh**4-4*sdet4izhtsus**2*ctw**6*us*mz**4*mh**2+2*sdet4izhtsus
     & **2*ctw**6*us*mz**6+2*sdet4izhtsus**2*ctw**6*mz**2*mh**6-4*sdet4i
     & zhtsus**2*ctw**6*mz**4*mh**4+2*sdet4izhtsus**2*ctw**6*mz**6*mh**2
     & )
     & +propizqs*c0chuscww*(-sdet4izhtsus*ctw**2*us-2*sdet4izhtsus*ctw**
     & 4*mh**2-2*sdet4izhtsus*ctw**6*mz**2+sdet4izhtsus**2*ctw**4*ts*mz*
     & *2*mh**2-4*sdet4izhtsus**2*ctw**4*us*mz**2*mh**2-sdet4izhtsus**2*
     & ctw**4*us*mz**4-2*sdet4izhtsus**2*ctw**4*us**2*mz**2-2*sdet4izhts
     & us**2*ctw**4*mz**2*mh**4-2*sdet4izhtsus**2*ctw**6*ts*mz**2*mh**2+
     & 2*sdet4izhtsus**2*ctw**6*us*mz**4+2*sdet4izhtsus**2*ctw**6*mz**2*
     & mh**4-2*sdet4izhtsus**2*ctw**6*mz**4*mh**2)
     & +propizqs*c0chusczz*vpael**3/qs*(-1d0/2/ctw**2-1d0/2*sdet4izhtsus
     & /ctw**2*ts*mz**2-1d0/2*sdet4izhtsus/ctw**2*ts*mh**2-1d0/2*sdet4iz
     & htsus/ctw**2*us*mz**2-1d0/2*sdet4izhtsus/ctw**2*mz**2*mh**2-sdet4
     & izhtsus/ctw**2*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**2*mh**4-
     & 1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2+1d0/2*sdet4izhtsus**2
     & /ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6+sdet
     & 4izhtsus**2/ctw**2*mz**4*mh**4-sdet4izhtsus**2/ctw**2*mz**6*mh**2
     & )
     & +propizqs*c0chusczz*vpael**3*(1d0/2*sdet4izhtsus**2/ctw**2*ts*mz*
     & *2*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4)
     & +propizqs*c0ccqswcw*(sdet4izhtsus*ctw**2*us+sdet4izhtsus*ctw**2*m
     & h**2+2*sdet4izhtsus*ctw**4*ts+4*sdet4izhtsus*ctw**4*mz**2+6*sdet4
     & izhtsus**2*ctw**4*ts*mz**2*mh**2+2*sdet4izhtsus**2*ctw**4*ts*mz**
     & 4+4*sdet4izhtsus**2*ctw**4*ts**2*mz**2+2*sdet4izhtsus**2*ctw**4*t
     & s**2*mh**2+2*sdet4izhtsus**2*ctw**4*ts**3+4*sdet4izhtsus**2*ctw**
     & 4*us*mz**2*mh**2+2*sdet4izhtsus**2*ctw**4*us*mz**4+2*sdet4izhtsus
     & **2*ctw**4*us**2*mz**2+2*sdet4izhtsus**2*ctw**4*mz**2*mh**4+6*sde
     & t4izhtsus**2*ctw**4*mz**4*mh**2)
     & +propizqs*b0fzcc*vpael**3/qs*(-sdet4izhtsus/ctw**2*ts-sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0fzcc/qs*(-2*sdet4izhtsus*ctw**2*ts-2*sdet4izhtsus*ctw
     & **2*mz**2)
     & +propizqs*b0fhww/qs*(-2*sdet4izhtsus*ctw**2*ts-2*sdet4izhtsus*ctw
     & **2*mz**2)
     & +propizqs*b0fhww*(-4*sdet4izhtsus*ctw**4)
     & +propizqs*b0fhzz*vpael**3/qs*(-sdet4izhtsus/ctw**2*ts-sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0ftswc/qs*(2*sdet4izhtsus*ctw**2*ts+2*sdet4izhtsus*ctw
     & **2*mz**2)
     & +propizqs*b0ftswc*(4*sdet4izhtsus*ctw**4)
     & +propizqs*b0ftszc*vpael**3/qs*(sdet4izhtsus/ctw**2*ts+sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0fuswc/qs*(2*sdet4izhtsus*ctw**2*ts+2*sdet4izhtsus*ctw
     & **2*mz**2)
     & +propizqs*b0fuszc*vpael**3/qs*(sdet4izhtsus/ctw**2*ts+sdet4izhtsu
     & s/ctw**2*mz**2)
     & +det3izhqs*vpael*cfl*(1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d
     & 0/2/ctw**2*vpamo**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2*mmo*
     & *2-1d0/2/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2
     & *mta**2-1d0/2/ctw**2*vpata**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*
     & mh**2*mta**2-1d0/2/ctw**2*vmata**2*mta**2)
     & +det3izhqs*vpael*cfq*(1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d
     & 0/2/ctw**2*vpach**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mh**2*mch*
     & *2-1d0/2/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2
     & *mst**2-1d0/2/ctw**2*vpast**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*
     & mh**2*mst**2-1d0/2/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpatp**2/m
     & z**2*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2*mtp**2+1d0/4/ctw**2*vmatp
     & **2/mz**2*mh**2*mtp**2-1d0/2/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*
     & vpabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2*mbt**2+1d0/4/ct
     & w**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vmabt**2*mbt**2)
     & +det3izhqs*vpael*(1d0/4/ctw**2*mz**2-7d0/8/ctw**2*mh**2-2*ctw**2*
     & mz**2+6*ctw**4*mz**2-3*ctw**4*mh**2+1d0/2*mz**2+3d0/4*mh**2)
     & +det3izhqs**2*c0zhqswww*vpael*(-3d0/2/ctw**2*mz**6*mh**2-3*ctw**2
     & *mz**6*mh**2-9*ctw**4*mz**6*mh**2+21d0/4*mz**6*mh**2)
     & +det3izhqs**2*c0zhqszhh*vpael*(-9/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqshzz*vpael*(-18/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqsmomomo*vpael*cfl*(3d0/4/ctw**2*vpamo**2*mz**4
     & *mh**2*mmo**2+3d0/4/ctw**2*vmamo**2*mz**4*mh**2*mmo**2)
     & +det3izhqs**2*c0zhqschchch*vpael*cfq*(3d0/4/ctw**2*vpach**2*mz**4
     & *mh**2*mch**2+3d0/4/ctw**2*vmach**2*mz**4*mh**2*mch**2)
     & +det3izhqs**2*c0zhqsststst*vpael*cfq*(3d0/4/ctw**2*vpast**2*mz**4
     & *mh**2*mst**2+3d0/4/ctw**2*vmast**2*mz**4*mh**2*mst**2)
     & +det3izhqs**2*c0zhqstatata*vpael*cfl*(3d0/4/ctw**2*vpata**2*mz**4
     & *mh**2*mta**2+3d0/4/ctw**2*vmata**2*mz**4*mh**2*mta**2)
     & +det3izhqs**2*c0zhqstptptp*vpael*cfq*(3d0/4/ctw**2*vpatp**2*mz**4
     & *mh**2*mtp**2+3d0/4/ctw**2*vmatp**2*mz**4*mh**2*mtp**2)
     & +det3izhqs**2*c0zhqsbtbtbt*vpael*cfq*(3d0/4/ctw**2*vpabt**2*mz**4
     & *mh**2*mbt**2+3d0/4/ctw**2*vmabt**2*mz**4*mh**2*mbt**2)
     & +det3izhqs**2*b0fzww*vpael*(-3d0/4/ctw**2*mz**4*mh**2-3d0/2*ctw**
     & 2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2+21d0/8*mz**4*mh**2)
     & +det3izhqs**2*b0fzmomo*vpael*cfl*(3d0/8/ctw**2*vpamo**2*mz**2*mh*
     & *2*mmo**2+3d0/8/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fzchch*vpael*cfq*(3d0/8/ctw**2*vpach**2*mz**2*mh*
     & *2*mch**2+3d0/8/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fzstst*vpael*cfq*(3d0/8/ctw**2*vpast**2*mz**2*mh*
     & *2*mst**2+3d0/8/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fztata*vpael*cfl*(3d0/8/ctw**2*vpata**2*mz**2*mh*
     & *2*mta**2+3d0/8/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fztptp*vpael*cfq*(3d0/8/ctw**2*vpatp**2*mz**2*mh*
     & *2*mtp**2+3d0/8/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fzbtbt*vpael*cfq*(3d0/8/ctw**2*vpabt**2*mz**2*mh*
     & *2*mbt**2+3d0/8/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fhww*vpael*(3d0/2/ctw**2*mz**4*mh**2+3*ctw**2*mz*
     & *4*mh**2+9*ctw**4*mz**4*mh**2-21d0/4*mz**4*mh**2)
     & +det3izhqs**2*b0fhzz*vpael*(9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhhh*vpael*(-9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhmomo*vpael*cfl*(-3d0/4/ctw**2*vpamo**2*mz**2*mh
     & **2*mmo**2-3d0/4/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fhchch*vpael*cfq*(-3d0/4/ctw**2*vpach**2*mz**2*mh
     & **2*mch**2-3d0/4/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fhstst*vpael*cfq*(-3d0/4/ctw**2*vpast**2*mz**2*mh
     & **2*mst**2-3d0/4/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fhtata*vpael*cfl*(-3d0/4/ctw**2*vpata**2*mz**2*mh
     & **2*mta**2-3d0/4/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fhtptp*vpael*cfq*(-3d0/4/ctw**2*vpatp**2*mz**2*mh
     & **2*mtp**2-3d0/4/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fhbtbt*vpael*cfq*(-3d0/4/ctw**2*vpabt**2*mz**2*mh
     & **2*mbt**2-3d0/4/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fqsww*vpael*(-3d0/4/ctw**2*mz**4*mh**2-3d0/2*ctw*
     & *2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2+21d0/8*mz**4*mh**2)
     & +det3izhqs**2*b0fqsmomo*vpael*cfl*(3d0/8/ctw**2*vpamo**2*mz**2*mh
     & **2*mmo**2+3d0/8/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fqschch*vpael*cfq*(3d0/8/ctw**2*vpach**2*mz**2*mh
     & **2*mch**2+3d0/8/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fqsstst*vpael*cfq*(3d0/8/ctw**2*vpast**2*mz**2*mh
     & **2*mst**2+3d0/8/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fqstata*vpael*cfl*(3d0/8/ctw**2*vpata**2*mz**2*mh
     & **2*mta**2+3d0/8/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fqstptp*vpael*cfq*(3d0/8/ctw**2*vpatp**2*mz**2*mh
     & **2*mtp**2+3d0/8/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fqsbtbt*vpael*cfq*(3d0/8/ctw**2*vpabt**2*mz**2*mh
     & **2*mbt**2+3d0/8/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*c0zhqswww*vpael*(1d0/2/ctw**2*mz**2*mh**2+3d0/2/ctw**2
     & *mz**4+1d0/2*ctw**2*mz**2*mh**2+ctw**2*mz**4+16*ctw**4*mz**4+6*ct
     & w**6*mz**2*mh**2-12*ctw**6*mz**4-1d0/2*mz**2*mh**2-5*mz**4)
     & +det3izhqs*c0zhqszhh*vpael*(51d0/4/ctw**2*mz**2*mh**2+9/ctw**2*mz
     & **4)
     & +det3izhqs*c0zhqshzz*vpael*(17/ctw**2*mz**2*mh**2+18/ctw**2*mz**4
     & )
     & +det3izhqs*c0zhqsmomomo*vpael*cfl*(1d0/2/ctw**2*vpamo*vmamo*mh**2
     & *mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mh**2*mmo**4-1d0/ctw**2*vpamo
     & **2*mz**2*mmo**2-1d0/4/ctw**2*vpamo**2*mh**2*mmo**2+1d0/ctw**2*vp
     & amo**2*mmo**4-1d0/2/ctw**2*vmamo**2/mz**2*mh**2*mmo**4-1d0/ctw**2
     & *vmamo**2*mz**2*mmo**2-1d0/4/ctw**2*vmamo**2*mh**2*mmo**2+1d0/ctw
     & **2*vmamo**2*mmo**4)
     & +det3izhqs*c0zhqschchch*vpael*cfq*(1d0/2/ctw**2*vpach*vmach*mh**2
     & *mch**2-1d0/2/ctw**2*vpach**2/mz**2*mh**2*mch**4-1d0/ctw**2*vpach
     & **2*mz**2*mch**2-1d0/4/ctw**2*vpach**2*mh**2*mch**2+1d0/ctw**2*vp
     & ach**2*mch**4-1d0/2/ctw**2*vmach**2/mz**2*mh**2*mch**4-1d0/ctw**2
     & *vmach**2*mz**2*mch**2-1d0/4/ctw**2*vmach**2*mh**2*mch**2+1d0/ctw
     & **2*vmach**2*mch**4)
     & +det3izhqs*c0zhqsststst*vpael*cfq*(1d0/2/ctw**2*vpast*vmast*mh**2
     & *mst**2-1d0/2/ctw**2*vpast**2/mz**2*mh**2*mst**4-1d0/ctw**2*vpast
     & **2*mz**2*mst**2-1d0/4/ctw**2*vpast**2*mh**2*mst**2+1d0/ctw**2*vp
     & ast**2*mst**4-1d0/2/ctw**2*vmast**2/mz**2*mh**2*mst**4-1d0/ctw**2
     & *vmast**2*mz**2*mst**2-1d0/4/ctw**2*vmast**2*mh**2*mst**2+1d0/ctw
     & **2*vmast**2*mst**4)
     & +det3izhqs*c0zhqstatata*vpael*cfl*(1d0/2/ctw**2*vpata*vmata*mh**2
     & *mta**2-1d0/2/ctw**2*vpata**2/mz**2*mh**2*mta**4-1d0/ctw**2*vpata
     & **2*mz**2*mta**2-1d0/4/ctw**2*vpata**2*mh**2*mta**2+1d0/ctw**2*vp
     & ata**2*mta**4-1d0/2/ctw**2*vmata**2/mz**2*mh**2*mta**4-1d0/ctw**2
     & *vmata**2*mz**2*mta**2-1d0/4/ctw**2*vmata**2*mh**2*mta**2+1d0/ctw
     & **2*vmata**2*mta**4)
     & +det3izhqs*c0zhqstptptp*vpael*cfq*(1d0/2/ctw**2*vpatp*vmatp*mh**2
     & *mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mh**2*mtp**4-1d0/ctw**2*vpatp
     & **2*mz**2*mtp**2-1d0/4/ctw**2*vpatp**2*mh**2*mtp**2+1d0/ctw**2*vp
     & atp**2*mtp**4-1d0/2/ctw**2*vmatp**2/mz**2*mh**2*mtp**4-1d0/ctw**2
     & *vmatp**2*mz**2*mtp**2-1d0/4/ctw**2*vmatp**2*mh**2*mtp**2+1d0/ctw
     & **2*vmatp**2*mtp**4)
     & +det3izhqs*c0zhqsbtbtbt*vpael*cfq*(1d0/2/ctw**2*vpabt*vmabt*mh**2
     & *mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mh**2*mbt**4-1d0/ctw**2*vpabt
     & **2*mz**2*mbt**2-1d0/4/ctw**2*vpabt**2*mh**2*mbt**2+1d0/ctw**2*vp
     & abt**2*mbt**4-1d0/2/ctw**2*vmabt**2/mz**2*mh**2*mbt**4-1d0/ctw**2
     & *vmabt**2*mz**2*mbt**2-1d0/4/ctw**2*vmabt**2*mh**2*mbt**2+1d0/ctw
     & **2*vmabt**2*mbt**4)
     & +det3izhqs*a0fz*vpael*(1d0/4/ctw**2*mz**2-1d0/4/ctw**2*mh**2)
     & +det3izhqs*a0fh*vpael*(3d0/4/ctw**2*mh**2)
     & +det3izhqs*b0fzww*vpael*(3d0/4/ctw**2*mz**2+1d0/8/ctw**2*mh**2+2*
     & ctw**2*mz**2+1d0/2*ctw**2*mh**2+3*ctw**4*mz**2-11d0/4*mz**2)
     & +det3izhqs*b0fzzh*vpael*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fzmomo*vpael*cfl*(1d0/4/ctw**2*vpamo*vmamo/mz**2*mh*
     & *2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw**2*v
     & pamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw
     & **2*vmamo**2*mmo**2)
     & +det3izhqs*b0fzchch*vpael*cfq*(1d0/4/ctw**2*vpach*vmach/mz**2*mh*
     & *2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ctw**2*v
     & pach**2*mch**2-1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-1d0/4/ctw
     & **2*vmach**2*mch**2)
     & +det3izhqs*b0fzstst*vpael*cfq*(1d0/4/ctw**2*vpast*vmast/mz**2*mh*
     & *2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ctw**2*v
     & past**2*mst**2-1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-1d0/4/ctw
     & **2*vmast**2*mst**2)
     & +det3izhqs*b0fztata*vpael*cfl*(1d0/4/ctw**2*vpata*vmata/mz**2*mh*
     & *2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ctw**2*v
     & pata**2*mta**2-1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d0/4/ctw
     & **2*vmata**2*mta**2)
     & +det3izhqs*b0fztptp*vpael*cfq*(1d0/4/ctw**2*vpatp*vmatp/mz**2*mh*
     & *2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw**2*v
     & patp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw
     & **2*vmatp**2*mtp**2)
     & +det3izhqs*b0fzbtbt*vpael*cfq*(1d0/4/ctw**2*vpabt*vmabt/mz**2*mh*
     & *2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw**2*v
     & pabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw
     & **2*vmabt**2*mbt**2)
     & +det3izhqs*b0fhww*vpael*(-3d0/2/ctw**2*mz**2-1d0/4/ctw**2*mh**2-4
     & *ctw**2*mz**2-ctw**2*mh**2-6*ctw**4*mz**2+11d0/2*mz**2)
     & +det3izhqs*b0fhzz*vpael*(-17d0/4/ctw**2*mz**2-21d0/8/ctw**2*mh**2
     & )
     & +det3izhqs*b0fhhh*vpael*(9d0/2/ctw**2*mz**2+33d0/8/ctw**2*mh**2)
     & +det3izhqs*b0fhmomo*vpael*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mh
     & **2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2+1d0/2/ctw**2*
     & vpamo**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2*mmo**2+1d0/2/ct
     & w**2*vmamo**2*mmo**2)
     & +det3izhqs*b0fhchch*vpael*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mh
     & **2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2+1d0/2/ctw**2*
     & vpach**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mh**2*mch**2+1d0/2/ct
     & w**2*vmach**2*mch**2)
     & +det3izhqs*b0fhstst*vpael*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mh
     & **2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2*mst**2+1d0/2/ctw**2*
     & vpast**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*mh**2*mst**2+1d0/2/ct
     & w**2*vmast**2*mst**2)
     & +det3izhqs*b0fhtata*vpael*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mh
     & **2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta**2+1d0/2/ctw**2*
     & vpata**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*mh**2*mta**2+1d0/2/ct
     & w**2*vmata**2*mta**2)
     & +det3izhqs*b0fhtptp*vpael*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mh
     & **2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mh**2*mtp**2+1d0/2/ctw**2*
     & vpatp**2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mh**2*mtp**2+1d0/2/ct
     & w**2*vmatp**2*mtp**2)
     & +det3izhqs*b0fhbtbt*vpael*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mh
     & **2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt**2+1d0/2/ctw**2*
     & vpabt**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mh**2*mbt**2+1d0/2/ct
     & w**2*vmabt**2*mbt**2)
     & +det3izhqs*b0fqsww*vpael*(3d0/4/ctw**2*mz**2+1d0/8/ctw**2*mh**2+2
     & *ctw**2*mz**2+1d0/2*ctw**2*mh**2+3*ctw**4*mz**2-11d0/4*mz**2)
     & +det3izhqs*b0fqszh*vpael*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fqsmomo*vpael*cfl*(1d0/4/ctw**2*vpamo*vmamo/mz**2*mh
     & **2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw**2*
     & vpamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-1d0/4/ct
     & w**2*vmamo**2*mmo**2)
     & +det3izhqs*b0fqschch*vpael*cfq*(1d0/4/ctw**2*vpach*vmach/mz**2*mh
     & **2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ctw**2*
     & vpach**2*mch**2-1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-1d0/4/ct
     & w**2*vmach**2*mch**2)
     & +det3izhqs*b0fqsstst*vpael*cfq*(1d0/4/ctw**2*vpast*vmast/mz**2*mh
     & **2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ctw**2*
     & vpast**2*mst**2-1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-1d0/4/ct
     & w**2*vmast**2*mst**2)
     & +det3izhqs*b0fqstata*vpael*cfl*(1d0/4/ctw**2*vpata*vmata/mz**2*mh
     & **2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ctw**2*
     & vpata**2*mta**2-1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d0/4/ct
     & w**2*vmata**2*mta**2)
     & +det3izhqs*b0fqstptp*vpael*cfq*(1d0/4/ctw**2*vpatp*vmatp/mz**2*mh
     & **2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw**2*
     & vpatp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-1d0/4/ct
     & w**2*vmatp**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*vpael*cfq*(1d0/4/ctw**2*vpabt*vmabt/mz**2*mh
     & **2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw**2*
     & vpabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/4/ct
     & w**2*vmabt**2*mbt**2)
     & +c0zhqswww*vpael*(-1-4*ctw**2+12*ctw**4)
     & +c0zhqszhh*vpael*(-3/ctw**2/mz**2*mh**2-21d0/2/ctw**2)
     & +c0zhqshzz*vpael*(-3d0/2/ctw**2/mz**2*mh**2-13/ctw**2)
     & +c0zhqsmomomo*vpael*cfl*(-1d0/ctw**2*vpamo*vmamo/mz**2*mmo**2)
     & +c0zhqschchch*vpael*cfq*(-1d0/ctw**2*vpach*vmach/mz**2*mch**2)
     & +c0zhqsststst*vpael*cfq*(-1d0/ctw**2*vpast*vmast/mz**2*mst**2)
     & +c0zhqstatata*vpael*cfl*(-1d0/ctw**2*vpata*vmata/mz**2*mta**2)
     & +c0zhqstptptp*vpael*cfq*(-1d0/ctw**2*vpatp*vmatp/mz**2*mtp**2)
     & +c0zhqsbtbtbt*vpael*cfq*(-1d0/ctw**2*vpabt*vmabt/mz**2*mbt**2)
     & +a0fh*vpael*(-1d0/ctw**2/mz**2)
     & +b0fzzh*vpael*(1d0/2/ctw**2/mz**2)
     & +b0fhzz*vpael*(1d0/ctw**2/mz**2)
     & +b0fhhh*vpael*(-3/ctw**2/mz**2)
     & +b0fqszh*vpael*(1d0/2/ctw**2/mz**2)

      ffgp2=
     & +vpael*(3d0/2/ctw**2/mz**2+2*ctw**2/mz**2-2/mz**2)
     & +propizqs*qel/qs*(2*stw**2/mz**2-4*stw**4/mz**2)
     & +propizqs*det3izhqs*qel*cfl/qs*(stw**2*qmo*vpamo/mz**2*mh**2*mmo*
     & *2-stw**2*qmo*vpamo*mmo**2+stw**2*qmo*vmamo/mz**2*mh**2*mmo**2-st
     & w**2*qmo*vmamo*mmo**2+stw**2*qta*vpata/mz**2*mh**2*mta**2-stw**2*
     & qta*vpata*mta**2+stw**2*qta*vmata/mz**2*mh**2*mta**2-stw**2*qta*v
     & mata*mta**2)
     & +propizqs*det3izhqs*qel*cfl*(stw**2*qmo*vpamo/mz**2*mmo**2+stw**2
     & *qmo*vmamo/mz**2*mmo**2+stw**2*qta*vpata/mz**2*mta**2+stw**2*qta*
     & vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*qel*cfq/qs*(stw**2*qch*vpach/mz**2*mh**2*mch*
     & *2-stw**2*qch*vpach*mch**2+stw**2*qch*vmach/mz**2*mh**2*mch**2-st
     & w**2*qch*vmach*mch**2+stw**2*qst*vpast/mz**2*mh**2*mst**2-stw**2*
     & qst*vpast*mst**2+stw**2*qst*vmast/mz**2*mh**2*mst**2-stw**2*qst*v
     & mast*mst**2+stw**2*qtp*vpatp/mz**2*mh**2*mtp**2-stw**2*qtp*vpatp*
     & mtp**2+stw**2*qtp*vmatp/mz**2*mh**2*mtp**2-stw**2*qtp*vmatp*mtp**
     & 2+stw**2*qbt*vpabt/mz**2*mh**2*mbt**2-stw**2*qbt*vpabt*mbt**2+stw
     & **2*qbt*vmabt/mz**2*mh**2*mbt**2-stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*qel*cfq*(stw**2*qch*vpach/mz**2*mch**2+stw**2
     & *qch*vmach/mz**2*mch**2+stw**2*qst*vpast/mz**2*mst**2+stw**2*qst*
     & vmast/mz**2*mst**2+stw**2*qtp*vpatp/mz**2*mtp**2+stw**2*qtp*vmatp
     & /mz**2*mtp**2+stw**2*qbt*vpabt/mz**2*mbt**2+stw**2*qbt*vmabt/mz**
     & 2*mbt**2)
     & +propizqs*det3izhqs*qel/qs*(11d0/2*stw**2*mz**2-11d0/2*stw**2*mh*
     & *2-12*stw**4*mz**2+12*stw**4*mh**2+6*stw**6*mz**2-6*stw**6*mh**2)
     & 
     & +propizqs*det3izhqs*qel*qs*(1d0/2*stw**2/mz**2-stw**4/mz**2)
     & +propizqs*det3izhqs*qel*(1d0/2*stw**2/mz**2*mh**2-4*stw**2-stw**4
     & /mz**2*mh**2+9*stw**4-6*stw**6)
     & +propizqs*det3izhqs*vpael*cfl*(1d0/4/ctw**2*vpamo**2/mz**2*mmo**2
     & +1d0/4/ctw**2*vmamo**2/mz**2*mmo**2+1d0/4/ctw**2*vpata**2/mz**2*m
     & ta**2+1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*vpael*cfq*(1d0/4/ctw**2*vpach**2/mz**2*mch**2
     & +1d0/4/ctw**2*vmach**2/mz**2*mch**2+1d0/4/ctw**2*vpast**2/mz**2*m
     & st**2+1d0/4/ctw**2*vmast**2/mz**2*mst**2+1d0/4/ctw**2*vpatp**2/mz
     & **2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mtp**2+1d0/4/ctw**2*vpabt*
     & *2/mz**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*vpael*qs*(3d0/8/ctw**2/mz**2+1d0/2*ctw**2/mz*
     & *2-1d0/2/mz**2)
     & +propizqs*det3izhqs*vpael*(-3d0/4+3d0/8/ctw**2/mz**2*mh**2+1d0/4/
     & ctw**2+1d0/2*ctw**2/mz**2*mh**2+3d0/2*ctw**2-3*ctw**4-1d0/2/mz**2
     & *mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qel*qs*(15d0/2*stw**2*mz**2*mh**
     & 2+3d0/4*stw**2*mh**4-33d0/2*stw**4*mz**2*mh**2-3d0/2*stw**4*mh**4
     & +9*stw**6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qel*(27d0/4*stw**2*mz**2*mh**4-1
     & 5d0/2*stw**2*mz**4*mh**2+3d0/4*stw**2*mh**6-15*stw**4*mz**2*mh**4
     & +33d0/2*stw**4*mz**4*mh**2-3d0/2*stw**4*mh**6+9*stw**6*mz**2*mh**
     & 4-9*stw**6*mz**4*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*vpael*qs*(3d0/16/ctw**2*mz**2*mh
     & **2+3d0/8/ctw**2*mz**4+3d0/16/ctw**2*mh**4-3d0/4*ctw**2*mz**2*mh*
     & *2+3d0/4*ctw**2*mh**4+9d0/2*ctw**4*mz**2*mh**2+9d0/2*ctw**4*mz**4
     & -3d0/8*mz**2*mh**2-9d0/8*mz**4-3d0/4*mh**4)
     & +propizqs*det3izhqs**2*c0zhqswww*vpael*(15d0/16/ctw**2*mz**4*mh**
     & 2+3d0/8/ctw**2*mz**6+3d0/16/ctw**2*mh**6-3d0/2*ctw**2*mz**2*mh**4
     & +15d0/4*ctw**2*mz**4*mh**2+3d0/4*ctw**2*mh**6+9d0/2*ctw**4*mz**2*
     & mh**4+9d0/2*ctw**4*mz**6+3d0/8*mz**2*mh**4-15d0/4*mz**4*mh**2-9d0
     & /8*mz**6-3d0/4*mh**6)
     & +propizqs*det3izhqs**2*c0zhqszhh*vpael*qs*(9d0/32/ctw**2/mz**2*mh
     & **6+9d0/16/ctw**2*mz**2*mh**2+9d0/4/ctw**2*mz**4+9d0/32/ctw**2*mh
     & **4)
     & +propizqs*det3izhqs**2*c0zhqszhh*vpael*(9d0/32/ctw**2/mz**2*mh**8
     & +45d0/32/ctw**2*mz**2*mh**4+81d0/16/ctw**2*mz**4*mh**2+9d0/4/ctw*
     & *2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqshzz*vpael*qs*(3d0/32/ctw**2/mz**2*mh
     & **6+9d0/8/ctw**2*mz**2*mh**2+39d0/8/ctw**2*mz**4+9d0/32/ctw**2*mh
     & **4)
     & +propizqs*det3izhqs**2*c0zhqshzz*vpael*(3d0/32/ctw**2/mz**2*mh**8
     & +87d0/32/ctw**2*mz**2*mh**4+75d0/8/ctw**2*mz**4*mh**2+39d0/8/ctw*
     & *2*mz**6+15d0/16/ctw**2*mh**6)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qel*cfl*qs*(-3d0/2*stw**2*qmo
     & *vpamo*mh**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qel*cfl*(3d0/2*stw**2*qmo*vpa
     & mo*mz**2*mh**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**4*mmo**2+3d0/2*s
     & tw**2*qmo*vmamo*mz**2*mh**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**4*m
     & mo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vpael*cfl*qs*(-3d0/8/ctw**2*v
     & pamo**2*mz**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2-3d0/8/ctw
     & **2*vmamo**2*mz**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vpael*cfl*(-3d0/8/ctw**2*vpam
     & o**2*mz**4*mmo**2-3d0/8/ctw**2*vpamo**2*mh**4*mmo**2-3d0/8/ctw**2
     & *vmamo**2*mz**4*mmo**2-3d0/8/ctw**2*vmamo**2*mh**4*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qel*cfq*qs*(-3d0/2*stw**2*qch
     & *vpach*mh**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qel*cfq*(3d0/2*stw**2*qch*vpa
     & ch*mz**2*mh**2*mch**2-3d0/2*stw**2*qch*vpach*mh**4*mch**2+3d0/2*s
     & tw**2*qch*vmach*mz**2*mh**2*mch**2-3d0/2*stw**2*qch*vmach*mh**4*m
     & ch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vpael*cfq*qs*(-3d0/8/ctw**2*v
     & pach**2*mz**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2-3d0/8/ctw
     & **2*vmach**2*mz**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vpael*cfq*(-3d0/8/ctw**2*vpac
     & h**2*mz**4*mch**2-3d0/8/ctw**2*vpach**2*mh**4*mch**2-3d0/8/ctw**2
     & *vmach**2*mz**4*mch**2-3d0/8/ctw**2*vmach**2*mh**4*mch**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qel*cfq*qs*(-3d0/2*stw**2*qst
     & *vpast*mh**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qel*cfq*(3d0/2*stw**2*qst*vpa
     & st*mz**2*mh**2*mst**2-3d0/2*stw**2*qst*vpast*mh**4*mst**2+3d0/2*s
     & tw**2*qst*vmast*mz**2*mh**2*mst**2-3d0/2*stw**2*qst*vmast*mh**4*m
     & st**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vpael*cfq*qs*(-3d0/8/ctw**2*v
     & past**2*mz**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2-3d0/8/ctw
     & **2*vmast**2*mz**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vpael*cfq*(-3d0/8/ctw**2*vpas
     & t**2*mz**4*mst**2-3d0/8/ctw**2*vpast**2*mh**4*mst**2-3d0/8/ctw**2
     & *vmast**2*mz**4*mst**2-3d0/8/ctw**2*vmast**2*mh**4*mst**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qel*cfl*qs*(-3d0/2*stw**2*qta
     & *vpata*mh**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qel*cfl*(3d0/2*stw**2*qta*vpa
     & ta*mz**2*mh**2*mta**2-3d0/2*stw**2*qta*vpata*mh**4*mta**2+3d0/2*s
     & tw**2*qta*vmata*mz**2*mh**2*mta**2-3d0/2*stw**2*qta*vmata*mh**4*m
     & ta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vpael*cfl*qs*(-3d0/8/ctw**2*v
     & pata**2*mz**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2-3d0/8/ctw
     & **2*vmata**2*mz**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vpael*cfl*(-3d0/8/ctw**2*vpat
     & a**2*mz**4*mta**2-3d0/8/ctw**2*vpata**2*mh**4*mta**2-3d0/8/ctw**2
     & *vmata**2*mz**4*mta**2-3d0/8/ctw**2*vmata**2*mh**4*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qel*cfq*qs*(-3d0/2*stw**2*qtp
     & *vpatp*mh**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qel*cfq*(3d0/2*stw**2*qtp*vpa
     & tp*mz**2*mh**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**4*mtp**2+3d0/2*s
     & tw**2*qtp*vmatp*mz**2*mh**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**4*m
     & tp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vpael*cfq*qs*(-3d0/8/ctw**2*v
     & patp**2*mz**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2-3d0/8/ctw
     & **2*vmatp**2*mz**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vpael*cfq*(-3d0/8/ctw**2*vpat
     & p**2*mz**4*mtp**2-3d0/8/ctw**2*vpatp**2*mh**4*mtp**2-3d0/8/ctw**2
     & *vmatp**2*mz**4*mtp**2-3d0/8/ctw**2*vmatp**2*mh**4*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qel*cfq*qs*(-3d0/2*stw**2*qbt
     & *vpabt*mh**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qel*cfq*(3d0/2*stw**2*qbt*vpa
     & bt*mz**2*mh**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**4*mbt**2+3d0/2*s
     & tw**2*qbt*vmabt*mz**2*mh**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**4*m
     & bt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vpael*cfq*qs*(-3d0/8/ctw**2*v
     & pabt**2*mz**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2-3d0/8/ctw
     & **2*vmabt**2*mz**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vpael*cfq*(-3d0/8/ctw**2*vpab
     & t**2*mz**4*mbt**2-3d0/8/ctw**2*vpabt**2*mh**4*mbt**2-3d0/8/ctw**2
     & *vmabt**2*mz**4*mbt**2-3d0/8/ctw**2*vmabt**2*mh**4*mbt**2)
     & +propizqs*det3izhqs**2*b0fzww*qel*qs*(15d0/2*stw**2*mz**2+3d0/4*s
     & tw**2*mh**2-33d0/2*stw**4*mz**2-3d0/2*stw**4*mh**2+9*stw**6*mz**2
     & )
     & +propizqs*det3izhqs**2*b0fzww*qel*(33d0/4*stw**2*mz**2*mh**2+15d0
     & /2*stw**2*mz**4+3d0/4*stw**2*mh**4-18*stw**4*mz**2*mh**2-33d0/2*s
     & tw**4*mz**4-3d0/2*stw**4*mh**4+9*stw**6*mz**2*mh**2+9*stw**6*mz**
     & 4)
     & +propizqs*det3izhqs**2*b0fzww*vpael*qs*(3d0/16/ctw**2*mz**2+3d0/1
     & 6/ctw**2*mh**2-3d0/4*ctw**2*mz**2+3d0/4*ctw**2*mh**2+9d0/2*ctw**4
     & *mz**2-3d0/8*mz**2-3d0/4*mh**2)
     & +propizqs*det3izhqs**2*b0fzww*vpael*(3d0/8/ctw**2*mz**2*mh**2+3d0
     & /16/ctw**2*mz**4+3d0/16/ctw**2*mh**4+3d0/4*ctw**2*mz**4+3d0/4*ctw
     & **2*mh**4+9d0/2*ctw**4*mz**2*mh**2-9d0/8*mz**2*mh**2-3d0/4*mz**4-
     & 3d0/4*mh**4)
     & +propizqs*det3izhqs**2*b0fzzh*vpael*qs*(3d0/16/ctw**2*mz**2+3d0/1
     & 6/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fzzh*vpael*(3d0/8/ctw**2*mz**2*mh**2-3d0
     & /16/ctw**2*mz**4-3d0/16/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fzmomo*qel*cfl*qs*(-3d0/2*stw**2*qmo*vpa
     & mo*mmo**2-3d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qel*cfl*(-3d0/2*stw**2*qmo*vpamo*
     & mz**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**2*mmo**2-3d0/2*stw**2*qmo
     & *vmamo*mz**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vpael*cfl*qs*(-3d0/8/ctw**2*vpamo
     & **2*mmo**2-3d0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vpael*cfl*(-3d0/8/ctw**2*vpamo**2
     & *mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzchch*qel*cfq*qs*(-3d0/2*stw**2*qch*vpa
     & ch*mch**2-3d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qel*cfq*(-3d0/2*stw**2*qch*vpach*
     & mz**2*mch**2-3d0/2*stw**2*qch*vpach*mh**2*mch**2-3d0/2*stw**2*qch
     & *vmach*mz**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vpael*cfq*qs*(-3d0/8/ctw**2*vpach
     & **2*mch**2-3d0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vpael*cfq*(-3d0/8/ctw**2*vpach**2
     & *mh**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzstst*qel*cfq*qs*(-3d0/2*stw**2*qst*vpa
     & st*mst**2-3d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qel*cfq*(-3d0/2*stw**2*qst*vpast*
     & mz**2*mst**2-3d0/2*stw**2*qst*vpast*mh**2*mst**2-3d0/2*stw**2*qst
     & *vmast*mz**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vpael*cfq*qs*(-3d0/8/ctw**2*vpast
     & **2*mst**2-3d0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vpael*cfq*(-3d0/8/ctw**2*vpast**2
     & *mh**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fztata*qel*cfl*qs*(-3d0/2*stw**2*qta*vpa
     & ta*mta**2-3d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qel*cfl*(-3d0/2*stw**2*qta*vpata*
     & mz**2*mta**2-3d0/2*stw**2*qta*vpata*mh**2*mta**2-3d0/2*stw**2*qta
     & *vmata*mz**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vpael*cfl*qs*(-3d0/8/ctw**2*vpata
     & **2*mta**2-3d0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vpael*cfl*(-3d0/8/ctw**2*vpata**2
     & *mh**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztptp*qel*cfq*qs*(-3d0/2*stw**2*qtp*vpa
     & tp*mtp**2-3d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qel*cfq*(-3d0/2*stw**2*qtp*vpatp*
     & mz**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**2*mtp**2-3d0/2*stw**2*qtp
     & *vmatp*mz**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vpael*cfq*qs*(-3d0/8/ctw**2*vpatp
     & **2*mtp**2-3d0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vpael*cfq*(-3d0/8/ctw**2*vpatp**2
     & *mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qel*cfq*qs*(-3d0/2*stw**2*qbt*vpa
     & bt*mbt**2-3d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qel*cfq*(-3d0/2*stw**2*qbt*vpabt*
     & mz**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**2*mbt**2-3d0/2*stw**2*qbt
     & *vmabt*mz**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vpael*cfq*qs*(-3d0/8/ctw**2*vpabt
     & **2*mbt**2-3d0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vpael*cfq*(-3d0/8/ctw**2*vpabt**2
     & *mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhww*qel*(-15*stw**2*mz**2*mh**2-3d0/2*s
     & tw**2*mh**4+33*stw**4*mz**2*mh**2+3*stw**4*mh**4-18*stw**6*mz**2*
     & mh**2)
     & +propizqs*det3izhqs**2*b0fhww*vpael*qs*(-3d0/8/ctw**2*mz**2-3d0/2
     & *ctw**2*mz**2+3d0/2*mz**2)
     & +propizqs*det3izhqs**2*b0fhww*vpael*(-3d0/4/ctw**2*mz**2*mh**2-3d
     & 0/8/ctw**2*mz**4-3d0/8/ctw**2*mh**4-3d0/2*ctw**2*mz**4-3d0/2*ctw*
     & *2*mh**4-9*ctw**4*mz**2*mh**2+9d0/4*mz**2*mh**2+3d0/2*mz**4+3d0/2
     & *mh**4)
     & +propizqs*det3izhqs**2*b0fhzz*vpael*qs*(-3d0/32/ctw**2/mz**2*mh**
     & 4-15d0/16/ctw**2*mz**2-9d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhzz*vpael*(-3d0/32/ctw**2/mz**2*mh**6-8
     & 7d0/32/ctw**2*mz**2*mh**2-15d0/16/ctw**2*mz**4-3d0/4/ctw**2*mh**4
     & )
     & +propizqs*det3izhqs**2*b0fhhh*vpael*qs*(9d0/32/ctw**2/mz**2*mh**4
     & +9d0/8/ctw**2*mz**2+9d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhhh*vpael*(9d0/32/ctw**2/mz**2*mh**6+81
     & d0/32/ctw**2*mz**2*mh**2+9d0/8/ctw**2*mz**4+9d0/16/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fhmomo*qel*cfl*(3*stw**2*qmo*vpamo*mh**2
     & *mmo**2+3*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhmomo*vpael*cfl*(3d0/4/ctw**2*vpamo**2*
     & mh**2*mmo**2+3d0/4/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhchch*qel*cfq*(3*stw**2*qch*vpach*mh**2
     & *mch**2+3*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhchch*vpael*cfq*(3d0/4/ctw**2*vpach**2*
     & mh**2*mch**2+3d0/4/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhstst*qel*cfq*(3*stw**2*qst*vpast*mh**2
     & *mst**2+3*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhstst*vpael*cfq*(3d0/4/ctw**2*vpast**2*
     & mh**2*mst**2+3d0/4/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhtata*qel*cfl*(3*stw**2*qta*vpata*mh**2
     & *mta**2+3*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtata*vpael*cfl*(3d0/4/ctw**2*vpata**2*
     & mh**2*mta**2+3d0/4/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtptp*qel*cfq*(3*stw**2*qtp*vpatp*mh**2
     & *mtp**2+3*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhtptp*vpael*cfq*(3d0/4/ctw**2*vpatp**2*
     & mh**2*mtp**2+3d0/4/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*qel*cfq*(3*stw**2*qbt*vpabt*mh**2
     & *mbt**2+3*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*vpael*cfq*(3d0/4/ctw**2*vpabt**2*
     & mh**2*mbt**2+3d0/4/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsww*qel*qs*(-15d0/2*stw**2*mz**2-3d0/4
     & *stw**2*mh**2+33d0/2*stw**4*mz**2+3d0/2*stw**4*mh**2-9*stw**6*mz*
     & *2)
     & +propizqs*det3izhqs**2*b0fqsww*qel*(27d0/4*stw**2*mz**2*mh**2-15d
     & 0/2*stw**2*mz**4+3d0/4*stw**2*mh**4-15*stw**4*mz**2*mh**2+33d0/2*
     & stw**4*mz**4-3d0/2*stw**4*mh**4+9*stw**6*mz**2*mh**2-9*stw**6*mz*
     & *4)
     & +propizqs*det3izhqs**2*b0fqsww*vpael*qs*(3d0/16/ctw**2*mz**2-3d0/
     & 16/ctw**2*mh**2+9d0/4*ctw**2*mz**2-3d0/4*ctw**2*mh**2-9d0/2*ctw**
     & 4*mz**2-9d0/8*mz**2+3d0/4*mh**2)
     & +propizqs*det3izhqs**2*b0fqsww*vpael*(3d0/8/ctw**2*mz**2*mh**2+3d
     & 0/16/ctw**2*mz**4+3d0/16/ctw**2*mh**4+3d0/4*ctw**2*mz**4+3d0/4*ct
     & w**2*mh**4+9d0/2*ctw**4*mz**2*mh**2-9d0/8*mz**2*mh**2-3d0/4*mz**4
     & -3d0/4*mh**4)
     & +propizqs*det3izhqs**2*b0fqszh*vpael*qs*(-3d0/16/ctw**2/mz**2*mh*
     & *4-3d0/8/ctw**2*mz**2-3d0/16/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqszh*vpael*(-3d0/16/ctw**2/mz**2*mh**6-
     & 3d0/16/ctw**2*mz**2*mh**2+3d0/8/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fqsmomo*qel*cfl*qs*(3d0/2*stw**2*qmo*vpa
     & mo*mmo**2+3d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qel*cfl*(3d0/2*stw**2*qmo*vpamo*
     & mz**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**2*mmo**2+3d0/2*stw**2*qmo
     & *vmamo*mz**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vpael*cfl*qs*(3d0/8/ctw**2*vpamo
     & **2*mmo**2+3d0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vpael*cfl*(-3d0/8/ctw**2*vpamo**
     & 2*mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqschch*qel*cfq*qs*(3d0/2*stw**2*qch*vpa
     & ch*mch**2+3d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qel*cfq*(3d0/2*stw**2*qch*vpach*
     & mz**2*mch**2-3d0/2*stw**2*qch*vpach*mh**2*mch**2+3d0/2*stw**2*qch
     & *vmach*mz**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vpael*cfq*qs*(3d0/8/ctw**2*vpach
     & **2*mch**2+3d0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vpael*cfq*(-3d0/8/ctw**2*vpach**
     & 2*mh**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qel*cfq*qs*(3d0/2*stw**2*qst*vpa
     & st*mst**2+3d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qel*cfq*(3d0/2*stw**2*qst*vpast*
     & mz**2*mst**2-3d0/2*stw**2*qst*vpast*mh**2*mst**2+3d0/2*stw**2*qst
     & *vmast*mz**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vpael*cfq*qs*(3d0/8/ctw**2*vpast
     & **2*mst**2+3d0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vpael*cfq*(-3d0/8/ctw**2*vpast**
     & 2*mh**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqstata*qel*cfl*qs*(3d0/2*stw**2*qta*vpa
     & ta*mta**2+3d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qel*cfl*(3d0/2*stw**2*qta*vpata*
     & mz**2*mta**2-3d0/2*stw**2*qta*vpata*mh**2*mta**2+3d0/2*stw**2*qta
     & *vmata*mz**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vpael*cfl*qs*(3d0/8/ctw**2*vpata
     & **2*mta**2+3d0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vpael*cfl*(-3d0/8/ctw**2*vpata**
     & 2*mh**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qel*cfq*qs*(3d0/2*stw**2*qtp*vpa
     & tp*mtp**2+3d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qel*cfq*(3d0/2*stw**2*qtp*vpatp*
     & mz**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**2*mtp**2+3d0/2*stw**2*qtp
     & *vmatp*mz**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vpael*cfq*qs*(3d0/8/ctw**2*vpatp
     & **2*mtp**2+3d0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vpael*cfq*(-3d0/8/ctw**2*vpatp**
     & 2*mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qel*cfq*qs*(3d0/2*stw**2*qbt*vpa
     & bt*mbt**2+3d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qel*cfq*(3d0/2*stw**2*qbt*vpabt*
     & mz**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**2*mbt**2+3d0/2*stw**2*qbt
     & *vmabt*mz**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vpael*cfq*qs*(3d0/8/ctw**2*vpabt
     & **2*mbt**2+3d0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vpael*cfq*(-3d0/8/ctw**2*vpabt**
     & 2*mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqswww*qel/qs*(11*stw**2*mz**2*mh**2-11*st
     & w**2*mz**4-35*stw**4*mz**2*mh**2+35*stw**4*mz**4+36*stw**6*mz**2*
     & mh**2-36*stw**6*mz**4-12*stw**8*mz**2*mh**2+12*stw**8*mz**4)
     & +propizqs*det3izhqs*c0zhqswww*qel*qs*(-stw**2+3*stw**4-2*stw**6)
     & +propizqs*det3izhqs*c0zhqswww*qel*(18*stw**2*mz**2-48*stw**4*mz**
     & 2+stw**4*mh**2+42*stw**6*mz**2-2*stw**6*mh**2-12*stw**8*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*vpael*qs*(-3d0/4+ctw**2-ctw**4)
     & +propizqs*det3izhqs*c0zhqswww*vpael*(1d0/4/ctw**2*mh**2-1d0/2*ctw
     & **2*mz**2+2*ctw**2*mh**2+3*ctw**4*mz**2-ctw**4*mh**2+6*ctw**6*mz*
     & *2-1d0/4*mz**2-7d0/4*mh**2)
     & +propizqs*det3izhqs*c0zhqszhh*vpael*qs*(-3d0/4/ctw**2/mz**2*mh**2
     & -21d0/8/ctw**2)
     & +propizqs*det3izhqs*c0zhqszhh*vpael*(-3d0/4/ctw**2/mz**2*mh**4-21
     & d0/8/ctw**2*mz**2-6/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqshzz*vpael*qs*(-3d0/8/ctw**2/mz**2*mh**2
     & -7d0/2/ctw**2)
     & +propizqs*det3izhqs*c0zhqshzz*vpael*(-7d0/8/ctw**2/mz**2*mh**4-11
     & d0/4/ctw**2*mz**2-7/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*qel*cfl/qs*(-2*stw**2*qmo*vpamo/
     & mz**2*mh**2*mmo**4+2*stw**2*qmo*vpamo*mmo**4-2*stw**2*qmo*vmamo/m
     & z**2*mh**2*mmo**4+2*stw**2*qmo*vmamo*mmo**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*qel*cfl*(-2*stw**2*qmo*vpamo/mz*
     & *2*mmo**4-2*stw**2*qmo*vpamo*mmo**2-2*stw**2*qmo*vmamo/mz**2*mmo*
     & *4-2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vpael*cfl*qs*(-1d0/4/ctw**2*vpam
     & o*vmamo/mz**2*mmo**2+1d0/8/ctw**2*vpamo**2/mz**2*mmo**2+1d0/8/ctw
     & **2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vpael*cfl*(-1d0/4/ctw**2*vpamo*v
     & mamo/mz**2*mh**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo*mmo**2+1d0/8/ctw
     & **2*vpamo**2/mz**2*mh**2*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mmo**
     & 4-3d0/8/ctw**2*vpamo**2*mmo**2+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*
     & mmo**2-1d0/2/ctw**2*vmamo**2/mz**2*mmo**4-3d0/8/ctw**2*vmamo**2*m
     & mo**2)
     & +propizqs*det3izhqs*c0zhqschchch*qel*cfq/qs*(-2*stw**2*qch*vpach/
     & mz**2*mh**2*mch**4+2*stw**2*qch*vpach*mch**4-2*stw**2*qch*vmach/m
     & z**2*mh**2*mch**4+2*stw**2*qch*vmach*mch**4)
     & +propizqs*det3izhqs*c0zhqschchch*qel*cfq*(-2*stw**2*qch*vpach/mz*
     & *2*mch**4-2*stw**2*qch*vpach*mch**2-2*stw**2*qch*vmach/mz**2*mch*
     & *4-2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vpael*cfq*qs*(-1d0/4/ctw**2*vpac
     & h*vmach/mz**2*mch**2+1d0/8/ctw**2*vpach**2/mz**2*mch**2+1d0/8/ctw
     & **2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vpael*cfq*(-1d0/4/ctw**2*vpach*v
     & mach/mz**2*mh**2*mch**2-1d0/4/ctw**2*vpach*vmach*mch**2+1d0/8/ctw
     & **2*vpach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mch**
     & 4-3d0/8/ctw**2*vpach**2*mch**2+1d0/8/ctw**2*vmach**2/mz**2*mh**2*
     & mch**2-1d0/2/ctw**2*vmach**2/mz**2*mch**4-3d0/8/ctw**2*vmach**2*m
     & ch**2)
     & +propizqs*det3izhqs*c0zhqsststst*qel*cfq/qs*(-2*stw**2*qst*vpast/
     & mz**2*mh**2*mst**4+2*stw**2*qst*vpast*mst**4-2*stw**2*qst*vmast/m
     & z**2*mh**2*mst**4+2*stw**2*qst*vmast*mst**4)
     & +propizqs*det3izhqs*c0zhqsststst*qel*cfq*(-2*stw**2*qst*vpast/mz*
     & *2*mst**4-2*stw**2*qst*vpast*mst**2-2*stw**2*qst*vmast/mz**2*mst*
     & *4-2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*vpael*cfq*qs*(-1d0/4/ctw**2*vpas
     & t*vmast/mz**2*mst**2+1d0/8/ctw**2*vpast**2/mz**2*mst**2+1d0/8/ctw
     & **2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*vpael*cfq*(-1d0/4/ctw**2*vpast*v
     & mast/mz**2*mh**2*mst**2-1d0/4/ctw**2*vpast*vmast*mst**2+1d0/8/ctw
     & **2*vpast**2/mz**2*mh**2*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mst**
     & 4-3d0/8/ctw**2*vpast**2*mst**2+1d0/8/ctw**2*vmast**2/mz**2*mh**2*
     & mst**2-1d0/2/ctw**2*vmast**2/mz**2*mst**4-3d0/8/ctw**2*vmast**2*m
     & st**2)
     & +propizqs*det3izhqs*c0zhqstatata*qel*cfl/qs*(-2*stw**2*qta*vpata/
     & mz**2*mh**2*mta**4+2*stw**2*qta*vpata*mta**4-2*stw**2*qta*vmata/m
     & z**2*mh**2*mta**4+2*stw**2*qta*vmata*mta**4)
     & +propizqs*det3izhqs*c0zhqstatata*qel*cfl*(-2*stw**2*qta*vpata/mz*
     & *2*mta**4-2*stw**2*qta*vpata*mta**2-2*stw**2*qta*vmata/mz**2*mta*
     & *4-2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vpael*cfl*qs*(-1d0/4/ctw**2*vpat
     & a*vmata/mz**2*mta**2+1d0/8/ctw**2*vpata**2/mz**2*mta**2+1d0/8/ctw
     & **2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vpael*cfl*(-1d0/4/ctw**2*vpata*v
     & mata/mz**2*mh**2*mta**2-1d0/4/ctw**2*vpata*vmata*mta**2+1d0/8/ctw
     & **2*vpata**2/mz**2*mh**2*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mta**
     & 4-3d0/8/ctw**2*vpata**2*mta**2+1d0/8/ctw**2*vmata**2/mz**2*mh**2*
     & mta**2-1d0/2/ctw**2*vmata**2/mz**2*mta**4-3d0/8/ctw**2*vmata**2*m
     & ta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qel*cfq/qs*(-2*stw**2*qtp*vpatp/
     & mz**2*mh**2*mtp**4+2*stw**2*qtp*vpatp*mtp**4-2*stw**2*qtp*vmatp/m
     & z**2*mh**2*mtp**4+2*stw**2*qtp*vmatp*mtp**4)
     & +propizqs*det3izhqs*c0zhqstptptp*qel*cfq*(-2*stw**2*qtp*vpatp/mz*
     & *2*mtp**4-2*stw**2*qtp*vpatp*mtp**2-2*stw**2*qtp*vmatp/mz**2*mtp*
     & *4-2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vpael*cfq*qs*(-1d0/4/ctw**2*vpat
     & p*vmatp/mz**2*mtp**2+1d0/8/ctw**2*vpatp**2/mz**2*mtp**2+1d0/8/ctw
     & **2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vpael*cfq*(-1d0/4/ctw**2*vpatp*v
     & matp/mz**2*mh**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp*mtp**2+1d0/8/ctw
     & **2*vpatp**2/mz**2*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**
     & 4-3d0/8/ctw**2*vpatp**2*mtp**2+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*
     & mtp**2-1d0/2/ctw**2*vmatp**2/mz**2*mtp**4-3d0/8/ctw**2*vmatp**2*m
     & tp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qel*cfq/qs*(-2*stw**2*qbt*vpabt/
     & mz**2*mh**2*mbt**4+2*stw**2*qbt*vpabt*mbt**4-2*stw**2*qbt*vmabt/m
     & z**2*mh**2*mbt**4+2*stw**2*qbt*vmabt*mbt**4)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qel*cfq*(-2*stw**2*qbt*vpabt/mz*
     & *2*mbt**4-2*stw**2*qbt*vpabt*mbt**2-2*stw**2*qbt*vmabt/mz**2*mbt*
     & *4-2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vpael*cfq*qs*(-1d0/4/ctw**2*vpab
     & t*vmabt/mz**2*mbt**2+1d0/8/ctw**2*vpabt**2/mz**2*mbt**2+1d0/8/ctw
     & **2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vpael*cfq*(-1d0/4/ctw**2*vpabt*v
     & mabt/mz**2*mh**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt*mbt**2+1d0/8/ctw
     & **2*vpabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**
     & 4-3d0/8/ctw**2*vpabt**2*mbt**2+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*
     & mbt**2-1d0/2/ctw**2*vmabt**2/mz**2*mbt**4-3d0/8/ctw**2*vmabt**2*m
     & bt**2)
     & +propizqs*det3izhqs*a0fh*vpael*qs*(-1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*a0fh*vpael*(-1d0/2/ctw**2/mz**2*mh**2-1d0/4/c
     & tw**2)
     & +propizqs*det3izhqs*b0fzww*qel/qs*(5*stw**2*mz**2+1d0/2*stw**2*mh
     & **2-11*stw**4*mz**2-stw**4*mh**2+6*stw**6*mz**2)
     & +propizqs*det3izhqs*b0fzww*vpael*(1d0/2)
     & +propizqs*det3izhqs*b0fzzh*vpael*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fzzh*vpael*(1d0/4/ctw**2/mz**2*mh**2+3d0/8/
     & ctw**2)
     & +propizqs*det3izhqs*b0fzmomo*qel*cfl/qs*(-stw**2*qmo*vpamo*mmo**2
     & -stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*vpael*cfl*(1d0/4/ctw**2*vpamo*vmamo/
     & mz**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mmo**2-1d0/8/ctw**2*vmam
     & o**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*qel*cfq/qs*(-stw**2*qch*vpach*mch**2
     & -stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fzchch*vpael*cfq*(1d0/4/ctw**2*vpach*vmach/
     & mz**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mch**2-1d0/8/ctw**2*vmac
     & h**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzstst*qel*cfq/qs*(-stw**2*qst*vpast*mst**2
     & -stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fzstst*vpael*cfq*(1d0/4/ctw**2*vpast*vmast/
     & mz**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mst**2-1d0/8/ctw**2*vmas
     & t**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fztata*qel*cfl/qs*(-stw**2*qta*vpata*mta**2
     & -stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fztata*vpael*cfl*(1d0/4/ctw**2*vpata*vmata/
     & mz**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mta**2-1d0/8/ctw**2*vmat
     & a**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztptp*qel*cfq/qs*(-stw**2*qtp*vpatp*mtp**2
     & -stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*vpael*cfq*(1d0/4/ctw**2*vpatp*vmatp/
     & mz**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mtp**2-1d0/8/ctw**2*vmat
     & p**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*qel*cfq/qs*(-stw**2*qbt*vpabt*mbt**2
     & -stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*vpael*cfq*(1d0/4/ctw**2*vpabt*vmabt/
     & mz**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mbt**2-1d0/8/ctw**2*vmab
     & t**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhww*qel/qs*(-5*stw**2*mz**2-1d0/2*stw**2*m
     & h**2+11*stw**4*mz**2+stw**4*mh**2-6*stw**6*mz**2)
     & +propizqs*det3izhqs*b0fhww*qel*(1d0/2*stw**2/mz**2*mh**2+5*stw**2
     & -stw**4/mz**2*mh**2-11*stw**4+6*stw**6)
     & +propizqs*det3izhqs*b0fhww*vpael*(1d0/4+1d0/8/ctw**2/mz**2*mh**2+
     & 1d0/2*ctw**2/mz**2*mh**2-ctw**2+3*ctw**4-1d0/2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fhzz*vpael*qs*(1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhzz*vpael*(9d0/16/ctw**2/mz**2*mh**2+3d0/8
     & /ctw**2)
     & +propizqs*det3izhqs*b0fhhh*vpael*qs*(-3d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhhh*vpael*(-21d0/16/ctw**2/mz**2*mh**2-3d0
     & /4/ctw**2)
     & +propizqs*det3izhqs*b0fhmomo*qel*cfl/qs*(stw**2*qmo*vpamo*mmo**2+
     & stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qel*cfl*(-stw**2*qmo*vpamo/mz**2*mmo
     & **2-stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*vpael*cfl*(-1d0/4/ctw**2*vpamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*qel*cfq/qs*(stw**2*qch*vpach*mch**2+
     & stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qel*cfq*(-stw**2*qch*vpach/mz**2*mch
     & **2-stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*vpael*cfq*(-1d0/4/ctw**2*vpach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*qel*cfq/qs*(stw**2*qst*vpast*mst**2+
     & stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qel*cfq*(-stw**2*qst*vpast/mz**2*mst
     & **2-stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*vpael*cfq*(-1d0/4/ctw**2*vpast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*qel*cfl/qs*(stw**2*qta*vpata*mta**2+
     & stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qel*cfl*(-stw**2*qta*vpata/mz**2*mta
     & **2-stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*vpael*cfl*(-1d0/4/ctw**2*vpata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*qel*cfq/qs*(stw**2*qtp*vpatp*mtp**2+
     & stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qel*cfq*(-stw**2*qtp*vpatp/mz**2*mtp
     & **2-stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*vpael*cfq*(-1d0/4/ctw**2*vpatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel*cfq/qs*(stw**2*qbt*vpabt*mbt**2+
     & stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel*cfq*(-stw**2*qbt*vpabt/mz**2*mbt
     & **2-stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*vpael*cfq*(-1d0/4/ctw**2*vpabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*qel*(-1d0/2*stw**2/mz**2*mh**2-5*stw*
     & *2+stw**4/mz**2*mh**2+11*stw**4-6*stw**6)
     & +propizqs*det3izhqs*b0fqsww*vpael*(-3d0/4-1d0/8/ctw**2/mz**2*mh**
     & 2-1d0/2*ctw**2/mz**2*mh**2+ctw**2-3*ctw**4+1d0/2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fqszh*vpael*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fqszh*vpael*(-1d0/4/ctw**2)
     & +propizqs*det3izhqs*b0fqsmomo*qel*cfl*(stw**2*qmo*vpamo/mz**2*mmo
     & **2+stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*vpael*cfl*(-1d0/4/ctw**2*vpamo*vmam
     & o/mz**2*mmo**2+3d0/8/ctw**2*vpamo**2/mz**2*mmo**2+3d0/8/ctw**2*vm
     & amo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*qel*cfq*(stw**2*qch*vpach/mz**2*mch
     & **2+stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*vpael*cfq*(-1d0/4/ctw**2*vpach*vmac
     & h/mz**2*mch**2+3d0/8/ctw**2*vpach**2/mz**2*mch**2+3d0/8/ctw**2*vm
     & ach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*qel*cfq*(stw**2*qst*vpast/mz**2*mst
     & **2+stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*vpael*cfq*(-1d0/4/ctw**2*vpast*vmas
     & t/mz**2*mst**2+3d0/8/ctw**2*vpast**2/mz**2*mst**2+3d0/8/ctw**2*vm
     & ast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*qel*cfl*(stw**2*qta*vpata/mz**2*mta
     & **2+stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*vpael*cfl*(-1d0/4/ctw**2*vpata*vmat
     & a/mz**2*mta**2+3d0/8/ctw**2*vpata**2/mz**2*mta**2+3d0/8/ctw**2*vm
     & ata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*qel*cfq*(stw**2*qtp*vpatp/mz**2*mtp
     & **2+stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*vpael*cfq*(-1d0/4/ctw**2*vpatp*vmat
     & p/mz**2*mtp**2+3d0/8/ctw**2*vpatp**2/mz**2*mtp**2+3d0/8/ctw**2*vm
     & atp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qel*cfq*(stw**2*qbt*vpabt/mz**2*mbt
     & **2+stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*vpael*cfq*(-1d0/4/ctw**2*vpabt*vmab
     & t/mz**2*mbt**2+3d0/8/ctw**2*vpabt**2/mz**2*mbt**2+3d0/8/ctw**2*vm
     & abt**2/mz**2*mbt**2)
     & +propizqs*sdet3iczts*c0cztswcc/qs*(-2*ctw**4*mz**2)
     & +propizqs*sdet3iczts*c0cztszcc*vpael**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3iczts*c0cztscww*(-4*sdet4izhtsus*ctw**6*mz**4)
     & +propizqs*sdet3iczts*b0fzww*(-4*sdet4izhtsus*ctw**4*mz**2)
     & +propizqs*sdet3iczts*b0fzcc*vpael**3/qs*(1d0/ctw**2)
     & +propizqs*sdet3iczts*b0fzcc/qs*(2*ctw**2)
     & +propizqs*sdet3iczts*b0ftswc/qs*(-2*ctw**2)
     & +propizqs*sdet3iczts*b0ftswc*(4*sdet4izhtsus*ctw**4*mz**2)
     & +propizqs*sdet3iczts*b0ftszc*vpael**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichus*c0chuscww/qs*(-2*ctw**4*mz**2)
     & +propizqs*sdet3ichus*c0chuscww*(4*sdet4izhtsus*ctw**6*mz**2*mh**2
     & )
     & +propizqs*sdet3ichus*c0chusczz*vpael**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3ichus*b0fhww/qs*(-2*ctw**2)
     & +propizqs*sdet3ichus*b0fhww*(4*sdet4izhtsus*ctw**4*mh**2)
     & +propizqs*sdet3ichus*b0fhzz*vpael**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichus*b0fuswc/qs*(2*ctw**2)
     & +propizqs*sdet3ichus*b0fuswc*(-4*sdet4izhtsus*ctw**4*mh**2)
     & +propizqs*sdet3ichus*b0fuszc*vpael**3/qs*(1d0/ctw**2)
     & +propizqs*d0zchctsusccww/qs*(ctw**2*us+ctw**2*mz**2-ctw**4*mz**2-
     & 2*sdet4izhtsus*ctw**4*us*mz**2*mh**2+2*sdet4izhtsus*ctw**4*us*mz*
     & *4-2*sdet4izhtsus*ctw**4*mz**4*mh**2+2*sdet4izhtsus*ctw**4*mz**6+
     & sdet4izhtsus*ctw**6*mz**4*mh**2-sdet4izhtsus*ctw**6*mz**6-sdet4iz
     & htsus**2*ctw**6*ts*mz**8+sdet4izhtsus**2*ctw**6*us*mz**4*mh**4-2*
     & sdet4izhtsus**2*ctw**6*us*mz**6*mh**2+sdet4izhtsus**2*ctw**6*mz**
     & 6*mh**4-3*sdet4izhtsus**2*ctw**6*mz**8*mh**2)
     & +propizqs*d0zchctsusccww*(-2*sdet4izhtsus*ctw**4*us*mz**2-sdet4iz
     & htsus**2*ctw**6*ts*mz**6+sdet4izhtsus**2*ctw**6*us*mz**4*mh**2-sd
     & et4izhtsus**2*ctw**6*us**2*mz**4)
     & +propizqs*d0zchctsuscczz*vpael**3/qs*(1d0/2/ctw**2*us-sdet4izhtsu
     & s/ctw**2*us*mz**2*mh**2+sdet4izhtsus/ctw**2*us*mz**4-1d0/2*sdet4i
     & zhtsus/ctw**2*mz**4*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**6-1d0/2*s
     & det4izhtsus**2/ctw**2*ts*mz**8+1d0/2*sdet4izhtsus**2/ctw**2*us*mz
     & **4*mh**4-sdet4izhtsus**2/ctw**2*us*mz**6*mh**2+1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**6*mh**4-3d0/2*sdet4izhtsus**2/ctw**2*mz**8*mh**2)
     & 
     & +propizqs*d0zchctsuscczz*vpael**3*(-sdet4izhtsus/ctw**2*us*mz**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6+1d0/2*sdet4izhtsus**2/ctw**
     & 2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us**2*mz**4)
     & +propizqs*d0cczhqstswcww/qs*(-sdet4izhtsus*ctw**4*ts*mz**2*mh**2+
     & sdet4izhtsus*ctw**4*ts*mz**4-sdet4izhtsus*ctw**4*mz**2*mh**4+sdet
     & 4izhtsus*ctw**4*mz**4*mh**2+2*sdet4izhtsus*ctw**6*ts*mz**2*mh**2-
     & 2*sdet4izhtsus*ctw**6*ts*mz**4+2*sdet4izhtsus*ctw**6*mz**2*mh**4-
     & 2*sdet4izhtsus*ctw**6*mz**4*mh**2+2*sdet4izhtsus*ctw**8*mz**4*mh*
     & *2-2*sdet4izhtsus*ctw**8*mz**6-2*sdet4izhtsus**2*ctw**8*ts*mz**4*
     & mh**4+4*sdet4izhtsus**2*ctw**8*ts*mz**6*mh**2-2*sdet4izhtsus**2*c
     & tw**8*ts*mz**8-2*sdet4izhtsus**2*ctw**8*mz**4*mh**6+4*sdet4izhtsu
     & s**2*ctw**8*mz**6*mh**4-2*sdet4izhtsus**2*ctw**8*mz**8*mh**2)
     & +propizqs*d0cczhqstswcww*(-2*ctw**4-sdet4izhtsus*ctw**2*ts*mh**2-
     & sdet4izhtsus*ctw**2*ts**2-3*sdet4izhtsus*ctw**4*ts*mz**2-5*sdet4i
     & zhtsus*ctw**4*mz**2*mh**2-4*sdet4izhtsus*ctw**6*us*mz**2+2*sdet4i
     & zhtsus*ctw**6*mz**2*mh**2-4*sdet4izhtsus*ctw**6*mz**4-2*sdet4izht
     & sus**2*ctw**4*ts*mz**2*mh**4-4*sdet4izhtsus**2*ctw**4*ts*mz**4*mh
     & **2-4*sdet4izhtsus**2*ctw**4*ts**2*mz**2*mh**2-2*sdet4izhtsus**2*
     & ctw**4*ts**2*mz**4-2*sdet4izhtsus**2*ctw**4*ts**3*mz**2-2*sdet4iz
     & htsus**2*ctw**4*mz**4*mh**4+4*sdet4izhtsus**2*ctw**6*ts*mz**4*mh*
     & *2+4*sdet4izhtsus**2*ctw**6*ts**2*mz**4-4*sdet4izhtsus**2*ctw**6*
     & us*mz**4*mh**2-4*sdet4izhtsus**2*ctw**6*mz**6*mh**2-2*sdet4izhtsu
     & s**2*ctw**8*ts*mz**6+2*sdet4izhtsus**2*ctw**8*us*mz**4*mh**2-2*sd
     & et4izhtsus**2*ctw**8*us**2*mz**4-2*sdet4izhtsus**2*ctw**8*mz**4*m
     & h**4+4*sdet4izhtsus**2*ctw**8*mz**6*mh**2)
     & +propizqs*d0cchzqsuswcww/qs*(-2*sdet4izhtsus*ctw**6*us*mz**2*mh**
     & 2+2*sdet4izhtsus*ctw**6*us*mz**4-2*sdet4izhtsus*ctw**6*mz**4*mh**
     & 2+2*sdet4izhtsus*ctw**6*mz**6+2*sdet4izhtsus*ctw**8*mz**4*mh**2-2
     & *sdet4izhtsus*ctw**8*mz**6+2*sdet4izhtsus**2*ctw**8*us*mz**4*mh**
     & 4-4*sdet4izhtsus**2*ctw**8*us*mz**6*mh**2+2*sdet4izhtsus**2*ctw**
     & 8*us*mz**8+2*sdet4izhtsus**2*ctw**8*mz**6*mh**4-4*sdet4izhtsus**2
     & *ctw**8*mz**8*mh**2+2*sdet4izhtsus**2*ctw**8*mz**10)
     & +propizqs*d0cchzqsuswcww*(-4*sdet4izhtsus*ctw**6*us*mz**2-2*sdet4
     & izhtsus*ctw**6*mz**4-2*sdet4izhtsus**2*ctw**4*us*mz**4*mh**2-4*sd
     & et4izhtsus**2*ctw**4*us**2*mz**2*mh**2-2*sdet4izhtsus**2*ctw**4*u
     & s**2*mz**4-4*sdet4izhtsus**2*ctw**4*us**3*mz**2-2*sdet4izhtsus**2
     & *ctw**4*us**3*mh**2-2*sdet4izhtsus**2*ctw**4*us**4-4*sdet4izhtsus
     & **2*ctw**6*us*mz**4*mh**2+4*sdet4izhtsus**2*ctw**6*us**2*mz**4+4*
     & sdet4izhtsus**2*ctw**6*us**3*mz**2-4*sdet4izhtsus**2*ctw**6*mz**6
     & *mh**2-2*sdet4izhtsus**2*ctw**8*ts*mz**6+2*sdet4izhtsus**2*ctw**8
     & *us*mz**4*mh**2-2*sdet4izhtsus**2*ctw**8*us**2*mz**4+2*sdet4izhts
     & us**2*ctw**8*mz**8)
     & +propizqs*c0zhqswww*qel/qs*(20*stw**2-44*stw**4+24*stw**6)
     & +propizqs*c0zhqswww/qs*(sdet4izhtsus*ctw**2*ts*mz**2-sdet4izhtsus
     & *ctw**2*ts*mh**2+sdet4izhtsus*ctw**2*mz**2*mh**2-sdet4izhtsus*ctw
     & **2*mh**4-2*sdet4izhtsus*ctw**4*ts*mz**2+2*sdet4izhtsus*ctw**4*ts
     & *mh**2+2*sdet4izhtsus*ctw**4*us*mz**2-2*sdet4izhtsus*ctw**4*us*mh
     & **2-4*sdet4izhtsus*ctw**4*mz**2*mh**2+2*sdet4izhtsus*ctw**4*mz**4
     & +2*sdet4izhtsus*ctw**4*mh**4+4*sdet4izhtsus*ctw**6*mz**2*mh**2-4*
     & sdet4izhtsus*ctw**6*mz**4-2*sdet4izhtsus**2*ctw**6*ts*mz**2*mh**4
     & +4*sdet4izhtsus**2*ctw**6*ts*mz**4*mh**2-2*sdet4izhtsus**2*ctw**6
     & *ts*mz**6+2*sdet4izhtsus**2*ctw**6*us*mz**2*mh**4-4*sdet4izhtsus*
     & *2*ctw**6*us*mz**4*mh**2+2*sdet4izhtsus**2*ctw**6*us*mz**6-2*sdet
     & 4izhtsus**2*ctw**6*mz**2*mh**6+6*sdet4izhtsus**2*ctw**6*mz**4*mh*
     & *4-6*sdet4izhtsus**2*ctw**6*mz**6*mh**2+2*sdet4izhtsus**2*ctw**6*
     & mz**8)
     & +propizqs*c0zhqswww*(sdet4izhtsus*ctw**2*ts-sdet4izhtsus*ctw**2*m
     & h**2-2*sdet4izhtsus*ctw**4*us+2*sdet4izhtsus*ctw**4*mz**2+2*sdet4
     & izhtsus*ctw**4*mh**2+2*sdet4izhtsus**2*ctw**4*ts*mz**2*mh**2+2*sd
     & et4izhtsus**2*ctw**4*ts**2*mz**2-4*sdet4izhtsus**2*ctw**4*us*mz**
     & 2*mh**2+2*sdet4izhtsus**2*ctw**4*us**2*mz**2+2*sdet4izhtsus**2*ct
     & w**4*us**3-4*sdet4izhtsus**2*ctw**4*mz**4*mh**2-4*sdet4izhtsus**2
     & *ctw**6*ts*mz**4+4*sdet4izhtsus**2*ctw**6*us*mz**2*mh**2-4*sdet4i
     & zhtsus**2*ctw**6*us**2*mz**2-2*sdet4izhtsus**2*ctw**6*mz**2*mh**4
     & +4*sdet4izhtsus**2*ctw**6*mz**4*mh**2+2*sdet4izhtsus**2*ctw**6*mz
     & **6)
     & +propizqs*c0zhqsmomomo*qel*cfl/qs*(-2*stw**2*qmo*vpamo/mz**2*mmo*
     & *2-2*stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*qel*cfq/qs*(-2*stw**2*qch*vpach/mz**2*mch*
     & *2-2*stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*qel*cfq/qs*(-2*stw**2*qst*vpast/mz**2*mst*
     & *2-2*stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*qel*cfl/qs*(-2*stw**2*qta*vpata/mz**2*mta*
     & *2-2*stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*qel*cfq/qs*(-2*stw**2*qtp*vpatp/mz**2*mtp*
     & *2-2*stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*qel*cfq/qs*(-2*stw**2*qbt*vpabt/mz**2*mbt*
     & *2-2*stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*c0cztswcc/qs*(-ctw**2+sdet4izhtsus*ctw**2*ts*mz**2+sdet
     & 4izhtsus*ctw**2*us*mz**2+sdet4izhtsus*ctw**2*mz**2*mh**2+sdet4izh
     & tsus*ctw**2*mz**4+sdet4izhtsus*ctw**4*us*mz**2+sdet4izhtsus*ctw**
     & 4*mz**4)
     & +propizqs*c0cztswcc*(sdet4izhtsus**2*ctw**4*ts*mz**4-sdet4izhtsus
     & **2*ctw**4*us*mz**4)
     & +propizqs*c0cztszcc*vpael**3/qs*(-1d0/2/ctw**2+1d0/2*sdet4izhtsus
     & /ctw**2*ts*mz**2+sdet4izhtsus/ctw**2*us*mz**2+1d0/2*sdet4izhtsus/
     & ctw**2*mz**2*mh**2+sdet4izhtsus/ctw**2*mz**4)
     & +propizqs*c0cztszcc*vpael**3*(1d0/2*sdet4izhtsus**2/ctw**2*ts*mz*
     & *4-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4)
     & +propizqs*c0cztscww/qs*(ctw**2-2*ctw**4+2*sdet4izhtsus*ctw**6*ts*
     & mz**2+2*sdet4izhtsus*ctw**6*mz**2*mh**2)
     & +propizqs*c0cztscww*(-sdet4izhtsus*ctw**2*ts-2*sdet4izhtsus*ctw**
     & 4*mz**2+2*sdet4izhtsus*ctw**6*mz**2-2*sdet4izhtsus**2*ctw**4*ts*m
     & z**2*mh**2-2*sdet4izhtsus**2*ctw**4*ts*mz**4-2*sdet4izhtsus**2*ct
     & w**4*ts**2*mz**2-2*sdet4izhtsus**2*ctw**4*mz**4*mh**2+2*sdet4izht
     & sus**2*ctw**6*ts*mz**4-2*sdet4izhtsus**2*ctw**6*us*mz**4)
     & +propizqs*c0czuswcc/qs*(ctw**2-sdet4izhtsus*ctw**2*us*mz**2+sdet4
     & izhtsus*ctw**2*us*mh**2+sdet4izhtsus*ctw**2*mz**2*mh**2-sdet4izht
     & sus*ctw**2*mz**4+sdet4izhtsus*ctw**4*us*mz**2-sdet4izhtsus*ctw**4
     & *mz**2*mh**2+2*sdet4izhtsus*ctw**4*mz**4+sdet4izhtsus**2*ctw**4*t
     & s*mz**6-sdet4izhtsus**2*ctw**4*us*mz**2*mh**4+2*sdet4izhtsus**2*c
     & tw**4*us*mz**4*mh**2-sdet4izhtsus**2*ctw**4*mz**4*mh**4+3*sdet4iz
     & htsus**2*ctw**4*mz**6*mh**2)
     & +propizqs*c0czuswcc*(sdet4izhtsus*ctw**2*us-sdet4izhtsus**2*ctw**
     & 4*us*mz**2*mh**2+sdet4izhtsus**2*ctw**4*us*mz**4+sdet4izhtsus**2*
     & ctw**4*us**2*mz**2)
     & +propizqs*c0czuszcc*vpael**3/qs*(1d0/2/ctw**2+1d0/2*sdet4izhtsus/
     & ctw**2*us*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**4+1d0/2*sdet4izhtsu
     & s**2/ctw**2*ts*mz**6-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**2*mh**4+
     & sdet4izhtsus**2/ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**
     & 2*mz**4*mh**4+3d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2)
     & +propizqs*c0czuszcc*vpael**3*(1d0/2*sdet4izhtsus/ctw**2*us-1d0/2*
     & sdet4izhtsus**2/ctw**2*us*mz**2*mh**2+1d0/2*sdet4izhtsus**2/ctw**
     & 2*us*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*us**2*mz**2)
     & +propizqs*c0czuscww/qs*(2*ctw**4-2*sdet4izhtsus*ctw**4*us*mz**2+2
     & *sdet4izhtsus*ctw**4*us*mh**2+2*sdet4izhtsus*ctw**4*mz**2*mh**2-2
     & *sdet4izhtsus*ctw**4*mz**4+2*sdet4izhtsus*ctw**6*us*mz**2-2*sdet4
     & izhtsus*ctw**6*mz**2*mh**2+4*sdet4izhtsus*ctw**6*mz**4-2*sdet4izh
     & tsus**2*ctw**6*us*mz**2*mh**4+4*sdet4izhtsus**2*ctw**6*us*mz**4*m
     & h**2-2*sdet4izhtsus**2*ctw**6*us*mz**6-2*sdet4izhtsus**2*ctw**6*m
     & z**4*mh**4+4*sdet4izhtsus**2*ctw**6*mz**6*mh**2-2*sdet4izhtsus**2
     & *ctw**6*mz**8)
     & +propizqs*c0czuscww*(2*sdet4izhtsus*ctw**4*us-2*sdet4izhtsus**2*c
     & tw**4*us*mz**4-4*sdet4izhtsus**2*ctw**4*us**2*mz**2-2*sdet4izhtsu
     & s**2*ctw**4*us**3-2*sdet4izhtsus**2*ctw**6*us*mz**2*mh**2+2*sdet4
     & izhtsus**2*ctw**6*us*mz**4+2*sdet4izhtsus**2*ctw**6*us**2*mz**2-2
     & *sdet4izhtsus**2*ctw**6*mz**6)
     & +propizqs*c0chtscww/qs*(-2*ctw**2+2*ctw**4-2*sdet4izhtsus*ctw**2*
     & ts*mz**2+sdet4izhtsus*ctw**2*ts*mh**2-sdet4izhtsus*ctw**2*us*mh**
     & 2-3*sdet4izhtsus*ctw**2*mz**2*mh**2+sdet4izhtsus*ctw**2*mh**4+2*s
     & det4izhtsus*ctw**4*ts*mz**2-2*sdet4izhtsus*ctw**4*ts*mh**2-sdet4i
     & zhtsus*ctw**4*us*mz**2+3*sdet4izhtsus*ctw**4*mz**2*mh**2-2*sdet4i
     & zhtsus*ctw**4*mz**4-2*sdet4izhtsus*ctw**4*mh**4-2*sdet4izhtsus*ct
     & w**6*ts*mz**2-4*sdet4izhtsus*ctw**6*mz**2*mh**2+2*sdet4izhtsus*ct
     & w**6*mz**4+sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2-sdet4izhtsus**2*
     & ctw**4*ts*mz**6+sdet4izhtsus**2*ctw**4*us*mz**2*mh**4-sdet4izhtsu
     & s**2*ctw**4*us*mz**4*mh**2+2*sdet4izhtsus**2*ctw**4*mz**4*mh**4-2
     & *sdet4izhtsus**2*ctw**4*mz**6*mh**2+2*sdet4izhtsus**2*ctw**6*ts*m
     & z**2*mh**4-4*sdet4izhtsus**2*ctw**6*ts*mz**4*mh**2+2*sdet4izhtsus
     & **2*ctw**6*ts*mz**6+2*sdet4izhtsus**2*ctw**6*mz**2*mh**6-4*sdet4i
     & zhtsus**2*ctw**6*mz**4*mh**4+2*sdet4izhtsus**2*ctw**6*mz**6*mh**2
     & )
     & +propizqs*c0chtscww*(-sdet4izhtsus*ctw**2*ts-2*sdet4izhtsus*ctw**
     & 4*mh**2-2*sdet4izhtsus*ctw**6*mz**2-4*sdet4izhtsus**2*ctw**4*ts*m
     & z**2*mh**2-sdet4izhtsus**2*ctw**4*ts*mz**4-2*sdet4izhtsus**2*ctw*
     & *4*ts**2*mz**2+sdet4izhtsus**2*ctw**4*us*mz**2*mh**2-2*sdet4izhts
     & us**2*ctw**4*mz**2*mh**4+2*sdet4izhtsus**2*ctw**6*ts*mz**4-2*sdet
     & 4izhtsus**2*ctw**6*us*mz**2*mh**2+2*sdet4izhtsus**2*ctw**6*mz**2*
     & mh**4-2*sdet4izhtsus**2*ctw**6*mz**4*mh**2)
     & +propizqs*c0chtsczz*vpael**3/qs*(-1d0/2/ctw**2-1d0/2*sdet4izhtsus
     & /ctw**2*ts*mz**2-1d0/2*sdet4izhtsus/ctw**2*us*mz**2-1d0/2*sdet4iz
     & htsus/ctw**2*us*mh**2-1d0/2*sdet4izhtsus/ctw**2*mz**2*mh**2-sdet4
     & izhtsus/ctw**2*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6+1d0/2*sdet4izhtsus**2/ctw**
     & 2*us*mz**2*mh**4-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2+sdet
     & 4izhtsus**2/ctw**2*mz**4*mh**4-sdet4izhtsus**2/ctw**2*mz**6*mh**2
     & )
     & +propizqs*c0chtsczz*vpael**3*(-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz
     & **4+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**2*mh**2)
     & +propizqs*c0chuscww/qs*(ctw**2-2*ctw**4-sdet4izhtsus*ctw**4*us*mz
     & **2-sdet4izhtsus*ctw**4*mz**4-2*sdet4izhtsus*ctw**6*us*mz**2-2*sd
     & et4izhtsus*ctw**6*mz**4-sdet4izhtsus**2*ctw**4*ts*mz**4*mh**2-sde
     & t4izhtsus**2*ctw**4*us*mz**4*mh**2-sdet4izhtsus**2*ctw**4*mz**4*m
     & h**4-sdet4izhtsus**2*ctw**4*mz**6*mh**2)
     & +propizqs*c0chuscww*(-sdet4izhtsus*ctw**2*us+2*sdet4izhtsus*ctw**
     & 4*us-4*sdet4izhtsus*ctw**6*mz**2-2*sdet4izhtsus**2*ctw**4*us*mz**
     & 2*mh**2-3*sdet4izhtsus**2*ctw**4*us**2*mz**2-2*sdet4izhtsus**2*ct
     & w**4*us**2*mh**2-2*sdet4izhtsus**2*ctw**4*us**3+2*sdet4izhtsus**2
     & *ctw**6*us**2*mz**2-2*sdet4izhtsus**2*ctw**6*mz**4*mh**2)
     & +propizqs*c0chusczz*vpael**3/qs*(1d0/2/ctw**2-1d0/2*sdet4izhtsus/
     & ctw**2*us*mz**2-1d0/2*sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsu
     & s**2/ctw**2*ts*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*
     & mh**2-1d0/2*sdet4izhtsus**2/ctw**2*mz**4*mh**4-1d0/2*sdet4izhtsus
     & **2/ctw**2*mz**6*mh**2)
     & +propizqs*c0chusczz*vpael**3*(-1d0/2*sdet4izhtsus/ctw**2*us-1d0/2
     & *sdet4izhtsus**2/ctw**2*us**2*mz**2)
     & +propizqs*c0ccqswcw*(sdet4izhtsus*ctw**2*ts+sdet4izhtsus*ctw**2*m
     & h**2+2*sdet4izhtsus*ctw**4*us+4*sdet4izhtsus*ctw**4*mz**2+4*sdet4
     & izhtsus**2*ctw**4*ts*mz**2*mh**2+2*sdet4izhtsus**2*ctw**4*ts*mz**
     & 4+2*sdet4izhtsus**2*ctw**4*ts**2*mz**2+6*sdet4izhtsus**2*ctw**4*u
     & s*mz**2*mh**2+2*sdet4izhtsus**2*ctw**4*us*mz**4+4*sdet4izhtsus**2
     & *ctw**4*us**2*mz**2+2*sdet4izhtsus**2*ctw**4*us**2*mh**2+2*sdet4i
     & zhtsus**2*ctw**4*us**3+2*sdet4izhtsus**2*ctw**4*mz**2*mh**4+6*sde
     & t4izhtsus**2*ctw**4*mz**4*mh**2)
     & +propizqs*b0fzcc*vpael**3/qs*(-sdet4izhtsus/ctw**2*us-sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0fzcc/qs*(-2*sdet4izhtsus*ctw**2*us-2*sdet4izhtsus*ctw
     & **2*mz**2)
     & +propizqs*b0fhww/qs*(-2*sdet4izhtsus*ctw**2*us-2*sdet4izhtsus*ctw
     & **2*mz**2)
     & +propizqs*b0fhww*(-4*sdet4izhtsus*ctw**4)
     & +propizqs*b0fhzz*vpael**3/qs*(-sdet4izhtsus/ctw**2*us-sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0ftswc/qs*(2*sdet4izhtsus*ctw**2*us+2*sdet4izhtsus*ctw
     & **2*mz**2)
     & +propizqs*b0ftszc*vpael**3/qs*(sdet4izhtsus/ctw**2*us+sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0fuswc/qs*(2*sdet4izhtsus*ctw**2*us+2*sdet4izhtsus*ctw
     & **2*mz**2)
     & +propizqs*b0fuswc*(4*sdet4izhtsus*ctw**4)
     & +propizqs*b0fuszc*vpael**3/qs*(sdet4izhtsus/ctw**2*us+sdet4izhtsu
     & s/ctw**2*mz**2)
     & +det3izhqs*vpael*cfl*(1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d
     & 0/2/ctw**2*vpamo**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2*mmo*
     & *2-1d0/2/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2
     & *mta**2-1d0/2/ctw**2*vpata**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*
     & mh**2*mta**2-1d0/2/ctw**2*vmata**2*mta**2)
     & +det3izhqs*vpael*cfq*(1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d
     & 0/2/ctw**2*vpach**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mh**2*mch*
     & *2-1d0/2/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2
     & *mst**2-1d0/2/ctw**2*vpast**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*
     & mh**2*mst**2-1d0/2/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpatp**2/m
     & z**2*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2*mtp**2+1d0/4/ctw**2*vmatp
     & **2/mz**2*mh**2*mtp**2-1d0/2/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*
     & vpabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2*mbt**2+1d0/4/ct
     & w**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vmabt**2*mbt**2)
     & +det3izhqs*vpael*(1d0/4/ctw**2*mz**2-7d0/8/ctw**2*mh**2-2*ctw**2*
     & mz**2+6*ctw**4*mz**2-3*ctw**4*mh**2+1d0/2*mz**2+3d0/4*mh**2)
     & +det3izhqs**2*c0zhqswww*vpael*(-3d0/2/ctw**2*mz**6*mh**2-3*ctw**2
     & *mz**6*mh**2-9*ctw**4*mz**6*mh**2+21d0/4*mz**6*mh**2)
     & +det3izhqs**2*c0zhqszhh*vpael*(-9/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqshzz*vpael*(-18/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqsmomomo*vpael*cfl*(3d0/4/ctw**2*vpamo**2*mz**4
     & *mh**2*mmo**2+3d0/4/ctw**2*vmamo**2*mz**4*mh**2*mmo**2)
     & +det3izhqs**2*c0zhqschchch*vpael*cfq*(3d0/4/ctw**2*vpach**2*mz**4
     & *mh**2*mch**2+3d0/4/ctw**2*vmach**2*mz**4*mh**2*mch**2)
     & +det3izhqs**2*c0zhqsststst*vpael*cfq*(3d0/4/ctw**2*vpast**2*mz**4
     & *mh**2*mst**2+3d0/4/ctw**2*vmast**2*mz**4*mh**2*mst**2)
     & +det3izhqs**2*c0zhqstatata*vpael*cfl*(3d0/4/ctw**2*vpata**2*mz**4
     & *mh**2*mta**2+3d0/4/ctw**2*vmata**2*mz**4*mh**2*mta**2)
     & +det3izhqs**2*c0zhqstptptp*vpael*cfq*(3d0/4/ctw**2*vpatp**2*mz**4
     & *mh**2*mtp**2+3d0/4/ctw**2*vmatp**2*mz**4*mh**2*mtp**2)
     & +det3izhqs**2*c0zhqsbtbtbt*vpael*cfq*(3d0/4/ctw**2*vpabt**2*mz**4
     & *mh**2*mbt**2+3d0/4/ctw**2*vmabt**2*mz**4*mh**2*mbt**2)
     & +det3izhqs**2*b0fzww*vpael*(-3d0/4/ctw**2*mz**4*mh**2-3d0/2*ctw**
     & 2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2+21d0/8*mz**4*mh**2)
     & +det3izhqs**2*b0fzmomo*vpael*cfl*(3d0/8/ctw**2*vpamo**2*mz**2*mh*
     & *2*mmo**2+3d0/8/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fzchch*vpael*cfq*(3d0/8/ctw**2*vpach**2*mz**2*mh*
     & *2*mch**2+3d0/8/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fzstst*vpael*cfq*(3d0/8/ctw**2*vpast**2*mz**2*mh*
     & *2*mst**2+3d0/8/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fztata*vpael*cfl*(3d0/8/ctw**2*vpata**2*mz**2*mh*
     & *2*mta**2+3d0/8/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fztptp*vpael*cfq*(3d0/8/ctw**2*vpatp**2*mz**2*mh*
     & *2*mtp**2+3d0/8/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fzbtbt*vpael*cfq*(3d0/8/ctw**2*vpabt**2*mz**2*mh*
     & *2*mbt**2+3d0/8/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fhww*vpael*(3d0/2/ctw**2*mz**4*mh**2+3*ctw**2*mz*
     & *4*mh**2+9*ctw**4*mz**4*mh**2-21d0/4*mz**4*mh**2)
     & +det3izhqs**2*b0fhzz*vpael*(9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhhh*vpael*(-9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhmomo*vpael*cfl*(-3d0/4/ctw**2*vpamo**2*mz**2*mh
     & **2*mmo**2-3d0/4/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fhchch*vpael*cfq*(-3d0/4/ctw**2*vpach**2*mz**2*mh
     & **2*mch**2-3d0/4/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fhstst*vpael*cfq*(-3d0/4/ctw**2*vpast**2*mz**2*mh
     & **2*mst**2-3d0/4/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fhtata*vpael*cfl*(-3d0/4/ctw**2*vpata**2*mz**2*mh
     & **2*mta**2-3d0/4/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fhtptp*vpael*cfq*(-3d0/4/ctw**2*vpatp**2*mz**2*mh
     & **2*mtp**2-3d0/4/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fhbtbt*vpael*cfq*(-3d0/4/ctw**2*vpabt**2*mz**2*mh
     & **2*mbt**2-3d0/4/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fqsww*vpael*(-3d0/4/ctw**2*mz**4*mh**2-3d0/2*ctw*
     & *2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2+21d0/8*mz**4*mh**2)
     & +det3izhqs**2*b0fqsmomo*vpael*cfl*(3d0/8/ctw**2*vpamo**2*mz**2*mh
     & **2*mmo**2+3d0/8/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fqschch*vpael*cfq*(3d0/8/ctw**2*vpach**2*mz**2*mh
     & **2*mch**2+3d0/8/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fqsstst*vpael*cfq*(3d0/8/ctw**2*vpast**2*mz**2*mh
     & **2*mst**2+3d0/8/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fqstata*vpael*cfl*(3d0/8/ctw**2*vpata**2*mz**2*mh
     & **2*mta**2+3d0/8/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fqstptp*vpael*cfq*(3d0/8/ctw**2*vpatp**2*mz**2*mh
     & **2*mtp**2+3d0/8/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fqsbtbt*vpael*cfq*(3d0/8/ctw**2*vpabt**2*mz**2*mh
     & **2*mbt**2+3d0/8/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*c0zhqswww*vpael*(1d0/2/ctw**2*mz**2*mh**2+3d0/2/ctw**2
     & *mz**4+1d0/2*ctw**2*mz**2*mh**2+ctw**2*mz**4+16*ctw**4*mz**4+6*ct
     & w**6*mz**2*mh**2-12*ctw**6*mz**4-1d0/2*mz**2*mh**2-5*mz**4)
     & +det3izhqs*c0zhqszhh*vpael*(51d0/4/ctw**2*mz**2*mh**2+9/ctw**2*mz
     & **4)
     & +det3izhqs*c0zhqshzz*vpael*(17/ctw**2*mz**2*mh**2+18/ctw**2*mz**4
     & )
     & +det3izhqs*c0zhqsmomomo*vpael*cfl*(1d0/2/ctw**2*vpamo*vmamo*mh**2
     & *mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mh**2*mmo**4-1d0/ctw**2*vpamo
     & **2*mz**2*mmo**2-1d0/4/ctw**2*vpamo**2*mh**2*mmo**2+1d0/ctw**2*vp
     & amo**2*mmo**4-1d0/2/ctw**2*vmamo**2/mz**2*mh**2*mmo**4-1d0/ctw**2
     & *vmamo**2*mz**2*mmo**2-1d0/4/ctw**2*vmamo**2*mh**2*mmo**2+1d0/ctw
     & **2*vmamo**2*mmo**4)
     & +det3izhqs*c0zhqschchch*vpael*cfq*(1d0/2/ctw**2*vpach*vmach*mh**2
     & *mch**2-1d0/2/ctw**2*vpach**2/mz**2*mh**2*mch**4-1d0/ctw**2*vpach
     & **2*mz**2*mch**2-1d0/4/ctw**2*vpach**2*mh**2*mch**2+1d0/ctw**2*vp
     & ach**2*mch**4-1d0/2/ctw**2*vmach**2/mz**2*mh**2*mch**4-1d0/ctw**2
     & *vmach**2*mz**2*mch**2-1d0/4/ctw**2*vmach**2*mh**2*mch**2+1d0/ctw
     & **2*vmach**2*mch**4)
     & +det3izhqs*c0zhqsststst*vpael*cfq*(1d0/2/ctw**2*vpast*vmast*mh**2
     & *mst**2-1d0/2/ctw**2*vpast**2/mz**2*mh**2*mst**4-1d0/ctw**2*vpast
     & **2*mz**2*mst**2-1d0/4/ctw**2*vpast**2*mh**2*mst**2+1d0/ctw**2*vp
     & ast**2*mst**4-1d0/2/ctw**2*vmast**2/mz**2*mh**2*mst**4-1d0/ctw**2
     & *vmast**2*mz**2*mst**2-1d0/4/ctw**2*vmast**2*mh**2*mst**2+1d0/ctw
     & **2*vmast**2*mst**4)
     & +det3izhqs*c0zhqstatata*vpael*cfl*(1d0/2/ctw**2*vpata*vmata*mh**2
     & *mta**2-1d0/2/ctw**2*vpata**2/mz**2*mh**2*mta**4-1d0/ctw**2*vpata
     & **2*mz**2*mta**2-1d0/4/ctw**2*vpata**2*mh**2*mta**2+1d0/ctw**2*vp
     & ata**2*mta**4-1d0/2/ctw**2*vmata**2/mz**2*mh**2*mta**4-1d0/ctw**2
     & *vmata**2*mz**2*mta**2-1d0/4/ctw**2*vmata**2*mh**2*mta**2+1d0/ctw
     & **2*vmata**2*mta**4)
     & +det3izhqs*c0zhqstptptp*vpael*cfq*(1d0/2/ctw**2*vpatp*vmatp*mh**2
     & *mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mh**2*mtp**4-1d0/ctw**2*vpatp
     & **2*mz**2*mtp**2-1d0/4/ctw**2*vpatp**2*mh**2*mtp**2+1d0/ctw**2*vp
     & atp**2*mtp**4-1d0/2/ctw**2*vmatp**2/mz**2*mh**2*mtp**4-1d0/ctw**2
     & *vmatp**2*mz**2*mtp**2-1d0/4/ctw**2*vmatp**2*mh**2*mtp**2+1d0/ctw
     & **2*vmatp**2*mtp**4)
     & +det3izhqs*c0zhqsbtbtbt*vpael*cfq*(1d0/2/ctw**2*vpabt*vmabt*mh**2
     & *mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mh**2*mbt**4-1d0/ctw**2*vpabt
     & **2*mz**2*mbt**2-1d0/4/ctw**2*vpabt**2*mh**2*mbt**2+1d0/ctw**2*vp
     & abt**2*mbt**4-1d0/2/ctw**2*vmabt**2/mz**2*mh**2*mbt**4-1d0/ctw**2
     & *vmabt**2*mz**2*mbt**2-1d0/4/ctw**2*vmabt**2*mh**2*mbt**2+1d0/ctw
     & **2*vmabt**2*mbt**4)
     & +det3izhqs*a0fz*vpael*(1d0/4/ctw**2*mz**2-1d0/4/ctw**2*mh**2)
     & +det3izhqs*a0fh*vpael*(3d0/4/ctw**2*mh**2)
     & +det3izhqs*b0fzww*vpael*(3d0/4/ctw**2*mz**2+1d0/8/ctw**2*mh**2+2*
     & ctw**2*mz**2+1d0/2*ctw**2*mh**2+3*ctw**4*mz**2-11d0/4*mz**2)
     & +det3izhqs*b0fzzh*vpael*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fzmomo*vpael*cfl*(1d0/4/ctw**2*vpamo*vmamo/mz**2*mh*
     & *2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw**2*v
     & pamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw
     & **2*vmamo**2*mmo**2)
     & +det3izhqs*b0fzchch*vpael*cfq*(1d0/4/ctw**2*vpach*vmach/mz**2*mh*
     & *2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ctw**2*v
     & pach**2*mch**2-1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-1d0/4/ctw
     & **2*vmach**2*mch**2)
     & +det3izhqs*b0fzstst*vpael*cfq*(1d0/4/ctw**2*vpast*vmast/mz**2*mh*
     & *2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ctw**2*v
     & past**2*mst**2-1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-1d0/4/ctw
     & **2*vmast**2*mst**2)
     & +det3izhqs*b0fztata*vpael*cfl*(1d0/4/ctw**2*vpata*vmata/mz**2*mh*
     & *2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ctw**2*v
     & pata**2*mta**2-1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d0/4/ctw
     & **2*vmata**2*mta**2)
     & +det3izhqs*b0fztptp*vpael*cfq*(1d0/4/ctw**2*vpatp*vmatp/mz**2*mh*
     & *2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw**2*v
     & patp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw
     & **2*vmatp**2*mtp**2)
     & +det3izhqs*b0fzbtbt*vpael*cfq*(1d0/4/ctw**2*vpabt*vmabt/mz**2*mh*
     & *2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw**2*v
     & pabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw
     & **2*vmabt**2*mbt**2)
     & +det3izhqs*b0fhww*vpael*(-3d0/2/ctw**2*mz**2-1d0/4/ctw**2*mh**2-4
     & *ctw**2*mz**2-ctw**2*mh**2-6*ctw**4*mz**2+11d0/2*mz**2)
     & +det3izhqs*b0fhzz*vpael*(-17d0/4/ctw**2*mz**2-21d0/8/ctw**2*mh**2
     & )
     & +det3izhqs*b0fhhh*vpael*(9d0/2/ctw**2*mz**2+33d0/8/ctw**2*mh**2)
     & +det3izhqs*b0fhmomo*vpael*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mh
     & **2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2+1d0/2/ctw**2*
     & vpamo**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2*mmo**2+1d0/2/ct
     & w**2*vmamo**2*mmo**2)
     & +det3izhqs*b0fhchch*vpael*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mh
     & **2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2+1d0/2/ctw**2*
     & vpach**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mh**2*mch**2+1d0/2/ct
     & w**2*vmach**2*mch**2)
     & +det3izhqs*b0fhstst*vpael*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mh
     & **2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2*mst**2+1d0/2/ctw**2*
     & vpast**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*mh**2*mst**2+1d0/2/ct
     & w**2*vmast**2*mst**2)
     & +det3izhqs*b0fhtata*vpael*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mh
     & **2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta**2+1d0/2/ctw**2*
     & vpata**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*mh**2*mta**2+1d0/2/ct
     & w**2*vmata**2*mta**2)
     & +det3izhqs*b0fhtptp*vpael*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mh
     & **2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mh**2*mtp**2+1d0/2/ctw**2*
     & vpatp**2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mh**2*mtp**2+1d0/2/ct
     & w**2*vmatp**2*mtp**2)
     & +det3izhqs*b0fhbtbt*vpael*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mh
     & **2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt**2+1d0/2/ctw**2*
     & vpabt**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mh**2*mbt**2+1d0/2/ct
     & w**2*vmabt**2*mbt**2)
     & +det3izhqs*b0fqsww*vpael*(3d0/4/ctw**2*mz**2+1d0/8/ctw**2*mh**2+2
     & *ctw**2*mz**2+1d0/2*ctw**2*mh**2+3*ctw**4*mz**2-11d0/4*mz**2)
     & +det3izhqs*b0fqszh*vpael*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fqsmomo*vpael*cfl*(1d0/4/ctw**2*vpamo*vmamo/mz**2*mh
     & **2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw**2*
     & vpamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-1d0/4/ct
     & w**2*vmamo**2*mmo**2)
     & +det3izhqs*b0fqschch*vpael*cfq*(1d0/4/ctw**2*vpach*vmach/mz**2*mh
     & **2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ctw**2*
     & vpach**2*mch**2-1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-1d0/4/ct
     & w**2*vmach**2*mch**2)
     & +det3izhqs*b0fqsstst*vpael*cfq*(1d0/4/ctw**2*vpast*vmast/mz**2*mh
     & **2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ctw**2*
     & vpast**2*mst**2-1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-1d0/4/ct
     & w**2*vmast**2*mst**2)
     & +det3izhqs*b0fqstata*vpael*cfl*(1d0/4/ctw**2*vpata*vmata/mz**2*mh
     & **2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ctw**2*
     & vpata**2*mta**2-1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d0/4/ct
     & w**2*vmata**2*mta**2)
     & +det3izhqs*b0fqstptp*vpael*cfq*(1d0/4/ctw**2*vpatp*vmatp/mz**2*mh
     & **2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw**2*
     & vpatp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-1d0/4/ct
     & w**2*vmatp**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*vpael*cfq*(1d0/4/ctw**2*vpabt*vmabt/mz**2*mh
     & **2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw**2*
     & vpabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/4/ct
     & w**2*vmabt**2*mbt**2)
     & +c0zhqswww*vpael*(-1-4*ctw**2+12*ctw**4)
     & +c0zhqszhh*vpael*(-3/ctw**2/mz**2*mh**2-21d0/2/ctw**2)
     & +c0zhqshzz*vpael*(-3d0/2/ctw**2/mz**2*mh**2-13/ctw**2)
     & +c0zhqsmomomo*vpael*cfl*(-1d0/ctw**2*vpamo*vmamo/mz**2*mmo**2)
     & +c0zhqschchch*vpael*cfq*(-1d0/ctw**2*vpach*vmach/mz**2*mch**2)
     & +c0zhqsststst*vpael*cfq*(-1d0/ctw**2*vpast*vmast/mz**2*mst**2)
     & +c0zhqstatata*vpael*cfl*(-1d0/ctw**2*vpata*vmata/mz**2*mta**2)
     & +c0zhqstptptp*vpael*cfq*(-1d0/ctw**2*vpatp*vmatp/mz**2*mtp**2)
     & +c0zhqsbtbtbt*vpael*cfq*(-1d0/ctw**2*vpabt*vmabt/mz**2*mbt**2)
     & +a0fh*vpael*(-1d0/ctw**2/mz**2)
     & +b0fzzh*vpael*(1d0/2/ctw**2/mz**2)
     & +b0fhzz*vpael*(1d0/ctw**2/mz**2)
     & +b0fhhh*vpael*(-3/ctw**2/mz**2)
     & +b0fqszh*vpael*(1d0/2/ctw**2/mz**2)

      ffgm0=
     & +vpael**2*(-1d0/8/ctw**2)
     & +vmael**2*(-1d0/4/ctw**2)
     & +cfl*(-1d0/2/ctw**2*vpamo**2/mz**2*mmo**2-1d0/2/ctw**2*vmamo**2/m
     & z**2*mmo**2-1d0/2/ctw**2*vpata**2/mz**2*mta**2-1d0/2/ctw**2*vmata
     & **2/mz**2*mta**2)
     & +cfq*(-1d0/2/ctw**2*vpach**2/mz**2*mch**2-1d0/2/ctw**2*vmach**2/m
     & z**2*mch**2-1d0/2/ctw**2*vpast**2/mz**2*mst**2-1d0/2/ctw**2*vmast
     & **2/mz**2*mst**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**2-1d0/2/ctw**2*
     & vmatp**2/mz**2*mtp**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**2-1d0/2/ct
     & w**2*vmabt**2/mz**2*mbt**2)
     & +propzqs*a0fw*(-8d0/3*ctw**2*mz**2+3*ctw**2*mz**4/mh**2-4*ctw**4*
     & mz**2+1d0/6*mz**2)
     & +propzqs*a0fz*(1d0/6/ctw**2*mz**2+3d0/2/ctw**2*mz**4/mh**2-1d0/12
     & /ctw**2*mh**2)
     & +propzqs*a0fh*(1d0/12/ctw**2/mz**2*mh**4+1d0/2/ctw**2*mh**2)
     & +propzqs*b0fqsww*(1d0/12/ctw**2*mz**2-17d0/3*ctw**2*mz**2-4*ctw**
     & 4*mz**2+4d0/3*mz**2)
     & +propzqs*b0fqszh*(1d0/12/ctw**2/mz**2*mh**4+1d0/ctw**2*mz**2-1d0/
     & 3/ctw**2*mh**2)
     & +propzqs*(-1d0/18/ctw**2*mz**2+1d0/ctw**2*mz**4/mh**2-1d0/6/ctw**
     & 2*mh**2-8d0/3*ctw**2*mz**2+2*ctw**2*mz**4/mh**2-4*ctw**4*mz**2-mz
     & **2*zmzzzbos-5d0/9*mz**2)
     & +propizqs*cfl/qs*(qmo*vpamo/mz**2*mmo**2+qmo*vmamo/mz**2*mmo**2+q
     & ta*vpata/mz**2*mta**2+qta*vmata/mz**2*mta**2)
     & +propizqs*cfq/qs*(qch*vpach/mz**2*mch**2+qch*vmach/mz**2*mch**2+q
     & st*vpast/mz**2*mst**2+qst*vmast/mz**2*mst**2+qtp*vpatp/mz**2*mtp*
     & *2+qtp*vmatp/mz**2*mtp**2+qbt*vpabt/mz**2*mbt**2+qbt*vmabt/mz**2*
     & mbt**2)
     & +propizqs/qs*(-ctw**2/mz**2*mh**2+1d0/3*ctw**2-2*ctw**4+1d0/2/mz*
     & *2*mh**2)
     & +propizqs*det3izhqs*c0zhqswww*qs*(-1d0/8/ctw**2*mz**2-1d0/2*ctw**
     & 2*mz**2+1d0/2*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*(-1d0/4/ctw**2*mz**2*mh**2-1d0/8/ct
     & w**2*mz**4-1d0/8/ctw**2*mh**4-1d0/2*ctw**2*mz**2*mh**2-1d0/2*ctw*
     & *2*mz**4+3d0/4*mz**2*mh**2+1d0/2*mz**4+1d0/4*mh**4)
     & +propizqs*det3izhqs*c0zhqszhh*qs*(-3d0/4/ctw**2*mz**2-3d0/16/ctw*
     & *2*mh**2)
     & +propizqs*det3izhqs*c0zhqszhh*(-3d0/16/ctw**2/mz**2*mh**6-27d0/16
     & /ctw**2*mz**2*mh**2-3d0/4/ctw**2*mz**4-3d0/8/ctw**2*mh**4)
     & +propizqs*det3izhqs*c0zhqshzz*qs*(-1d0/8/ctw**2/mz**2*mh**4-11d0/
     & 8/ctw**2*mz**2-7d0/16/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqshzz*(-3d0/16/ctw**2/mz**2*mh**6-55d0/16
     & /ctw**2*mz**2*mh**2-11d0/8/ctw**2*mz**4-1d0/ctw**2*mh**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*cfl*(1d0/4/ctw**2*vpamo**2*mh**2
     & *mmo**2+1d0/4/ctw**2*vmamo**2*mh**2*mmo**2-1d0/2*qmo*vpamo*mh**2*
     & mmo**2-1d0/2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqschchch*cfq*(1d0/4/ctw**2*vpach**2*mh**2
     & *mch**2+1d0/4/ctw**2*vmach**2*mh**2*mch**2-1d0/2*qch*vpach*mh**2*
     & mch**2-1d0/2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs*c0zhqsststst*cfq*(1d0/4/ctw**2*vpast**2*mh**2
     & *mst**2+1d0/4/ctw**2*vmast**2*mh**2*mst**2-1d0/2*qst*vpast*mh**2*
     & mst**2-1d0/2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs*c0zhqstatata*cfl*(1d0/4/ctw**2*vpata**2*mh**2
     & *mta**2+1d0/4/ctw**2*vmata**2*mh**2*mta**2-1d0/2*qta*vpata*mh**2*
     & mta**2-1d0/2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*cfq*(1d0/4/ctw**2*vpatp**2*mh**2
     & *mtp**2+1d0/4/ctw**2*vmatp**2*mh**2*mtp**2-1d0/2*qtp*vpatp*mh**2*
     & mtp**2-1d0/2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*cfq*(1d0/4/ctw**2*vpabt**2*mh**2
     & *mbt**2+1d0/4/ctw**2*vmabt**2*mh**2*mbt**2-1d0/2*qbt*vpabt*mh**2*
     & mbt**2-1d0/2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs*b0fzww/qs*(-3d0/2*ctw**4*mz**2*mh**2+3d0/2*ct
     & w**4*mz**4+1d0/8*mz**2*mh**2-1d0/8*mz**4)
     & +propizqs*det3izhqs*b0fzww*qs*(1d0/8-1d0/16/ctw**2)
     & +propizqs*det3izhqs*b0fzww*(-1d0/16/ctw**2*mz**2-3d0/16/ctw**2*mh
     & **2+1d0/2*ctw**2*mz**2-1d0/8*mz**2+3d0/8*mh**2)
     & +propizqs*det3izhqs*b0fzzh*qs*(1d0/16/ctw**2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fzzh*(1d0/16/ctw**2/mz**2*mh**4-1d0/8/ctw**
     & 2*mz**2+1d0/16/ctw**2*mh**2)
     & +propizqs*det3izhqs*b0fzmomo*cfl/qs*(-1d0/4*qmo*vpamo*mz**2*mmo**
     & 2+1d0/4*qmo*vpamo*mh**2*mmo**2-1d0/4*qmo*vmamo*mz**2*mmo**2+1d0/4
     & *qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*cfl*(1d0/8/ctw**2*vpamo**2*mmo**2+1d
     & 0/8/ctw**2*vmamo**2*mmo**2-1d0/4*qmo*vpamo*mmo**2-1d0/4*qmo*vmamo
     & *mmo**2)
     & +propizqs*det3izhqs*b0fzchch*cfq/qs*(-1d0/4*qch*vpach*mz**2*mch**
     & 2+1d0/4*qch*vpach*mh**2*mch**2-1d0/4*qch*vmach*mz**2*mch**2+1d0/4
     & *qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs*b0fzchch*cfq*(1d0/8/ctw**2*vpach**2*mch**2+1d
     & 0/8/ctw**2*vmach**2*mch**2-1d0/4*qch*vpach*mch**2-1d0/4*qch*vmach
     & *mch**2)
     & +propizqs*det3izhqs*b0fzstst*cfq/qs*(-1d0/4*qst*vpast*mz**2*mst**
     & 2+1d0/4*qst*vpast*mh**2*mst**2-1d0/4*qst*vmast*mz**2*mst**2+1d0/4
     & *qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs*b0fzstst*cfq*(1d0/8/ctw**2*vpast**2*mst**2+1d
     & 0/8/ctw**2*vmast**2*mst**2-1d0/4*qst*vpast*mst**2-1d0/4*qst*vmast
     & *mst**2)
     & +propizqs*det3izhqs*b0fztata*cfl/qs*(-1d0/4*qta*vpata*mz**2*mta**
     & 2+1d0/4*qta*vpata*mh**2*mta**2-1d0/4*qta*vmata*mz**2*mta**2+1d0/4
     & *qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs*b0fztata*cfl*(1d0/8/ctw**2*vpata**2*mta**2+1d
     & 0/8/ctw**2*vmata**2*mta**2-1d0/4*qta*vpata*mta**2-1d0/4*qta*vmata
     & *mta**2)
     & +propizqs*det3izhqs*b0fztptp*cfq/qs*(-1d0/4*qtp*vpatp*mz**2*mtp**
     & 2+1d0/4*qtp*vpatp*mh**2*mtp**2-1d0/4*qtp*vmatp*mz**2*mtp**2+1d0/4
     & *qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*cfq*(1d0/8/ctw**2*vpatp**2*mtp**2+1d
     & 0/8/ctw**2*vmatp**2*mtp**2-1d0/4*qtp*vpatp*mtp**2-1d0/4*qtp*vmatp
     & *mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*cfq/qs*(-1d0/4*qbt*vpabt*mz**2*mbt**
     & 2+1d0/4*qbt*vpabt*mh**2*mbt**2-1d0/4*qbt*vmabt*mz**2*mbt**2+1d0/4
     & *qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*cfq*(1d0/8/ctw**2*vpabt**2*mbt**2+1d
     & 0/8/ctw**2*vmabt**2*mbt**2-1d0/4*qbt*vpabt*mbt**2-1d0/4*qbt*vmabt
     & *mbt**2)
     & +propizqs*det3izhqs*b0fhww/qs*(3d0/2*ctw**4*mz**2*mh**2-3d0/2*ctw
     & **4*mz**4-1d0/8*mz**2*mh**2+1d0/8*mz**4)
     & +propizqs*det3izhqs*b0fhww*qs*(-1d0/4+1d0/16/ctw**2/mz**2*mh**2+1
     & d0/8/ctw**2-1d0/8/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fhww*(1d0/16/ctw**2/mz**2*mh**4+1d0/8/ctw**
     & 2*mz**2+5d0/16/ctw**2*mh**2-3d0/2*ctw**4*mz**2-1d0/8/mz**2*mh**4-
     & 1d0/8*mz**2-5d0/8*mh**2)
     & +propizqs*det3izhqs*b0fhzz*qs*(3d0/32/ctw**2/mz**2*mh**2+7d0/16/c
     & tw**2)
     & +propizqs*det3izhqs*b0fhzz*(5d0/32/ctw**2/mz**2*mh**4+7d0/16/ctw*
     & *2*mz**2+29d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs*b0fhhh*qs*(-3d0/32/ctw**2/mz**2*mh**2-3d0/8/c
     & tw**2)
     & +propizqs*det3izhqs*b0fhhh*(-9d0/32/ctw**2/mz**2*mh**4-3d0/8/ctw*
     & *2*mz**2-27d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl/qs*(1d0/4*qmo*vpamo*mz**2*mmo**2
     & -1d0/4*qmo*vpamo*mh**2*mmo**2+1d0/4*qmo*vmamo*mz**2*mmo**2-1d0/4*
     & qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl*qs*(-1d0/8/ctw**2*vpamo**2/mz**2
     & *mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mmo**2+1d0/4*qmo*vpamo/mz**2*
     & mmo**2+1d0/4*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*cfl*(-1d0/8/ctw**2*vpamo**2/mz**2*mh
     & **2*mmo**2-1d0/8/ctw**2*vpamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz*
     & *2*mh**2*mmo**2-1d0/8/ctw**2*vmamo**2*mmo**2+1d0/4*qmo*vpamo/mz**
     & 2*mh**2*mmo**2+1d0/2*qmo*vpamo*mmo**2+1d0/4*qmo*vmamo/mz**2*mh**2
     & *mmo**2+1d0/2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*cfq/qs*(1d0/4*qch*vpach*mz**2*mch**2
     & -1d0/4*qch*vpach*mh**2*mch**2+1d0/4*qch*vmach*mz**2*mch**2-1d0/4*
     & qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*cfq*qs*(-1d0/8/ctw**2*vpach**2/mz**2
     & *mch**2-1d0/8/ctw**2*vmach**2/mz**2*mch**2+1d0/4*qch*vpach/mz**2*
     & mch**2+1d0/4*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*cfq*(-1d0/8/ctw**2*vpach**2/mz**2*mh
     & **2*mch**2-1d0/8/ctw**2*vpach**2*mch**2-1d0/8/ctw**2*vmach**2/mz*
     & *2*mh**2*mch**2-1d0/8/ctw**2*vmach**2*mch**2+1d0/4*qch*vpach/mz**
     & 2*mh**2*mch**2+1d0/2*qch*vpach*mch**2+1d0/4*qch*vmach/mz**2*mh**2
     & *mch**2+1d0/2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fhstst*cfq/qs*(1d0/4*qst*vpast*mz**2*mst**2
     & -1d0/4*qst*vpast*mh**2*mst**2+1d0/4*qst*vmast*mz**2*mst**2-1d0/4*
     & qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*cfq*qs*(-1d0/8/ctw**2*vpast**2/mz**2
     & *mst**2-1d0/8/ctw**2*vmast**2/mz**2*mst**2+1d0/4*qst*vpast/mz**2*
     & mst**2+1d0/4*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*cfq*(-1d0/8/ctw**2*vpast**2/mz**2*mh
     & **2*mst**2-1d0/8/ctw**2*vpast**2*mst**2-1d0/8/ctw**2*vmast**2/mz*
     & *2*mh**2*mst**2-1d0/8/ctw**2*vmast**2*mst**2+1d0/4*qst*vpast/mz**
     & 2*mh**2*mst**2+1d0/2*qst*vpast*mst**2+1d0/4*qst*vmast/mz**2*mh**2
     & *mst**2+1d0/2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fhtata*cfl/qs*(1d0/4*qta*vpata*mz**2*mta**2
     & -1d0/4*qta*vpata*mh**2*mta**2+1d0/4*qta*vmata*mz**2*mta**2-1d0/4*
     & qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*cfl*qs*(-1d0/8/ctw**2*vpata**2/mz**2
     & *mta**2-1d0/8/ctw**2*vmata**2/mz**2*mta**2+1d0/4*qta*vpata/mz**2*
     & mta**2+1d0/4*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*cfl*(-1d0/8/ctw**2*vpata**2/mz**2*mh
     & **2*mta**2-1d0/8/ctw**2*vpata**2*mta**2-1d0/8/ctw**2*vmata**2/mz*
     & *2*mh**2*mta**2-1d0/8/ctw**2*vmata**2*mta**2+1d0/4*qta*vpata/mz**
     & 2*mh**2*mta**2+1d0/2*qta*vpata*mta**2+1d0/4*qta*vmata/mz**2*mh**2
     & *mta**2+1d0/2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq/qs*(1d0/4*qtp*vpatp*mz**2*mtp**2
     & -1d0/4*qtp*vpatp*mh**2*mtp**2+1d0/4*qtp*vmatp*mz**2*mtp**2-1d0/4*
     & qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq*qs*(-1d0/8/ctw**2*vpatp**2/mz**2
     & *mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mtp**2+1d0/4*qtp*vpatp/mz**2*
     & mtp**2+1d0/4*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*cfq*(-1d0/8/ctw**2*vpatp**2/mz**2*mh
     & **2*mtp**2-1d0/8/ctw**2*vpatp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz*
     & *2*mh**2*mtp**2-1d0/8/ctw**2*vmatp**2*mtp**2+1d0/4*qtp*vpatp/mz**
     & 2*mh**2*mtp**2+1d0/2*qtp*vpatp*mtp**2+1d0/4*qtp*vmatp/mz**2*mh**2
     & *mtp**2+1d0/2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq/qs*(1d0/4*qbt*vpabt*mz**2*mbt**2
     & -1d0/4*qbt*vpabt*mh**2*mbt**2+1d0/4*qbt*vmabt*mz**2*mbt**2-1d0/4*
     & qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq*qs*(-1d0/8/ctw**2*vpabt**2/mz**2
     & *mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mbt**2+1d0/4*qbt*vpabt/mz**2*
     & mbt**2+1d0/4*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*cfq*(-1d0/8/ctw**2*vpabt**2/mz**2*mh
     & **2*mbt**2-1d0/8/ctw**2*vpabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz*
     & *2*mh**2*mbt**2-1d0/8/ctw**2*vmabt**2*mbt**2+1d0/4*qbt*vpabt/mz**
     & 2*mh**2*mbt**2+1d0/2*qbt*vpabt*mbt**2+1d0/4*qbt*vmabt/mz**2*mh**2
     & *mbt**2+1d0/2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*qs*(1d0/8-1d0/16/ctw**2/mz**2*mh**2-1
     & d0/16/ctw**2+1d0/8/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fqsww*(-1d0/16/ctw**2/mz**2*mh**4-1d0/16/ct
     & w**2*mz**2-1d0/8/ctw**2*mh**2-1d0/2*ctw**2*mz**2+3d0/2*ctw**4*mz*
     & *2+1d0/8/mz**2*mh**4+1d0/4*mz**2+1d0/4*mh**2)
     & +propizqs*det3izhqs*b0fqszh*qs*(-1d0/16/ctw**2/mz**2*mh**2-1d0/16
     & /ctw**2)
     & +propizqs*det3izhqs*b0fqszh*(1d0/16/ctw**2/mz**2*mh**4+1d0/16/ctw
     & **2*mz**2-1d0/8/ctw**2*mh**2)
     & +propizqs*det3izhqs*b0fqsmomo*cfl*qs*(1d0/8/ctw**2*vpamo**2/mz**2
     & *mmo**2+1d0/8/ctw**2*vmamo**2/mz**2*mmo**2-1d0/4*qmo*vpamo/mz**2*
     & mmo**2-1d0/4*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*cfl*(1d0/8/ctw**2*vpamo**2/mz**2*mh
     & **2*mmo**2+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-1d0/4*qmo*vpa
     & mo/mz**2*mh**2*mmo**2-1d0/4*qmo*vpamo*mmo**2-1d0/4*qmo*vmamo/mz**
     & 2*mh**2*mmo**2-1d0/4*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*cfq*qs*(1d0/8/ctw**2*vpach**2/mz**2
     & *mch**2+1d0/8/ctw**2*vmach**2/mz**2*mch**2-1d0/4*qch*vpach/mz**2*
     & mch**2-1d0/4*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*cfq*(1d0/8/ctw**2*vpach**2/mz**2*mh
     & **2*mch**2+1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-1d0/4*qch*vpa
     & ch/mz**2*mh**2*mch**2-1d0/4*qch*vpach*mch**2-1d0/4*qch*vmach/mz**
     & 2*mh**2*mch**2-1d0/4*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*cfq*qs*(1d0/8/ctw**2*vpast**2/mz**2
     & *mst**2+1d0/8/ctw**2*vmast**2/mz**2*mst**2-1d0/4*qst*vpast/mz**2*
     & mst**2-1d0/4*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*cfq*(1d0/8/ctw**2*vpast**2/mz**2*mh
     & **2*mst**2+1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-1d0/4*qst*vpa
     & st/mz**2*mh**2*mst**2-1d0/4*qst*vpast*mst**2-1d0/4*qst*vmast/mz**
     & 2*mh**2*mst**2-1d0/4*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fqstata*cfl*qs*(1d0/8/ctw**2*vpata**2/mz**2
     & *mta**2+1d0/8/ctw**2*vmata**2/mz**2*mta**2-1d0/4*qta*vpata/mz**2*
     & mta**2-1d0/4*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*cfl*(1d0/8/ctw**2*vpata**2/mz**2*mh
     & **2*mta**2+1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d0/4*qta*vpa
     & ta/mz**2*mh**2*mta**2-1d0/4*qta*vpata*mta**2-1d0/4*qta*vmata/mz**
     & 2*mh**2*mta**2-1d0/4*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*cfq*qs*(1d0/8/ctw**2*vpatp**2/mz**2
     & *mtp**2+1d0/8/ctw**2*vmatp**2/mz**2*mtp**2-1d0/4*qtp*vpatp/mz**2*
     & mtp**2-1d0/4*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*cfq*(1d0/8/ctw**2*vpatp**2/mz**2*mh
     & **2*mtp**2+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-1d0/4*qtp*vpa
     & tp/mz**2*mh**2*mtp**2-1d0/4*qtp*vpatp*mtp**2-1d0/4*qtp*vmatp/mz**
     & 2*mh**2*mtp**2-1d0/4*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*cfq*qs*(1d0/8/ctw**2*vpabt**2/mz**2
     & *mbt**2+1d0/8/ctw**2*vmabt**2/mz**2*mbt**2-1d0/4*qbt*vpabt/mz**2*
     & mbt**2-1d0/4*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*cfq*(1d0/8/ctw**2*vpabt**2/mz**2*mh
     & **2*mbt**2+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/4*qbt*vpa
     & bt/mz**2*mh**2*mbt**2-1d0/4*qbt*vpabt*mbt**2-1d0/4*qbt*vmabt/mz**
     & 2*mh**2*mbt**2-1d0/4*qbt*vmabt*mbt**2)
     & +propizqs*sdet3ichts*c0chtsczz*vmael**2*(-1d0/2/ctw**2*mz**2)
     & +propizqs*sdet3ichts*b0fhzz*vmael**2*(-1d0/2/ctw**2)
     & +propizqs*sdet3ichts*b0ftszc*vmael**2*(1d0/2/ctw**2)
     & +propizqs*sdet3ichus*c0chusczz*vmael**2*(-1d0/2/ctw**2*mz**2)
     & +propizqs*sdet3ichus*b0fhzz*vmael**2*(-1d0/2/ctw**2)
     & +propizqs*sdet3ichus*b0fuszc*vmael**2*(1d0/2/ctw**2)
     & +propizqs*d0zchctsuscczz*vmael**2/qs*(1d0/2/ctw**2*us*mz**2+1d0/2
     & /ctw**2*us*mh**2+1d0/2/ctw**2*us**2+5d0/4/ctw**2*mz**2*mh**2-3d0/
     & 4/ctw**2*mz**4+1d0/4*sdet4izhtsus/ctw**2*ts*mz**4*mh**2+1d0/4*sde
     & t4izhtsus/ctw**2*ts*mz**6+1d0/4*sdet4izhtsus/ctw**2*us*mz**4*mh**
     & 2+1d0/4*sdet4izhtsus/ctw**2*us*mz**6+sdet4izhtsus/ctw**2*mz**6*mh
     & **2)
     & +propizqs*d0zchctsuscczz*vmael**2*(1d0/2/ctw**2*us+5d0/4/ctw**2*m
     & z**2+1d0/4*sdet4izhtsus/ctw**2*ts*mz**4+1d0/4*sdet4izhtsus/ctw**2
     & *us*mz**4)
     & +propizqs*c0zhqswww/qs*(-2*ctw**2*mz**2+ctw**2*mh**2+6*ctw**4*mz*
     & *2-6*ctw**4*mh**2+12*ctw**6*mz**2)
     & +propizqs*c0zhqswww*(-2*ctw**2)
     & +propizqs*c0zhqsmomomo*cfl/qs*(1d0/2*qmo*vpamo/mz**2*mh**2*mmo**2
     & -2*qmo*vpamo/mz**2*mmo**4-1d0/2*qmo*vpamo*mmo**2+1d0/2*qmo*vmamo/
     & mz**2*mh**2*mmo**2-2*qmo*vmamo/mz**2*mmo**4-1d0/2*qmo*vmamo*mmo**
     & 2)
     & +propizqs*c0zhqsmomomo*cfl*(-1d0/4/ctw**2*vpamo**2/mz**2*mmo**2-1
     & d0/4/ctw**2*vmamo**2/mz**2*mmo**2+1d0/2*qmo*vpamo/mz**2*mmo**2+1d
     & 0/2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*cfq/qs*(1d0/2*qch*vpach/mz**2*mh**2*mch**2
     & -2*qch*vpach/mz**2*mch**4-1d0/2*qch*vpach*mch**2+1d0/2*qch*vmach/
     & mz**2*mh**2*mch**2-2*qch*vmach/mz**2*mch**4-1d0/2*qch*vmach*mch**
     & 2)
     & +propizqs*c0zhqschchch*cfq*(-1d0/4/ctw**2*vpach**2/mz**2*mch**2-1
     & d0/4/ctw**2*vmach**2/mz**2*mch**2+1d0/2*qch*vpach/mz**2*mch**2+1d
     & 0/2*qch*vmach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*cfq/qs*(1d0/2*qst*vpast/mz**2*mh**2*mst**2
     & -2*qst*vpast/mz**2*mst**4-1d0/2*qst*vpast*mst**2+1d0/2*qst*vmast/
     & mz**2*mh**2*mst**2-2*qst*vmast/mz**2*mst**4-1d0/2*qst*vmast*mst**
     & 2)
     & +propizqs*c0zhqsststst*cfq*(-1d0/4/ctw**2*vpast**2/mz**2*mst**2-1
     & d0/4/ctw**2*vmast**2/mz**2*mst**2+1d0/2*qst*vpast/mz**2*mst**2+1d
     & 0/2*qst*vmast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*cfl/qs*(1d0/2*qta*vpata/mz**2*mh**2*mta**2
     & -2*qta*vpata/mz**2*mta**4-1d0/2*qta*vpata*mta**2+1d0/2*qta*vmata/
     & mz**2*mh**2*mta**2-2*qta*vmata/mz**2*mta**4-1d0/2*qta*vmata*mta**
     & 2)
     & +propizqs*c0zhqstatata*cfl*(-1d0/4/ctw**2*vpata**2/mz**2*mta**2-1
     & d0/4/ctw**2*vmata**2/mz**2*mta**2+1d0/2*qta*vpata/mz**2*mta**2+1d
     & 0/2*qta*vmata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*cfq/qs*(1d0/2*qtp*vpatp/mz**2*mh**2*mtp**2
     & -2*qtp*vpatp/mz**2*mtp**4-1d0/2*qtp*vpatp*mtp**2+1d0/2*qtp*vmatp/
     & mz**2*mh**2*mtp**2-2*qtp*vmatp/mz**2*mtp**4-1d0/2*qtp*vmatp*mtp**
     & 2)
     & +propizqs*c0zhqstptptp*cfq*(-1d0/4/ctw**2*vpatp**2/mz**2*mtp**2-1
     & d0/4/ctw**2*vmatp**2/mz**2*mtp**2+1d0/2*qtp*vpatp/mz**2*mtp**2+1d
     & 0/2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*cfq/qs*(1d0/2*qbt*vpabt/mz**2*mh**2*mbt**2
     & -2*qbt*vpabt/mz**2*mbt**4-1d0/2*qbt*vpabt*mbt**2+1d0/2*qbt*vmabt/
     & mz**2*mh**2*mbt**2-2*qbt*vmabt/mz**2*mbt**4-1d0/2*qbt*vmabt*mbt**
     & 2)
     & +propizqs*c0zhqsbtbtbt*cfq*(-1d0/4/ctw**2*vpabt**2/mz**2*mbt**2-1
     & d0/4/ctw**2*vmabt**2/mz**2*mbt**2+1d0/2*qbt*vpabt/mz**2*mbt**2+1d
     & 0/2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*c0cztszcc*vmael**2/qs*(-1d0/2/ctw**2*us-1d0/2/ctw**2*mh
     & **2-1d0/4*sdet4izhtsus/ctw**2*ts*mz**2*mh**2-1d0/4*sdet4izhtsus/c
     & tw**2*us*mz**4-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2)
     & +propizqs*c0cztszcc*vmael**2*(-1d0/2/ctw**2-1d0/4*sdet4izhtsus/ct
     & w**2*ts*mz**2)
     & +propizqs*c0czuszcc*vmael**2/qs*(1d0/2/ctw**2*us+1d0/2/ctw**2*mz*
     & *2-1d0/4*sdet4izhtsus/ctw**2*ts*mz**4-1d0/4*sdet4izhtsus/ctw**2*u
     & s*mz**2*mh**2-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2)
     & +propizqs*c0czuszcc*vmael**2*(-1d0/4*sdet4izhtsus/ctw**2*us*mz**2
     & )
     & +propizqs*c0chtsczz*vmael**2/qs*(-1d0/2/ctw**2*us-1d0/2/ctw**2*mz
     & **2+1d0/4*sdet4izhtsus/ctw**2*ts*mz**4+1d0/4*sdet4izhtsus/ctw**2*
     & us*mz**2*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2)
     & +propizqs*c0chtsczz*vmael**2*(1d0/4*sdet4izhtsus/ctw**2*ts*mz**2)
     & +propizqs*c0chusczz*vmael**2/qs*(1d0/2/ctw**2*us+1d0/2/ctw**2*mh*
     & *2+1d0/4*sdet4izhtsus/ctw**2*ts*mz**2*mh**2+1d0/4*sdet4izhtsus/ct
     & w**2*us*mz**4+1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2)
     & +propizqs*c0chusczz*vmael**2*(1d0/2/ctw**2+1d0/4*sdet4izhtsus/ctw
     & **2*us*mz**2)
     & +propizqs*c0ccqsczc*vmael**2/qs*(-1d0/2/ctw**2*mz**2)
     & +propizqs*c0ccqsczc*vmael**2*(-1d0/2/ctw**2)
     & +propizqs*a0fw/qs*(-2d0/3*ctw**2+4*ctw**4)
     & +propizqs*a0fz*vmael**2/qs*(1d0/2/ctw**2)
     & +propizqs*a0fz/qs*(1d0/12/ctw**2/mz**2*mh**2-1d0/12/ctw**2)
     & +propizqs*a0fh/qs*(-1d0/12/ctw**2/mz**4*mh**4+1d0/12/ctw**2/mz**2
     & *mh**2)
     & +propizqs*b0fzww/qs*(-1d0/2+ctw**2)
     & +propizqs*b0fhww/qs*(1d0/2-ctw**2)
     & +propizqs*b0fqsww/qs*(-2d0/3*ctw**2+4*ctw**4)
     & +propizqs*b0fqszh/qs*(-1d0/12/ctw**2/mz**4*mh**4+1d0/6/ctw**2/mz*
     & *2*mh**2-1d0/12/ctw**2)
     & +propizqs*b0fqscc*vmael**2/qs*(1d0/2/ctw**2)
     & +det3izhqs*c0zhqswww*(1d0/2/ctw**2*mz**4*mh**2+ctw**2*mz**4*mh**2
     & +3*ctw**4*mz**4*mh**2-7d0/4*mz**4*mh**2)
     & +det3izhqs*c0zhqszhh*(3/ctw**2*mz**4*mh**2)
     & +det3izhqs*c0zhqshzz*(6/ctw**2*mz**4*mh**2)
     & +det3izhqs*c0zhqsmomomo*cfl*(-1d0/4/ctw**2*vpamo**2*mz**2*mh**2*m
     & mo**2-1d0/4/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs*c0zhqschchch*cfq*(-1d0/4/ctw**2*vpach**2*mz**2*mh**2*m
     & ch**2-1d0/4/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs*c0zhqsststst*cfq*(-1d0/4/ctw**2*vpast**2*mz**2*mh**2*m
     & st**2-1d0/4/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs*c0zhqstatata*cfl*(-1d0/4/ctw**2*vpata**2*mz**2*mh**2*m
     & ta**2-1d0/4/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs*c0zhqstptptp*cfq*(-1d0/4/ctw**2*vpatp**2*mz**2*mh**2*m
     & tp**2-1d0/4/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs*c0zhqsbtbtbt*cfq*(-1d0/4/ctw**2*vpabt**2*mz**2*mh**2*m
     & bt**2-1d0/4/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*b0fzww*(1d0/4/ctw**2*mz**2*mh**2+1d0/2*ctw**2*mz**2*mh
     & **2+3d0/2*ctw**4*mz**2*mh**2-7d0/8*mz**2*mh**2)
     & +det3izhqs*b0fzmomo*cfl*(-1d0/8/ctw**2*vpamo**2*mh**2*mmo**2-1d0/
     & 8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fzchch*cfq*(-1d0/8/ctw**2*vpach**2*mh**2*mch**2-1d0/
     & 8/ctw**2*vmach**2*mh**2*mch**2)
     & +det3izhqs*b0fzstst*cfq*(-1d0/8/ctw**2*vpast**2*mh**2*mst**2-1d0/
     & 8/ctw**2*vmast**2*mh**2*mst**2)
     & +det3izhqs*b0fztata*cfl*(-1d0/8/ctw**2*vpata**2*mh**2*mta**2-1d0/
     & 8/ctw**2*vmata**2*mh**2*mta**2)
     & +det3izhqs*b0fztptp*cfq*(-1d0/8/ctw**2*vpatp**2*mh**2*mtp**2-1d0/
     & 8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fzbtbt*cfq*(-1d0/8/ctw**2*vpabt**2*mh**2*mbt**2-1d0/
     & 8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +det3izhqs*b0fhww*(-1d0/2/ctw**2*mz**2*mh**2-ctw**2*mz**2*mh**2-3
     & *ctw**4*mz**2*mh**2+7d0/4*mz**2*mh**2)
     & +det3izhqs*b0fhzz*(-3d0/2/ctw**2*mz**2*mh**2)
     & +det3izhqs*b0fhhh*(3d0/2/ctw**2*mz**2*mh**2)
     & +det3izhqs*b0fhmomo*cfl*(1d0/4/ctw**2*vpamo**2*mh**2*mmo**2+1d0/4
     & /ctw**2*vmamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fhchch*cfq*(1d0/4/ctw**2*vpach**2*mh**2*mch**2+1d0/4
     & /ctw**2*vmach**2*mh**2*mch**2)
     & +det3izhqs*b0fhstst*cfq*(1d0/4/ctw**2*vpast**2*mh**2*mst**2+1d0/4
     & /ctw**2*vmast**2*mh**2*mst**2)
     & +det3izhqs*b0fhtata*cfl*(1d0/4/ctw**2*vpata**2*mh**2*mta**2+1d0/4
     & /ctw**2*vmata**2*mh**2*mta**2)
     & +det3izhqs*b0fhtptp*cfq*(1d0/4/ctw**2*vpatp**2*mh**2*mtp**2+1d0/4
     & /ctw**2*vmatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fhbtbt*cfq*(1d0/4/ctw**2*vpabt**2*mh**2*mbt**2+1d0/4
     & /ctw**2*vmabt**2*mh**2*mbt**2)
     & +det3izhqs*b0fqsww*(1d0/4/ctw**2*mz**2*mh**2+1d0/2*ctw**2*mz**2*m
     & h**2+3d0/2*ctw**4*mz**2*mh**2-7d0/8*mz**2*mh**2)
     & +det3izhqs*b0fqsmomo*cfl*(-1d0/8/ctw**2*vpamo**2*mh**2*mmo**2-1d0
     & /8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +det3izhqs*b0fqschch*cfq*(-1d0/8/ctw**2*vpach**2*mh**2*mch**2-1d0
     & /8/ctw**2*vmach**2*mh**2*mch**2)
     & +det3izhqs*b0fqsstst*cfq*(-1d0/8/ctw**2*vpast**2*mh**2*mst**2-1d0
     & /8/ctw**2*vmast**2*mh**2*mst**2)
     & +det3izhqs*b0fqstata*cfl*(-1d0/8/ctw**2*vpata**2*mh**2*mta**2-1d0
     & /8/ctw**2*vmata**2*mh**2*mta**2)
     & +det3izhqs*b0fqstptp*cfq*(-1d0/8/ctw**2*vpatp**2*mh**2*mtp**2-1d0
     & /8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*cfq*(-1d0/8/ctw**2*vpabt**2*mh**2*mbt**2-1d0
     & /8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +c0zhqswww*(-1d0/2/ctw**2*mz**2+ctw**2*mz**2-2*ctw**2*mh**2-12*ct
     & w**4*mz**2+6*ctw**4*mh**2-12*ctw**6*mz**2+2*mz**2+1d0/2*mh**2)
     & +c0zhqszhh*(-3d0/4/ctw**2/mz**2*mh**4-3/ctw**2*mz**2+3d0/4/ctw**2
     & *mh**2)
     & +c0zhqshzz*(-1d0/2/ctw**2/mz**2*mh**4-5/ctw**2*mz**2-2/ctw**2*mh*
     & *2)
     & +c0zhqsmomomo*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mh**2*mmo**2+2
     & /ctw**2*vpamo*vmamo/mz**2*mmo**4+1d0/2/ctw**2*vpamo**2*mmo**2+1d0
     & /2/ctw**2*vmamo**2*mmo**2)
     & +c0zhqschchch*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mh**2*mch**2+2
     & /ctw**2*vpach*vmach/mz**2*mch**4+1d0/2/ctw**2*vpach**2*mch**2+1d0
     & /2/ctw**2*vmach**2*mch**2)
     & +c0zhqsststst*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mh**2*mst**2+2
     & /ctw**2*vpast*vmast/mz**2*mst**4+1d0/2/ctw**2*vpast**2*mst**2+1d0
     & /2/ctw**2*vmast**2*mst**2)
     & +c0zhqstatata*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mh**2*mta**2+2
     & /ctw**2*vpata*vmata/mz**2*mta**4+1d0/2/ctw**2*vpata**2*mta**2+1d0
     & /2/ctw**2*vmata**2*mta**2)
     & +c0zhqstptptp*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mh**2*mtp**2+2
     & /ctw**2*vpatp*vmatp/mz**2*mtp**4+1d0/2/ctw**2*vpatp**2*mtp**2+1d0
     & /2/ctw**2*vmatp**2*mtp**2)
     & +c0zhqsbtbtbt*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mh**2*mbt**2+2
     & /ctw**2*vpabt*vmabt/mz**2*mbt**4+1d0/2/ctw**2*vpabt**2*mbt**2+1d0
     & /2/ctw**2*vmabt**2*mbt**2)
     & +c0ccqsczc*vmael**2*(2/ctw**2*mz**2)
     & +a0fw*(-1d0/4-3d0/2*ctw**2*mz**2/mh**2+8d0/3*ctw**2-4*ctw**4)
     & +a0fz*vmael**2*(-5d0/4/ctw**2)
     & +a0fz*(-1d0/8/ctw**2/mz**2*mh**2-3d0/4/ctw**2*mz**2/mh**2)
     & +a0fh*(1d0/8/ctw**2/mz**4*mh**4-1d0/2/ctw**2/mz**2*mh**2)
     & +b0fzww*(1d0/6-7d0/24/ctw**2+5d0/2*ctw**2)
     & +b0fzzh*(1d0/24/ctw**2/mz**4*mh**4+1d0/6/ctw**2/mz**2*mh**2-1d0/2
     & /ctw**2)
     & +b0fzmomo*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mmo**2+1d0/4/ctw**
     & 2*vpamo**2/mz**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mmo**2)
     & +b0fzchch*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mch**2+1d0/4/ctw**
     & 2*vpach**2/mz**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mch**2)
     & +b0fzstst*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mst**2+1d0/4/ctw**
     & 2*vpast**2/mz**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*mst**2)
     & +b0fztata*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mta**2+1d0/4/ctw**
     & 2*vpata**2/mz**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +b0fztptp*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mtp**2+1d0/4/ctw**
     & 2*vpatp**2/mz**2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mtp**2)
     & +b0fzbtbt*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mbt**2+1d0/4/ctw**
     & 2*vpabt**2/mz**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +b0fhww*(-1+1d0/2/ctw**2+2*ctw**2)
     & +b0fhzz*(1d0/4/ctw**2/mz**2*mh**2+2/ctw**2)
     & +b0fhhh*(-3d0/4/ctw**2/mz**2*mh**2-3d0/2/ctw**2)
     & +b0fqsww*(1d0/6-1d0/3/ctw**2-1d0/3*ctw**2-4*ctw**4)
     & +b0fqszh*(1d0/12/ctw**2/mz**4*mh**4+1d0/12/ctw**2/mz**2*mh**2-1d0
     & /2/ctw**2)
     & +b0fqsmomo*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mmo**2+1d0/4/ctw*
     & *2*vpamo**2/mz**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mmo**2)
     & +b0fqschch*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mch**2+1d0/4/ctw*
     & *2*vpach**2/mz**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mch**2)
     & +b0fqsstst*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mst**2+1d0/4/ctw*
     & *2*vpast**2/mz**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*mst**2)
     & +b0fqstata*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mta**2+1d0/4/ctw*
     & *2*vpata**2/mz**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +b0fqstptp*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mtp**2+1d0/4/ctw*
     & *2*vpatp**2/mz**2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mtp**2)
     & +b0fqsbtbt*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mbt**2+1d0/4/ctw*
     & *2*vpabt**2/mz**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +b0fqscc*vmael**2*(-5d0/4/ctw**2)
     & +dreal(b0pzww)*(1d0/24/ctw**2*mz**2-17d0/6*ctw**2*mz**2-2*ctw**4*
     & mz**2+2d0/3*mz**2)
     & +dreal(b0pzzh)*(1d0/24/ctw**2/mz**2*mh**4+1d0/2/ctw**2*mz**2-1d0/
     & 6/ctw**2*mh**2)
     & +dreal(b0phww)*(1d0/8/ctw**2/mz**2*mh**4+3d0/2*ctw**2*mz**2-1d0/2
     & *mh**2)
     & +dreal(b0phzz)*(1d0/16/ctw**2/mz**2*mh**4+3d0/4/ctw**2*mz**2-1d0/
     & 4/ctw**2*mh**2)
     & +dreal(b0phhh)*(9d0/16/ctw**2/mz**2*mh**4)
     & +dreal(b0pccz)*vpael**2*(-1d0/4/ctw**2*mz**2)
     & +dreal(b0pccz)*vmael**2*(-1d0/4/ctw**2*mz**2)
     & +13d0/18+3d0/4/ctw**2/mz**2*mh**2-1d0/2/ctw**2*mz**2/mh**2+1d0/12
     & /ctw**2+ctw**2/mz**2*mh**2-ctw**2*mz**2/mh**2+2d0/3*ctw**2+2*ctw*
     & *4-1d0/mz**2*mh**2-za1bos+zmzzzbos-1d0/2*zmwzwbos-1d0/2*deltarhob
     & os-za1fer+zmzzzfer-1d0/2*zmwzwfer-1d0/2*deltarhofer+1d0/2*zz1fer+
     & 1d0/2*zh1fer+caldzfer-pizgfer

      ffgm1=
     & +vmael*(3d0/2/ctw**2/mz**2+2*ctw**2/mz**2-2/mz**2)
     & +propizqs*qel/qs*(2*stw**2/mz**2-4*stw**4/mz**2)
     & +propizqs*det3izhqs*qel*cfl/qs*(stw**2*qmo*vpamo/mz**2*mh**2*mmo*
     & *2-stw**2*qmo*vpamo*mmo**2+stw**2*qmo*vmamo/mz**2*mh**2*mmo**2-st
     & w**2*qmo*vmamo*mmo**2+stw**2*qta*vpata/mz**2*mh**2*mta**2-stw**2*
     & qta*vpata*mta**2+stw**2*qta*vmata/mz**2*mh**2*mta**2-stw**2*qta*v
     & mata*mta**2)
     & +propizqs*det3izhqs*qel*cfl*(stw**2*qmo*vpamo/mz**2*mmo**2+stw**2
     & *qmo*vmamo/mz**2*mmo**2+stw**2*qta*vpata/mz**2*mta**2+stw**2*qta*
     & vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*qel*cfq/qs*(stw**2*qch*vpach/mz**2*mh**2*mch*
     & *2-stw**2*qch*vpach*mch**2+stw**2*qch*vmach/mz**2*mh**2*mch**2-st
     & w**2*qch*vmach*mch**2+stw**2*qst*vpast/mz**2*mh**2*mst**2-stw**2*
     & qst*vpast*mst**2+stw**2*qst*vmast/mz**2*mh**2*mst**2-stw**2*qst*v
     & mast*mst**2+stw**2*qtp*vpatp/mz**2*mh**2*mtp**2-stw**2*qtp*vpatp*
     & mtp**2+stw**2*qtp*vmatp/mz**2*mh**2*mtp**2-stw**2*qtp*vmatp*mtp**
     & 2+stw**2*qbt*vpabt/mz**2*mh**2*mbt**2-stw**2*qbt*vpabt*mbt**2+stw
     & **2*qbt*vmabt/mz**2*mh**2*mbt**2-stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*qel*cfq*(stw**2*qch*vpach/mz**2*mch**2+stw**2
     & *qch*vmach/mz**2*mch**2+stw**2*qst*vpast/mz**2*mst**2+stw**2*qst*
     & vmast/mz**2*mst**2+stw**2*qtp*vpatp/mz**2*mtp**2+stw**2*qtp*vmatp
     & /mz**2*mtp**2+stw**2*qbt*vpabt/mz**2*mbt**2+stw**2*qbt*vmabt/mz**
     & 2*mbt**2)
     & +propizqs*det3izhqs*qel/qs*(11d0/2*stw**2*mz**2-11d0/2*stw**2*mh*
     & *2-12*stw**4*mz**2+12*stw**4*mh**2+6*stw**6*mz**2-6*stw**6*mh**2)
     & 
     & +propizqs*det3izhqs*qel*qs*(1d0/2*stw**2/mz**2-stw**4/mz**2)
     & +propizqs*det3izhqs*qel*(1d0/2*stw**2/mz**2*mh**2-4*stw**2-stw**4
     & /mz**2*mh**2+9*stw**4-6*stw**6)
     & +propizqs*det3izhqs*vmael*cfl*(1d0/4/ctw**2*vpamo**2/mz**2*mmo**2
     & +1d0/4/ctw**2*vmamo**2/mz**2*mmo**2+1d0/4/ctw**2*vpata**2/mz**2*m
     & ta**2+1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*vmael*cfq*(1d0/4/ctw**2*vpach**2/mz**2*mch**2
     & +1d0/4/ctw**2*vmach**2/mz**2*mch**2+1d0/4/ctw**2*vpast**2/mz**2*m
     & st**2+1d0/4/ctw**2*vmast**2/mz**2*mst**2+1d0/4/ctw**2*vpatp**2/mz
     & **2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mtp**2+1d0/4/ctw**2*vpabt*
     & *2/mz**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*vmael*qs*(3d0/8/ctw**2/mz**2+1d0/2*ctw**2/mz*
     & *2-1d0/2/mz**2)
     & +propizqs*det3izhqs*vmael*(-3d0/4+3d0/8/ctw**2/mz**2*mh**2+1d0/4/
     & ctw**2+1d0/2*ctw**2/mz**2*mh**2+3d0/2*ctw**2-3*ctw**4-1d0/2/mz**2
     & *mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qel*qs*(15d0/2*stw**2*mz**2*mh**
     & 2+3d0/4*stw**2*mh**4-33d0/2*stw**4*mz**2*mh**2-3d0/2*stw**4*mh**4
     & +9*stw**6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qel*(27d0/4*stw**2*mz**2*mh**4-1
     & 5d0/2*stw**2*mz**4*mh**2+3d0/4*stw**2*mh**6-15*stw**4*mz**2*mh**4
     & +33d0/2*stw**4*mz**4*mh**2-3d0/2*stw**4*mh**6+9*stw**6*mz**2*mh**
     & 4-9*stw**6*mz**4*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*vmael*qs*(3d0/16/ctw**2*mz**2*mh
     & **2+3d0/8/ctw**2*mz**4+3d0/16/ctw**2*mh**4-3d0/4*ctw**2*mz**2*mh*
     & *2+3d0/4*ctw**2*mh**4+9d0/2*ctw**4*mz**2*mh**2+9d0/2*ctw**4*mz**4
     & -3d0/8*mz**2*mh**2-9d0/8*mz**4-3d0/4*mh**4)
     & +propizqs*det3izhqs**2*c0zhqswww*vmael*(15d0/16/ctw**2*mz**4*mh**
     & 2+3d0/8/ctw**2*mz**6+3d0/16/ctw**2*mh**6-3d0/2*ctw**2*mz**2*mh**4
     & +15d0/4*ctw**2*mz**4*mh**2+3d0/4*ctw**2*mh**6+9d0/2*ctw**4*mz**2*
     & mh**4+9d0/2*ctw**4*mz**6+3d0/8*mz**2*mh**4-15d0/4*mz**4*mh**2-9d0
     & /8*mz**6-3d0/4*mh**6)
     & +propizqs*det3izhqs**2*c0zhqszhh*vmael*qs*(9d0/32/ctw**2/mz**2*mh
     & **6+9d0/16/ctw**2*mz**2*mh**2+9d0/4/ctw**2*mz**4+9d0/32/ctw**2*mh
     & **4)
     & +propizqs*det3izhqs**2*c0zhqszhh*vmael*(9d0/32/ctw**2/mz**2*mh**8
     & +45d0/32/ctw**2*mz**2*mh**4+81d0/16/ctw**2*mz**4*mh**2+9d0/4/ctw*
     & *2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqshzz*vmael*qs*(3d0/32/ctw**2/mz**2*mh
     & **6+9d0/8/ctw**2*mz**2*mh**2+39d0/8/ctw**2*mz**4+9d0/32/ctw**2*mh
     & **4)
     & +propizqs*det3izhqs**2*c0zhqshzz*vmael*(3d0/32/ctw**2/mz**2*mh**8
     & +87d0/32/ctw**2*mz**2*mh**4+75d0/8/ctw**2*mz**4*mh**2+39d0/8/ctw*
     & *2*mz**6+15d0/16/ctw**2*mh**6)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qel*cfl*qs*(-3d0/2*stw**2*qmo
     & *vpamo*mh**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qel*cfl*(3d0/2*stw**2*qmo*vpa
     & mo*mz**2*mh**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**4*mmo**2+3d0/2*s
     & tw**2*qmo*vmamo*mz**2*mh**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**4*m
     & mo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vmael*cfl*qs*(-3d0/8/ctw**2*v
     & pamo**2*mz**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2-3d0/8/ctw
     & **2*vmamo**2*mz**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vmael*cfl*(-3d0/8/ctw**2*vpam
     & o**2*mz**4*mmo**2-3d0/8/ctw**2*vpamo**2*mh**4*mmo**2-3d0/8/ctw**2
     & *vmamo**2*mz**4*mmo**2-3d0/8/ctw**2*vmamo**2*mh**4*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qel*cfq*qs*(-3d0/2*stw**2*qch
     & *vpach*mh**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qel*cfq*(3d0/2*stw**2*qch*vpa
     & ch*mz**2*mh**2*mch**2-3d0/2*stw**2*qch*vpach*mh**4*mch**2+3d0/2*s
     & tw**2*qch*vmach*mz**2*mh**2*mch**2-3d0/2*stw**2*qch*vmach*mh**4*m
     & ch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vmael*cfq*qs*(-3d0/8/ctw**2*v
     & pach**2*mz**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2-3d0/8/ctw
     & **2*vmach**2*mz**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vmael*cfq*(-3d0/8/ctw**2*vpac
     & h**2*mz**4*mch**2-3d0/8/ctw**2*vpach**2*mh**4*mch**2-3d0/8/ctw**2
     & *vmach**2*mz**4*mch**2-3d0/8/ctw**2*vmach**2*mh**4*mch**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qel*cfq*qs*(-3d0/2*stw**2*qst
     & *vpast*mh**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qel*cfq*(3d0/2*stw**2*qst*vpa
     & st*mz**2*mh**2*mst**2-3d0/2*stw**2*qst*vpast*mh**4*mst**2+3d0/2*s
     & tw**2*qst*vmast*mz**2*mh**2*mst**2-3d0/2*stw**2*qst*vmast*mh**4*m
     & st**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vmael*cfq*qs*(-3d0/8/ctw**2*v
     & past**2*mz**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2-3d0/8/ctw
     & **2*vmast**2*mz**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vmael*cfq*(-3d0/8/ctw**2*vpas
     & t**2*mz**4*mst**2-3d0/8/ctw**2*vpast**2*mh**4*mst**2-3d0/8/ctw**2
     & *vmast**2*mz**4*mst**2-3d0/8/ctw**2*vmast**2*mh**4*mst**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qel*cfl*qs*(-3d0/2*stw**2*qta
     & *vpata*mh**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qel*cfl*(3d0/2*stw**2*qta*vpa
     & ta*mz**2*mh**2*mta**2-3d0/2*stw**2*qta*vpata*mh**4*mta**2+3d0/2*s
     & tw**2*qta*vmata*mz**2*mh**2*mta**2-3d0/2*stw**2*qta*vmata*mh**4*m
     & ta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vmael*cfl*qs*(-3d0/8/ctw**2*v
     & pata**2*mz**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2-3d0/8/ctw
     & **2*vmata**2*mz**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vmael*cfl*(-3d0/8/ctw**2*vpat
     & a**2*mz**4*mta**2-3d0/8/ctw**2*vpata**2*mh**4*mta**2-3d0/8/ctw**2
     & *vmata**2*mz**4*mta**2-3d0/8/ctw**2*vmata**2*mh**4*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qel*cfq*qs*(-3d0/2*stw**2*qtp
     & *vpatp*mh**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qel*cfq*(3d0/2*stw**2*qtp*vpa
     & tp*mz**2*mh**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**4*mtp**2+3d0/2*s
     & tw**2*qtp*vmatp*mz**2*mh**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**4*m
     & tp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vmael*cfq*qs*(-3d0/8/ctw**2*v
     & patp**2*mz**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2-3d0/8/ctw
     & **2*vmatp**2*mz**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vmael*cfq*(-3d0/8/ctw**2*vpat
     & p**2*mz**4*mtp**2-3d0/8/ctw**2*vpatp**2*mh**4*mtp**2-3d0/8/ctw**2
     & *vmatp**2*mz**4*mtp**2-3d0/8/ctw**2*vmatp**2*mh**4*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qel*cfq*qs*(-3d0/2*stw**2*qbt
     & *vpabt*mh**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qel*cfq*(3d0/2*stw**2*qbt*vpa
     & bt*mz**2*mh**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**4*mbt**2+3d0/2*s
     & tw**2*qbt*vmabt*mz**2*mh**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**4*m
     & bt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vmael*cfq*qs*(-3d0/8/ctw**2*v
     & pabt**2*mz**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2-3d0/8/ctw
     & **2*vmabt**2*mz**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vmael*cfq*(-3d0/8/ctw**2*vpab
     & t**2*mz**4*mbt**2-3d0/8/ctw**2*vpabt**2*mh**4*mbt**2-3d0/8/ctw**2
     & *vmabt**2*mz**4*mbt**2-3d0/8/ctw**2*vmabt**2*mh**4*mbt**2)
     & +propizqs*det3izhqs**2*b0fzww*qel*qs*(15d0/2*stw**2*mz**2+3d0/4*s
     & tw**2*mh**2-33d0/2*stw**4*mz**2-3d0/2*stw**4*mh**2+9*stw**6*mz**2
     & )
     & +propizqs*det3izhqs**2*b0fzww*qel*(33d0/4*stw**2*mz**2*mh**2+15d0
     & /2*stw**2*mz**4+3d0/4*stw**2*mh**4-18*stw**4*mz**2*mh**2-33d0/2*s
     & tw**4*mz**4-3d0/2*stw**4*mh**4+9*stw**6*mz**2*mh**2+9*stw**6*mz**
     & 4)
     & +propizqs*det3izhqs**2*b0fzww*vmael*qs*(3d0/16/ctw**2*mz**2+3d0/1
     & 6/ctw**2*mh**2-3d0/4*ctw**2*mz**2+3d0/4*ctw**2*mh**2+9d0/2*ctw**4
     & *mz**2-3d0/8*mz**2-3d0/4*mh**2)
     & +propizqs*det3izhqs**2*b0fzww*vmael*(3d0/8/ctw**2*mz**2*mh**2+3d0
     & /16/ctw**2*mz**4+3d0/16/ctw**2*mh**4+3d0/4*ctw**2*mz**4+3d0/4*ctw
     & **2*mh**4+9d0/2*ctw**4*mz**2*mh**2-9d0/8*mz**2*mh**2-3d0/4*mz**4-
     & 3d0/4*mh**4)
     & +propizqs*det3izhqs**2*b0fzzh*vmael*qs*(3d0/16/ctw**2*mz**2+3d0/1
     & 6/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fzzh*vmael*(3d0/8/ctw**2*mz**2*mh**2-3d0
     & /16/ctw**2*mz**4-3d0/16/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fzmomo*qel*cfl*qs*(-3d0/2*stw**2*qmo*vpa
     & mo*mmo**2-3d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qel*cfl*(-3d0/2*stw**2*qmo*vpamo*
     & mz**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**2*mmo**2-3d0/2*stw**2*qmo
     & *vmamo*mz**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vmael*cfl*qs*(-3d0/8/ctw**2*vpamo
     & **2*mmo**2-3d0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vmael*cfl*(-3d0/8/ctw**2*vpamo**2
     & *mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzchch*qel*cfq*qs*(-3d0/2*stw**2*qch*vpa
     & ch*mch**2-3d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qel*cfq*(-3d0/2*stw**2*qch*vpach*
     & mz**2*mch**2-3d0/2*stw**2*qch*vpach*mh**2*mch**2-3d0/2*stw**2*qch
     & *vmach*mz**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vmael*cfq*qs*(-3d0/8/ctw**2*vpach
     & **2*mch**2-3d0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vmael*cfq*(-3d0/8/ctw**2*vpach**2
     & *mh**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzstst*qel*cfq*qs*(-3d0/2*stw**2*qst*vpa
     & st*mst**2-3d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qel*cfq*(-3d0/2*stw**2*qst*vpast*
     & mz**2*mst**2-3d0/2*stw**2*qst*vpast*mh**2*mst**2-3d0/2*stw**2*qst
     & *vmast*mz**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vmael*cfq*qs*(-3d0/8/ctw**2*vpast
     & **2*mst**2-3d0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vmael*cfq*(-3d0/8/ctw**2*vpast**2
     & *mh**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fztata*qel*cfl*qs*(-3d0/2*stw**2*qta*vpa
     & ta*mta**2-3d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qel*cfl*(-3d0/2*stw**2*qta*vpata*
     & mz**2*mta**2-3d0/2*stw**2*qta*vpata*mh**2*mta**2-3d0/2*stw**2*qta
     & *vmata*mz**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vmael*cfl*qs*(-3d0/8/ctw**2*vpata
     & **2*mta**2-3d0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vmael*cfl*(-3d0/8/ctw**2*vpata**2
     & *mh**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztptp*qel*cfq*qs*(-3d0/2*stw**2*qtp*vpa
     & tp*mtp**2-3d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qel*cfq*(-3d0/2*stw**2*qtp*vpatp*
     & mz**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**2*mtp**2-3d0/2*stw**2*qtp
     & *vmatp*mz**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vmael*cfq*qs*(-3d0/8/ctw**2*vpatp
     & **2*mtp**2-3d0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vmael*cfq*(-3d0/8/ctw**2*vpatp**2
     & *mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qel*cfq*qs*(-3d0/2*stw**2*qbt*vpa
     & bt*mbt**2-3d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qel*cfq*(-3d0/2*stw**2*qbt*vpabt*
     & mz**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**2*mbt**2-3d0/2*stw**2*qbt
     & *vmabt*mz**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vmael*cfq*qs*(-3d0/8/ctw**2*vpabt
     & **2*mbt**2-3d0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vmael*cfq*(-3d0/8/ctw**2*vpabt**2
     & *mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhww*qel*(-15*stw**2*mz**2*mh**2-3d0/2*s
     & tw**2*mh**4+33*stw**4*mz**2*mh**2+3*stw**4*mh**4-18*stw**6*mz**2*
     & mh**2)
     & +propizqs*det3izhqs**2*b0fhww*vmael*qs*(-3d0/8/ctw**2*mz**2-3d0/2
     & *ctw**2*mz**2+3d0/2*mz**2)
     & +propizqs*det3izhqs**2*b0fhww*vmael*(-3d0/4/ctw**2*mz**2*mh**2-3d
     & 0/8/ctw**2*mz**4-3d0/8/ctw**2*mh**4-3d0/2*ctw**2*mz**4-3d0/2*ctw*
     & *2*mh**4-9*ctw**4*mz**2*mh**2+9d0/4*mz**2*mh**2+3d0/2*mz**4+3d0/2
     & *mh**4)
     & +propizqs*det3izhqs**2*b0fhzz*vmael*qs*(-3d0/32/ctw**2/mz**2*mh**
     & 4-15d0/16/ctw**2*mz**2-9d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhzz*vmael*(-3d0/32/ctw**2/mz**2*mh**6-8
     & 7d0/32/ctw**2*mz**2*mh**2-15d0/16/ctw**2*mz**4-3d0/4/ctw**2*mh**4
     & )
     & +propizqs*det3izhqs**2*b0fhhh*vmael*qs*(9d0/32/ctw**2/mz**2*mh**4
     & +9d0/8/ctw**2*mz**2+9d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhhh*vmael*(9d0/32/ctw**2/mz**2*mh**6+81
     & d0/32/ctw**2*mz**2*mh**2+9d0/8/ctw**2*mz**4+9d0/16/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fhmomo*qel*cfl*(3*stw**2*qmo*vpamo*mh**2
     & *mmo**2+3*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhmomo*vmael*cfl*(3d0/4/ctw**2*vpamo**2*
     & mh**2*mmo**2+3d0/4/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhchch*qel*cfq*(3*stw**2*qch*vpach*mh**2
     & *mch**2+3*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhchch*vmael*cfq*(3d0/4/ctw**2*vpach**2*
     & mh**2*mch**2+3d0/4/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhstst*qel*cfq*(3*stw**2*qst*vpast*mh**2
     & *mst**2+3*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhstst*vmael*cfq*(3d0/4/ctw**2*vpast**2*
     & mh**2*mst**2+3d0/4/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhtata*qel*cfl*(3*stw**2*qta*vpata*mh**2
     & *mta**2+3*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtata*vmael*cfl*(3d0/4/ctw**2*vpata**2*
     & mh**2*mta**2+3d0/4/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtptp*qel*cfq*(3*stw**2*qtp*vpatp*mh**2
     & *mtp**2+3*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhtptp*vmael*cfq*(3d0/4/ctw**2*vpatp**2*
     & mh**2*mtp**2+3d0/4/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*qel*cfq*(3*stw**2*qbt*vpabt*mh**2
     & *mbt**2+3*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*vmael*cfq*(3d0/4/ctw**2*vpabt**2*
     & mh**2*mbt**2+3d0/4/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsww*qel*qs*(-15d0/2*stw**2*mz**2-3d0/4
     & *stw**2*mh**2+33d0/2*stw**4*mz**2+3d0/2*stw**4*mh**2-9*stw**6*mz*
     & *2)
     & +propizqs*det3izhqs**2*b0fqsww*qel*(27d0/4*stw**2*mz**2*mh**2-15d
     & 0/2*stw**2*mz**4+3d0/4*stw**2*mh**4-15*stw**4*mz**2*mh**2+33d0/2*
     & stw**4*mz**4-3d0/2*stw**4*mh**4+9*stw**6*mz**2*mh**2-9*stw**6*mz*
     & *4)
     & +propizqs*det3izhqs**2*b0fqsww*vmael*qs*(3d0/16/ctw**2*mz**2-3d0/
     & 16/ctw**2*mh**2+9d0/4*ctw**2*mz**2-3d0/4*ctw**2*mh**2-9d0/2*ctw**
     & 4*mz**2-9d0/8*mz**2+3d0/4*mh**2)
     & +propizqs*det3izhqs**2*b0fqsww*vmael*(3d0/8/ctw**2*mz**2*mh**2+3d
     & 0/16/ctw**2*mz**4+3d0/16/ctw**2*mh**4+3d0/4*ctw**2*mz**4+3d0/4*ct
     & w**2*mh**4+9d0/2*ctw**4*mz**2*mh**2-9d0/8*mz**2*mh**2-3d0/4*mz**4
     & -3d0/4*mh**4)
     & +propizqs*det3izhqs**2*b0fqszh*vmael*qs*(-3d0/16/ctw**2/mz**2*mh*
     & *4-3d0/8/ctw**2*mz**2-3d0/16/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqszh*vmael*(-3d0/16/ctw**2/mz**2*mh**6-
     & 3d0/16/ctw**2*mz**2*mh**2+3d0/8/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fqsmomo*qel*cfl*qs*(3d0/2*stw**2*qmo*vpa
     & mo*mmo**2+3d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qel*cfl*(3d0/2*stw**2*qmo*vpamo*
     & mz**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**2*mmo**2+3d0/2*stw**2*qmo
     & *vmamo*mz**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vmael*cfl*qs*(3d0/8/ctw**2*vpamo
     & **2*mmo**2+3d0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vmael*cfl*(-3d0/8/ctw**2*vpamo**
     & 2*mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqschch*qel*cfq*qs*(3d0/2*stw**2*qch*vpa
     & ch*mch**2+3d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qel*cfq*(3d0/2*stw**2*qch*vpach*
     & mz**2*mch**2-3d0/2*stw**2*qch*vpach*mh**2*mch**2+3d0/2*stw**2*qch
     & *vmach*mz**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vmael*cfq*qs*(3d0/8/ctw**2*vpach
     & **2*mch**2+3d0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vmael*cfq*(-3d0/8/ctw**2*vpach**
     & 2*mh**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qel*cfq*qs*(3d0/2*stw**2*qst*vpa
     & st*mst**2+3d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qel*cfq*(3d0/2*stw**2*qst*vpast*
     & mz**2*mst**2-3d0/2*stw**2*qst*vpast*mh**2*mst**2+3d0/2*stw**2*qst
     & *vmast*mz**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vmael*cfq*qs*(3d0/8/ctw**2*vpast
     & **2*mst**2+3d0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vmael*cfq*(-3d0/8/ctw**2*vpast**
     & 2*mh**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqstata*qel*cfl*qs*(3d0/2*stw**2*qta*vpa
     & ta*mta**2+3d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qel*cfl*(3d0/2*stw**2*qta*vpata*
     & mz**2*mta**2-3d0/2*stw**2*qta*vpata*mh**2*mta**2+3d0/2*stw**2*qta
     & *vmata*mz**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vmael*cfl*qs*(3d0/8/ctw**2*vpata
     & **2*mta**2+3d0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vmael*cfl*(-3d0/8/ctw**2*vpata**
     & 2*mh**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qel*cfq*qs*(3d0/2*stw**2*qtp*vpa
     & tp*mtp**2+3d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qel*cfq*(3d0/2*stw**2*qtp*vpatp*
     & mz**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**2*mtp**2+3d0/2*stw**2*qtp
     & *vmatp*mz**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vmael*cfq*qs*(3d0/8/ctw**2*vpatp
     & **2*mtp**2+3d0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vmael*cfq*(-3d0/8/ctw**2*vpatp**
     & 2*mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qel*cfq*qs*(3d0/2*stw**2*qbt*vpa
     & bt*mbt**2+3d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qel*cfq*(3d0/2*stw**2*qbt*vpabt*
     & mz**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**2*mbt**2+3d0/2*stw**2*qbt
     & *vmabt*mz**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vmael*cfq*qs*(3d0/8/ctw**2*vpabt
     & **2*mbt**2+3d0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vmael*cfq*(-3d0/8/ctw**2*vpabt**
     & 2*mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqswww*qel/qs*(11*stw**2*mz**2*mh**2-11*st
     & w**2*mz**4-35*stw**4*mz**2*mh**2+35*stw**4*mz**4+36*stw**6*mz**2*
     & mh**2-36*stw**6*mz**4-12*stw**8*mz**2*mh**2+12*stw**8*mz**4)
     & +propizqs*det3izhqs*c0zhqswww*qel*qs*(-stw**2+3*stw**4-2*stw**6)
     & +propizqs*det3izhqs*c0zhqswww*qel*(18*stw**2*mz**2-48*stw**4*mz**
     & 2+stw**4*mh**2+42*stw**6*mz**2-2*stw**6*mh**2-12*stw**8*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*vmael*qs*(-3d0/4+ctw**2-ctw**4)
     & +propizqs*det3izhqs*c0zhqswww*vmael*(1d0/4/ctw**2*mh**2-1d0/2*ctw
     & **2*mz**2+2*ctw**2*mh**2+3*ctw**4*mz**2-ctw**4*mh**2+6*ctw**6*mz*
     & *2-1d0/4*mz**2-7d0/4*mh**2)
     & +propizqs*det3izhqs*c0zhqszhh*vmael*qs*(-3d0/4/ctw**2/mz**2*mh**2
     & -21d0/8/ctw**2)
     & +propizqs*det3izhqs*c0zhqszhh*vmael*(-3d0/4/ctw**2/mz**2*mh**4-21
     & d0/8/ctw**2*mz**2-6/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqshzz*vmael*qs*(-3d0/8/ctw**2/mz**2*mh**2
     & -7d0/2/ctw**2)
     & +propizqs*det3izhqs*c0zhqshzz*vmael*(-7d0/8/ctw**2/mz**2*mh**4-11
     & d0/4/ctw**2*mz**2-7/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*qel*cfl/qs*(-2*stw**2*qmo*vpamo/
     & mz**2*mh**2*mmo**4+2*stw**2*qmo*vpamo*mmo**4-2*stw**2*qmo*vmamo/m
     & z**2*mh**2*mmo**4+2*stw**2*qmo*vmamo*mmo**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*qel*cfl*(-2*stw**2*qmo*vpamo/mz*
     & *2*mmo**4-2*stw**2*qmo*vpamo*mmo**2-2*stw**2*qmo*vmamo/mz**2*mmo*
     & *4-2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vmael*cfl*qs*(-1d0/4/ctw**2*vpam
     & o*vmamo/mz**2*mmo**2+1d0/8/ctw**2*vpamo**2/mz**2*mmo**2+1d0/8/ctw
     & **2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vmael*cfl*(-1d0/4/ctw**2*vpamo*v
     & mamo/mz**2*mh**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo*mmo**2+1d0/8/ctw
     & **2*vpamo**2/mz**2*mh**2*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mmo**
     & 4-3d0/8/ctw**2*vpamo**2*mmo**2+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*
     & mmo**2-1d0/2/ctw**2*vmamo**2/mz**2*mmo**4-3d0/8/ctw**2*vmamo**2*m
     & mo**2)
     & +propizqs*det3izhqs*c0zhqschchch*qel*cfq/qs*(-2*stw**2*qch*vpach/
     & mz**2*mh**2*mch**4+2*stw**2*qch*vpach*mch**4-2*stw**2*qch*vmach/m
     & z**2*mh**2*mch**4+2*stw**2*qch*vmach*mch**4)
     & +propizqs*det3izhqs*c0zhqschchch*qel*cfq*(-2*stw**2*qch*vpach/mz*
     & *2*mch**4-2*stw**2*qch*vpach*mch**2-2*stw**2*qch*vmach/mz**2*mch*
     & *4-2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vmael*cfq*qs*(-1d0/4/ctw**2*vpac
     & h*vmach/mz**2*mch**2+1d0/8/ctw**2*vpach**2/mz**2*mch**2+1d0/8/ctw
     & **2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vmael*cfq*(-1d0/4/ctw**2*vpach*v
     & mach/mz**2*mh**2*mch**2-1d0/4/ctw**2*vpach*vmach*mch**2+1d0/8/ctw
     & **2*vpach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mch**
     & 4-3d0/8/ctw**2*vpach**2*mch**2+1d0/8/ctw**2*vmach**2/mz**2*mh**2*
     & mch**2-1d0/2/ctw**2*vmach**2/mz**2*mch**4-3d0/8/ctw**2*vmach**2*m
     & ch**2)
     & +propizqs*det3izhqs*c0zhqsststst*qel*cfq/qs*(-2*stw**2*qst*vpast/
     & mz**2*mh**2*mst**4+2*stw**2*qst*vpast*mst**4-2*stw**2*qst*vmast/m
     & z**2*mh**2*mst**4+2*stw**2*qst*vmast*mst**4)
     & +propizqs*det3izhqs*c0zhqsststst*qel*cfq*(-2*stw**2*qst*vpast/mz*
     & *2*mst**4-2*stw**2*qst*vpast*mst**2-2*stw**2*qst*vmast/mz**2*mst*
     & *4-2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*vmael*cfq*qs*(-1d0/4/ctw**2*vpas
     & t*vmast/mz**2*mst**2+1d0/8/ctw**2*vpast**2/mz**2*mst**2+1d0/8/ctw
     & **2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*vmael*cfq*(-1d0/4/ctw**2*vpast*v
     & mast/mz**2*mh**2*mst**2-1d0/4/ctw**2*vpast*vmast*mst**2+1d0/8/ctw
     & **2*vpast**2/mz**2*mh**2*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mst**
     & 4-3d0/8/ctw**2*vpast**2*mst**2+1d0/8/ctw**2*vmast**2/mz**2*mh**2*
     & mst**2-1d0/2/ctw**2*vmast**2/mz**2*mst**4-3d0/8/ctw**2*vmast**2*m
     & st**2)
     & +propizqs*det3izhqs*c0zhqstatata*qel*cfl/qs*(-2*stw**2*qta*vpata/
     & mz**2*mh**2*mta**4+2*stw**2*qta*vpata*mta**4-2*stw**2*qta*vmata/m
     & z**2*mh**2*mta**4+2*stw**2*qta*vmata*mta**4)
     & +propizqs*det3izhqs*c0zhqstatata*qel*cfl*(-2*stw**2*qta*vpata/mz*
     & *2*mta**4-2*stw**2*qta*vpata*mta**2-2*stw**2*qta*vmata/mz**2*mta*
     & *4-2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vmael*cfl*qs*(-1d0/4/ctw**2*vpat
     & a*vmata/mz**2*mta**2+1d0/8/ctw**2*vpata**2/mz**2*mta**2+1d0/8/ctw
     & **2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vmael*cfl*(-1d0/4/ctw**2*vpata*v
     & mata/mz**2*mh**2*mta**2-1d0/4/ctw**2*vpata*vmata*mta**2+1d0/8/ctw
     & **2*vpata**2/mz**2*mh**2*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mta**
     & 4-3d0/8/ctw**2*vpata**2*mta**2+1d0/8/ctw**2*vmata**2/mz**2*mh**2*
     & mta**2-1d0/2/ctw**2*vmata**2/mz**2*mta**4-3d0/8/ctw**2*vmata**2*m
     & ta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qel*cfq/qs*(-2*stw**2*qtp*vpatp/
     & mz**2*mh**2*mtp**4+2*stw**2*qtp*vpatp*mtp**4-2*stw**2*qtp*vmatp/m
     & z**2*mh**2*mtp**4+2*stw**2*qtp*vmatp*mtp**4)
     & +propizqs*det3izhqs*c0zhqstptptp*qel*cfq*(-2*stw**2*qtp*vpatp/mz*
     & *2*mtp**4-2*stw**2*qtp*vpatp*mtp**2-2*stw**2*qtp*vmatp/mz**2*mtp*
     & *4-2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vmael*cfq*qs*(-1d0/4/ctw**2*vpat
     & p*vmatp/mz**2*mtp**2+1d0/8/ctw**2*vpatp**2/mz**2*mtp**2+1d0/8/ctw
     & **2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vmael*cfq*(-1d0/4/ctw**2*vpatp*v
     & matp/mz**2*mh**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp*mtp**2+1d0/8/ctw
     & **2*vpatp**2/mz**2*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**
     & 4-3d0/8/ctw**2*vpatp**2*mtp**2+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*
     & mtp**2-1d0/2/ctw**2*vmatp**2/mz**2*mtp**4-3d0/8/ctw**2*vmatp**2*m
     & tp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qel*cfq/qs*(-2*stw**2*qbt*vpabt/
     & mz**2*mh**2*mbt**4+2*stw**2*qbt*vpabt*mbt**4-2*stw**2*qbt*vmabt/m
     & z**2*mh**2*mbt**4+2*stw**2*qbt*vmabt*mbt**4)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qel*cfq*(-2*stw**2*qbt*vpabt/mz*
     & *2*mbt**4-2*stw**2*qbt*vpabt*mbt**2-2*stw**2*qbt*vmabt/mz**2*mbt*
     & *4-2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vmael*cfq*qs*(-1d0/4/ctw**2*vpab
     & t*vmabt/mz**2*mbt**2+1d0/8/ctw**2*vpabt**2/mz**2*mbt**2+1d0/8/ctw
     & **2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vmael*cfq*(-1d0/4/ctw**2*vpabt*v
     & mabt/mz**2*mh**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt*mbt**2+1d0/8/ctw
     & **2*vpabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**
     & 4-3d0/8/ctw**2*vpabt**2*mbt**2+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*
     & mbt**2-1d0/2/ctw**2*vmabt**2/mz**2*mbt**4-3d0/8/ctw**2*vmabt**2*m
     & bt**2)
     & +propizqs*det3izhqs*a0fh*vmael*qs*(-1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*a0fh*vmael*(-1d0/2/ctw**2/mz**2*mh**2-1d0/4/c
     & tw**2)
     & +propizqs*det3izhqs*b0fzww*qel/qs*(5*stw**2*mz**2+1d0/2*stw**2*mh
     & **2-11*stw**4*mz**2-stw**4*mh**2+6*stw**6*mz**2)
     & +propizqs*det3izhqs*b0fzww*vmael*(1d0/2)
     & +propizqs*det3izhqs*b0fzzh*vmael*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fzzh*vmael*(1d0/4/ctw**2/mz**2*mh**2+3d0/8/
     & ctw**2)
     & +propizqs*det3izhqs*b0fzmomo*qel*cfl/qs*(-stw**2*qmo*vpamo*mmo**2
     & -stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*vmael*cfl*(1d0/4/ctw**2*vpamo*vmamo/
     & mz**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mmo**2-1d0/8/ctw**2*vmam
     & o**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*qel*cfq/qs*(-stw**2*qch*vpach*mch**2
     & -stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fzchch*vmael*cfq*(1d0/4/ctw**2*vpach*vmach/
     & mz**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mch**2-1d0/8/ctw**2*vmac
     & h**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzstst*qel*cfq/qs*(-stw**2*qst*vpast*mst**2
     & -stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fzstst*vmael*cfq*(1d0/4/ctw**2*vpast*vmast/
     & mz**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mst**2-1d0/8/ctw**2*vmas
     & t**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fztata*qel*cfl/qs*(-stw**2*qta*vpata*mta**2
     & -stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fztata*vmael*cfl*(1d0/4/ctw**2*vpata*vmata/
     & mz**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mta**2-1d0/8/ctw**2*vmat
     & a**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztptp*qel*cfq/qs*(-stw**2*qtp*vpatp*mtp**2
     & -stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*vmael*cfq*(1d0/4/ctw**2*vpatp*vmatp/
     & mz**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mtp**2-1d0/8/ctw**2*vmat
     & p**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*qel*cfq/qs*(-stw**2*qbt*vpabt*mbt**2
     & -stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*vmael*cfq*(1d0/4/ctw**2*vpabt*vmabt/
     & mz**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mbt**2-1d0/8/ctw**2*vmab
     & t**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhww*qel/qs*(-5*stw**2*mz**2-1d0/2*stw**2*m
     & h**2+11*stw**4*mz**2+stw**4*mh**2-6*stw**6*mz**2)
     & +propizqs*det3izhqs*b0fhww*qel*(1d0/2*stw**2/mz**2*mh**2+5*stw**2
     & -stw**4/mz**2*mh**2-11*stw**4+6*stw**6)
     & +propizqs*det3izhqs*b0fhww*vmael*(1d0/4+1d0/8/ctw**2/mz**2*mh**2+
     & 1d0/2*ctw**2/mz**2*mh**2-ctw**2+3*ctw**4-1d0/2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fhzz*vmael*qs*(1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhzz*vmael*(9d0/16/ctw**2/mz**2*mh**2+3d0/8
     & /ctw**2)
     & +propizqs*det3izhqs*b0fhhh*vmael*qs*(-3d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhhh*vmael*(-21d0/16/ctw**2/mz**2*mh**2-3d0
     & /4/ctw**2)
     & +propizqs*det3izhqs*b0fhmomo*qel*cfl/qs*(stw**2*qmo*vpamo*mmo**2+
     & stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qel*cfl*(-stw**2*qmo*vpamo/mz**2*mmo
     & **2-stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*vmael*cfl*(-1d0/4/ctw**2*vpamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*qel*cfq/qs*(stw**2*qch*vpach*mch**2+
     & stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qel*cfq*(-stw**2*qch*vpach/mz**2*mch
     & **2-stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*vmael*cfq*(-1d0/4/ctw**2*vpach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*qel*cfq/qs*(stw**2*qst*vpast*mst**2+
     & stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qel*cfq*(-stw**2*qst*vpast/mz**2*mst
     & **2-stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*vmael*cfq*(-1d0/4/ctw**2*vpast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*qel*cfl/qs*(stw**2*qta*vpata*mta**2+
     & stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qel*cfl*(-stw**2*qta*vpata/mz**2*mta
     & **2-stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*vmael*cfl*(-1d0/4/ctw**2*vpata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*qel*cfq/qs*(stw**2*qtp*vpatp*mtp**2+
     & stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qel*cfq*(-stw**2*qtp*vpatp/mz**2*mtp
     & **2-stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*vmael*cfq*(-1d0/4/ctw**2*vpatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel*cfq/qs*(stw**2*qbt*vpabt*mbt**2+
     & stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel*cfq*(-stw**2*qbt*vpabt/mz**2*mbt
     & **2-stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*vmael*cfq*(-1d0/4/ctw**2*vpabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*qel*(-1d0/2*stw**2/mz**2*mh**2-5*stw*
     & *2+stw**4/mz**2*mh**2+11*stw**4-6*stw**6)
     & +propizqs*det3izhqs*b0fqsww*vmael*(-3d0/4-1d0/8/ctw**2/mz**2*mh**
     & 2-1d0/2*ctw**2/mz**2*mh**2+ctw**2-3*ctw**4+1d0/2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fqszh*vmael*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fqszh*vmael*(-1d0/4/ctw**2)
     & +propizqs*det3izhqs*b0fqsmomo*qel*cfl*(stw**2*qmo*vpamo/mz**2*mmo
     & **2+stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*vmael*cfl*(-1d0/4/ctw**2*vpamo*vmam
     & o/mz**2*mmo**2+3d0/8/ctw**2*vpamo**2/mz**2*mmo**2+3d0/8/ctw**2*vm
     & amo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*qel*cfq*(stw**2*qch*vpach/mz**2*mch
     & **2+stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*vmael*cfq*(-1d0/4/ctw**2*vpach*vmac
     & h/mz**2*mch**2+3d0/8/ctw**2*vpach**2/mz**2*mch**2+3d0/8/ctw**2*vm
     & ach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*qel*cfq*(stw**2*qst*vpast/mz**2*mst
     & **2+stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*vmael*cfq*(-1d0/4/ctw**2*vpast*vmas
     & t/mz**2*mst**2+3d0/8/ctw**2*vpast**2/mz**2*mst**2+3d0/8/ctw**2*vm
     & ast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*qel*cfl*(stw**2*qta*vpata/mz**2*mta
     & **2+stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*vmael*cfl*(-1d0/4/ctw**2*vpata*vmat
     & a/mz**2*mta**2+3d0/8/ctw**2*vpata**2/mz**2*mta**2+3d0/8/ctw**2*vm
     & ata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*qel*cfq*(stw**2*qtp*vpatp/mz**2*mtp
     & **2+stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*vmael*cfq*(-1d0/4/ctw**2*vpatp*vmat
     & p/mz**2*mtp**2+3d0/8/ctw**2*vpatp**2/mz**2*mtp**2+3d0/8/ctw**2*vm
     & atp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qel*cfq*(stw**2*qbt*vpabt/mz**2*mbt
     & **2+stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*vmael*cfq*(-1d0/4/ctw**2*vpabt*vmab
     & t/mz**2*mbt**2+3d0/8/ctw**2*vpabt**2/mz**2*mbt**2+3d0/8/ctw**2*vm
     & abt**2/mz**2*mbt**2)
     & +propizqs*sdet3iczus*c0czuszcc*vmael**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3iczus*b0fzcc*vmael**3/qs*(1d0/ctw**2)
     & +propizqs*sdet3iczus*b0fuszc*vmael**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichts*c0chtsczz*vmael**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3ichts*b0fhzz*vmael**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichts*b0ftszc*vmael**3/qs*(1d0/ctw**2)
     & +propizqs*d0zchctsuscczz*vmael**3/qs*(-1d0/2/ctw**2*us-1d0/2/ctw*
     & *2*mz**2-1d0/2/ctw**2*mh**2-sdet4izhtsus/ctw**2*ts*mz**2*mh**2+sd
     & et4izhtsus/ctw**2*ts*mz**4-1d0/2*sdet4izhtsus/ctw**2*mz**4*mh**2+
     & 1d0/2*sdet4izhtsus/ctw**2*mz**6+1d0/2*sdet4izhtsus**2/ctw**2*ts*m
     & z**4*mh**4-sdet4izhtsus**2/ctw**2*ts*mz**6*mh**2-1d0/2*sdet4izhts
     & us**2/ctw**2*us*mz**8+1d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**4-3d
     & 0/2*sdet4izhtsus**2/ctw**2*mz**8*mh**2)
     & +propizqs*d0zchctsuscczz*vmael**3*(-1d0/2/ctw**2-sdet4izhtsus/ctw
     & **2*ts*mz**2+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2-1d0/2*sd
     & et4izhtsus**2/ctw**2*ts**2*mz**4-1d0/2*sdet4izhtsus**2/ctw**2*us*
     & mz**6)
     & +propizqs*c0zhqswww*qel/qs*(20*stw**2-44*stw**4+24*stw**6)
     & +propizqs*c0zhqsmomomo*qel*cfl/qs*(-2*stw**2*qmo*vpamo/mz**2*mmo*
     & *2-2*stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*qel*cfq/qs*(-2*stw**2*qch*vpach/mz**2*mch*
     & *2-2*stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*qel*cfq/qs*(-2*stw**2*qst*vpast/mz**2*mst*
     & *2-2*stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*qel*cfl/qs*(-2*stw**2*qta*vpata/mz**2*mta*
     & *2-2*stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*qel*cfq/qs*(-2*stw**2*qtp*vpatp/mz**2*mtp*
     & *2-2*stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*qel*cfq/qs*(-2*stw**2*qbt*vpabt/mz**2*mbt*
     & *2-2*stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*c0cztszcc*vmael**3/qs*(1d0/2/ctw**2+1d0/2*sdet4izhtsus/
     & ctw**2*ts*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsu
     & s**2/ctw**2*ts*mz**2*mh**4+sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2+
     & 1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6-1d0/2*sdet4izhtsus**2/ctw**
     & 2*mz**4*mh**4+3d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2)
     & +propizqs*c0cztszcc*vmael**3*(1d0/2*sdet4izhtsus/ctw**2*ts-1d0/2*
     & sdet4izhtsus**2/ctw**2*ts*mz**2*mh**2+1d0/2*sdet4izhtsus**2/ctw**
     & 2*ts*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*ts**2*mz**2)
     & +propizqs*c0czuszcc*vmael**3/qs*(-1d0/2/ctw**2+sdet4izhtsus/ctw**
     & 2*ts*mz**2+1d0/2*sdet4izhtsus/ctw**2*us*mz**2+1d0/2*sdet4izhtsus/
     & ctw**2*mz**2*mh**2+sdet4izhtsus/ctw**2*mz**4)
     & +propizqs*c0czuszcc*vmael**3*(-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz
     & **4+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4)
     & +propizqs*c0chtsczz*vmael**3/qs*(1d0/2/ctw**2-1d0/2*sdet4izhtsus/
     & ctw**2*ts*mz**2-1d0/2*sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsu
     & s**2/ctw**2*ts*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*
     & mh**2-1d0/2*sdet4izhtsus**2/ctw**2*mz**4*mh**4-1d0/2*sdet4izhtsus
     & **2/ctw**2*mz**6*mh**2)
     & +propizqs*c0chtsczz*vmael**3*(-1d0/2*sdet4izhtsus/ctw**2*ts-1d0/2
     & *sdet4izhtsus**2/ctw**2*ts**2*mz**2)
     & +propizqs*c0chusczz*vmael**3/qs*(-1d0/2/ctw**2-1d0/2*sdet4izhtsus
     & /ctw**2*ts*mz**2-1d0/2*sdet4izhtsus/ctw**2*ts*mh**2-1d0/2*sdet4iz
     & htsus/ctw**2*us*mz**2-1d0/2*sdet4izhtsus/ctw**2*mz**2*mh**2-sdet4
     & izhtsus/ctw**2*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**2*mh**4-
     & 1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2+1d0/2*sdet4izhtsus**2
     & /ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**6+sdet
     & 4izhtsus**2/ctw**2*mz**4*mh**4-sdet4izhtsus**2/ctw**2*mz**6*mh**2
     & )
     & +propizqs*c0chusczz*vmael**3*(1d0/2*sdet4izhtsus**2/ctw**2*ts*mz*
     & *2*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4)
     & +propizqs*b0fzcc*vmael**3/qs*(-sdet4izhtsus/ctw**2*ts-sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0fhzz*vmael**3/qs*(-sdet4izhtsus/ctw**2*ts-sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0ftszc*vmael**3/qs*(sdet4izhtsus/ctw**2*ts+sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0fuszc*vmael**3/qs*(sdet4izhtsus/ctw**2*ts+sdet4izhtsu
     & s/ctw**2*mz**2)
     & +det3izhqs*vmael*cfl*(1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d
     & 0/2/ctw**2*vpamo**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2*mmo*
     & *2-1d0/2/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2
     & *mta**2-1d0/2/ctw**2*vpata**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*
     & mh**2*mta**2-1d0/2/ctw**2*vmata**2*mta**2)
     & +det3izhqs*vmael*cfq*(1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d
     & 0/2/ctw**2*vpach**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mh**2*mch*
     & *2-1d0/2/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2
     & *mst**2-1d0/2/ctw**2*vpast**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*
     & mh**2*mst**2-1d0/2/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpatp**2/m
     & z**2*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2*mtp**2+1d0/4/ctw**2*vmatp
     & **2/mz**2*mh**2*mtp**2-1d0/2/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*
     & vpabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2*mbt**2+1d0/4/ct
     & w**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vmabt**2*mbt**2)
     & +det3izhqs*vmael*(1d0/4/ctw**2*mz**2-7d0/8/ctw**2*mh**2-2*ctw**2*
     & mz**2+6*ctw**4*mz**2-3*ctw**4*mh**2+1d0/2*mz**2+3d0/4*mh**2)
     & +det3izhqs**2*c0zhqswww*vmael*(-3d0/2/ctw**2*mz**6*mh**2-3*ctw**2
     & *mz**6*mh**2-9*ctw**4*mz**6*mh**2+21d0/4*mz**6*mh**2)
     & +det3izhqs**2*c0zhqszhh*vmael*(-9/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqshzz*vmael*(-18/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqsmomomo*vmael*cfl*(3d0/4/ctw**2*vpamo**2*mz**4
     & *mh**2*mmo**2+3d0/4/ctw**2*vmamo**2*mz**4*mh**2*mmo**2)
     & +det3izhqs**2*c0zhqschchch*vmael*cfq*(3d0/4/ctw**2*vpach**2*mz**4
     & *mh**2*mch**2+3d0/4/ctw**2*vmach**2*mz**4*mh**2*mch**2)
     & +det3izhqs**2*c0zhqsststst*vmael*cfq*(3d0/4/ctw**2*vpast**2*mz**4
     & *mh**2*mst**2+3d0/4/ctw**2*vmast**2*mz**4*mh**2*mst**2)
     & +det3izhqs**2*c0zhqstatata*vmael*cfl*(3d0/4/ctw**2*vpata**2*mz**4
     & *mh**2*mta**2+3d0/4/ctw**2*vmata**2*mz**4*mh**2*mta**2)
     & +det3izhqs**2*c0zhqstptptp*vmael*cfq*(3d0/4/ctw**2*vpatp**2*mz**4
     & *mh**2*mtp**2+3d0/4/ctw**2*vmatp**2*mz**4*mh**2*mtp**2)
     & +det3izhqs**2*c0zhqsbtbtbt*vmael*cfq*(3d0/4/ctw**2*vpabt**2*mz**4
     & *mh**2*mbt**2+3d0/4/ctw**2*vmabt**2*mz**4*mh**2*mbt**2)
     & +det3izhqs**2*b0fzww*vmael*(-3d0/4/ctw**2*mz**4*mh**2-3d0/2*ctw**
     & 2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2+21d0/8*mz**4*mh**2)
     & +det3izhqs**2*b0fzmomo*vmael*cfl*(3d0/8/ctw**2*vpamo**2*mz**2*mh*
     & *2*mmo**2+3d0/8/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fzchch*vmael*cfq*(3d0/8/ctw**2*vpach**2*mz**2*mh*
     & *2*mch**2+3d0/8/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fzstst*vmael*cfq*(3d0/8/ctw**2*vpast**2*mz**2*mh*
     & *2*mst**2+3d0/8/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fztata*vmael*cfl*(3d0/8/ctw**2*vpata**2*mz**2*mh*
     & *2*mta**2+3d0/8/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fztptp*vmael*cfq*(3d0/8/ctw**2*vpatp**2*mz**2*mh*
     & *2*mtp**2+3d0/8/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fzbtbt*vmael*cfq*(3d0/8/ctw**2*vpabt**2*mz**2*mh*
     & *2*mbt**2+3d0/8/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fhww*vmael*(3d0/2/ctw**2*mz**4*mh**2+3*ctw**2*mz*
     & *4*mh**2+9*ctw**4*mz**4*mh**2-21d0/4*mz**4*mh**2)
     & +det3izhqs**2*b0fhzz*vmael*(9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhhh*vmael*(-9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhmomo*vmael*cfl*(-3d0/4/ctw**2*vpamo**2*mz**2*mh
     & **2*mmo**2-3d0/4/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fhchch*vmael*cfq*(-3d0/4/ctw**2*vpach**2*mz**2*mh
     & **2*mch**2-3d0/4/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fhstst*vmael*cfq*(-3d0/4/ctw**2*vpast**2*mz**2*mh
     & **2*mst**2-3d0/4/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fhtata*vmael*cfl*(-3d0/4/ctw**2*vpata**2*mz**2*mh
     & **2*mta**2-3d0/4/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fhtptp*vmael*cfq*(-3d0/4/ctw**2*vpatp**2*mz**2*mh
     & **2*mtp**2-3d0/4/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fhbtbt*vmael*cfq*(-3d0/4/ctw**2*vpabt**2*mz**2*mh
     & **2*mbt**2-3d0/4/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fqsww*vmael*(-3d0/4/ctw**2*mz**4*mh**2-3d0/2*ctw*
     & *2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2+21d0/8*mz**4*mh**2)
     & +det3izhqs**2*b0fqsmomo*vmael*cfl*(3d0/8/ctw**2*vpamo**2*mz**2*mh
     & **2*mmo**2+3d0/8/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fqschch*vmael*cfq*(3d0/8/ctw**2*vpach**2*mz**2*mh
     & **2*mch**2+3d0/8/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fqsstst*vmael*cfq*(3d0/8/ctw**2*vpast**2*mz**2*mh
     & **2*mst**2+3d0/8/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fqstata*vmael*cfl*(3d0/8/ctw**2*vpata**2*mz**2*mh
     & **2*mta**2+3d0/8/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fqstptp*vmael*cfq*(3d0/8/ctw**2*vpatp**2*mz**2*mh
     & **2*mtp**2+3d0/8/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fqsbtbt*vmael*cfq*(3d0/8/ctw**2*vpabt**2*mz**2*mh
     & **2*mbt**2+3d0/8/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*c0zhqswww*vmael*(1d0/2/ctw**2*mz**2*mh**2+3d0/2/ctw**2
     & *mz**4+1d0/2*ctw**2*mz**2*mh**2+ctw**2*mz**4+16*ctw**4*mz**4+6*ct
     & w**6*mz**2*mh**2-12*ctw**6*mz**4-1d0/2*mz**2*mh**2-5*mz**4)
     & +det3izhqs*c0zhqszhh*vmael*(51d0/4/ctw**2*mz**2*mh**2+9/ctw**2*mz
     & **4)
     & +det3izhqs*c0zhqshzz*vmael*(17/ctw**2*mz**2*mh**2+18/ctw**2*mz**4
     & )
     & +det3izhqs*c0zhqsmomomo*vmael*cfl*(1d0/2/ctw**2*vpamo*vmamo*mh**2
     & *mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mh**2*mmo**4-1d0/ctw**2*vpamo
     & **2*mz**2*mmo**2-1d0/4/ctw**2*vpamo**2*mh**2*mmo**2+1d0/ctw**2*vp
     & amo**2*mmo**4-1d0/2/ctw**2*vmamo**2/mz**2*mh**2*mmo**4-1d0/ctw**2
     & *vmamo**2*mz**2*mmo**2-1d0/4/ctw**2*vmamo**2*mh**2*mmo**2+1d0/ctw
     & **2*vmamo**2*mmo**4)
     & +det3izhqs*c0zhqschchch*vmael*cfq*(1d0/2/ctw**2*vpach*vmach*mh**2
     & *mch**2-1d0/2/ctw**2*vpach**2/mz**2*mh**2*mch**4-1d0/ctw**2*vpach
     & **2*mz**2*mch**2-1d0/4/ctw**2*vpach**2*mh**2*mch**2+1d0/ctw**2*vp
     & ach**2*mch**4-1d0/2/ctw**2*vmach**2/mz**2*mh**2*mch**4-1d0/ctw**2
     & *vmach**2*mz**2*mch**2-1d0/4/ctw**2*vmach**2*mh**2*mch**2+1d0/ctw
     & **2*vmach**2*mch**4)
     & +det3izhqs*c0zhqsststst*vmael*cfq*(1d0/2/ctw**2*vpast*vmast*mh**2
     & *mst**2-1d0/2/ctw**2*vpast**2/mz**2*mh**2*mst**4-1d0/ctw**2*vpast
     & **2*mz**2*mst**2-1d0/4/ctw**2*vpast**2*mh**2*mst**2+1d0/ctw**2*vp
     & ast**2*mst**4-1d0/2/ctw**2*vmast**2/mz**2*mh**2*mst**4-1d0/ctw**2
     & *vmast**2*mz**2*mst**2-1d0/4/ctw**2*vmast**2*mh**2*mst**2+1d0/ctw
     & **2*vmast**2*mst**4)
     & +det3izhqs*c0zhqstatata*vmael*cfl*(1d0/2/ctw**2*vpata*vmata*mh**2
     & *mta**2-1d0/2/ctw**2*vpata**2/mz**2*mh**2*mta**4-1d0/ctw**2*vpata
     & **2*mz**2*mta**2-1d0/4/ctw**2*vpata**2*mh**2*mta**2+1d0/ctw**2*vp
     & ata**2*mta**4-1d0/2/ctw**2*vmata**2/mz**2*mh**2*mta**4-1d0/ctw**2
     & *vmata**2*mz**2*mta**2-1d0/4/ctw**2*vmata**2*mh**2*mta**2+1d0/ctw
     & **2*vmata**2*mta**4)
     & +det3izhqs*c0zhqstptptp*vmael*cfq*(1d0/2/ctw**2*vpatp*vmatp*mh**2
     & *mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mh**2*mtp**4-1d0/ctw**2*vpatp
     & **2*mz**2*mtp**2-1d0/4/ctw**2*vpatp**2*mh**2*mtp**2+1d0/ctw**2*vp
     & atp**2*mtp**4-1d0/2/ctw**2*vmatp**2/mz**2*mh**2*mtp**4-1d0/ctw**2
     & *vmatp**2*mz**2*mtp**2-1d0/4/ctw**2*vmatp**2*mh**2*mtp**2+1d0/ctw
     & **2*vmatp**2*mtp**4)
     & +det3izhqs*c0zhqsbtbtbt*vmael*cfq*(1d0/2/ctw**2*vpabt*vmabt*mh**2
     & *mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mh**2*mbt**4-1d0/ctw**2*vpabt
     & **2*mz**2*mbt**2-1d0/4/ctw**2*vpabt**2*mh**2*mbt**2+1d0/ctw**2*vp
     & abt**2*mbt**4-1d0/2/ctw**2*vmabt**2/mz**2*mh**2*mbt**4-1d0/ctw**2
     & *vmabt**2*mz**2*mbt**2-1d0/4/ctw**2*vmabt**2*mh**2*mbt**2+1d0/ctw
     & **2*vmabt**2*mbt**4)
     & +det3izhqs*a0fz*vmael*(1d0/4/ctw**2*mz**2-1d0/4/ctw**2*mh**2)
     & +det3izhqs*a0fh*vmael*(3d0/4/ctw**2*mh**2)
     & +det3izhqs*b0fzww*vmael*(3d0/4/ctw**2*mz**2+1d0/8/ctw**2*mh**2+2*
     & ctw**2*mz**2+1d0/2*ctw**2*mh**2+3*ctw**4*mz**2-11d0/4*mz**2)
     & +det3izhqs*b0fzzh*vmael*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fzmomo*vmael*cfl*(1d0/4/ctw**2*vpamo*vmamo/mz**2*mh*
     & *2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw**2*v
     & pamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw
     & **2*vmamo**2*mmo**2)
     & +det3izhqs*b0fzchch*vmael*cfq*(1d0/4/ctw**2*vpach*vmach/mz**2*mh*
     & *2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ctw**2*v
     & pach**2*mch**2-1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-1d0/4/ctw
     & **2*vmach**2*mch**2)
     & +det3izhqs*b0fzstst*vmael*cfq*(1d0/4/ctw**2*vpast*vmast/mz**2*mh*
     & *2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ctw**2*v
     & past**2*mst**2-1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-1d0/4/ctw
     & **2*vmast**2*mst**2)
     & +det3izhqs*b0fztata*vmael*cfl*(1d0/4/ctw**2*vpata*vmata/mz**2*mh*
     & *2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ctw**2*v
     & pata**2*mta**2-1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d0/4/ctw
     & **2*vmata**2*mta**2)
     & +det3izhqs*b0fztptp*vmael*cfq*(1d0/4/ctw**2*vpatp*vmatp/mz**2*mh*
     & *2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw**2*v
     & patp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw
     & **2*vmatp**2*mtp**2)
     & +det3izhqs*b0fzbtbt*vmael*cfq*(1d0/4/ctw**2*vpabt*vmabt/mz**2*mh*
     & *2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw**2*v
     & pabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw
     & **2*vmabt**2*mbt**2)
     & +det3izhqs*b0fhww*vmael*(-3d0/2/ctw**2*mz**2-1d0/4/ctw**2*mh**2-4
     & *ctw**2*mz**2-ctw**2*mh**2-6*ctw**4*mz**2+11d0/2*mz**2)
     & +det3izhqs*b0fhzz*vmael*(-17d0/4/ctw**2*mz**2-21d0/8/ctw**2*mh**2
     & )
     & +det3izhqs*b0fhhh*vmael*(9d0/2/ctw**2*mz**2+33d0/8/ctw**2*mh**2)
     & +det3izhqs*b0fhmomo*vmael*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mh
     & **2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2+1d0/2/ctw**2*
     & vpamo**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2*mmo**2+1d0/2/ct
     & w**2*vmamo**2*mmo**2)
     & +det3izhqs*b0fhchch*vmael*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mh
     & **2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2+1d0/2/ctw**2*
     & vpach**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mh**2*mch**2+1d0/2/ct
     & w**2*vmach**2*mch**2)
     & +det3izhqs*b0fhstst*vmael*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mh
     & **2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2*mst**2+1d0/2/ctw**2*
     & vpast**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*mh**2*mst**2+1d0/2/ct
     & w**2*vmast**2*mst**2)
     & +det3izhqs*b0fhtata*vmael*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mh
     & **2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta**2+1d0/2/ctw**2*
     & vpata**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*mh**2*mta**2+1d0/2/ct
     & w**2*vmata**2*mta**2)
     & +det3izhqs*b0fhtptp*vmael*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mh
     & **2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mh**2*mtp**2+1d0/2/ctw**2*
     & vpatp**2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mh**2*mtp**2+1d0/2/ct
     & w**2*vmatp**2*mtp**2)
     & +det3izhqs*b0fhbtbt*vmael*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mh
     & **2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt**2+1d0/2/ctw**2*
     & vpabt**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mh**2*mbt**2+1d0/2/ct
     & w**2*vmabt**2*mbt**2)
     & +det3izhqs*b0fqsww*vmael*(3d0/4/ctw**2*mz**2+1d0/8/ctw**2*mh**2+2
     & *ctw**2*mz**2+1d0/2*ctw**2*mh**2+3*ctw**4*mz**2-11d0/4*mz**2)
     & +det3izhqs*b0fqszh*vmael*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fqsmomo*vmael*cfl*(1d0/4/ctw**2*vpamo*vmamo/mz**2*mh
     & **2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw**2*
     & vpamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-1d0/4/ct
     & w**2*vmamo**2*mmo**2)
     & +det3izhqs*b0fqschch*vmael*cfq*(1d0/4/ctw**2*vpach*vmach/mz**2*mh
     & **2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ctw**2*
     & vpach**2*mch**2-1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-1d0/4/ct
     & w**2*vmach**2*mch**2)
     & +det3izhqs*b0fqsstst*vmael*cfq*(1d0/4/ctw**2*vpast*vmast/mz**2*mh
     & **2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ctw**2*
     & vpast**2*mst**2-1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-1d0/4/ct
     & w**2*vmast**2*mst**2)
     & +det3izhqs*b0fqstata*vmael*cfl*(1d0/4/ctw**2*vpata*vmata/mz**2*mh
     & **2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ctw**2*
     & vpata**2*mta**2-1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d0/4/ct
     & w**2*vmata**2*mta**2)
     & +det3izhqs*b0fqstptp*vmael*cfq*(1d0/4/ctw**2*vpatp*vmatp/mz**2*mh
     & **2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw**2*
     & vpatp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-1d0/4/ct
     & w**2*vmatp**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*vmael*cfq*(1d0/4/ctw**2*vpabt*vmabt/mz**2*mh
     & **2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw**2*
     & vpabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/4/ct
     & w**2*vmabt**2*mbt**2)
     & +c0zhqswww*vmael*(-1-4*ctw**2+12*ctw**4)
     & +c0zhqszhh*vmael*(-3/ctw**2/mz**2*mh**2-21d0/2/ctw**2)
     & +c0zhqshzz*vmael*(-3d0/2/ctw**2/mz**2*mh**2-13/ctw**2)
     & +c0zhqsmomomo*vmael*cfl*(-1d0/ctw**2*vpamo*vmamo/mz**2*mmo**2)
     & +c0zhqschchch*vmael*cfq*(-1d0/ctw**2*vpach*vmach/mz**2*mch**2)
     & +c0zhqsststst*vmael*cfq*(-1d0/ctw**2*vpast*vmast/mz**2*mst**2)
     & +c0zhqstatata*vmael*cfl*(-1d0/ctw**2*vpata*vmata/mz**2*mta**2)
     & +c0zhqstptptp*vmael*cfq*(-1d0/ctw**2*vpatp*vmatp/mz**2*mtp**2)
     & +c0zhqsbtbtbt*vmael*cfq*(-1d0/ctw**2*vpabt*vmabt/mz**2*mbt**2)
     & +a0fh*vmael*(-1d0/ctw**2/mz**2)
     & +b0fzzh*vmael*(1d0/2/ctw**2/mz**2)
     & +b0fhzz*vmael*(1d0/ctw**2/mz**2)
     & +b0fhhh*vmael*(-3/ctw**2/mz**2)
     & +b0fqszh*vmael*(1d0/2/ctw**2/mz**2)

      ffgm2=
     & +vmael*(3d0/2/ctw**2/mz**2+2*ctw**2/mz**2-2/mz**2)
     & +propizqs*qel/qs*(2*stw**2/mz**2-4*stw**4/mz**2)
     & +propizqs*det3izhqs*qel*cfl/qs*(stw**2*qmo*vpamo/mz**2*mh**2*mmo*
     & *2-stw**2*qmo*vpamo*mmo**2+stw**2*qmo*vmamo/mz**2*mh**2*mmo**2-st
     & w**2*qmo*vmamo*mmo**2+stw**2*qta*vpata/mz**2*mh**2*mta**2-stw**2*
     & qta*vpata*mta**2+stw**2*qta*vmata/mz**2*mh**2*mta**2-stw**2*qta*v
     & mata*mta**2)
     & +propizqs*det3izhqs*qel*cfl*(stw**2*qmo*vpamo/mz**2*mmo**2+stw**2
     & *qmo*vmamo/mz**2*mmo**2+stw**2*qta*vpata/mz**2*mta**2+stw**2*qta*
     & vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*qel*cfq/qs*(stw**2*qch*vpach/mz**2*mh**2*mch*
     & *2-stw**2*qch*vpach*mch**2+stw**2*qch*vmach/mz**2*mh**2*mch**2-st
     & w**2*qch*vmach*mch**2+stw**2*qst*vpast/mz**2*mh**2*mst**2-stw**2*
     & qst*vpast*mst**2+stw**2*qst*vmast/mz**2*mh**2*mst**2-stw**2*qst*v
     & mast*mst**2+stw**2*qtp*vpatp/mz**2*mh**2*mtp**2-stw**2*qtp*vpatp*
     & mtp**2+stw**2*qtp*vmatp/mz**2*mh**2*mtp**2-stw**2*qtp*vmatp*mtp**
     & 2+stw**2*qbt*vpabt/mz**2*mh**2*mbt**2-stw**2*qbt*vpabt*mbt**2+stw
     & **2*qbt*vmabt/mz**2*mh**2*mbt**2-stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*qel*cfq*(stw**2*qch*vpach/mz**2*mch**2+stw**2
     & *qch*vmach/mz**2*mch**2+stw**2*qst*vpast/mz**2*mst**2+stw**2*qst*
     & vmast/mz**2*mst**2+stw**2*qtp*vpatp/mz**2*mtp**2+stw**2*qtp*vmatp
     & /mz**2*mtp**2+stw**2*qbt*vpabt/mz**2*mbt**2+stw**2*qbt*vmabt/mz**
     & 2*mbt**2)
     & +propizqs*det3izhqs*qel/qs*(11d0/2*stw**2*mz**2-11d0/2*stw**2*mh*
     & *2-12*stw**4*mz**2+12*stw**4*mh**2+6*stw**6*mz**2-6*stw**6*mh**2)
     & 
     & +propizqs*det3izhqs*qel*qs*(1d0/2*stw**2/mz**2-stw**4/mz**2)
     & +propizqs*det3izhqs*qel*(1d0/2*stw**2/mz**2*mh**2-4*stw**2-stw**4
     & /mz**2*mh**2+9*stw**4-6*stw**6)
     & +propizqs*det3izhqs*vmael*cfl*(1d0/4/ctw**2*vpamo**2/mz**2*mmo**2
     & +1d0/4/ctw**2*vmamo**2/mz**2*mmo**2+1d0/4/ctw**2*vpata**2/mz**2*m
     & ta**2+1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*vmael*cfq*(1d0/4/ctw**2*vpach**2/mz**2*mch**2
     & +1d0/4/ctw**2*vmach**2/mz**2*mch**2+1d0/4/ctw**2*vpast**2/mz**2*m
     & st**2+1d0/4/ctw**2*vmast**2/mz**2*mst**2+1d0/4/ctw**2*vpatp**2/mz
     & **2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mtp**2+1d0/4/ctw**2*vpabt*
     & *2/mz**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*vmael*qs*(3d0/8/ctw**2/mz**2+1d0/2*ctw**2/mz*
     & *2-1d0/2/mz**2)
     & +propizqs*det3izhqs*vmael*(-3d0/4+3d0/8/ctw**2/mz**2*mh**2+1d0/4/
     & ctw**2+1d0/2*ctw**2/mz**2*mh**2+3d0/2*ctw**2-3*ctw**4-1d0/2/mz**2
     & *mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qel*qs*(15d0/2*stw**2*mz**2*mh**
     & 2+3d0/4*stw**2*mh**4-33d0/2*stw**4*mz**2*mh**2-3d0/2*stw**4*mh**4
     & +9*stw**6*mz**2*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*qel*(27d0/4*stw**2*mz**2*mh**4-1
     & 5d0/2*stw**2*mz**4*mh**2+3d0/4*stw**2*mh**6-15*stw**4*mz**2*mh**4
     & +33d0/2*stw**4*mz**4*mh**2-3d0/2*stw**4*mh**6+9*stw**6*mz**2*mh**
     & 4-9*stw**6*mz**4*mh**2)
     & +propizqs*det3izhqs**2*c0zhqswww*vmael*qs*(3d0/16/ctw**2*mz**2*mh
     & **2+3d0/8/ctw**2*mz**4+3d0/16/ctw**2*mh**4-3d0/4*ctw**2*mz**2*mh*
     & *2+3d0/4*ctw**2*mh**4+9d0/2*ctw**4*mz**2*mh**2+9d0/2*ctw**4*mz**4
     & -3d0/8*mz**2*mh**2-9d0/8*mz**4-3d0/4*mh**4)
     & +propizqs*det3izhqs**2*c0zhqswww*vmael*(15d0/16/ctw**2*mz**4*mh**
     & 2+3d0/8/ctw**2*mz**6+3d0/16/ctw**2*mh**6-3d0/2*ctw**2*mz**2*mh**4
     & +15d0/4*ctw**2*mz**4*mh**2+3d0/4*ctw**2*mh**6+9d0/2*ctw**4*mz**2*
     & mh**4+9d0/2*ctw**4*mz**6+3d0/8*mz**2*mh**4-15d0/4*mz**4*mh**2-9d0
     & /8*mz**6-3d0/4*mh**6)
     & +propizqs*det3izhqs**2*c0zhqszhh*vmael*qs*(9d0/32/ctw**2/mz**2*mh
     & **6+9d0/16/ctw**2*mz**2*mh**2+9d0/4/ctw**2*mz**4+9d0/32/ctw**2*mh
     & **4)
     & +propizqs*det3izhqs**2*c0zhqszhh*vmael*(9d0/32/ctw**2/mz**2*mh**8
     & +45d0/32/ctw**2*mz**2*mh**4+81d0/16/ctw**2*mz**4*mh**2+9d0/4/ctw*
     & *2*mz**6)
     & +propizqs*det3izhqs**2*c0zhqshzz*vmael*qs*(3d0/32/ctw**2/mz**2*mh
     & **6+9d0/8/ctw**2*mz**2*mh**2+39d0/8/ctw**2*mz**4+9d0/32/ctw**2*mh
     & **4)
     & +propizqs*det3izhqs**2*c0zhqshzz*vmael*(3d0/32/ctw**2/mz**2*mh**8
     & +87d0/32/ctw**2*mz**2*mh**4+75d0/8/ctw**2*mz**4*mh**2+39d0/8/ctw*
     & *2*mz**6+15d0/16/ctw**2*mh**6)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qel*cfl*qs*(-3d0/2*stw**2*qmo
     & *vpamo*mh**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*qel*cfl*(3d0/2*stw**2*qmo*vpa
     & mo*mz**2*mh**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**4*mmo**2+3d0/2*s
     & tw**2*qmo*vmamo*mz**2*mh**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**4*m
     & mo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vmael*cfl*qs*(-3d0/8/ctw**2*v
     & pamo**2*mz**2*mmo**2-3d0/8/ctw**2*vpamo**2*mh**2*mmo**2-3d0/8/ctw
     & **2*vmamo**2*mz**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqsmomomo*vmael*cfl*(-3d0/8/ctw**2*vpam
     & o**2*mz**4*mmo**2-3d0/8/ctw**2*vpamo**2*mh**4*mmo**2-3d0/8/ctw**2
     & *vmamo**2*mz**4*mmo**2-3d0/8/ctw**2*vmamo**2*mh**4*mmo**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qel*cfq*qs*(-3d0/2*stw**2*qch
     & *vpach*mh**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*qel*cfq*(3d0/2*stw**2*qch*vpa
     & ch*mz**2*mh**2*mch**2-3d0/2*stw**2*qch*vpach*mh**4*mch**2+3d0/2*s
     & tw**2*qch*vmach*mz**2*mh**2*mch**2-3d0/2*stw**2*qch*vmach*mh**4*m
     & ch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vmael*cfq*qs*(-3d0/8/ctw**2*v
     & pach**2*mz**2*mch**2-3d0/8/ctw**2*vpach**2*mh**2*mch**2-3d0/8/ctw
     & **2*vmach**2*mz**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*c0zhqschchch*vmael*cfq*(-3d0/8/ctw**2*vpac
     & h**2*mz**4*mch**2-3d0/8/ctw**2*vpach**2*mh**4*mch**2-3d0/8/ctw**2
     & *vmach**2*mz**4*mch**2-3d0/8/ctw**2*vmach**2*mh**4*mch**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qel*cfq*qs*(-3d0/2*stw**2*qst
     & *vpast*mh**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*qel*cfq*(3d0/2*stw**2*qst*vpa
     & st*mz**2*mh**2*mst**2-3d0/2*stw**2*qst*vpast*mh**4*mst**2+3d0/2*s
     & tw**2*qst*vmast*mz**2*mh**2*mst**2-3d0/2*stw**2*qst*vmast*mh**4*m
     & st**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vmael*cfq*qs*(-3d0/8/ctw**2*v
     & past**2*mz**2*mst**2-3d0/8/ctw**2*vpast**2*mh**2*mst**2-3d0/8/ctw
     & **2*vmast**2*mz**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*c0zhqsststst*vmael*cfq*(-3d0/8/ctw**2*vpas
     & t**2*mz**4*mst**2-3d0/8/ctw**2*vpast**2*mh**4*mst**2-3d0/8/ctw**2
     & *vmast**2*mz**4*mst**2-3d0/8/ctw**2*vmast**2*mh**4*mst**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qel*cfl*qs*(-3d0/2*stw**2*qta
     & *vpata*mh**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*qel*cfl*(3d0/2*stw**2*qta*vpa
     & ta*mz**2*mh**2*mta**2-3d0/2*stw**2*qta*vpata*mh**4*mta**2+3d0/2*s
     & tw**2*qta*vmata*mz**2*mh**2*mta**2-3d0/2*stw**2*qta*vmata*mh**4*m
     & ta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vmael*cfl*qs*(-3d0/8/ctw**2*v
     & pata**2*mz**2*mta**2-3d0/8/ctw**2*vpata**2*mh**2*mta**2-3d0/8/ctw
     & **2*vmata**2*mz**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstatata*vmael*cfl*(-3d0/8/ctw**2*vpat
     & a**2*mz**4*mta**2-3d0/8/ctw**2*vpata**2*mh**4*mta**2-3d0/8/ctw**2
     & *vmata**2*mz**4*mta**2-3d0/8/ctw**2*vmata**2*mh**4*mta**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qel*cfq*qs*(-3d0/2*stw**2*qtp
     & *vpatp*mh**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*qel*cfq*(3d0/2*stw**2*qtp*vpa
     & tp*mz**2*mh**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**4*mtp**2+3d0/2*s
     & tw**2*qtp*vmatp*mz**2*mh**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**4*m
     & tp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vmael*cfq*qs*(-3d0/8/ctw**2*v
     & patp**2*mz**2*mtp**2-3d0/8/ctw**2*vpatp**2*mh**2*mtp**2-3d0/8/ctw
     & **2*vmatp**2*mz**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqstptptp*vmael*cfq*(-3d0/8/ctw**2*vpat
     & p**2*mz**4*mtp**2-3d0/8/ctw**2*vpatp**2*mh**4*mtp**2-3d0/8/ctw**2
     & *vmatp**2*mz**4*mtp**2-3d0/8/ctw**2*vmatp**2*mh**4*mtp**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qel*cfq*qs*(-3d0/2*stw**2*qbt
     & *vpabt*mh**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*qel*cfq*(3d0/2*stw**2*qbt*vpa
     & bt*mz**2*mh**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**4*mbt**2+3d0/2*s
     & tw**2*qbt*vmabt*mz**2*mh**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**4*m
     & bt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vmael*cfq*qs*(-3d0/8/ctw**2*v
     & pabt**2*mz**2*mbt**2-3d0/8/ctw**2*vpabt**2*mh**2*mbt**2-3d0/8/ctw
     & **2*vmabt**2*mz**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*c0zhqsbtbtbt*vmael*cfq*(-3d0/8/ctw**2*vpab
     & t**2*mz**4*mbt**2-3d0/8/ctw**2*vpabt**2*mh**4*mbt**2-3d0/8/ctw**2
     & *vmabt**2*mz**4*mbt**2-3d0/8/ctw**2*vmabt**2*mh**4*mbt**2)
     & +propizqs*det3izhqs**2*b0fzww*qel*qs*(15d0/2*stw**2*mz**2+3d0/4*s
     & tw**2*mh**2-33d0/2*stw**4*mz**2-3d0/2*stw**4*mh**2+9*stw**6*mz**2
     & )
     & +propizqs*det3izhqs**2*b0fzww*qel*(33d0/4*stw**2*mz**2*mh**2+15d0
     & /2*stw**2*mz**4+3d0/4*stw**2*mh**4-18*stw**4*mz**2*mh**2-33d0/2*s
     & tw**4*mz**4-3d0/2*stw**4*mh**4+9*stw**6*mz**2*mh**2+9*stw**6*mz**
     & 4)
     & +propizqs*det3izhqs**2*b0fzww*vmael*qs*(3d0/16/ctw**2*mz**2+3d0/1
     & 6/ctw**2*mh**2-3d0/4*ctw**2*mz**2+3d0/4*ctw**2*mh**2+9d0/2*ctw**4
     & *mz**2-3d0/8*mz**2-3d0/4*mh**2)
     & +propizqs*det3izhqs**2*b0fzww*vmael*(3d0/8/ctw**2*mz**2*mh**2+3d0
     & /16/ctw**2*mz**4+3d0/16/ctw**2*mh**4+3d0/4*ctw**2*mz**4+3d0/4*ctw
     & **2*mh**4+9d0/2*ctw**4*mz**2*mh**2-9d0/8*mz**2*mh**2-3d0/4*mz**4-
     & 3d0/4*mh**4)
     & +propizqs*det3izhqs**2*b0fzzh*vmael*qs*(3d0/16/ctw**2*mz**2+3d0/1
     & 6/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fzzh*vmael*(3d0/8/ctw**2*mz**2*mh**2-3d0
     & /16/ctw**2*mz**4-3d0/16/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fzmomo*qel*cfl*qs*(-3d0/2*stw**2*qmo*vpa
     & mo*mmo**2-3d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*qel*cfl*(-3d0/2*stw**2*qmo*vpamo*
     & mz**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**2*mmo**2-3d0/2*stw**2*qmo
     & *vmamo*mz**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vmael*cfl*qs*(-3d0/8/ctw**2*vpamo
     & **2*mmo**2-3d0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzmomo*vmael*cfl*(-3d0/8/ctw**2*vpamo**2
     & *mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fzchch*qel*cfq*qs*(-3d0/2*stw**2*qch*vpa
     & ch*mch**2-3d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*qel*cfq*(-3d0/2*stw**2*qch*vpach*
     & mz**2*mch**2-3d0/2*stw**2*qch*vpach*mh**2*mch**2-3d0/2*stw**2*qch
     & *vmach*mz**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vmael*cfq*qs*(-3d0/8/ctw**2*vpach
     & **2*mch**2-3d0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzchch*vmael*cfq*(-3d0/8/ctw**2*vpach**2
     & *mh**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fzstst*qel*cfq*qs*(-3d0/2*stw**2*qst*vpa
     & st*mst**2-3d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*qel*cfq*(-3d0/2*stw**2*qst*vpast*
     & mz**2*mst**2-3d0/2*stw**2*qst*vpast*mh**2*mst**2-3d0/2*stw**2*qst
     & *vmast*mz**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vmael*cfq*qs*(-3d0/8/ctw**2*vpast
     & **2*mst**2-3d0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fzstst*vmael*cfq*(-3d0/8/ctw**2*vpast**2
     & *mh**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fztata*qel*cfl*qs*(-3d0/2*stw**2*qta*vpa
     & ta*mta**2-3d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*qel*cfl*(-3d0/2*stw**2*qta*vpata*
     & mz**2*mta**2-3d0/2*stw**2*qta*vpata*mh**2*mta**2-3d0/2*stw**2*qta
     & *vmata*mz**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vmael*cfl*qs*(-3d0/8/ctw**2*vpata
     & **2*mta**2-3d0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztata*vmael*cfl*(-3d0/8/ctw**2*vpata**2
     & *mh**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fztptp*qel*cfq*qs*(-3d0/2*stw**2*qtp*vpa
     & tp*mtp**2-3d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*qel*cfq*(-3d0/2*stw**2*qtp*vpatp*
     & mz**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**2*mtp**2-3d0/2*stw**2*qtp
     & *vmatp*mz**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vmael*cfq*qs*(-3d0/8/ctw**2*vpatp
     & **2*mtp**2-3d0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fztptp*vmael*cfq*(-3d0/8/ctw**2*vpatp**2
     & *mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qel*cfq*qs*(-3d0/2*stw**2*qbt*vpa
     & bt*mbt**2-3d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*qel*cfq*(-3d0/2*stw**2*qbt*vpabt*
     & mz**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**2*mbt**2-3d0/2*stw**2*qbt
     & *vmabt*mz**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vmael*cfq*qs*(-3d0/8/ctw**2*vpabt
     & **2*mbt**2-3d0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fzbtbt*vmael*cfq*(-3d0/8/ctw**2*vpabt**2
     & *mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhww*qel*(-15*stw**2*mz**2*mh**2-3d0/2*s
     & tw**2*mh**4+33*stw**4*mz**2*mh**2+3*stw**4*mh**4-18*stw**6*mz**2*
     & mh**2)
     & +propizqs*det3izhqs**2*b0fhww*vmael*qs*(-3d0/8/ctw**2*mz**2-3d0/2
     & *ctw**2*mz**2+3d0/2*mz**2)
     & +propizqs*det3izhqs**2*b0fhww*vmael*(-3d0/4/ctw**2*mz**2*mh**2-3d
     & 0/8/ctw**2*mz**4-3d0/8/ctw**2*mh**4-3d0/2*ctw**2*mz**4-3d0/2*ctw*
     & *2*mh**4-9*ctw**4*mz**2*mh**2+9d0/4*mz**2*mh**2+3d0/2*mz**4+3d0/2
     & *mh**4)
     & +propizqs*det3izhqs**2*b0fhzz*vmael*qs*(-3d0/32/ctw**2/mz**2*mh**
     & 4-15d0/16/ctw**2*mz**2-9d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhzz*vmael*(-3d0/32/ctw**2/mz**2*mh**6-8
     & 7d0/32/ctw**2*mz**2*mh**2-15d0/16/ctw**2*mz**4-3d0/4/ctw**2*mh**4
     & )
     & +propizqs*det3izhqs**2*b0fhhh*vmael*qs*(9d0/32/ctw**2/mz**2*mh**4
     & +9d0/8/ctw**2*mz**2+9d0/32/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fhhh*vmael*(9d0/32/ctw**2/mz**2*mh**6+81
     & d0/32/ctw**2*mz**2*mh**2+9d0/8/ctw**2*mz**4+9d0/16/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fhmomo*qel*cfl*(3*stw**2*qmo*vpamo*mh**2
     & *mmo**2+3*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhmomo*vmael*cfl*(3d0/4/ctw**2*vpamo**2*
     & mh**2*mmo**2+3d0/4/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fhchch*qel*cfq*(3*stw**2*qch*vpach*mh**2
     & *mch**2+3*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhchch*vmael*cfq*(3d0/4/ctw**2*vpach**2*
     & mh**2*mch**2+3d0/4/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fhstst*qel*cfq*(3*stw**2*qst*vpast*mh**2
     & *mst**2+3*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhstst*vmael*cfq*(3d0/4/ctw**2*vpast**2*
     & mh**2*mst**2+3d0/4/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fhtata*qel*cfl*(3*stw**2*qta*vpata*mh**2
     & *mta**2+3*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtata*vmael*cfl*(3d0/4/ctw**2*vpata**2*
     & mh**2*mta**2+3d0/4/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fhtptp*qel*cfq*(3*stw**2*qtp*vpatp*mh**2
     & *mtp**2+3*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhtptp*vmael*cfq*(3d0/4/ctw**2*vpatp**2*
     & mh**2*mtp**2+3d0/4/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*qel*cfq*(3*stw**2*qbt*vpabt*mh**2
     & *mbt**2+3*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fhbtbt*vmael*cfq*(3d0/4/ctw**2*vpabt**2*
     & mh**2*mbt**2+3d0/4/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsww*qel*qs*(-15d0/2*stw**2*mz**2-3d0/4
     & *stw**2*mh**2+33d0/2*stw**4*mz**2+3d0/2*stw**4*mh**2-9*stw**6*mz*
     & *2)
     & +propizqs*det3izhqs**2*b0fqsww*qel*(27d0/4*stw**2*mz**2*mh**2-15d
     & 0/2*stw**2*mz**4+3d0/4*stw**2*mh**4-15*stw**4*mz**2*mh**2+33d0/2*
     & stw**4*mz**4-3d0/2*stw**4*mh**4+9*stw**6*mz**2*mh**2-9*stw**6*mz*
     & *4)
     & +propizqs*det3izhqs**2*b0fqsww*vmael*qs*(3d0/16/ctw**2*mz**2-3d0/
     & 16/ctw**2*mh**2+9d0/4*ctw**2*mz**2-3d0/4*ctw**2*mh**2-9d0/2*ctw**
     & 4*mz**2-9d0/8*mz**2+3d0/4*mh**2)
     & +propizqs*det3izhqs**2*b0fqsww*vmael*(3d0/8/ctw**2*mz**2*mh**2+3d
     & 0/16/ctw**2*mz**4+3d0/16/ctw**2*mh**4+3d0/4*ctw**2*mz**4+3d0/4*ct
     & w**2*mh**4+9d0/2*ctw**4*mz**2*mh**2-9d0/8*mz**2*mh**2-3d0/4*mz**4
     & -3d0/4*mh**4)
     & +propizqs*det3izhqs**2*b0fqszh*vmael*qs*(-3d0/16/ctw**2/mz**2*mh*
     & *4-3d0/8/ctw**2*mz**2-3d0/16/ctw**2*mh**2)
     & +propizqs*det3izhqs**2*b0fqszh*vmael*(-3d0/16/ctw**2/mz**2*mh**6-
     & 3d0/16/ctw**2*mz**2*mh**2+3d0/8/ctw**2*mh**4)
     & +propizqs*det3izhqs**2*b0fqsmomo*qel*cfl*qs*(3d0/2*stw**2*qmo*vpa
     & mo*mmo**2+3d0/2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*qel*cfl*(3d0/2*stw**2*qmo*vpamo*
     & mz**2*mmo**2-3d0/2*stw**2*qmo*vpamo*mh**2*mmo**2+3d0/2*stw**2*qmo
     & *vmamo*mz**2*mmo**2-3d0/2*stw**2*qmo*vmamo*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vmael*cfl*qs*(3d0/8/ctw**2*vpamo
     & **2*mmo**2+3d0/8/ctw**2*vmamo**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqsmomo*vmael*cfl*(-3d0/8/ctw**2*vpamo**
     & 2*mh**2*mmo**2-3d0/8/ctw**2*vmamo**2*mh**2*mmo**2)
     & +propizqs*det3izhqs**2*b0fqschch*qel*cfq*qs*(3d0/2*stw**2*qch*vpa
     & ch*mch**2+3d0/2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*qel*cfq*(3d0/2*stw**2*qch*vpach*
     & mz**2*mch**2-3d0/2*stw**2*qch*vpach*mh**2*mch**2+3d0/2*stw**2*qch
     & *vmach*mz**2*mch**2-3d0/2*stw**2*qch*vmach*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vmael*cfq*qs*(3d0/8/ctw**2*vpach
     & **2*mch**2+3d0/8/ctw**2*vmach**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqschch*vmael*cfq*(-3d0/8/ctw**2*vpach**
     & 2*mh**2*mch**2-3d0/8/ctw**2*vmach**2*mh**2*mch**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qel*cfq*qs*(3d0/2*stw**2*qst*vpa
     & st*mst**2+3d0/2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*qel*cfq*(3d0/2*stw**2*qst*vpast*
     & mz**2*mst**2-3d0/2*stw**2*qst*vpast*mh**2*mst**2+3d0/2*stw**2*qst
     & *vmast*mz**2*mst**2-3d0/2*stw**2*qst*vmast*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vmael*cfq*qs*(3d0/8/ctw**2*vpast
     & **2*mst**2+3d0/8/ctw**2*vmast**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqsstst*vmael*cfq*(-3d0/8/ctw**2*vpast**
     & 2*mh**2*mst**2-3d0/8/ctw**2*vmast**2*mh**2*mst**2)
     & +propizqs*det3izhqs**2*b0fqstata*qel*cfl*qs*(3d0/2*stw**2*qta*vpa
     & ta*mta**2+3d0/2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*qel*cfl*(3d0/2*stw**2*qta*vpata*
     & mz**2*mta**2-3d0/2*stw**2*qta*vpata*mh**2*mta**2+3d0/2*stw**2*qta
     & *vmata*mz**2*mta**2-3d0/2*stw**2*qta*vmata*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vmael*cfl*qs*(3d0/8/ctw**2*vpata
     & **2*mta**2+3d0/8/ctw**2*vmata**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstata*vmael*cfl*(-3d0/8/ctw**2*vpata**
     & 2*mh**2*mta**2-3d0/8/ctw**2*vmata**2*mh**2*mta**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qel*cfq*qs*(3d0/2*stw**2*qtp*vpa
     & tp*mtp**2+3d0/2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*qel*cfq*(3d0/2*stw**2*qtp*vpatp*
     & mz**2*mtp**2-3d0/2*stw**2*qtp*vpatp*mh**2*mtp**2+3d0/2*stw**2*qtp
     & *vmatp*mz**2*mtp**2-3d0/2*stw**2*qtp*vmatp*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vmael*cfq*qs*(3d0/8/ctw**2*vpatp
     & **2*mtp**2+3d0/8/ctw**2*vmatp**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqstptp*vmael*cfq*(-3d0/8/ctw**2*vpatp**
     & 2*mh**2*mtp**2-3d0/8/ctw**2*vmatp**2*mh**2*mtp**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qel*cfq*qs*(3d0/2*stw**2*qbt*vpa
     & bt*mbt**2+3d0/2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*qel*cfq*(3d0/2*stw**2*qbt*vpabt*
     & mz**2*mbt**2-3d0/2*stw**2*qbt*vpabt*mh**2*mbt**2+3d0/2*stw**2*qbt
     & *vmabt*mz**2*mbt**2-3d0/2*stw**2*qbt*vmabt*mh**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vmael*cfq*qs*(3d0/8/ctw**2*vpabt
     & **2*mbt**2+3d0/8/ctw**2*vmabt**2*mbt**2)
     & +propizqs*det3izhqs**2*b0fqsbtbt*vmael*cfq*(-3d0/8/ctw**2*vpabt**
     & 2*mh**2*mbt**2-3d0/8/ctw**2*vmabt**2*mh**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqswww*qel/qs*(11*stw**2*mz**2*mh**2-11*st
     & w**2*mz**4-35*stw**4*mz**2*mh**2+35*stw**4*mz**4+36*stw**6*mz**2*
     & mh**2-36*stw**6*mz**4-12*stw**8*mz**2*mh**2+12*stw**8*mz**4)
     & +propizqs*det3izhqs*c0zhqswww*qel*qs*(-stw**2+3*stw**4-2*stw**6)
     & +propizqs*det3izhqs*c0zhqswww*qel*(18*stw**2*mz**2-48*stw**4*mz**
     & 2+stw**4*mh**2+42*stw**6*mz**2-2*stw**6*mh**2-12*stw**8*mz**2)
     & +propizqs*det3izhqs*c0zhqswww*vmael*qs*(-3d0/4+ctw**2-ctw**4)
     & +propizqs*det3izhqs*c0zhqswww*vmael*(1d0/4/ctw**2*mh**2-1d0/2*ctw
     & **2*mz**2+2*ctw**2*mh**2+3*ctw**4*mz**2-ctw**4*mh**2+6*ctw**6*mz*
     & *2-1d0/4*mz**2-7d0/4*mh**2)
     & +propizqs*det3izhqs*c0zhqszhh*vmael*qs*(-3d0/4/ctw**2/mz**2*mh**2
     & -21d0/8/ctw**2)
     & +propizqs*det3izhqs*c0zhqszhh*vmael*(-3d0/4/ctw**2/mz**2*mh**4-21
     & d0/8/ctw**2*mz**2-6/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqshzz*vmael*qs*(-3d0/8/ctw**2/mz**2*mh**2
     & -7d0/2/ctw**2)
     & +propizqs*det3izhqs*c0zhqshzz*vmael*(-7d0/8/ctw**2/mz**2*mh**4-11
     & d0/4/ctw**2*mz**2-7/ctw**2*mh**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*qel*cfl/qs*(-2*stw**2*qmo*vpamo/
     & mz**2*mh**2*mmo**4+2*stw**2*qmo*vpamo*mmo**4-2*stw**2*qmo*vmamo/m
     & z**2*mh**2*mmo**4+2*stw**2*qmo*vmamo*mmo**4)
     & +propizqs*det3izhqs*c0zhqsmomomo*qel*cfl*(-2*stw**2*qmo*vpamo/mz*
     & *2*mmo**4-2*stw**2*qmo*vpamo*mmo**2-2*stw**2*qmo*vmamo/mz**2*mmo*
     & *4-2*stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vmael*cfl*qs*(-1d0/4/ctw**2*vpam
     & o*vmamo/mz**2*mmo**2+1d0/8/ctw**2*vpamo**2/mz**2*mmo**2+1d0/8/ctw
     & **2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*c0zhqsmomomo*vmael*cfl*(-1d0/4/ctw**2*vpamo*v
     & mamo/mz**2*mh**2*mmo**2-1d0/4/ctw**2*vpamo*vmamo*mmo**2+1d0/8/ctw
     & **2*vpamo**2/mz**2*mh**2*mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mmo**
     & 4-3d0/8/ctw**2*vpamo**2*mmo**2+1d0/8/ctw**2*vmamo**2/mz**2*mh**2*
     & mmo**2-1d0/2/ctw**2*vmamo**2/mz**2*mmo**4-3d0/8/ctw**2*vmamo**2*m
     & mo**2)
     & +propizqs*det3izhqs*c0zhqschchch*qel*cfq/qs*(-2*stw**2*qch*vpach/
     & mz**2*mh**2*mch**4+2*stw**2*qch*vpach*mch**4-2*stw**2*qch*vmach/m
     & z**2*mh**2*mch**4+2*stw**2*qch*vmach*mch**4)
     & +propizqs*det3izhqs*c0zhqschchch*qel*cfq*(-2*stw**2*qch*vpach/mz*
     & *2*mch**4-2*stw**2*qch*vpach*mch**2-2*stw**2*qch*vmach/mz**2*mch*
     & *4-2*stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vmael*cfq*qs*(-1d0/4/ctw**2*vpac
     & h*vmach/mz**2*mch**2+1d0/8/ctw**2*vpach**2/mz**2*mch**2+1d0/8/ctw
     & **2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*c0zhqschchch*vmael*cfq*(-1d0/4/ctw**2*vpach*v
     & mach/mz**2*mh**2*mch**2-1d0/4/ctw**2*vpach*vmach*mch**2+1d0/8/ctw
     & **2*vpach**2/mz**2*mh**2*mch**2-1d0/2/ctw**2*vpach**2/mz**2*mch**
     & 4-3d0/8/ctw**2*vpach**2*mch**2+1d0/8/ctw**2*vmach**2/mz**2*mh**2*
     & mch**2-1d0/2/ctw**2*vmach**2/mz**2*mch**4-3d0/8/ctw**2*vmach**2*m
     & ch**2)
     & +propizqs*det3izhqs*c0zhqsststst*qel*cfq/qs*(-2*stw**2*qst*vpast/
     & mz**2*mh**2*mst**4+2*stw**2*qst*vpast*mst**4-2*stw**2*qst*vmast/m
     & z**2*mh**2*mst**4+2*stw**2*qst*vmast*mst**4)
     & +propizqs*det3izhqs*c0zhqsststst*qel*cfq*(-2*stw**2*qst*vpast/mz*
     & *2*mst**4-2*stw**2*qst*vpast*mst**2-2*stw**2*qst*vmast/mz**2*mst*
     & *4-2*stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*vmael*cfq*qs*(-1d0/4/ctw**2*vpas
     & t*vmast/mz**2*mst**2+1d0/8/ctw**2*vpast**2/mz**2*mst**2+1d0/8/ctw
     & **2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*c0zhqsststst*vmael*cfq*(-1d0/4/ctw**2*vpast*v
     & mast/mz**2*mh**2*mst**2-1d0/4/ctw**2*vpast*vmast*mst**2+1d0/8/ctw
     & **2*vpast**2/mz**2*mh**2*mst**2-1d0/2/ctw**2*vpast**2/mz**2*mst**
     & 4-3d0/8/ctw**2*vpast**2*mst**2+1d0/8/ctw**2*vmast**2/mz**2*mh**2*
     & mst**2-1d0/2/ctw**2*vmast**2/mz**2*mst**4-3d0/8/ctw**2*vmast**2*m
     & st**2)
     & +propizqs*det3izhqs*c0zhqstatata*qel*cfl/qs*(-2*stw**2*qta*vpata/
     & mz**2*mh**2*mta**4+2*stw**2*qta*vpata*mta**4-2*stw**2*qta*vmata/m
     & z**2*mh**2*mta**4+2*stw**2*qta*vmata*mta**4)
     & +propizqs*det3izhqs*c0zhqstatata*qel*cfl*(-2*stw**2*qta*vpata/mz*
     & *2*mta**4-2*stw**2*qta*vpata*mta**2-2*stw**2*qta*vmata/mz**2*mta*
     & *4-2*stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vmael*cfl*qs*(-1d0/4/ctw**2*vpat
     & a*vmata/mz**2*mta**2+1d0/8/ctw**2*vpata**2/mz**2*mta**2+1d0/8/ctw
     & **2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*c0zhqstatata*vmael*cfl*(-1d0/4/ctw**2*vpata*v
     & mata/mz**2*mh**2*mta**2-1d0/4/ctw**2*vpata*vmata*mta**2+1d0/8/ctw
     & **2*vpata**2/mz**2*mh**2*mta**2-1d0/2/ctw**2*vpata**2/mz**2*mta**
     & 4-3d0/8/ctw**2*vpata**2*mta**2+1d0/8/ctw**2*vmata**2/mz**2*mh**2*
     & mta**2-1d0/2/ctw**2*vmata**2/mz**2*mta**4-3d0/8/ctw**2*vmata**2*m
     & ta**2)
     & +propizqs*det3izhqs*c0zhqstptptp*qel*cfq/qs*(-2*stw**2*qtp*vpatp/
     & mz**2*mh**2*mtp**4+2*stw**2*qtp*vpatp*mtp**4-2*stw**2*qtp*vmatp/m
     & z**2*mh**2*mtp**4+2*stw**2*qtp*vmatp*mtp**4)
     & +propizqs*det3izhqs*c0zhqstptptp*qel*cfq*(-2*stw**2*qtp*vpatp/mz*
     & *2*mtp**4-2*stw**2*qtp*vpatp*mtp**2-2*stw**2*qtp*vmatp/mz**2*mtp*
     & *4-2*stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vmael*cfq*qs*(-1d0/4/ctw**2*vpat
     & p*vmatp/mz**2*mtp**2+1d0/8/ctw**2*vpatp**2/mz**2*mtp**2+1d0/8/ctw
     & **2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*c0zhqstptptp*vmael*cfq*(-1d0/4/ctw**2*vpatp*v
     & matp/mz**2*mh**2*mtp**2-1d0/4/ctw**2*vpatp*vmatp*mtp**2+1d0/8/ctw
     & **2*vpatp**2/mz**2*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mtp**
     & 4-3d0/8/ctw**2*vpatp**2*mtp**2+1d0/8/ctw**2*vmatp**2/mz**2*mh**2*
     & mtp**2-1d0/2/ctw**2*vmatp**2/mz**2*mtp**4-3d0/8/ctw**2*vmatp**2*m
     & tp**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qel*cfq/qs*(-2*stw**2*qbt*vpabt/
     & mz**2*mh**2*mbt**4+2*stw**2*qbt*vpabt*mbt**4-2*stw**2*qbt*vmabt/m
     & z**2*mh**2*mbt**4+2*stw**2*qbt*vmabt*mbt**4)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*qel*cfq*(-2*stw**2*qbt*vpabt/mz*
     & *2*mbt**4-2*stw**2*qbt*vpabt*mbt**2-2*stw**2*qbt*vmabt/mz**2*mbt*
     & *4-2*stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vmael*cfq*qs*(-1d0/4/ctw**2*vpab
     & t*vmabt/mz**2*mbt**2+1d0/8/ctw**2*vpabt**2/mz**2*mbt**2+1d0/8/ctw
     & **2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*c0zhqsbtbtbt*vmael*cfq*(-1d0/4/ctw**2*vpabt*v
     & mabt/mz**2*mh**2*mbt**2-1d0/4/ctw**2*vpabt*vmabt*mbt**2+1d0/8/ctw
     & **2*vpabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mbt**
     & 4-3d0/8/ctw**2*vpabt**2*mbt**2+1d0/8/ctw**2*vmabt**2/mz**2*mh**2*
     & mbt**2-1d0/2/ctw**2*vmabt**2/mz**2*mbt**4-3d0/8/ctw**2*vmabt**2*m
     & bt**2)
     & +propizqs*det3izhqs*a0fh*vmael*qs*(-1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*a0fh*vmael*(-1d0/2/ctw**2/mz**2*mh**2-1d0/4/c
     & tw**2)
     & +propizqs*det3izhqs*b0fzww*qel/qs*(5*stw**2*mz**2+1d0/2*stw**2*mh
     & **2-11*stw**4*mz**2-stw**4*mh**2+6*stw**6*mz**2)
     & +propizqs*det3izhqs*b0fzww*vmael*(1d0/2)
     & +propizqs*det3izhqs*b0fzzh*vmael*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fzzh*vmael*(1d0/4/ctw**2/mz**2*mh**2+3d0/8/
     & ctw**2)
     & +propizqs*det3izhqs*b0fzmomo*qel*cfl/qs*(-stw**2*qmo*vpamo*mmo**2
     & -stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fzmomo*vmael*cfl*(1d0/4/ctw**2*vpamo*vmamo/
     & mz**2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mmo**2-1d0/8/ctw**2*vmam
     & o**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fzchch*qel*cfq/qs*(-stw**2*qch*vpach*mch**2
     & -stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fzchch*vmael*cfq*(1d0/4/ctw**2*vpach*vmach/
     & mz**2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mch**2-1d0/8/ctw**2*vmac
     & h**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fzstst*qel*cfq/qs*(-stw**2*qst*vpast*mst**2
     & -stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fzstst*vmael*cfq*(1d0/4/ctw**2*vpast*vmast/
     & mz**2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mst**2-1d0/8/ctw**2*vmas
     & t**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fztata*qel*cfl/qs*(-stw**2*qta*vpata*mta**2
     & -stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fztata*vmael*cfl*(1d0/4/ctw**2*vpata*vmata/
     & mz**2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mta**2-1d0/8/ctw**2*vmat
     & a**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fztptp*qel*cfq/qs*(-stw**2*qtp*vpatp*mtp**2
     & -stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fztptp*vmael*cfq*(1d0/4/ctw**2*vpatp*vmatp/
     & mz**2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mtp**2-1d0/8/ctw**2*vmat
     & p**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fzbtbt*qel*cfq/qs*(-stw**2*qbt*vpabt*mbt**2
     & -stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fzbtbt*vmael*cfq*(1d0/4/ctw**2*vpabt*vmabt/
     & mz**2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mbt**2-1d0/8/ctw**2*vmab
     & t**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhww*qel/qs*(-5*stw**2*mz**2-1d0/2*stw**2*m
     & h**2+11*stw**4*mz**2+stw**4*mh**2-6*stw**6*mz**2)
     & +propizqs*det3izhqs*b0fhww*qel*(1d0/2*stw**2/mz**2*mh**2+5*stw**2
     & -stw**4/mz**2*mh**2-11*stw**4+6*stw**6)
     & +propizqs*det3izhqs*b0fhww*vmael*(1d0/4+1d0/8/ctw**2/mz**2*mh**2+
     & 1d0/2*ctw**2/mz**2*mh**2-ctw**2+3*ctw**4-1d0/2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fhzz*vmael*qs*(1d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhzz*vmael*(9d0/16/ctw**2/mz**2*mh**2+3d0/8
     & /ctw**2)
     & +propizqs*det3izhqs*b0fhhh*vmael*qs*(-3d0/4/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fhhh*vmael*(-21d0/16/ctw**2/mz**2*mh**2-3d0
     & /4/ctw**2)
     & +propizqs*det3izhqs*b0fhmomo*qel*cfl/qs*(stw**2*qmo*vpamo*mmo**2+
     & stw**2*qmo*vmamo*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*qel*cfl*(-stw**2*qmo*vpamo/mz**2*mmo
     & **2-stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhmomo*vmael*cfl*(-1d0/4/ctw**2*vpamo**2/mz
     & **2*mmo**2-1d0/4/ctw**2*vmamo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fhchch*qel*cfq/qs*(stw**2*qch*vpach*mch**2+
     & stw**2*qch*vmach*mch**2)
     & +propizqs*det3izhqs*b0fhchch*qel*cfq*(-stw**2*qch*vpach/mz**2*mch
     & **2-stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhchch*vmael*cfq*(-1d0/4/ctw**2*vpach**2/mz
     & **2*mch**2-1d0/4/ctw**2*vmach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fhstst*qel*cfq/qs*(stw**2*qst*vpast*mst**2+
     & stw**2*qst*vmast*mst**2)
     & +propizqs*det3izhqs*b0fhstst*qel*cfq*(-stw**2*qst*vpast/mz**2*mst
     & **2-stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhstst*vmael*cfq*(-1d0/4/ctw**2*vpast**2/mz
     & **2*mst**2-1d0/4/ctw**2*vmast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fhtata*qel*cfl/qs*(stw**2*qta*vpata*mta**2+
     & stw**2*qta*vmata*mta**2)
     & +propizqs*det3izhqs*b0fhtata*qel*cfl*(-stw**2*qta*vpata/mz**2*mta
     & **2-stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtata*vmael*cfl*(-1d0/4/ctw**2*vpata**2/mz
     & **2*mta**2-1d0/4/ctw**2*vmata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fhtptp*qel*cfq/qs*(stw**2*qtp*vpatp*mtp**2+
     & stw**2*qtp*vmatp*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*qel*cfq*(-stw**2*qtp*vpatp/mz**2*mtp
     & **2-stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhtptp*vmael*cfq*(-1d0/4/ctw**2*vpatp**2/mz
     & **2*mtp**2-1d0/4/ctw**2*vmatp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel*cfq/qs*(stw**2*qbt*vpabt*mbt**2+
     & stw**2*qbt*vmabt*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*qel*cfq*(-stw**2*qbt*vpabt/mz**2*mbt
     & **2-stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fhbtbt*vmael*cfq*(-1d0/4/ctw**2*vpabt**2/mz
     & **2*mbt**2-1d0/4/ctw**2*vmabt**2/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsww*qel*(-1d0/2*stw**2/mz**2*mh**2-5*stw*
     & *2+stw**4/mz**2*mh**2+11*stw**4-6*stw**6)
     & +propizqs*det3izhqs*b0fqsww*vmael*(-3d0/4-1d0/8/ctw**2/mz**2*mh**
     & 2-1d0/2*ctw**2/mz**2*mh**2+ctw**2-3*ctw**4+1d0/2/mz**2*mh**2)
     & +propizqs*det3izhqs*b0fqszh*vmael*qs*(1d0/8/ctw**2/mz**2)
     & +propizqs*det3izhqs*b0fqszh*vmael*(-1d0/4/ctw**2)
     & +propizqs*det3izhqs*b0fqsmomo*qel*cfl*(stw**2*qmo*vpamo/mz**2*mmo
     & **2+stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqsmomo*vmael*cfl*(-1d0/4/ctw**2*vpamo*vmam
     & o/mz**2*mmo**2+3d0/8/ctw**2*vpamo**2/mz**2*mmo**2+3d0/8/ctw**2*vm
     & amo**2/mz**2*mmo**2)
     & +propizqs*det3izhqs*b0fqschch*qel*cfq*(stw**2*qch*vpach/mz**2*mch
     & **2+stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqschch*vmael*cfq*(-1d0/4/ctw**2*vpach*vmac
     & h/mz**2*mch**2+3d0/8/ctw**2*vpach**2/mz**2*mch**2+3d0/8/ctw**2*vm
     & ach**2/mz**2*mch**2)
     & +propizqs*det3izhqs*b0fqsstst*qel*cfq*(stw**2*qst*vpast/mz**2*mst
     & **2+stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqsstst*vmael*cfq*(-1d0/4/ctw**2*vpast*vmas
     & t/mz**2*mst**2+3d0/8/ctw**2*vpast**2/mz**2*mst**2+3d0/8/ctw**2*vm
     & ast**2/mz**2*mst**2)
     & +propizqs*det3izhqs*b0fqstata*qel*cfl*(stw**2*qta*vpata/mz**2*mta
     & **2+stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstata*vmael*cfl*(-1d0/4/ctw**2*vpata*vmat
     & a/mz**2*mta**2+3d0/8/ctw**2*vpata**2/mz**2*mta**2+3d0/8/ctw**2*vm
     & ata**2/mz**2*mta**2)
     & +propizqs*det3izhqs*b0fqstptp*qel*cfq*(stw**2*qtp*vpatp/mz**2*mtp
     & **2+stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqstptp*vmael*cfq*(-1d0/4/ctw**2*vpatp*vmat
     & p/mz**2*mtp**2+3d0/8/ctw**2*vpatp**2/mz**2*mtp**2+3d0/8/ctw**2*vm
     & atp**2/mz**2*mtp**2)
     & +propizqs*det3izhqs*b0fqsbtbt*qel*cfq*(stw**2*qbt*vpabt/mz**2*mbt
     & **2+stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*det3izhqs*b0fqsbtbt*vmael*cfq*(-1d0/4/ctw**2*vpabt*vmab
     & t/mz**2*mbt**2+3d0/8/ctw**2*vpabt**2/mz**2*mbt**2+3d0/8/ctw**2*vm
     & abt**2/mz**2*mbt**2)
     & +propizqs*sdet3iczts*c0cztszcc*vmael**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3iczts*b0fzcc*vmael**3/qs*(1d0/ctw**2)
     & +propizqs*sdet3iczts*b0ftszc*vmael**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichus*c0chusczz*vmael**3/qs*(-1d0/ctw**2*mz**2)
     & +propizqs*sdet3ichus*b0fhzz*vmael**3/qs*(-1d0/ctw**2)
     & +propizqs*sdet3ichus*b0fuszc*vmael**3/qs*(1d0/ctw**2)
     & +propizqs*d0zchctsuscczz*vmael**3/qs*(1d0/2/ctw**2*us-sdet4izhtsu
     & s/ctw**2*us*mz**2*mh**2+sdet4izhtsus/ctw**2*us*mz**4-1d0/2*sdet4i
     & zhtsus/ctw**2*mz**4*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**6-1d0/2*s
     & det4izhtsus**2/ctw**2*ts*mz**8+1d0/2*sdet4izhtsus**2/ctw**2*us*mz
     & **4*mh**4-sdet4izhtsus**2/ctw**2*us*mz**6*mh**2+1d0/2*sdet4izhtsu
     & s**2/ctw**2*mz**6*mh**4-3d0/2*sdet4izhtsus**2/ctw**2*mz**8*mh**2)
     & 
     & +propizqs*d0zchctsuscczz*vmael**3*(-sdet4izhtsus/ctw**2*us*mz**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6+1d0/2*sdet4izhtsus**2/ctw**
     & 2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us**2*mz**4)
     & +propizqs*c0zhqswww*qel/qs*(20*stw**2-44*stw**4+24*stw**6)
     & +propizqs*c0zhqsmomomo*qel*cfl/qs*(-2*stw**2*qmo*vpamo/mz**2*mmo*
     & *2-2*stw**2*qmo*vmamo/mz**2*mmo**2)
     & +propizqs*c0zhqschchch*qel*cfq/qs*(-2*stw**2*qch*vpach/mz**2*mch*
     & *2-2*stw**2*qch*vmach/mz**2*mch**2)
     & +propizqs*c0zhqsststst*qel*cfq/qs*(-2*stw**2*qst*vpast/mz**2*mst*
     & *2-2*stw**2*qst*vmast/mz**2*mst**2)
     & +propizqs*c0zhqstatata*qel*cfl/qs*(-2*stw**2*qta*vpata/mz**2*mta*
     & *2-2*stw**2*qta*vmata/mz**2*mta**2)
     & +propizqs*c0zhqstptptp*qel*cfq/qs*(-2*stw**2*qtp*vpatp/mz**2*mtp*
     & *2-2*stw**2*qtp*vmatp/mz**2*mtp**2)
     & +propizqs*c0zhqsbtbtbt*qel*cfq/qs*(-2*stw**2*qbt*vpabt/mz**2*mbt*
     & *2-2*stw**2*qbt*vmabt/mz**2*mbt**2)
     & +propizqs*c0cztszcc*vmael**3/qs*(-1d0/2/ctw**2+1d0/2*sdet4izhtsus
     & /ctw**2*ts*mz**2+sdet4izhtsus/ctw**2*us*mz**2+1d0/2*sdet4izhtsus/
     & ctw**2*mz**2*mh**2+sdet4izhtsus/ctw**2*mz**4)
     & +propizqs*c0cztszcc*vmael**3*(1d0/2*sdet4izhtsus**2/ctw**2*ts*mz*
     & *4-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4)
     & +propizqs*c0czuszcc*vmael**3/qs*(1d0/2/ctw**2+1d0/2*sdet4izhtsus/
     & ctw**2*us*mh**2+1d0/2*sdet4izhtsus/ctw**2*mz**4+1d0/2*sdet4izhtsu
     & s**2/ctw**2*ts*mz**6-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**2*mh**4+
     & sdet4izhtsus**2/ctw**2*us*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**
     & 2*mz**4*mh**4+3d0/2*sdet4izhtsus**2/ctw**2*mz**6*mh**2)
     & +propizqs*c0czuszcc*vmael**3*(1d0/2*sdet4izhtsus/ctw**2*us-1d0/2*
     & sdet4izhtsus**2/ctw**2*us*mz**2*mh**2+1d0/2*sdet4izhtsus**2/ctw**
     & 2*us*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*us**2*mz**2)
     & +propizqs*c0chtsczz*vmael**3/qs*(-1d0/2/ctw**2-1d0/2*sdet4izhtsus
     & /ctw**2*ts*mz**2-1d0/2*sdet4izhtsus/ctw**2*us*mz**2-1d0/2*sdet4iz
     & htsus/ctw**2*us*mh**2-1d0/2*sdet4izhtsus/ctw**2*mz**2*mh**2-sdet4
     & izhtsus/ctw**2*mz**4+1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**4*mh**2-
     & 1d0/2*sdet4izhtsus**2/ctw**2*ts*mz**6+1d0/2*sdet4izhtsus**2/ctw**
     & 2*us*mz**2*mh**4-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*mh**2+sdet
     & 4izhtsus**2/ctw**2*mz**4*mh**4-sdet4izhtsus**2/ctw**2*mz**6*mh**2
     & )
     & +propizqs*c0chtsczz*vmael**3*(-1d0/2*sdet4izhtsus**2/ctw**2*ts*mz
     & **4+1d0/2*sdet4izhtsus**2/ctw**2*us*mz**2*mh**2)
     & +propizqs*c0chusczz*vmael**3/qs*(1d0/2/ctw**2-1d0/2*sdet4izhtsus/
     & ctw**2*us*mz**2-1d0/2*sdet4izhtsus/ctw**2*mz**4-1d0/2*sdet4izhtsu
     & s**2/ctw**2*ts*mz**4*mh**2-1d0/2*sdet4izhtsus**2/ctw**2*us*mz**4*
     & mh**2-1d0/2*sdet4izhtsus**2/ctw**2*mz**4*mh**4-1d0/2*sdet4izhtsus
     & **2/ctw**2*mz**6*mh**2)
     & +propizqs*c0chusczz*vmael**3*(-1d0/2*sdet4izhtsus/ctw**2*us-1d0/2
     & *sdet4izhtsus**2/ctw**2*us**2*mz**2)
     & +propizqs*b0fzcc*vmael**3/qs*(-sdet4izhtsus/ctw**2*us-sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0fhzz*vmael**3/qs*(-sdet4izhtsus/ctw**2*us-sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0ftszc*vmael**3/qs*(sdet4izhtsus/ctw**2*us+sdet4izhtsu
     & s/ctw**2*mz**2)
     & +propizqs*b0fuszc*vmael**3/qs*(sdet4izhtsus/ctw**2*us+sdet4izhtsu
     & s/ctw**2*mz**2)
     & +det3izhqs*vmael*cfl*(1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d
     & 0/2/ctw**2*vpamo**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2*mmo*
     & *2-1d0/2/ctw**2*vmamo**2*mmo**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2
     & *mta**2-1d0/2/ctw**2*vpata**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*
     & mh**2*mta**2-1d0/2/ctw**2*vmata**2*mta**2)
     & +det3izhqs*vmael*cfq*(1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d
     & 0/2/ctw**2*vpach**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mh**2*mch*
     & *2-1d0/2/ctw**2*vmach**2*mch**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2
     & *mst**2-1d0/2/ctw**2*vpast**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*
     & mh**2*mst**2-1d0/2/ctw**2*vmast**2*mst**2+1d0/4/ctw**2*vpatp**2/m
     & z**2*mh**2*mtp**2-1d0/2/ctw**2*vpatp**2*mtp**2+1d0/4/ctw**2*vmatp
     & **2/mz**2*mh**2*mtp**2-1d0/2/ctw**2*vmatp**2*mtp**2+1d0/4/ctw**2*
     & vpabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vpabt**2*mbt**2+1d0/4/ct
     & w**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/2/ctw**2*vmabt**2*mbt**2)
     & +det3izhqs*vmael*(1d0/4/ctw**2*mz**2-7d0/8/ctw**2*mh**2-2*ctw**2*
     & mz**2+6*ctw**4*mz**2-3*ctw**4*mh**2+1d0/2*mz**2+3d0/4*mh**2)
     & +det3izhqs**2*c0zhqswww*vmael*(-3d0/2/ctw**2*mz**6*mh**2-3*ctw**2
     & *mz**6*mh**2-9*ctw**4*mz**6*mh**2+21d0/4*mz**6*mh**2)
     & +det3izhqs**2*c0zhqszhh*vmael*(-9/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqshzz*vmael*(-18/ctw**2*mz**6*mh**2)
     & +det3izhqs**2*c0zhqsmomomo*vmael*cfl*(3d0/4/ctw**2*vpamo**2*mz**4
     & *mh**2*mmo**2+3d0/4/ctw**2*vmamo**2*mz**4*mh**2*mmo**2)
     & +det3izhqs**2*c0zhqschchch*vmael*cfq*(3d0/4/ctw**2*vpach**2*mz**4
     & *mh**2*mch**2+3d0/4/ctw**2*vmach**2*mz**4*mh**2*mch**2)
     & +det3izhqs**2*c0zhqsststst*vmael*cfq*(3d0/4/ctw**2*vpast**2*mz**4
     & *mh**2*mst**2+3d0/4/ctw**2*vmast**2*mz**4*mh**2*mst**2)
     & +det3izhqs**2*c0zhqstatata*vmael*cfl*(3d0/4/ctw**2*vpata**2*mz**4
     & *mh**2*mta**2+3d0/4/ctw**2*vmata**2*mz**4*mh**2*mta**2)
     & +det3izhqs**2*c0zhqstptptp*vmael*cfq*(3d0/4/ctw**2*vpatp**2*mz**4
     & *mh**2*mtp**2+3d0/4/ctw**2*vmatp**2*mz**4*mh**2*mtp**2)
     & +det3izhqs**2*c0zhqsbtbtbt*vmael*cfq*(3d0/4/ctw**2*vpabt**2*mz**4
     & *mh**2*mbt**2+3d0/4/ctw**2*vmabt**2*mz**4*mh**2*mbt**2)
     & +det3izhqs**2*b0fzww*vmael*(-3d0/4/ctw**2*mz**4*mh**2-3d0/2*ctw**
     & 2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2+21d0/8*mz**4*mh**2)
     & +det3izhqs**2*b0fzmomo*vmael*cfl*(3d0/8/ctw**2*vpamo**2*mz**2*mh*
     & *2*mmo**2+3d0/8/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fzchch*vmael*cfq*(3d0/8/ctw**2*vpach**2*mz**2*mh*
     & *2*mch**2+3d0/8/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fzstst*vmael*cfq*(3d0/8/ctw**2*vpast**2*mz**2*mh*
     & *2*mst**2+3d0/8/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fztata*vmael*cfl*(3d0/8/ctw**2*vpata**2*mz**2*mh*
     & *2*mta**2+3d0/8/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fztptp*vmael*cfq*(3d0/8/ctw**2*vpatp**2*mz**2*mh*
     & *2*mtp**2+3d0/8/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fzbtbt*vmael*cfq*(3d0/8/ctw**2*vpabt**2*mz**2*mh*
     & *2*mbt**2+3d0/8/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fhww*vmael*(3d0/2/ctw**2*mz**4*mh**2+3*ctw**2*mz*
     & *4*mh**2+9*ctw**4*mz**4*mh**2-21d0/4*mz**4*mh**2)
     & +det3izhqs**2*b0fhzz*vmael*(9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhhh*vmael*(-9d0/2/ctw**2*mz**4*mh**2)
     & +det3izhqs**2*b0fhmomo*vmael*cfl*(-3d0/4/ctw**2*vpamo**2*mz**2*mh
     & **2*mmo**2-3d0/4/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fhchch*vmael*cfq*(-3d0/4/ctw**2*vpach**2*mz**2*mh
     & **2*mch**2-3d0/4/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fhstst*vmael*cfq*(-3d0/4/ctw**2*vpast**2*mz**2*mh
     & **2*mst**2-3d0/4/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fhtata*vmael*cfl*(-3d0/4/ctw**2*vpata**2*mz**2*mh
     & **2*mta**2-3d0/4/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fhtptp*vmael*cfq*(-3d0/4/ctw**2*vpatp**2*mz**2*mh
     & **2*mtp**2-3d0/4/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fhbtbt*vmael*cfq*(-3d0/4/ctw**2*vpabt**2*mz**2*mh
     & **2*mbt**2-3d0/4/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs**2*b0fqsww*vmael*(-3d0/4/ctw**2*mz**4*mh**2-3d0/2*ctw*
     & *2*mz**4*mh**2-9d0/2*ctw**4*mz**4*mh**2+21d0/8*mz**4*mh**2)
     & +det3izhqs**2*b0fqsmomo*vmael*cfl*(3d0/8/ctw**2*vpamo**2*mz**2*mh
     & **2*mmo**2+3d0/8/ctw**2*vmamo**2*mz**2*mh**2*mmo**2)
     & +det3izhqs**2*b0fqschch*vmael*cfq*(3d0/8/ctw**2*vpach**2*mz**2*mh
     & **2*mch**2+3d0/8/ctw**2*vmach**2*mz**2*mh**2*mch**2)
     & +det3izhqs**2*b0fqsstst*vmael*cfq*(3d0/8/ctw**2*vpast**2*mz**2*mh
     & **2*mst**2+3d0/8/ctw**2*vmast**2*mz**2*mh**2*mst**2)
     & +det3izhqs**2*b0fqstata*vmael*cfl*(3d0/8/ctw**2*vpata**2*mz**2*mh
     & **2*mta**2+3d0/8/ctw**2*vmata**2*mz**2*mh**2*mta**2)
     & +det3izhqs**2*b0fqstptp*vmael*cfq*(3d0/8/ctw**2*vpatp**2*mz**2*mh
     & **2*mtp**2+3d0/8/ctw**2*vmatp**2*mz**2*mh**2*mtp**2)
     & +det3izhqs**2*b0fqsbtbt*vmael*cfq*(3d0/8/ctw**2*vpabt**2*mz**2*mh
     & **2*mbt**2+3d0/8/ctw**2*vmabt**2*mz**2*mh**2*mbt**2)
     & +det3izhqs*c0zhqswww*vmael*(1d0/2/ctw**2*mz**2*mh**2+3d0/2/ctw**2
     & *mz**4+1d0/2*ctw**2*mz**2*mh**2+ctw**2*mz**4+16*ctw**4*mz**4+6*ct
     & w**6*mz**2*mh**2-12*ctw**6*mz**4-1d0/2*mz**2*mh**2-5*mz**4)
     & +det3izhqs*c0zhqszhh*vmael*(51d0/4/ctw**2*mz**2*mh**2+9/ctw**2*mz
     & **4)
     & +det3izhqs*c0zhqshzz*vmael*(17/ctw**2*mz**2*mh**2+18/ctw**2*mz**4
     & )
     & +det3izhqs*c0zhqsmomomo*vmael*cfl*(1d0/2/ctw**2*vpamo*vmamo*mh**2
     & *mmo**2-1d0/2/ctw**2*vpamo**2/mz**2*mh**2*mmo**4-1d0/ctw**2*vpamo
     & **2*mz**2*mmo**2-1d0/4/ctw**2*vpamo**2*mh**2*mmo**2+1d0/ctw**2*vp
     & amo**2*mmo**4-1d0/2/ctw**2*vmamo**2/mz**2*mh**2*mmo**4-1d0/ctw**2
     & *vmamo**2*mz**2*mmo**2-1d0/4/ctw**2*vmamo**2*mh**2*mmo**2+1d0/ctw
     & **2*vmamo**2*mmo**4)
     & +det3izhqs*c0zhqschchch*vmael*cfq*(1d0/2/ctw**2*vpach*vmach*mh**2
     & *mch**2-1d0/2/ctw**2*vpach**2/mz**2*mh**2*mch**4-1d0/ctw**2*vpach
     & **2*mz**2*mch**2-1d0/4/ctw**2*vpach**2*mh**2*mch**2+1d0/ctw**2*vp
     & ach**2*mch**4-1d0/2/ctw**2*vmach**2/mz**2*mh**2*mch**4-1d0/ctw**2
     & *vmach**2*mz**2*mch**2-1d0/4/ctw**2*vmach**2*mh**2*mch**2+1d0/ctw
     & **2*vmach**2*mch**4)
     & +det3izhqs*c0zhqsststst*vmael*cfq*(1d0/2/ctw**2*vpast*vmast*mh**2
     & *mst**2-1d0/2/ctw**2*vpast**2/mz**2*mh**2*mst**4-1d0/ctw**2*vpast
     & **2*mz**2*mst**2-1d0/4/ctw**2*vpast**2*mh**2*mst**2+1d0/ctw**2*vp
     & ast**2*mst**4-1d0/2/ctw**2*vmast**2/mz**2*mh**2*mst**4-1d0/ctw**2
     & *vmast**2*mz**2*mst**2-1d0/4/ctw**2*vmast**2*mh**2*mst**2+1d0/ctw
     & **2*vmast**2*mst**4)
     & +det3izhqs*c0zhqstatata*vmael*cfl*(1d0/2/ctw**2*vpata*vmata*mh**2
     & *mta**2-1d0/2/ctw**2*vpata**2/mz**2*mh**2*mta**4-1d0/ctw**2*vpata
     & **2*mz**2*mta**2-1d0/4/ctw**2*vpata**2*mh**2*mta**2+1d0/ctw**2*vp
     & ata**2*mta**4-1d0/2/ctw**2*vmata**2/mz**2*mh**2*mta**4-1d0/ctw**2
     & *vmata**2*mz**2*mta**2-1d0/4/ctw**2*vmata**2*mh**2*mta**2+1d0/ctw
     & **2*vmata**2*mta**4)
     & +det3izhqs*c0zhqstptptp*vmael*cfq*(1d0/2/ctw**2*vpatp*vmatp*mh**2
     & *mtp**2-1d0/2/ctw**2*vpatp**2/mz**2*mh**2*mtp**4-1d0/ctw**2*vpatp
     & **2*mz**2*mtp**2-1d0/4/ctw**2*vpatp**2*mh**2*mtp**2+1d0/ctw**2*vp
     & atp**2*mtp**4-1d0/2/ctw**2*vmatp**2/mz**2*mh**2*mtp**4-1d0/ctw**2
     & *vmatp**2*mz**2*mtp**2-1d0/4/ctw**2*vmatp**2*mh**2*mtp**2+1d0/ctw
     & **2*vmatp**2*mtp**4)
     & +det3izhqs*c0zhqsbtbtbt*vmael*cfq*(1d0/2/ctw**2*vpabt*vmabt*mh**2
     & *mbt**2-1d0/2/ctw**2*vpabt**2/mz**2*mh**2*mbt**4-1d0/ctw**2*vpabt
     & **2*mz**2*mbt**2-1d0/4/ctw**2*vpabt**2*mh**2*mbt**2+1d0/ctw**2*vp
     & abt**2*mbt**4-1d0/2/ctw**2*vmabt**2/mz**2*mh**2*mbt**4-1d0/ctw**2
     & *vmabt**2*mz**2*mbt**2-1d0/4/ctw**2*vmabt**2*mh**2*mbt**2+1d0/ctw
     & **2*vmabt**2*mbt**4)
     & +det3izhqs*a0fz*vmael*(1d0/4/ctw**2*mz**2-1d0/4/ctw**2*mh**2)
     & +det3izhqs*a0fh*vmael*(3d0/4/ctw**2*mh**2)
     & +det3izhqs*b0fzww*vmael*(3d0/4/ctw**2*mz**2+1d0/8/ctw**2*mh**2+2*
     & ctw**2*mz**2+1d0/2*ctw**2*mh**2+3*ctw**4*mz**2-11d0/4*mz**2)
     & +det3izhqs*b0fzzh*vmael*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fzmomo*vmael*cfl*(1d0/4/ctw**2*vpamo*vmamo/mz**2*mh*
     & *2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw**2*v
     & pamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw
     & **2*vmamo**2*mmo**2)
     & +det3izhqs*b0fzchch*vmael*cfq*(1d0/4/ctw**2*vpach*vmach/mz**2*mh*
     & *2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ctw**2*v
     & pach**2*mch**2-1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-1d0/4/ctw
     & **2*vmach**2*mch**2)
     & +det3izhqs*b0fzstst*vmael*cfq*(1d0/4/ctw**2*vpast*vmast/mz**2*mh*
     & *2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ctw**2*v
     & past**2*mst**2-1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-1d0/4/ctw
     & **2*vmast**2*mst**2)
     & +det3izhqs*b0fztata*vmael*cfl*(1d0/4/ctw**2*vpata*vmata/mz**2*mh*
     & *2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ctw**2*v
     & pata**2*mta**2-1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d0/4/ctw
     & **2*vmata**2*mta**2)
     & +det3izhqs*b0fztptp*vmael*cfq*(1d0/4/ctw**2*vpatp*vmatp/mz**2*mh*
     & *2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw**2*v
     & patp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw
     & **2*vmatp**2*mtp**2)
     & +det3izhqs*b0fzbtbt*vmael*cfq*(1d0/4/ctw**2*vpabt*vmabt/mz**2*mh*
     & *2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw**2*v
     & pabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw
     & **2*vmabt**2*mbt**2)
     & +det3izhqs*b0fhww*vmael*(-3d0/2/ctw**2*mz**2-1d0/4/ctw**2*mh**2-4
     & *ctw**2*mz**2-ctw**2*mh**2-6*ctw**4*mz**2+11d0/2*mz**2)
     & +det3izhqs*b0fhzz*vmael*(-17d0/4/ctw**2*mz**2-21d0/8/ctw**2*mh**2
     & )
     & +det3izhqs*b0fhhh*vmael*(9d0/2/ctw**2*mz**2+33d0/8/ctw**2*mh**2)
     & +det3izhqs*b0fhmomo*vmael*cfl*(-1d0/2/ctw**2*vpamo*vmamo/mz**2*mh
     & **2*mmo**2+1d0/4/ctw**2*vpamo**2/mz**2*mh**2*mmo**2+1d0/2/ctw**2*
     & vpamo**2*mmo**2+1d0/4/ctw**2*vmamo**2/mz**2*mh**2*mmo**2+1d0/2/ct
     & w**2*vmamo**2*mmo**2)
     & +det3izhqs*b0fhchch*vmael*cfq*(-1d0/2/ctw**2*vpach*vmach/mz**2*mh
     & **2*mch**2+1d0/4/ctw**2*vpach**2/mz**2*mh**2*mch**2+1d0/2/ctw**2*
     & vpach**2*mch**2+1d0/4/ctw**2*vmach**2/mz**2*mh**2*mch**2+1d0/2/ct
     & w**2*vmach**2*mch**2)
     & +det3izhqs*b0fhstst*vmael*cfq*(-1d0/2/ctw**2*vpast*vmast/mz**2*mh
     & **2*mst**2+1d0/4/ctw**2*vpast**2/mz**2*mh**2*mst**2+1d0/2/ctw**2*
     & vpast**2*mst**2+1d0/4/ctw**2*vmast**2/mz**2*mh**2*mst**2+1d0/2/ct
     & w**2*vmast**2*mst**2)
     & +det3izhqs*b0fhtata*vmael*cfl*(-1d0/2/ctw**2*vpata*vmata/mz**2*mh
     & **2*mta**2+1d0/4/ctw**2*vpata**2/mz**2*mh**2*mta**2+1d0/2/ctw**2*
     & vpata**2*mta**2+1d0/4/ctw**2*vmata**2/mz**2*mh**2*mta**2+1d0/2/ct
     & w**2*vmata**2*mta**2)
     & +det3izhqs*b0fhtptp*vmael*cfq*(-1d0/2/ctw**2*vpatp*vmatp/mz**2*mh
     & **2*mtp**2+1d0/4/ctw**2*vpatp**2/mz**2*mh**2*mtp**2+1d0/2/ctw**2*
     & vpatp**2*mtp**2+1d0/4/ctw**2*vmatp**2/mz**2*mh**2*mtp**2+1d0/2/ct
     & w**2*vmatp**2*mtp**2)
     & +det3izhqs*b0fhbtbt*vmael*cfq*(-1d0/2/ctw**2*vpabt*vmabt/mz**2*mh
     & **2*mbt**2+1d0/4/ctw**2*vpabt**2/mz**2*mh**2*mbt**2+1d0/2/ctw**2*
     & vpabt**2*mbt**2+1d0/4/ctw**2*vmabt**2/mz**2*mh**2*mbt**2+1d0/2/ct
     & w**2*vmabt**2*mbt**2)
     & +det3izhqs*b0fqsww*vmael*(3d0/4/ctw**2*mz**2+1d0/8/ctw**2*mh**2+2
     & *ctw**2*mz**2+1d0/2*ctw**2*mh**2+3*ctw**4*mz**2-11d0/4*mz**2)
     & +det3izhqs*b0fqszh*vmael*(-1d0/2/ctw**2*mh**2)
     & +det3izhqs*b0fqsmomo*vmael*cfl*(1d0/4/ctw**2*vpamo*vmamo/mz**2*mh
     & **2*mmo**2-1d0/8/ctw**2*vpamo**2/mz**2*mh**2*mmo**2-1d0/4/ctw**2*
     & vpamo**2*mmo**2-1d0/8/ctw**2*vmamo**2/mz**2*mh**2*mmo**2-1d0/4/ct
     & w**2*vmamo**2*mmo**2)
     & +det3izhqs*b0fqschch*vmael*cfq*(1d0/4/ctw**2*vpach*vmach/mz**2*mh
     & **2*mch**2-1d0/8/ctw**2*vpach**2/mz**2*mh**2*mch**2-1d0/4/ctw**2*
     & vpach**2*mch**2-1d0/8/ctw**2*vmach**2/mz**2*mh**2*mch**2-1d0/4/ct
     & w**2*vmach**2*mch**2)
     & +det3izhqs*b0fqsstst*vmael*cfq*(1d0/4/ctw**2*vpast*vmast/mz**2*mh
     & **2*mst**2-1d0/8/ctw**2*vpast**2/mz**2*mh**2*mst**2-1d0/4/ctw**2*
     & vpast**2*mst**2-1d0/8/ctw**2*vmast**2/mz**2*mh**2*mst**2-1d0/4/ct
     & w**2*vmast**2*mst**2)
     & +det3izhqs*b0fqstata*vmael*cfl*(1d0/4/ctw**2*vpata*vmata/mz**2*mh
     & **2*mta**2-1d0/8/ctw**2*vpata**2/mz**2*mh**2*mta**2-1d0/4/ctw**2*
     & vpata**2*mta**2-1d0/8/ctw**2*vmata**2/mz**2*mh**2*mta**2-1d0/4/ct
     & w**2*vmata**2*mta**2)
     & +det3izhqs*b0fqstptp*vmael*cfq*(1d0/4/ctw**2*vpatp*vmatp/mz**2*mh
     & **2*mtp**2-1d0/8/ctw**2*vpatp**2/mz**2*mh**2*mtp**2-1d0/4/ctw**2*
     & vpatp**2*mtp**2-1d0/8/ctw**2*vmatp**2/mz**2*mh**2*mtp**2-1d0/4/ct
     & w**2*vmatp**2*mtp**2)
     & +det3izhqs*b0fqsbtbt*vmael*cfq*(1d0/4/ctw**2*vpabt*vmabt/mz**2*mh
     & **2*mbt**2-1d0/8/ctw**2*vpabt**2/mz**2*mh**2*mbt**2-1d0/4/ctw**2*
     & vpabt**2*mbt**2-1d0/8/ctw**2*vmabt**2/mz**2*mh**2*mbt**2-1d0/4/ct
     & w**2*vmabt**2*mbt**2)
     & +c0zhqswww*vmael*(-1-4*ctw**2+12*ctw**4)
     & +c0zhqszhh*vmael*(-3/ctw**2/mz**2*mh**2-21d0/2/ctw**2)
     & +c0zhqshzz*vmael*(-3d0/2/ctw**2/mz**2*mh**2-13/ctw**2)
     & +c0zhqsmomomo*vmael*cfl*(-1d0/ctw**2*vpamo*vmamo/mz**2*mmo**2)
     & +c0zhqschchch*vmael*cfq*(-1d0/ctw**2*vpach*vmach/mz**2*mch**2)
     & +c0zhqsststst*vmael*cfq*(-1d0/ctw**2*vpast*vmast/mz**2*mst**2)
     & +c0zhqstatata*vmael*cfl*(-1d0/ctw**2*vpata*vmata/mz**2*mta**2)
     & +c0zhqstptptp*vmael*cfq*(-1d0/ctw**2*vpatp*vmatp/mz**2*mtp**2)
     & +c0zhqsbtbtbt*vmael*cfq*(-1d0/ctw**2*vpabt*vmabt/mz**2*mbt**2)
     & +a0fh*vmael*(-1d0/ctw**2/mz**2)
     & +b0fzzh*vmael*(1d0/2/ctw**2/mz**2)
     & +b0fhzz*vmael*(1d0/ctw**2/mz**2)
     & +b0fhhh*vmael*(-3/ctw**2/mz**2)
     & +b0fqszh*vmael*(1d0/2/ctw**2/mz**2)

      ffarray(1,1) = ffgp0
      ffarray(1,2) = ffgp1
      ffarray(1,3) = ffgp2
      ffarray(1,4) = ffgm0
      ffarray(1,5) = ffgm1
      ffarray(1,6) = ffgm2

      return
      end
